import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AmiCopyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#description AmiCopy#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#destination_outpost_arn AmiCopy#destination_outpost_arn}.
     *
     * @stability stable
     */
    readonly destinationOutpostArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#encrypted AmiCopy#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#kms_key_id AmiCopy#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#name AmiCopy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#source_ami_id AmiCopy#source_ami_id}.
     *
     * @stability stable
     */
    readonly sourceAmiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#source_ami_region AmiCopy#source_ami_region}.
     *
     * @stability stable
     */
    readonly sourceAmiRegion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#tags AmiCopy#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#tags_all AmiCopy#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * ebs_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#ebs_block_device AmiCopy#ebs_block_device}
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: AmiCopyEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#ephemeral_block_device AmiCopy#ephemeral_block_device}
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: AmiCopyEphemeralBlockDevice[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#timeouts AmiCopy#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: AmiCopyTimeouts;
}
/**
 * @stability stable
 */
export interface AmiCopyEbsBlockDevice {
}
/**
 * @stability stable
 */
export interface AmiCopyEphemeralBlockDevice {
}
/**
 * @stability stable
 */
export interface AmiCopyTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#create AmiCopy#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#delete AmiCopy#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#update AmiCopy#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html aws_ami_copy}.
 *
 * @stability stable
 */
export declare class AmiCopy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html aws_ami_copy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AmiCopyConfig);
    /**
     * @stability stable
     */
    get architecture(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _destinationOutpostArn?;
    /**
     * @stability stable
     */
    get destinationOutpostArn(): string;
    /**
     * @stability stable
     */
    set destinationOutpostArn(value: string);
    /**
     * @stability stable
     */
    resetDestinationOutpostArn(): void;
    /**
     * @stability stable
     */
    get destinationOutpostArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get enaSupport(): cdktf.IResolvable;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set encrypted(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get hypervisor(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageLocation(): string;
    /**
     * @stability stable
     */
    get imageOwnerAlias(): string;
    /**
     * @stability stable
     */
    get imageType(): string;
    /**
     * @stability stable
     */
    get kernelId(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get manageEbsSnapshots(): cdktf.IResolvable;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    get platformDetails(): string;
    /**
     * @stability stable
     */
    get public(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get ramdiskId(): string;
    /**
     * @stability stable
     */
    get rootDeviceName(): string;
    /**
     * @stability stable
     */
    get rootSnapshotId(): string;
    private _sourceAmiId;
    /**
     * @stability stable
     */
    get sourceAmiId(): string;
    /**
     * @stability stable
     */
    set sourceAmiId(value: string);
    /**
     * @stability stable
     */
    get sourceAmiIdInput(): string;
    private _sourceAmiRegion;
    /**
     * @stability stable
     */
    get sourceAmiRegion(): string;
    /**
     * @stability stable
     */
    set sourceAmiRegion(value: string);
    /**
     * @stability stable
     */
    get sourceAmiRegionInput(): string;
    /**
     * @stability stable
     */
    get sriovNetSupport(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get usageOperation(): string;
    /**
     * @stability stable
     */
    get virtualizationType(): string;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): AmiCopyEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: AmiCopyEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): AmiCopyEbsBlockDevice[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): AmiCopyEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: AmiCopyEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): AmiCopyEphemeralBlockDevice[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AmiCopyTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AmiCopyTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AmiCopyTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
