import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AmplifyBackendEnvironmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#app_id AmplifyBackendEnvironment#app_id}.
     *
     * @stability stable
     */
    readonly appId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#deployment_artifacts AmplifyBackendEnvironment#deployment_artifacts}.
     *
     * @stability stable
     */
    readonly deploymentArtifacts?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#environment_name AmplifyBackendEnvironment#environment_name}.
     *
     * @stability stable
     */
    readonly environmentName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#stack_name AmplifyBackendEnvironment#stack_name}.
     *
     * @stability stable
     */
    readonly stackName?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html aws_amplify_backend_environment}.
 *
 * @stability stable
 */
export declare class AmplifyBackendEnvironment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html aws_amplify_backend_environment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AmplifyBackendEnvironmentConfig);
    private _appId;
    /**
     * @stability stable
     */
    get appId(): string;
    /**
     * @stability stable
     */
    set appId(value: string);
    /**
     * @stability stable
     */
    get appIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _deploymentArtifacts?;
    /**
     * @stability stable
     */
    get deploymentArtifacts(): string;
    /**
     * @stability stable
     */
    set deploymentArtifacts(value: string);
    /**
     * @stability stable
     */
    resetDeploymentArtifacts(): void;
    /**
     * @stability stable
     */
    get deploymentArtifactsInput(): string | undefined;
    private _environmentName;
    /**
     * @stability stable
     */
    get environmentName(): string;
    /**
     * @stability stable
     */
    set environmentName(value: string);
    /**
     * @stability stable
     */
    get environmentNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _stackName?;
    /**
     * @stability stable
     */
    get stackName(): string;
    /**
     * @stability stable
     */
    set stackName(value: string);
    /**
     * @stability stable
     */
    resetStackName(): void;
    /**
     * @stability stable
     */
    get stackNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
