import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#description ApiGatewayUsagePlan#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#name ApiGatewayUsagePlan#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#product_code ApiGatewayUsagePlan#product_code}.
     *
     * @stability stable
     */
    readonly productCode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#tags ApiGatewayUsagePlan#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#tags_all ApiGatewayUsagePlan#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * api_stages block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#api_stages ApiGatewayUsagePlan#api_stages}
     *
     * @stability stable
     */
    readonly apiStages?: ApiGatewayUsagePlanApiStages[];
    /**
     * quota_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#quota_settings ApiGatewayUsagePlan#quota_settings}
     *
     * @stability stable
     */
    readonly quotaSettings?: ApiGatewayUsagePlanQuotaSettings[];
    /**
     * throttle_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#throttle_settings ApiGatewayUsagePlan#throttle_settings}
     *
     * @stability stable
     */
    readonly throttleSettings?: ApiGatewayUsagePlanThrottleSettings[];
}
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanApiStages {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#api_id ApiGatewayUsagePlan#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#stage ApiGatewayUsagePlan#stage}.
     *
     * @stability stable
     */
    readonly stage: string;
}
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanQuotaSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#limit ApiGatewayUsagePlan#limit}.
     *
     * @stability stable
     */
    readonly limit: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#offset ApiGatewayUsagePlan#offset}.
     *
     * @stability stable
     */
    readonly offset?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#period ApiGatewayUsagePlan#period}.
     *
     * @stability stable
     */
    readonly period: string;
}
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanThrottleSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#burst_limit ApiGatewayUsagePlan#burst_limit}.
     *
     * @stability stable
     */
    readonly burstLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html#rate_limit ApiGatewayUsagePlan#rate_limit}.
     *
     * @stability stable
     */
    readonly rateLimit?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html aws_api_gateway_usage_plan}.
 *
 * @stability stable
 */
export declare class ApiGatewayUsagePlan extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_usage_plan.html aws_api_gateway_usage_plan} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayUsagePlanConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _productCode?;
    /**
     * @stability stable
     */
    get productCode(): string;
    /**
     * @stability stable
     */
    set productCode(value: string);
    /**
     * @stability stable
     */
    resetProductCode(): void;
    /**
     * @stability stable
     */
    get productCodeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _apiStages?;
    /**
     * @stability stable
     */
    get apiStages(): ApiGatewayUsagePlanApiStages[];
    /**
     * @stability stable
     */
    set apiStages(value: ApiGatewayUsagePlanApiStages[]);
    /**
     * @stability stable
     */
    resetApiStages(): void;
    /**
     * @stability stable
     */
    get apiStagesInput(): ApiGatewayUsagePlanApiStages[] | undefined;
    private _quotaSettings?;
    /**
     * @stability stable
     */
    get quotaSettings(): ApiGatewayUsagePlanQuotaSettings[];
    /**
     * @stability stable
     */
    set quotaSettings(value: ApiGatewayUsagePlanQuotaSettings[]);
    /**
     * @stability stable
     */
    resetQuotaSettings(): void;
    /**
     * @stability stable
     */
    get quotaSettingsInput(): ApiGatewayUsagePlanQuotaSettings[] | undefined;
    private _throttleSettings?;
    /**
     * @stability stable
     */
    get throttleSettings(): ApiGatewayUsagePlanThrottleSettings[];
    /**
     * @stability stable
     */
    set throttleSettings(value: ApiGatewayUsagePlanThrottleSettings[]);
    /**
     * @stability stable
     */
    resetThrottleSettings(): void;
    /**
     * @stability stable
     */
    get throttleSettingsInput(): ApiGatewayUsagePlanThrottleSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
