import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#domain_name Apigatewayv2DomainName#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#tags Apigatewayv2DomainName#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#tags_all Apigatewayv2DomainName#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * domain_name_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#domain_name_configuration Apigatewayv2DomainName#domain_name_configuration}
     *
     * @stability stable
     */
    readonly domainNameConfiguration: Apigatewayv2DomainNameDomainNameConfiguration[];
    /**
     * mutual_tls_authentication block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#mutual_tls_authentication Apigatewayv2DomainName#mutual_tls_authentication}
     *
     * @stability stable
     */
    readonly mutualTlsAuthentication?: Apigatewayv2DomainNameMutualTlsAuthentication[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#timeouts Apigatewayv2DomainName#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: Apigatewayv2DomainNameTimeouts;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameDomainNameConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#certificate_arn Apigatewayv2DomainName#certificate_arn}.
     *
     * @stability stable
     */
    readonly certificateArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#endpoint_type Apigatewayv2DomainName#endpoint_type}.
     *
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#security_policy Apigatewayv2DomainName#security_policy}.
     *
     * @stability stable
     */
    readonly securityPolicy: string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameMutualTlsAuthentication {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#truststore_uri Apigatewayv2DomainName#truststore_uri}.
     *
     * @stability stable
     */
    readonly truststoreUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#truststore_version Apigatewayv2DomainName#truststore_version}.
     *
     * @stability stable
     */
    readonly truststoreVersion?: string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#create Apigatewayv2DomainName#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#update Apigatewayv2DomainName#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html aws_apigatewayv2_domain_name}.
 *
 * @stability stable
 */
export declare class Apigatewayv2DomainName extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html aws_apigatewayv2_domain_name} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2DomainNameConfig);
    /**
     * @stability stable
     */
    get apiMappingSelectionExpression(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _domainNameConfiguration;
    /**
     * @stability stable
     */
    get domainNameConfiguration(): Apigatewayv2DomainNameDomainNameConfiguration[];
    /**
     * @stability stable
     */
    set domainNameConfiguration(value: Apigatewayv2DomainNameDomainNameConfiguration[]);
    /**
     * @stability stable
     */
    get domainNameConfigurationInput(): Apigatewayv2DomainNameDomainNameConfiguration[];
    private _mutualTlsAuthentication?;
    /**
     * @stability stable
     */
    get mutualTlsAuthentication(): Apigatewayv2DomainNameMutualTlsAuthentication[];
    /**
     * @stability stable
     */
    set mutualTlsAuthentication(value: Apigatewayv2DomainNameMutualTlsAuthentication[]);
    /**
     * @stability stable
     */
    resetMutualTlsAuthentication(): void;
    /**
     * @stability stable
     */
    get mutualTlsAuthenticationInput(): Apigatewayv2DomainNameMutualTlsAuthentication[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Apigatewayv2DomainNameTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Apigatewayv2DomainNameTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Apigatewayv2DomainNameTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
