import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#mesh_name AppmeshGatewayRoute#mesh_name}.
     *
     * @stability stable
     */
    readonly meshName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#mesh_owner AppmeshGatewayRoute#mesh_owner}.
     *
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#name AppmeshGatewayRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#tags AppmeshGatewayRoute#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#tags_all AppmeshGatewayRoute#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_gateway_name AppmeshGatewayRoute#virtual_gateway_name}.
     *
     * @stability stable
     */
    readonly virtualGatewayName: string;
    /**
     * spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#spec AppmeshGatewayRoute#spec}
     *
     * @stability stable
     */
    readonly spec: AppmeshGatewayRouteSpec[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service_name AppmeshGatewayRoute#virtual_service_name}.
     *
     * @stability stable
     */
    readonly virtualServiceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteActionTarget {
    /**
     * virtual_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service AppmeshGatewayRoute#virtual_service}
     *
     * @stability stable
     */
    readonly virtualService: AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteAction {
    /**
     * target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#target AppmeshGatewayRoute#target}
     *
     * @stability stable
     */
    readonly target: AppmeshGatewayRouteSpecGrpcRouteActionTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#service_name AppmeshGatewayRoute#service_name}.
     *
     * @stability stable
     */
    readonly serviceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#action AppmeshGatewayRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshGatewayRouteSpecGrpcRouteAction[];
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#match AppmeshGatewayRoute#match}
     *
     * @stability stable
     */
    readonly match: AppmeshGatewayRouteSpecGrpcRouteMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service_name AppmeshGatewayRoute#virtual_service_name}.
     *
     * @stability stable
     */
    readonly virtualServiceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteActionTarget {
    /**
     * virtual_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service AppmeshGatewayRoute#virtual_service}
     *
     * @stability stable
     */
    readonly virtualService: AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteAction {
    /**
     * target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#target AppmeshGatewayRoute#target}
     *
     * @stability stable
     */
    readonly target: AppmeshGatewayRouteSpecHttp2RouteActionTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#prefix AppmeshGatewayRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2Route {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#action AppmeshGatewayRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshGatewayRouteSpecHttp2RouteAction[];
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#match AppmeshGatewayRoute#match}
     *
     * @stability stable
     */
    readonly match: AppmeshGatewayRouteSpecHttp2RouteMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service_name AppmeshGatewayRoute#virtual_service_name}.
     *
     * @stability stable
     */
    readonly virtualServiceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteActionTarget {
    /**
     * virtual_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service AppmeshGatewayRoute#virtual_service}
     *
     * @stability stable
     */
    readonly virtualService: AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteAction {
    /**
     * target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#target AppmeshGatewayRoute#target}
     *
     * @stability stable
     */
    readonly target: AppmeshGatewayRouteSpecHttpRouteActionTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#prefix AppmeshGatewayRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#action AppmeshGatewayRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshGatewayRouteSpecHttpRouteAction[];
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#match AppmeshGatewayRoute#match}
     *
     * @stability stable
     */
    readonly match: AppmeshGatewayRouteSpecHttpRouteMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpec {
    /**
     * grpc_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#grpc_route AppmeshGatewayRoute#grpc_route}
     *
     * @stability stable
     */
    readonly grpcRoute?: AppmeshGatewayRouteSpecGrpcRoute[];
    /**
     * http2_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#http2_route AppmeshGatewayRoute#http2_route}
     *
     * @stability stable
     */
    readonly http2Route?: AppmeshGatewayRouteSpecHttp2Route[];
    /**
     * http_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#http_route AppmeshGatewayRoute#http_route}
     *
     * @stability stable
     */
    readonly httpRoute?: AppmeshGatewayRouteSpecHttpRoute[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html aws_appmesh_gateway_route}.
 *
 * @stability stable
 */
export declare class AppmeshGatewayRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html aws_appmesh_gateway_route} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshGatewayRouteConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _virtualGatewayName;
    /**
     * @stability stable
     */
    get virtualGatewayName(): string;
    /**
     * @stability stable
     */
    set virtualGatewayName(value: string);
    /**
     * @stability stable
     */
    get virtualGatewayNameInput(): string;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshGatewayRouteSpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshGatewayRouteSpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshGatewayRouteSpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
