import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#mesh_name AppmeshVirtualGateway#mesh_name}.
     *
     * @stability stable
     */
    readonly meshName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#mesh_owner AppmeshVirtualGateway#mesh_owner}.
     *
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#name AppmeshVirtualGateway#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tags AppmeshVirtualGateway#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tags_all AppmeshVirtualGateway#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#spec AppmeshVirtualGateway#spec}
     *
     * @stability stable
     */
    readonly spec: AppmeshVirtualGatewaySpec[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#private_key AppmeshVirtualGateway#private_key}.
     *
     * @stability stable
     */
    readonly privateKey: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificate {
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFile[];
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#exact AppmeshVirtualGateway#exact}.
     *
     * @stability stable
     */
    readonly exact: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#match AppmeshVirtualGateway#match}
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_authority_arns AppmeshVirtualGateway#certificate_authority_arns}.
     *
     * @stability stable
     */
    readonly certificateAuthorityArns: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust {
    /**
     * acm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#acm AppmeshVirtualGateway#acm}
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm[];
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile[];
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#subject_alternative_names AppmeshVirtualGateway#subject_alternative_names}
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames[];
    /**
     * trust block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#trust AppmeshVirtualGateway#trust}
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#enforce AppmeshVirtualGateway#enforce}.
     *
     * @stability stable
     */
    readonly enforce?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#ports AppmeshVirtualGateway#ports}.
     *
     * @stability stable
     */
    readonly ports?: number[];
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate AppmeshVirtualGateway#certificate}
     *
     * @stability stable
     */
    readonly certificate?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificate[];
    /**
     * validation block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#validation AppmeshVirtualGateway#validation}
     *
     * @stability stable
     */
    readonly validation: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy {
    /**
     * tls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tls AppmeshVirtualGateway#tls}
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaults {
    /**
     * client_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#client_policy AppmeshVirtualGateway#client_policy}
     *
     * @stability stable
     */
    readonly clientPolicy?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_requests AppmeshVirtualGateway#max_requests}.
     *
     * @stability stable
     */
    readonly maxRequests: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPoolHttp {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_connections AppmeshVirtualGateway#max_connections}.
     *
     * @stability stable
     */
    readonly maxConnections: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_pending_requests AppmeshVirtualGateway#max_pending_requests}.
     *
     * @stability stable
     */
    readonly maxPendingRequests?: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_requests AppmeshVirtualGateway#max_requests}.
     *
     * @stability stable
     */
    readonly maxRequests: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPool {
    /**
     * grpc block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#grpc AppmeshVirtualGateway#grpc}
     *
     * @stability stable
     */
    readonly grpc?: AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc[];
    /**
     * http block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#http AppmeshVirtualGateway#http}
     *
     * @stability stable
     */
    readonly http?: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp[];
    /**
     * http2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#http2 AppmeshVirtualGateway#http2}
     *
     * @stability stable
     */
    readonly http2?: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerHealthCheck {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#healthy_threshold AppmeshVirtualGateway#healthy_threshold}.
     *
     * @stability stable
     */
    readonly healthyThreshold: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#interval_millis AppmeshVirtualGateway#interval_millis}.
     *
     * @stability stable
     */
    readonly intervalMillis: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#path AppmeshVirtualGateway#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#port AppmeshVirtualGateway#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#protocol AppmeshVirtualGateway#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#timeout_millis AppmeshVirtualGateway#timeout_millis}.
     *
     * @stability stable
     */
    readonly timeoutMillis: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#unhealthy_threshold AppmeshVirtualGateway#unhealthy_threshold}.
     *
     * @stability stable
     */
    readonly unhealthyThreshold: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerPortMapping {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#port AppmeshVirtualGateway#port}.
     *
     * @stability stable
     */
    readonly port: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#protocol AppmeshVirtualGateway#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsCertificateAcm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_arn AppmeshVirtualGateway#certificate_arn}.
     *
     * @stability stable
     */
    readonly certificateArn: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsCertificateFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#private_key AppmeshVirtualGateway#private_key}.
     *
     * @stability stable
     */
    readonly privateKey: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsCertificateSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsCertificate {
    /**
     * acm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#acm AppmeshVirtualGateway#acm}
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualGatewaySpecListenerTlsCertificateAcm[];
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecListenerTlsCertificateFile[];
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualGatewaySpecListenerTlsCertificateSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#exact AppmeshVirtualGateway#exact}.
     *
     * @stability stable
     */
    readonly exact: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#match AppmeshVirtualGateway#match}
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsValidationTrustFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsValidationTrustSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsValidationTrust {
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecListenerTlsValidationTrustFile[];
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualGatewaySpecListenerTlsValidationTrustSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#subject_alternative_names AppmeshVirtualGateway#subject_alternative_names}
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNames[];
    /**
     * trust block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#trust AppmeshVirtualGateway#trust}
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualGatewaySpecListenerTlsValidationTrust[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#mode AppmeshVirtualGateway#mode}.
     *
     * @stability stable
     */
    readonly mode: string;
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate AppmeshVirtualGateway#certificate}
     *
     * @stability stable
     */
    readonly certificate: AppmeshVirtualGatewaySpecListenerTlsCertificate[];
    /**
     * validation block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#validation AppmeshVirtualGateway#validation}
     *
     * @stability stable
     */
    readonly validation?: AppmeshVirtualGatewaySpecListenerTlsValidation[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListener {
    /**
     * connection_pool block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#connection_pool AppmeshVirtualGateway#connection_pool}
     *
     * @stability stable
     */
    readonly connectionPool?: AppmeshVirtualGatewaySpecListenerConnectionPool[];
    /**
     * health_check block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#health_check AppmeshVirtualGateway#health_check}
     *
     * @stability stable
     */
    readonly healthCheck?: AppmeshVirtualGatewaySpecListenerHealthCheck[];
    /**
     * port_mapping block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#port_mapping AppmeshVirtualGateway#port_mapping}
     *
     * @stability stable
     */
    readonly portMapping: AppmeshVirtualGatewaySpecListenerPortMapping[];
    /**
     * tls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tls AppmeshVirtualGateway#tls}
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualGatewaySpecListenerTls[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecLoggingAccessLogFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#path AppmeshVirtualGateway#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecLoggingAccessLog {
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecLoggingAccessLogFile[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecLogging {
    /**
     * access_log block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#access_log AppmeshVirtualGateway#access_log}
     *
     * @stability stable
     */
    readonly accessLog?: AppmeshVirtualGatewaySpecLoggingAccessLog[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpec {
    /**
     * backend_defaults block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#backend_defaults AppmeshVirtualGateway#backend_defaults}
     *
     * @stability stable
     */
    readonly backendDefaults?: AppmeshVirtualGatewaySpecBackendDefaults[];
    /**
     * listener block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#listener AppmeshVirtualGateway#listener}
     *
     * @stability stable
     */
    readonly listener: AppmeshVirtualGatewaySpecListener[];
    /**
     * logging block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#logging AppmeshVirtualGateway#logging}
     *
     * @stability stable
     */
    readonly logging?: AppmeshVirtualGatewaySpecLogging[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html aws_appmesh_virtual_gateway}.
 *
 * @stability stable
 */
export declare class AppmeshVirtualGateway extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html aws_appmesh_virtual_gateway} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshVirtualGatewayConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshVirtualGatewaySpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshVirtualGatewaySpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshVirtualGatewaySpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
