import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppstreamFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#description AppstreamFleet#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#disconnect_timeout_in_seconds AppstreamFleet#disconnect_timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly disconnectTimeoutInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#display_name AppstreamFleet#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#enable_default_internet_access AppstreamFleet#enable_default_internet_access}.
     *
     * @stability stable
     */
    readonly enableDefaultInternetAccess?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#fleet_type AppstreamFleet#fleet_type}.
     *
     * @stability stable
     */
    readonly fleetType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#iam_role_arn AppstreamFleet#iam_role_arn}.
     *
     * @stability stable
     */
    readonly iamRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#idle_disconnect_timeout_in_seconds AppstreamFleet#idle_disconnect_timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly idleDisconnectTimeoutInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#image_arn AppstreamFleet#image_arn}.
     *
     * @stability stable
     */
    readonly imageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#image_name AppstreamFleet#image_name}.
     *
     * @stability stable
     */
    readonly imageName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#instance_type AppstreamFleet#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#max_user_duration_in_seconds AppstreamFleet#max_user_duration_in_seconds}.
     *
     * @stability stable
     */
    readonly maxUserDurationInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#name AppstreamFleet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#stream_view AppstreamFleet#stream_view}.
     *
     * @stability stable
     */
    readonly streamView?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#tags AppstreamFleet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#tags_all AppstreamFleet#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * compute_capacity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#compute_capacity AppstreamFleet#compute_capacity}
     *
     * @stability stable
     */
    readonly computeCapacity: AppstreamFleetComputeCapacity[];
    /**
     * domain_join_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#domain_join_info AppstreamFleet#domain_join_info}
     *
     * @stability stable
     */
    readonly domainJoinInfo?: AppstreamFleetDomainJoinInfo[];
    /**
     * vpc_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#vpc_config AppstreamFleet#vpc_config}
     *
     * @stability stable
     */
    readonly vpcConfig?: AppstreamFleetVpcConfig[];
}
/**
 * @stability stable
 */
export interface AppstreamFleetComputeCapacity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#desired_instances AppstreamFleet#desired_instances}.
     *
     * @stability stable
     */
    readonly desiredInstances: number;
}
/**
 * @stability stable
 */
export interface AppstreamFleetDomainJoinInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#directory_name AppstreamFleet#directory_name}.
     *
     * @stability stable
     */
    readonly directoryName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#organizational_unit_distinguished_name AppstreamFleet#organizational_unit_distinguished_name}.
     *
     * @stability stable
     */
    readonly organizationalUnitDistinguishedName?: string;
}
/**
 * @stability stable
 */
export interface AppstreamFleetVpcConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#security_group_ids AppstreamFleet#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#subnet_ids AppstreamFleet#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html aws_appstream_fleet}.
 *
 * @stability stable
 */
export declare class AppstreamFleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html aws_appstream_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppstreamFleetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disconnectTimeoutInSeconds?;
    /**
     * @stability stable
     */
    get disconnectTimeoutInSeconds(): number;
    /**
     * @stability stable
     */
    set disconnectTimeoutInSeconds(value: number);
    /**
     * @stability stable
     */
    resetDisconnectTimeoutInSeconds(): void;
    /**
     * @stability stable
     */
    get disconnectTimeoutInSecondsInput(): number | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _enableDefaultInternetAccess?;
    /**
     * @stability stable
     */
    get enableDefaultInternetAccess(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableDefaultInternetAccess(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableDefaultInternetAccess(): void;
    /**
     * @stability stable
     */
    get enableDefaultInternetAccessInput(): boolean | cdktf.IResolvable | undefined;
    private _fleetType?;
    /**
     * @stability stable
     */
    get fleetType(): string;
    /**
     * @stability stable
     */
    set fleetType(value: string);
    /**
     * @stability stable
     */
    resetFleetType(): void;
    /**
     * @stability stable
     */
    get fleetTypeInput(): string | undefined;
    private _iamRoleArn?;
    /**
     * @stability stable
     */
    get iamRoleArn(): string;
    /**
     * @stability stable
     */
    set iamRoleArn(value: string);
    /**
     * @stability stable
     */
    resetIamRoleArn(): void;
    /**
     * @stability stable
     */
    get iamRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _idleDisconnectTimeoutInSeconds?;
    /**
     * @stability stable
     */
    get idleDisconnectTimeoutInSeconds(): number;
    /**
     * @stability stable
     */
    set idleDisconnectTimeoutInSeconds(value: number);
    /**
     * @stability stable
     */
    resetIdleDisconnectTimeoutInSeconds(): void;
    /**
     * @stability stable
     */
    get idleDisconnectTimeoutInSecondsInput(): number | undefined;
    private _imageArn?;
    /**
     * @stability stable
     */
    get imageArn(): string;
    /**
     * @stability stable
     */
    set imageArn(value: string);
    /**
     * @stability stable
     */
    resetImageArn(): void;
    /**
     * @stability stable
     */
    get imageArnInput(): string | undefined;
    private _imageName?;
    /**
     * @stability stable
     */
    get imageName(): string;
    /**
     * @stability stable
     */
    set imageName(value: string);
    /**
     * @stability stable
     */
    resetImageName(): void;
    /**
     * @stability stable
     */
    get imageNameInput(): string | undefined;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    private _maxUserDurationInSeconds?;
    /**
     * @stability stable
     */
    get maxUserDurationInSeconds(): number;
    /**
     * @stability stable
     */
    set maxUserDurationInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaxUserDurationInSeconds(): void;
    /**
     * @stability stable
     */
    get maxUserDurationInSecondsInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get state(): string;
    private _streamView?;
    /**
     * @stability stable
     */
    get streamView(): string;
    /**
     * @stability stable
     */
    set streamView(value: string);
    /**
     * @stability stable
     */
    resetStreamView(): void;
    /**
     * @stability stable
     */
    get streamViewInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _computeCapacity;
    /**
     * @stability stable
     */
    get computeCapacity(): AppstreamFleetComputeCapacity[];
    /**
     * @stability stable
     */
    set computeCapacity(value: AppstreamFleetComputeCapacity[]);
    /**
     * @stability stable
     */
    get computeCapacityInput(): AppstreamFleetComputeCapacity[];
    private _domainJoinInfo?;
    /**
     * @stability stable
     */
    get domainJoinInfo(): AppstreamFleetDomainJoinInfo[];
    /**
     * @stability stable
     */
    set domainJoinInfo(value: AppstreamFleetDomainJoinInfo[]);
    /**
     * @stability stable
     */
    resetDomainJoinInfo(): void;
    /**
     * @stability stable
     */
    get domainJoinInfoInput(): AppstreamFleetDomainJoinInfo[] | undefined;
    private _vpcConfig?;
    /**
     * @stability stable
     */
    get vpcConfig(): AppstreamFleetVpcConfig[];
    /**
     * @stability stable
     */
    set vpcConfig(value: AppstreamFleetVpcConfig[]);
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): AppstreamFleetVpcConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
