import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppstreamStackConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#description AppstreamStack#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#display_name AppstreamStack#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#embed_host_domains AppstreamStack#embed_host_domains}.
     *
     * @stability stable
     */
    readonly embedHostDomains?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#feedback_url AppstreamStack#feedback_url}.
     *
     * @stability stable
     */
    readonly feedbackUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#name AppstreamStack#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#redirect_url AppstreamStack#redirect_url}.
     *
     * @stability stable
     */
    readonly redirectUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#tags AppstreamStack#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#tags_all AppstreamStack#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * access_endpoints block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#access_endpoints AppstreamStack#access_endpoints}
     *
     * @stability stable
     */
    readonly accessEndpoints?: AppstreamStackAccessEndpoints[];
    /**
     * application_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#application_settings AppstreamStack#application_settings}
     *
     * @stability stable
     */
    readonly applicationSettings?: AppstreamStackApplicationSettings[];
    /**
     * storage_connectors block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#storage_connectors AppstreamStack#storage_connectors}
     *
     * @stability stable
     */
    readonly storageConnectors?: AppstreamStackStorageConnectors[];
    /**
     * user_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#user_settings AppstreamStack#user_settings}
     *
     * @stability stable
     */
    readonly userSettings?: AppstreamStackUserSettings[];
}
/**
 * @stability stable
 */
export interface AppstreamStackAccessEndpoints {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#endpoint_type AppstreamStack#endpoint_type}.
     *
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#vpce_id AppstreamStack#vpce_id}.
     *
     * @stability stable
     */
    readonly vpceId?: string;
}
/**
 * @stability stable
 */
export interface AppstreamStackApplicationSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#enabled AppstreamStack#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#settings_group AppstreamStack#settings_group}.
     *
     * @stability stable
     */
    readonly settingsGroup?: string;
}
/**
 * @stability stable
 */
export interface AppstreamStackStorageConnectors {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#connector_type AppstreamStack#connector_type}.
     *
     * @stability stable
     */
    readonly connectorType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#domains AppstreamStack#domains}.
     *
     * @stability stable
     */
    readonly domains?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#resource_identifier AppstreamStack#resource_identifier}.
     *
     * @stability stable
     */
    readonly resourceIdentifier?: string;
}
/**
 * @stability stable
 */
export interface AppstreamStackUserSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#action AppstreamStack#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#permission AppstreamStack#permission}.
     *
     * @stability stable
     */
    readonly permission: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html aws_appstream_stack}.
 *
 * @stability stable
 */
export declare class AppstreamStack extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html aws_appstream_stack} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppstreamStackConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _embedHostDomains?;
    /**
     * @stability stable
     */
    get embedHostDomains(): string[];
    /**
     * @stability stable
     */
    set embedHostDomains(value: string[]);
    /**
     * @stability stable
     */
    resetEmbedHostDomains(): void;
    /**
     * @stability stable
     */
    get embedHostDomainsInput(): string[] | undefined;
    private _feedbackUrl?;
    /**
     * @stability stable
     */
    get feedbackUrl(): string;
    /**
     * @stability stable
     */
    set feedbackUrl(value: string);
    /**
     * @stability stable
     */
    resetFeedbackUrl(): void;
    /**
     * @stability stable
     */
    get feedbackUrlInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _redirectUrl?;
    /**
     * @stability stable
     */
    get redirectUrl(): string;
    /**
     * @stability stable
     */
    set redirectUrl(value: string);
    /**
     * @stability stable
     */
    resetRedirectUrl(): void;
    /**
     * @stability stable
     */
    get redirectUrlInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _accessEndpoints?;
    /**
     * @stability stable
     */
    get accessEndpoints(): AppstreamStackAccessEndpoints[];
    /**
     * @stability stable
     */
    set accessEndpoints(value: AppstreamStackAccessEndpoints[]);
    /**
     * @stability stable
     */
    resetAccessEndpoints(): void;
    /**
     * @stability stable
     */
    get accessEndpointsInput(): AppstreamStackAccessEndpoints[] | undefined;
    private _applicationSettings?;
    /**
     * @stability stable
     */
    get applicationSettings(): AppstreamStackApplicationSettings[];
    /**
     * @stability stable
     */
    set applicationSettings(value: AppstreamStackApplicationSettings[]);
    /**
     * @stability stable
     */
    resetApplicationSettings(): void;
    /**
     * @stability stable
     */
    get applicationSettingsInput(): AppstreamStackApplicationSettings[] | undefined;
    private _storageConnectors?;
    /**
     * @stability stable
     */
    get storageConnectors(): AppstreamStackStorageConnectors[];
    /**
     * @stability stable
     */
    set storageConnectors(value: AppstreamStackStorageConnectors[]);
    /**
     * @stability stable
     */
    resetStorageConnectors(): void;
    /**
     * @stability stable
     */
    get storageConnectorsInput(): AppstreamStackStorageConnectors[] | undefined;
    private _userSettings?;
    /**
     * @stability stable
     */
    get userSettings(): AppstreamStackUserSettings[];
    /**
     * @stability stable
     */
    set userSettings(value: AppstreamStackUserSettings[]);
    /**
     * @stability stable
     */
    resetUserSettings(): void;
    /**
     * @stability stable
     */
    get userSettingsInput(): AppstreamStackUserSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
