import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BackupRegionSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_region_settings.html#resource_type_opt_in_preference BackupRegionSettings#resource_type_opt_in_preference}.
     *
     * @stability stable
     */
    readonly resourceTypeOptInPreference: {
        [key: string]: boolean;
    } | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/backup_region_settings.html aws_backup_region_settings}.
 *
 * @stability stable
 */
export declare class BackupRegionSettings extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/backup_region_settings.html aws_backup_region_settings} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BackupRegionSettingsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _resourceTypeOptInPreference;
    /**
     * @stability stable
     */
    get resourceTypeOptInPreference(): {
        [key: string]: boolean;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set resourceTypeOptInPreference(value: {
        [key: string]: boolean;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get resourceTypeOptInPreferenceInput(): cdktf.IResolvable | {
        [key: string]: boolean;
    };
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
