import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BackupVaultNotificationsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_notifications.html#backup_vault_events BackupVaultNotifications#backup_vault_events}.
     *
     * @stability stable
     */
    readonly backupVaultEvents: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_notifications.html#backup_vault_name BackupVaultNotifications#backup_vault_name}.
     *
     * @stability stable
     */
    readonly backupVaultName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_notifications.html#sns_topic_arn BackupVaultNotifications#sns_topic_arn}.
     *
     * @stability stable
     */
    readonly snsTopicArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_notifications.html aws_backup_vault_notifications}.
 *
 * @stability stable
 */
export declare class BackupVaultNotifications extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_notifications.html aws_backup_vault_notifications} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BackupVaultNotificationsConfig);
    /**
     * @stability stable
     */
    get backupVaultArn(): string;
    private _backupVaultEvents;
    /**
     * @stability stable
     */
    get backupVaultEvents(): string[];
    /**
     * @stability stable
     */
    set backupVaultEvents(value: string[]);
    /**
     * @stability stable
     */
    get backupVaultEventsInput(): string[];
    private _backupVaultName;
    /**
     * @stability stable
     */
    get backupVaultName(): string;
    /**
     * @stability stable
     */
    set backupVaultName(value: string);
    /**
     * @stability stable
     */
    get backupVaultNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _snsTopicArn;
    /**
     * @stability stable
     */
    get snsTopicArn(): string;
    /**
     * @stability stable
     */
    set snsTopicArn(value: string);
    /**
     * @stability stable
     */
    get snsTopicArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
