import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BudgetsBudgetActionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#account_id BudgetsBudgetAction#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_type BudgetsBudgetAction#action_type}.
     *
     * @stability stable
     */
    readonly actionType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#approval_model BudgetsBudgetAction#approval_model}.
     *
     * @stability stable
     */
    readonly approvalModel: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#budget_name BudgetsBudgetAction#budget_name}.
     *
     * @stability stable
     */
    readonly budgetName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#execution_role_arn BudgetsBudgetAction#execution_role_arn}.
     *
     * @stability stable
     */
    readonly executionRoleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#notification_type BudgetsBudgetAction#notification_type}.
     *
     * @stability stable
     */
    readonly notificationType: string;
    /**
     * action_threshold block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_threshold BudgetsBudgetAction#action_threshold}
     *
     * @stability stable
     */
    readonly actionThreshold: BudgetsBudgetActionActionThreshold[];
    /**
     * definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#definition BudgetsBudgetAction#definition}
     *
     * @stability stable
     */
    readonly definition: BudgetsBudgetActionDefinition[];
    /**
     * subscriber block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#subscriber BudgetsBudgetAction#subscriber}
     *
     * @stability stable
     */
    readonly subscriber: BudgetsBudgetActionSubscriber[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionActionThreshold {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_threshold_type BudgetsBudgetAction#action_threshold_type}.
     *
     * @stability stable
     */
    readonly actionThresholdType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_threshold_value BudgetsBudgetAction#action_threshold_value}.
     *
     * @stability stable
     */
    readonly actionThresholdValue: number;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinitionIamActionDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#groups BudgetsBudgetAction#groups}.
     *
     * @stability stable
     */
    readonly groups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#policy_arn BudgetsBudgetAction#policy_arn}.
     *
     * @stability stable
     */
    readonly policyArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#roles BudgetsBudgetAction#roles}.
     *
     * @stability stable
     */
    readonly roles?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#users BudgetsBudgetAction#users}.
     *
     * @stability stable
     */
    readonly users?: string[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinitionScpActionDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#policy_id BudgetsBudgetAction#policy_id}.
     *
     * @stability stable
     */
    readonly policyId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#target_ids BudgetsBudgetAction#target_ids}.
     *
     * @stability stable
     */
    readonly targetIds: string[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinitionSsmActionDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_sub_type BudgetsBudgetAction#action_sub_type}.
     *
     * @stability stable
     */
    readonly actionSubType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#instance_ids BudgetsBudgetAction#instance_ids}.
     *
     * @stability stable
     */
    readonly instanceIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#region BudgetsBudgetAction#region}.
     *
     * @stability stable
     */
    readonly region: string;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinition {
    /**
     * iam_action_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#iam_action_definition BudgetsBudgetAction#iam_action_definition}
     *
     * @stability stable
     */
    readonly iamActionDefinition?: BudgetsBudgetActionDefinitionIamActionDefinition[];
    /**
     * scp_action_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#scp_action_definition BudgetsBudgetAction#scp_action_definition}
     *
     * @stability stable
     */
    readonly scpActionDefinition?: BudgetsBudgetActionDefinitionScpActionDefinition[];
    /**
     * ssm_action_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#ssm_action_definition BudgetsBudgetAction#ssm_action_definition}
     *
     * @stability stable
     */
    readonly ssmActionDefinition?: BudgetsBudgetActionDefinitionSsmActionDefinition[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionSubscriber {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#address BudgetsBudgetAction#address}.
     *
     * @stability stable
     */
    readonly address: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#subscription_type BudgetsBudgetAction#subscription_type}.
     *
     * @stability stable
     */
    readonly subscriptionType: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html aws_budgets_budget_action}.
 *
 * @stability stable
 */
export declare class BudgetsBudgetAction extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html aws_budgets_budget_action} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BudgetsBudgetActionConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get actionId(): string;
    private _actionType;
    /**
     * @stability stable
     */
    get actionType(): string;
    /**
     * @stability stable
     */
    set actionType(value: string);
    /**
     * @stability stable
     */
    get actionTypeInput(): string;
    private _approvalModel;
    /**
     * @stability stable
     */
    get approvalModel(): string;
    /**
     * @stability stable
     */
    set approvalModel(value: string);
    /**
     * @stability stable
     */
    get approvalModelInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _budgetName;
    /**
     * @stability stable
     */
    get budgetName(): string;
    /**
     * @stability stable
     */
    set budgetName(value: string);
    /**
     * @stability stable
     */
    get budgetNameInput(): string;
    private _executionRoleArn;
    /**
     * @stability stable
     */
    get executionRoleArn(): string;
    /**
     * @stability stable
     */
    set executionRoleArn(value: string);
    /**
     * @stability stable
     */
    get executionRoleArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _notificationType;
    /**
     * @stability stable
     */
    get notificationType(): string;
    /**
     * @stability stable
     */
    set notificationType(value: string);
    /**
     * @stability stable
     */
    get notificationTypeInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _actionThreshold;
    /**
     * @stability stable
     */
    get actionThreshold(): BudgetsBudgetActionActionThreshold[];
    /**
     * @stability stable
     */
    set actionThreshold(value: BudgetsBudgetActionActionThreshold[]);
    /**
     * @stability stable
     */
    get actionThresholdInput(): BudgetsBudgetActionActionThreshold[];
    private _definition;
    /**
     * @stability stable
     */
    get definition(): BudgetsBudgetActionDefinition[];
    /**
     * @stability stable
     */
    set definition(value: BudgetsBudgetActionDefinition[]);
    /**
     * @stability stable
     */
    get definitionInput(): BudgetsBudgetActionDefinition[];
    private _subscriber;
    /**
     * @stability stable
     */
    get subscriber(): BudgetsBudgetActionSubscriber[];
    /**
     * @stability stable
     */
    set subscriber(value: BudgetsBudgetActionSubscriber[]);
    /**
     * @stability stable
     */
    get subscriberInput(): BudgetsBudgetActionSubscriber[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
