import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BudgetsBudgetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#account_id BudgetsBudget#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#budget_type BudgetsBudget#budget_type}.
     *
     * @stability stable
     */
    readonly budgetType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#cost_filters BudgetsBudget#cost_filters}.
     *
     * @stability stable
     */
    readonly costFilters?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#limit_amount BudgetsBudget#limit_amount}.
     *
     * @stability stable
     */
    readonly limitAmount: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#limit_unit BudgetsBudget#limit_unit}.
     *
     * @stability stable
     */
    readonly limitUnit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#name BudgetsBudget#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#name_prefix BudgetsBudget#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#time_period_end BudgetsBudget#time_period_end}.
     *
     * @stability stable
     */
    readonly timePeriodEnd?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#time_period_start BudgetsBudget#time_period_start}.
     *
     * @stability stable
     */
    readonly timePeriodStart?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#time_unit BudgetsBudget#time_unit}.
     *
     * @stability stable
     */
    readonly timeUnit: string;
    /**
     * cost_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#cost_filter BudgetsBudget#cost_filter}
     *
     * @stability stable
     */
    readonly costFilter?: BudgetsBudgetCostFilter[];
    /**
     * cost_types block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#cost_types BudgetsBudget#cost_types}
     *
     * @stability stable
     */
    readonly costTypes?: BudgetsBudgetCostTypes[];
    /**
     * notification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#notification BudgetsBudget#notification}
     *
     * @stability stable
     */
    readonly notification?: BudgetsBudgetNotification[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetCostFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#name BudgetsBudget#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#values BudgetsBudget#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetCostTypes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_credit BudgetsBudget#include_credit}.
     *
     * @stability stable
     */
    readonly includeCredit?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_discount BudgetsBudget#include_discount}.
     *
     * @stability stable
     */
    readonly includeDiscount?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_other_subscription BudgetsBudget#include_other_subscription}.
     *
     * @stability stable
     */
    readonly includeOtherSubscription?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_recurring BudgetsBudget#include_recurring}.
     *
     * @stability stable
     */
    readonly includeRecurring?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_refund BudgetsBudget#include_refund}.
     *
     * @stability stable
     */
    readonly includeRefund?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_subscription BudgetsBudget#include_subscription}.
     *
     * @stability stable
     */
    readonly includeSubscription?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_support BudgetsBudget#include_support}.
     *
     * @stability stable
     */
    readonly includeSupport?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_tax BudgetsBudget#include_tax}.
     *
     * @stability stable
     */
    readonly includeTax?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_upfront BudgetsBudget#include_upfront}.
     *
     * @stability stable
     */
    readonly includeUpfront?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#use_amortized BudgetsBudget#use_amortized}.
     *
     * @stability stable
     */
    readonly useAmortized?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#use_blended BudgetsBudget#use_blended}.
     *
     * @stability stable
     */
    readonly useBlended?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetNotification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#comparison_operator BudgetsBudget#comparison_operator}.
     *
     * @stability stable
     */
    readonly comparisonOperator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#notification_type BudgetsBudget#notification_type}.
     *
     * @stability stable
     */
    readonly notificationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#subscriber_email_addresses BudgetsBudget#subscriber_email_addresses}.
     *
     * @stability stable
     */
    readonly subscriberEmailAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#subscriber_sns_topic_arns BudgetsBudget#subscriber_sns_topic_arns}.
     *
     * @stability stable
     */
    readonly subscriberSnsTopicArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#threshold BudgetsBudget#threshold}.
     *
     * @stability stable
     */
    readonly threshold: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#threshold_type BudgetsBudget#threshold_type}.
     *
     * @stability stable
     */
    readonly thresholdType: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html aws_budgets_budget}.
 *
 * @stability stable
 */
export declare class BudgetsBudget extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html aws_budgets_budget} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BudgetsBudgetConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _budgetType;
    /**
     * @stability stable
     */
    get budgetType(): string;
    /**
     * @stability stable
     */
    set budgetType(value: string);
    /**
     * @stability stable
     */
    get budgetTypeInput(): string;
    private _costFilters?;
    /**
     * @stability stable
     */
    get costFilters(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set costFilters(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCostFilters(): void;
    /**
     * @stability stable
     */
    get costFiltersInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _limitAmount;
    /**
     * @stability stable
     */
    get limitAmount(): string;
    /**
     * @stability stable
     */
    set limitAmount(value: string);
    /**
     * @stability stable
     */
    get limitAmountInput(): string;
    private _limitUnit;
    /**
     * @stability stable
     */
    get limitUnit(): string;
    /**
     * @stability stable
     */
    set limitUnit(value: string);
    /**
     * @stability stable
     */
    get limitUnitInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _timePeriodEnd?;
    /**
     * @stability stable
     */
    get timePeriodEnd(): string;
    /**
     * @stability stable
     */
    set timePeriodEnd(value: string);
    /**
     * @stability stable
     */
    resetTimePeriodEnd(): void;
    /**
     * @stability stable
     */
    get timePeriodEndInput(): string | undefined;
    private _timePeriodStart?;
    /**
     * @stability stable
     */
    get timePeriodStart(): string;
    /**
     * @stability stable
     */
    set timePeriodStart(value: string);
    /**
     * @stability stable
     */
    resetTimePeriodStart(): void;
    /**
     * @stability stable
     */
    get timePeriodStartInput(): string | undefined;
    private _timeUnit;
    /**
     * @stability stable
     */
    get timeUnit(): string;
    /**
     * @stability stable
     */
    set timeUnit(value: string);
    /**
     * @stability stable
     */
    get timeUnitInput(): string;
    private _costFilter?;
    /**
     * @stability stable
     */
    get costFilter(): BudgetsBudgetCostFilter[];
    /**
     * @stability stable
     */
    set costFilter(value: BudgetsBudgetCostFilter[]);
    /**
     * @stability stable
     */
    resetCostFilter(): void;
    /**
     * @stability stable
     */
    get costFilterInput(): BudgetsBudgetCostFilter[] | undefined;
    private _costTypes?;
    /**
     * @stability stable
     */
    get costTypes(): BudgetsBudgetCostTypes[];
    /**
     * @stability stable
     */
    set costTypes(value: BudgetsBudgetCostTypes[]);
    /**
     * @stability stable
     */
    resetCostTypes(): void;
    /**
     * @stability stable
     */
    get costTypesInput(): BudgetsBudgetCostTypes[] | undefined;
    private _notification?;
    /**
     * @stability stable
     */
    get notification(): BudgetsBudgetNotification[];
    /**
     * @stability stable
     */
    set notification(value: BudgetsBudgetNotification[]);
    /**
     * @stability stable
     */
    resetNotification(): void;
    /**
     * @stability stable
     */
    get notificationInput(): BudgetsBudgetNotification[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
