import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ChimeVoiceConnectorTerminationCredentialsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#voice_connector_id ChimeVoiceConnectorTerminationCredentials#voice_connector_id}.
     *
     * @stability stable
     */
    readonly voiceConnectorId: string;
    /**
     * credentials block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#credentials ChimeVoiceConnectorTerminationCredentials#credentials}
     *
     * @stability stable
     */
    readonly credentials: ChimeVoiceConnectorTerminationCredentialsCredentials[];
}
/**
 * @stability stable
 */
export interface ChimeVoiceConnectorTerminationCredentialsCredentials {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#password ChimeVoiceConnectorTerminationCredentials#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#username ChimeVoiceConnectorTerminationCredentials#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html aws_chime_voice_connector_termination_credentials}.
 *
 * @stability stable
 */
export declare class ChimeVoiceConnectorTerminationCredentials extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html aws_chime_voice_connector_termination_credentials} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ChimeVoiceConnectorTerminationCredentialsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _voiceConnectorId;
    /**
     * @stability stable
     */
    get voiceConnectorId(): string;
    /**
     * @stability stable
     */
    set voiceConnectorId(value: string);
    /**
     * @stability stable
     */
    get voiceConnectorIdInput(): string;
    private _credentials;
    /**
     * @stability stable
     */
    get credentials(): ChimeVoiceConnectorTerminationCredentialsCredentials[];
    /**
     * @stability stable
     */
    set credentials(value: ChimeVoiceConnectorTerminationCredentialsCredentials[]);
    /**
     * @stability stable
     */
    get credentialsInput(): ChimeVoiceConnectorTerminationCredentialsCredentials[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
