import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ChimeVoiceConnectorTerminationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#calling_regions ChimeVoiceConnectorTermination#calling_regions}.
     *
     * @stability stable
     */
    readonly callingRegions: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#cidr_allow_list ChimeVoiceConnectorTermination#cidr_allow_list}.
     *
     * @stability stable
     */
    readonly cidrAllowList: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#cps_limit ChimeVoiceConnectorTermination#cps_limit}.
     *
     * @stability stable
     */
    readonly cpsLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#default_phone_number ChimeVoiceConnectorTermination#default_phone_number}.
     *
     * @stability stable
     */
    readonly defaultPhoneNumber?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#disabled ChimeVoiceConnectorTermination#disabled}.
     *
     * @stability stable
     */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#voice_connector_id ChimeVoiceConnectorTermination#voice_connector_id}.
     *
     * @stability stable
     */
    readonly voiceConnectorId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html aws_chime_voice_connector_termination}.
 *
 * @stability stable
 */
export declare class ChimeVoiceConnectorTermination extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html aws_chime_voice_connector_termination} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ChimeVoiceConnectorTerminationConfig);
    private _callingRegions;
    /**
     * @stability stable
     */
    get callingRegions(): string[];
    /**
     * @stability stable
     */
    set callingRegions(value: string[]);
    /**
     * @stability stable
     */
    get callingRegionsInput(): string[];
    private _cidrAllowList;
    /**
     * @stability stable
     */
    get cidrAllowList(): string[];
    /**
     * @stability stable
     */
    set cidrAllowList(value: string[]);
    /**
     * @stability stable
     */
    get cidrAllowListInput(): string[];
    private _cpsLimit?;
    /**
     * @stability stable
     */
    get cpsLimit(): number;
    /**
     * @stability stable
     */
    set cpsLimit(value: number);
    /**
     * @stability stable
     */
    resetCpsLimit(): void;
    /**
     * @stability stable
     */
    get cpsLimitInput(): number | undefined;
    private _defaultPhoneNumber?;
    /**
     * @stability stable
     */
    get defaultPhoneNumber(): string;
    /**
     * @stability stable
     */
    set defaultPhoneNumber(value: string);
    /**
     * @stability stable
     */
    resetDefaultPhoneNumber(): void;
    /**
     * @stability stable
     */
    get defaultPhoneNumberInput(): string | undefined;
    private _disabled?;
    /**
     * @stability stable
     */
    get disabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set disabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDisabled(): void;
    /**
     * @stability stable
     */
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _voiceConnectorId;
    /**
     * @stability stable
     */
    get voiceConnectorId(): string;
    /**
     * @stability stable
     */
    set voiceConnectorId(value: string);
    /**
     * @stability stable
     */
    get voiceConnectorIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
