import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontMonitoringSubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#distribution_id CloudfrontMonitoringSubscription#distribution_id}.
     *
     * @stability stable
     */
    readonly distributionId: string;
    /**
     * monitoring_subscription block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#monitoring_subscription CloudfrontMonitoringSubscription#monitoring_subscription}
     *
     * @stability stable
     */
    readonly monitoringSubscription: CloudfrontMonitoringSubscriptionMonitoringSubscription[];
}
/**
 * @stability stable
 */
export interface CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#realtime_metrics_subscription_status CloudfrontMonitoringSubscription#realtime_metrics_subscription_status}.
     *
     * @stability stable
     */
    readonly realtimeMetricsSubscriptionStatus: string;
}
/**
 * @stability stable
 */
export interface CloudfrontMonitoringSubscriptionMonitoringSubscription {
    /**
     * realtime_metrics_subscription_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#realtime_metrics_subscription_config CloudfrontMonitoringSubscription#realtime_metrics_subscription_config}
     *
     * @stability stable
     */
    readonly realtimeMetricsSubscriptionConfig: CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfig[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html aws_cloudfront_monitoring_subscription}.
 *
 * @stability stable
 */
export declare class CloudfrontMonitoringSubscription extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html aws_cloudfront_monitoring_subscription} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontMonitoringSubscriptionConfig);
    private _distributionId;
    /**
     * @stability stable
     */
    get distributionId(): string;
    /**
     * @stability stable
     */
    set distributionId(value: string);
    /**
     * @stability stable
     */
    get distributionIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _monitoringSubscription;
    /**
     * @stability stable
     */
    get monitoringSubscription(): CloudfrontMonitoringSubscriptionMonitoringSubscription[];
    /**
     * @stability stable
     */
    set monitoringSubscription(value: CloudfrontMonitoringSubscriptionMonitoringSubscription[]);
    /**
     * @stability stable
     */
    get monitoringSubscriptionInput(): CloudfrontMonitoringSubscriptionMonitoringSubscription[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
