import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#fields CloudfrontRealtimeLogConfig#fields}.
     *
     * @stability stable
     */
    readonly fields: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#name CloudfrontRealtimeLogConfig#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#sampling_rate CloudfrontRealtimeLogConfig#sampling_rate}.
     *
     * @stability stable
     */
    readonly samplingRate: number;
    /**
     * endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#endpoint CloudfrontRealtimeLogConfig#endpoint}
     *
     * @stability stable
     */
    readonly endpoint: CloudfrontRealtimeLogConfigEndpoint[];
}
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#role_arn CloudfrontRealtimeLogConfig#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#stream_arn CloudfrontRealtimeLogConfig#stream_arn}.
     *
     * @stability stable
     */
    readonly streamArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#stream_type CloudfrontRealtimeLogConfig#stream_type}.
     *
     * @stability stable
     */
    readonly streamType: string;
    /**
     * kinesis_stream_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#kinesis_stream_config CloudfrontRealtimeLogConfig#kinesis_stream_config}
     *
     * @stability stable
     */
    readonly kinesisStreamConfig: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html aws_cloudfront_realtime_log_config}.
 *
 * @stability stable
 */
export declare class CloudfrontRealtimeLogConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html aws_cloudfront_realtime_log_config} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontRealtimeLogConfigConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _fields;
    /**
     * @stability stable
     */
    get fields(): string[];
    /**
     * @stability stable
     */
    set fields(value: string[]);
    /**
     * @stability stable
     */
    get fieldsInput(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _samplingRate;
    /**
     * @stability stable
     */
    get samplingRate(): number;
    /**
     * @stability stable
     */
    set samplingRate(value: number);
    /**
     * @stability stable
     */
    get samplingRateInput(): number;
    private _endpoint;
    /**
     * @stability stable
     */
    get endpoint(): CloudfrontRealtimeLogConfigEndpoint[];
    /**
     * @stability stable
     */
    set endpoint(value: CloudfrontRealtimeLogConfigEndpoint[]);
    /**
     * @stability stable
     */
    get endpointInput(): CloudfrontRealtimeLogConfigEndpoint[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
