import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchDashboardConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html#dashboard_body CloudwatchDashboard#dashboard_body}.
     *
     * @stability stable
     */
    readonly dashboardBody: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html#dashboard_name CloudwatchDashboard#dashboard_name}.
     *
     * @stability stable
     */
    readonly dashboardName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html aws_cloudwatch_dashboard}.
 *
 * @stability stable
 */
export declare class CloudwatchDashboard extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html aws_cloudwatch_dashboard} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchDashboardConfig);
    /**
     * @stability stable
     */
    get dashboardArn(): string;
    private _dashboardBody;
    /**
     * @stability stable
     */
    get dashboardBody(): string;
    /**
     * @stability stable
     */
    set dashboardBody(value: string);
    /**
     * @stability stable
     */
    get dashboardBodyInput(): string;
    private _dashboardName;
    /**
     * @stability stable
     */
    get dashboardName(): string;
    /**
     * @stability stable
     */
    set dashboardName(value: string);
    /**
     * @stability stable
     */
    get dashboardNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
