import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchMetricAlarmConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#actions_enabled CloudwatchMetricAlarm#actions_enabled}.
     *
     * @stability stable
     */
    readonly actionsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#alarm_actions CloudwatchMetricAlarm#alarm_actions}.
     *
     * @stability stable
     */
    readonly alarmActions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#alarm_description CloudwatchMetricAlarm#alarm_description}.
     *
     * @stability stable
     */
    readonly alarmDescription?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#alarm_name CloudwatchMetricAlarm#alarm_name}.
     *
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#comparison_operator CloudwatchMetricAlarm#comparison_operator}.
     *
     * @stability stable
     */
    readonly comparisonOperator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#datapoints_to_alarm CloudwatchMetricAlarm#datapoints_to_alarm}.
     *
     * @stability stable
     */
    readonly datapointsToAlarm?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#dimensions CloudwatchMetricAlarm#dimensions}.
     *
     * @stability stable
     */
    readonly dimensions?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#evaluate_low_sample_count_percentiles CloudwatchMetricAlarm#evaluate_low_sample_count_percentiles}.
     *
     * @stability stable
     */
    readonly evaluateLowSampleCountPercentiles?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#evaluation_periods CloudwatchMetricAlarm#evaluation_periods}.
     *
     * @stability stable
     */
    readonly evaluationPeriods: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#extended_statistic CloudwatchMetricAlarm#extended_statistic}.
     *
     * @stability stable
     */
    readonly extendedStatistic?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#insufficient_data_actions CloudwatchMetricAlarm#insufficient_data_actions}.
     *
     * @stability stable
     */
    readonly insufficientDataActions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric_name CloudwatchMetricAlarm#metric_name}.
     *
     * @stability stable
     */
    readonly metricName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#namespace CloudwatchMetricAlarm#namespace}.
     *
     * @stability stable
     */
    readonly namespace?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#ok_actions CloudwatchMetricAlarm#ok_actions}.
     *
     * @stability stable
     */
    readonly okActions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#period CloudwatchMetricAlarm#period}.
     *
     * @stability stable
     */
    readonly period?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#statistic CloudwatchMetricAlarm#statistic}.
     *
     * @stability stable
     */
    readonly statistic?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#tags CloudwatchMetricAlarm#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#tags_all CloudwatchMetricAlarm#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#threshold CloudwatchMetricAlarm#threshold}.
     *
     * @stability stable
     */
    readonly threshold?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#threshold_metric_id CloudwatchMetricAlarm#threshold_metric_id}.
     *
     * @stability stable
     */
    readonly thresholdMetricId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#treat_missing_data CloudwatchMetricAlarm#treat_missing_data}.
     *
     * @stability stable
     */
    readonly treatMissingData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#unit CloudwatchMetricAlarm#unit}.
     *
     * @stability stable
     */
    readonly unit?: string;
    /**
     * metric_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric_query CloudwatchMetricAlarm#metric_query}
     *
     * @stability stable
     */
    readonly metricQuery?: CloudwatchMetricAlarmMetricQuery[];
}
/**
 * @stability stable
 */
export interface CloudwatchMetricAlarmMetricQueryMetric {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#dimensions CloudwatchMetricAlarm#dimensions}.
     *
     * @stability stable
     */
    readonly dimensions?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric_name CloudwatchMetricAlarm#metric_name}.
     *
     * @stability stable
     */
    readonly metricName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#namespace CloudwatchMetricAlarm#namespace}.
     *
     * @stability stable
     */
    readonly namespace?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#period CloudwatchMetricAlarm#period}.
     *
     * @stability stable
     */
    readonly period: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#stat CloudwatchMetricAlarm#stat}.
     *
     * @stability stable
     */
    readonly stat: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#unit CloudwatchMetricAlarm#unit}.
     *
     * @stability stable
     */
    readonly unit?: string;
}
/**
 * @stability stable
 */
export interface CloudwatchMetricAlarmMetricQuery {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#account_id CloudwatchMetricAlarm#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#expression CloudwatchMetricAlarm#expression}.
     *
     * @stability stable
     */
    readonly expression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#id CloudwatchMetricAlarm#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#label CloudwatchMetricAlarm#label}.
     *
     * @stability stable
     */
    readonly label?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#return_data CloudwatchMetricAlarm#return_data}.
     *
     * @stability stable
     */
    readonly returnData?: boolean | cdktf.IResolvable;
    /**
     * metric block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric CloudwatchMetricAlarm#metric}
     *
     * @stability stable
     */
    readonly metric?: CloudwatchMetricAlarmMetricQueryMetric[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html aws_cloudwatch_metric_alarm}.
 *
 * @stability stable
 */
export declare class CloudwatchMetricAlarm extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html aws_cloudwatch_metric_alarm} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchMetricAlarmConfig);
    private _actionsEnabled?;
    /**
     * @stability stable
     */
    get actionsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set actionsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetActionsEnabled(): void;
    /**
     * @stability stable
     */
    get actionsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _alarmActions?;
    /**
     * @stability stable
     */
    get alarmActions(): string[];
    /**
     * @stability stable
     */
    set alarmActions(value: string[]);
    /**
     * @stability stable
     */
    resetAlarmActions(): void;
    /**
     * @stability stable
     */
    get alarmActionsInput(): string[] | undefined;
    private _alarmDescription?;
    /**
     * @stability stable
     */
    get alarmDescription(): string;
    /**
     * @stability stable
     */
    set alarmDescription(value: string);
    /**
     * @stability stable
     */
    resetAlarmDescription(): void;
    /**
     * @stability stable
     */
    get alarmDescriptionInput(): string | undefined;
    private _alarmName;
    /**
     * @stability stable
     */
    get alarmName(): string;
    /**
     * @stability stable
     */
    set alarmName(value: string);
    /**
     * @stability stable
     */
    get alarmNameInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _comparisonOperator;
    /**
     * @stability stable
     */
    get comparisonOperator(): string;
    /**
     * @stability stable
     */
    set comparisonOperator(value: string);
    /**
     * @stability stable
     */
    get comparisonOperatorInput(): string;
    private _datapointsToAlarm?;
    /**
     * @stability stable
     */
    get datapointsToAlarm(): number;
    /**
     * @stability stable
     */
    set datapointsToAlarm(value: number);
    /**
     * @stability stable
     */
    resetDatapointsToAlarm(): void;
    /**
     * @stability stable
     */
    get datapointsToAlarmInput(): number | undefined;
    private _dimensions?;
    /**
     * @stability stable
     */
    get dimensions(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set dimensions(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDimensions(): void;
    /**
     * @stability stable
     */
    get dimensionsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _evaluateLowSampleCountPercentiles?;
    /**
     * @stability stable
     */
    get evaluateLowSampleCountPercentiles(): string;
    /**
     * @stability stable
     */
    set evaluateLowSampleCountPercentiles(value: string);
    /**
     * @stability stable
     */
    resetEvaluateLowSampleCountPercentiles(): void;
    /**
     * @stability stable
     */
    get evaluateLowSampleCountPercentilesInput(): string | undefined;
    private _evaluationPeriods;
    /**
     * @stability stable
     */
    get evaluationPeriods(): number;
    /**
     * @stability stable
     */
    set evaluationPeriods(value: number);
    /**
     * @stability stable
     */
    get evaluationPeriodsInput(): number;
    private _extendedStatistic?;
    /**
     * @stability stable
     */
    get extendedStatistic(): string;
    /**
     * @stability stable
     */
    set extendedStatistic(value: string);
    /**
     * @stability stable
     */
    resetExtendedStatistic(): void;
    /**
     * @stability stable
     */
    get extendedStatisticInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _insufficientDataActions?;
    /**
     * @stability stable
     */
    get insufficientDataActions(): string[];
    /**
     * @stability stable
     */
    set insufficientDataActions(value: string[]);
    /**
     * @stability stable
     */
    resetInsufficientDataActions(): void;
    /**
     * @stability stable
     */
    get insufficientDataActionsInput(): string[] | undefined;
    private _metricName?;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    resetMetricName(): void;
    /**
     * @stability stable
     */
    get metricNameInput(): string | undefined;
    private _namespace?;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    set namespace(value: string);
    /**
     * @stability stable
     */
    resetNamespace(): void;
    /**
     * @stability stable
     */
    get namespaceInput(): string | undefined;
    private _okActions?;
    /**
     * @stability stable
     */
    get okActions(): string[];
    /**
     * @stability stable
     */
    set okActions(value: string[]);
    /**
     * @stability stable
     */
    resetOkActions(): void;
    /**
     * @stability stable
     */
    get okActionsInput(): string[] | undefined;
    private _period?;
    /**
     * @stability stable
     */
    get period(): number;
    /**
     * @stability stable
     */
    set period(value: number);
    /**
     * @stability stable
     */
    resetPeriod(): void;
    /**
     * @stability stable
     */
    get periodInput(): number | undefined;
    private _statistic?;
    /**
     * @stability stable
     */
    get statistic(): string;
    /**
     * @stability stable
     */
    set statistic(value: string);
    /**
     * @stability stable
     */
    resetStatistic(): void;
    /**
     * @stability stable
     */
    get statisticInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _threshold?;
    /**
     * @stability stable
     */
    get threshold(): number;
    /**
     * @stability stable
     */
    set threshold(value: number);
    /**
     * @stability stable
     */
    resetThreshold(): void;
    /**
     * @stability stable
     */
    get thresholdInput(): number | undefined;
    private _thresholdMetricId?;
    /**
     * @stability stable
     */
    get thresholdMetricId(): string;
    /**
     * @stability stable
     */
    set thresholdMetricId(value: string);
    /**
     * @stability stable
     */
    resetThresholdMetricId(): void;
    /**
     * @stability stable
     */
    get thresholdMetricIdInput(): string | undefined;
    private _treatMissingData?;
    /**
     * @stability stable
     */
    get treatMissingData(): string;
    /**
     * @stability stable
     */
    set treatMissingData(value: string);
    /**
     * @stability stable
     */
    resetTreatMissingData(): void;
    /**
     * @stability stable
     */
    get treatMissingDataInput(): string | undefined;
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    resetUnit(): void;
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _metricQuery?;
    /**
     * @stability stable
     */
    get metricQuery(): CloudwatchMetricAlarmMetricQuery[];
    /**
     * @stability stable
     */
    set metricQuery(value: CloudwatchMetricAlarmMetricQuery[]);
    /**
     * @stability stable
     */
    resetMetricQuery(): void;
    /**
     * @stability stable
     */
    get metricQueryInput(): CloudwatchMetricAlarmMetricQuery[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
