import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodeartifactRepositoryPermissionsPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codeartifact_repository_permissions_policy.html#domain CodeartifactRepositoryPermissionsPolicy#domain}.
     *
     * @stability stable
     */
    readonly domain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codeartifact_repository_permissions_policy.html#domain_owner CodeartifactRepositoryPermissionsPolicy#domain_owner}.
     *
     * @stability stable
     */
    readonly domainOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codeartifact_repository_permissions_policy.html#policy_document CodeartifactRepositoryPermissionsPolicy#policy_document}.
     *
     * @stability stable
     */
    readonly policyDocument: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codeartifact_repository_permissions_policy.html#policy_revision CodeartifactRepositoryPermissionsPolicy#policy_revision}.
     *
     * @stability stable
     */
    readonly policyRevision?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codeartifact_repository_permissions_policy.html#repository CodeartifactRepositoryPermissionsPolicy#repository}.
     *
     * @stability stable
     */
    readonly repository: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codeartifact_repository_permissions_policy.html aws_codeartifact_repository_permissions_policy}.
 *
 * @stability stable
 */
export declare class CodeartifactRepositoryPermissionsPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codeartifact_repository_permissions_policy.html aws_codeartifact_repository_permissions_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodeartifactRepositoryPermissionsPolicyConfig);
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    private _domainOwner?;
    /**
     * @stability stable
     */
    get domainOwner(): string;
    /**
     * @stability stable
     */
    set domainOwner(value: string);
    /**
     * @stability stable
     */
    resetDomainOwner(): void;
    /**
     * @stability stable
     */
    get domainOwnerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _policyDocument;
    /**
     * @stability stable
     */
    get policyDocument(): string;
    /**
     * @stability stable
     */
    set policyDocument(value: string);
    /**
     * @stability stable
     */
    get policyDocumentInput(): string;
    private _policyRevision?;
    /**
     * @stability stable
     */
    get policyRevision(): string;
    /**
     * @stability stable
     */
    set policyRevision(value: string);
    /**
     * @stability stable
     */
    resetPolicyRevision(): void;
    /**
     * @stability stable
     */
    get policyRevisionInput(): string | undefined;
    private _repository;
    /**
     * @stability stable
     */
    get repository(): string;
    /**
     * @stability stable
     */
    set repository(value: string);
    /**
     * @stability stable
     */
    get repositoryInput(): string;
    /**
     * @stability stable
     */
    get resourceArn(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
