import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodebuildProjectConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#badge_enabled CodebuildProject#badge_enabled}.
     *
     * @stability stable
     */
    readonly badgeEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_timeout CodebuildProject#build_timeout}.
     *
     * @stability stable
     */
    readonly buildTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#concurrent_build_limit CodebuildProject#concurrent_build_limit}.
     *
     * @stability stable
     */
    readonly concurrentBuildLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#description CodebuildProject#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_key CodebuildProject#encryption_key}.
     *
     * @stability stable
     */
    readonly encryptionKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#queued_timeout CodebuildProject#queued_timeout}.
     *
     * @stability stable
     */
    readonly queuedTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#service_role CodebuildProject#service_role}.
     *
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#source_version CodebuildProject#source_version}.
     *
     * @stability stable
     */
    readonly sourceVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#tags CodebuildProject#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#tags_all CodebuildProject#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * artifacts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#artifacts CodebuildProject#artifacts}
     *
     * @stability stable
     */
    readonly artifacts: CodebuildProjectArtifacts[];
    /**
     * build_batch_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_batch_config CodebuildProject#build_batch_config}
     *
     * @stability stable
     */
    readonly buildBatchConfig?: CodebuildProjectBuildBatchConfig[];
    /**
     * cache block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#cache CodebuildProject#cache}
     *
     * @stability stable
     */
    readonly cache?: CodebuildProjectCache[];
    /**
     * environment block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#environment CodebuildProject#environment}
     *
     * @stability stable
     */
    readonly environment: CodebuildProjectEnvironment[];
    /**
     * file_system_locations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#file_system_locations CodebuildProject#file_system_locations}
     *
     * @stability stable
     */
    readonly fileSystemLocations?: CodebuildProjectFileSystemLocations[];
    /**
     * logs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#logs_config CodebuildProject#logs_config}
     *
     * @stability stable
     */
    readonly logsConfig?: CodebuildProjectLogsConfig[];
    /**
     * secondary_artifacts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#secondary_artifacts CodebuildProject#secondary_artifacts}
     *
     * @stability stable
     */
    readonly secondaryArtifacts?: CodebuildProjectSecondaryArtifacts[];
    /**
     * secondary_sources block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#secondary_sources CodebuildProject#secondary_sources}
     *
     * @stability stable
     */
    readonly secondarySources?: CodebuildProjectSecondarySources[];
    /**
     * source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#source CodebuildProject#source}
     *
     * @stability stable
     */
    readonly source: CodebuildProjectSource[];
    /**
     * vpc_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#vpc_config CodebuildProject#vpc_config}
     *
     * @stability stable
     */
    readonly vpcConfig?: CodebuildProjectVpcConfig[];
}
/**
 * @stability stable
 */
export interface CodebuildProjectArtifacts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#artifact_identifier CodebuildProject#artifact_identifier}.
     *
     * @stability stable
     */
    readonly artifactIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_disabled CodebuildProject#encryption_disabled}.
     *
     * @stability stable
     */
    readonly encryptionDisabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#namespace_type CodebuildProject#namespace_type}.
     *
     * @stability stable
     */
    readonly namespaceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#override_artifact_name CodebuildProject#override_artifact_name}.
     *
     * @stability stable
     */
    readonly overrideArtifactName?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#packaging CodebuildProject#packaging}.
     *
     * @stability stable
     */
    readonly packaging?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#path CodebuildProject#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectBuildBatchConfigRestrictions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#compute_types_allowed CodebuildProject#compute_types_allowed}.
     *
     * @stability stable
     */
    readonly computeTypesAllowed?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#maximum_builds_allowed CodebuildProject#maximum_builds_allowed}.
     *
     * @stability stable
     */
    readonly maximumBuildsAllowed?: number;
}
/**
 * @stability stable
 */
export interface CodebuildProjectBuildBatchConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#combine_artifacts CodebuildProject#combine_artifacts}.
     *
     * @stability stable
     */
    readonly combineArtifacts?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#service_role CodebuildProject#service_role}.
     *
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#timeout_in_mins CodebuildProject#timeout_in_mins}.
     *
     * @stability stable
     */
    readonly timeoutInMins?: number;
    /**
     * restrictions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#restrictions CodebuildProject#restrictions}
     *
     * @stability stable
     */
    readonly restrictions?: CodebuildProjectBuildBatchConfigRestrictions[];
}
/**
 * @stability stable
 */
export interface CodebuildProjectCache {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#modes CodebuildProject#modes}.
     *
     * @stability stable
     */
    readonly modes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectEnvironmentEnvironmentVariable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#value CodebuildProject#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectEnvironmentRegistryCredential {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#credential CodebuildProject#credential}.
     *
     * @stability stable
     */
    readonly credential: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#credential_provider CodebuildProject#credential_provider}.
     *
     * @stability stable
     */
    readonly credentialProvider: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectEnvironment {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#certificate CodebuildProject#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#compute_type CodebuildProject#compute_type}.
     *
     * @stability stable
     */
    readonly computeType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#image CodebuildProject#image}.
     *
     * @stability stable
     */
    readonly image: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#image_pull_credentials_type CodebuildProject#image_pull_credentials_type}.
     *
     * @stability stable
     */
    readonly imagePullCredentialsType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#privileged_mode CodebuildProject#privileged_mode}.
     *
     * @stability stable
     */
    readonly privilegedMode?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * environment_variable block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#environment_variable CodebuildProject#environment_variable}
     *
     * @stability stable
     */
    readonly environmentVariable?: CodebuildProjectEnvironmentEnvironmentVariable[];
    /**
     * registry_credential block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#registry_credential CodebuildProject#registry_credential}
     *
     * @stability stable
     */
    readonly registryCredential?: CodebuildProjectEnvironmentRegistryCredential[];
}
/**
 * @stability stable
 */
export interface CodebuildProjectFileSystemLocations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#identifier CodebuildProject#identifier}.
     *
     * @stability stable
     */
    readonly identifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#mount_options CodebuildProject#mount_options}.
     *
     * @stability stable
     */
    readonly mountOptions?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#mount_point CodebuildProject#mount_point}.
     *
     * @stability stable
     */
    readonly mountPoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectLogsConfigCloudwatchLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#group_name CodebuildProject#group_name}.
     *
     * @stability stable
     */
    readonly groupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#status CodebuildProject#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#stream_name CodebuildProject#stream_name}.
     *
     * @stability stable
     */
    readonly streamName?: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectLogsConfigS3Logs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_disabled CodebuildProject#encryption_disabled}.
     *
     * @stability stable
     */
    readonly encryptionDisabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#status CodebuildProject#status}.
     *
     * @stability stable
     */
    readonly status?: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectLogsConfig {
    /**
     * cloudwatch_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#cloudwatch_logs CodebuildProject#cloudwatch_logs}
     *
     * @stability stable
     */
    readonly cloudwatchLogs?: CodebuildProjectLogsConfigCloudwatchLogs[];
    /**
     * s3_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#s3_logs CodebuildProject#s3_logs}
     *
     * @stability stable
     */
    readonly s3Logs?: CodebuildProjectLogsConfigS3Logs[];
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondaryArtifacts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#artifact_identifier CodebuildProject#artifact_identifier}.
     *
     * @stability stable
     */
    readonly artifactIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_disabled CodebuildProject#encryption_disabled}.
     *
     * @stability stable
     */
    readonly encryptionDisabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#namespace_type CodebuildProject#namespace_type}.
     *
     * @stability stable
     */
    readonly namespaceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#override_artifact_name CodebuildProject#override_artifact_name}.
     *
     * @stability stable
     */
    readonly overrideArtifactName?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#packaging CodebuildProject#packaging}.
     *
     * @stability stable
     */
    readonly packaging?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#path CodebuildProject#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySourcesAuth {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#resource CodebuildProject#resource}.
     *
     * @stability stable
     */
    readonly resource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySourcesBuildStatusConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#context CodebuildProject#context}.
     *
     * @stability stable
     */
    readonly context?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#target_url CodebuildProject#target_url}.
     *
     * @stability stable
     */
    readonly targetUrl?: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySourcesGitSubmodulesConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#fetch_submodules CodebuildProject#fetch_submodules}.
     *
     * @stability stable
     */
    readonly fetchSubmodules: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySources {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#buildspec CodebuildProject#buildspec}.
     *
     * @stability stable
     */
    readonly buildspec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_clone_depth CodebuildProject#git_clone_depth}.
     *
     * @stability stable
     */
    readonly gitCloneDepth?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#insecure_ssl CodebuildProject#insecure_ssl}.
     *
     * @stability stable
     */
    readonly insecureSsl?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#report_build_status CodebuildProject#report_build_status}.
     *
     * @stability stable
     */
    readonly reportBuildStatus?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#source_identifier CodebuildProject#source_identifier}.
     *
     * @stability stable
     */
    readonly sourceIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * auth block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#auth CodebuildProject#auth}
     *
     * @stability stable
     */
    readonly auth?: CodebuildProjectSecondarySourcesAuth[];
    /**
     * build_status_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_status_config CodebuildProject#build_status_config}
     *
     * @stability stable
     */
    readonly buildStatusConfig?: CodebuildProjectSecondarySourcesBuildStatusConfig[];
    /**
     * git_submodules_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_submodules_config CodebuildProject#git_submodules_config}
     *
     * @stability stable
     */
    readonly gitSubmodulesConfig?: CodebuildProjectSecondarySourcesGitSubmodulesConfig[];
}
/**
 * @stability stable
 */
export interface CodebuildProjectSourceAuth {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#resource CodebuildProject#resource}.
     *
     * @stability stable
     */
    readonly resource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSourceBuildStatusConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#context CodebuildProject#context}.
     *
     * @stability stable
     */
    readonly context?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#target_url CodebuildProject#target_url}.
     *
     * @stability stable
     */
    readonly targetUrl?: string;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSourceGitSubmodulesConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#fetch_submodules CodebuildProject#fetch_submodules}.
     *
     * @stability stable
     */
    readonly fetchSubmodules: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#buildspec CodebuildProject#buildspec}.
     *
     * @stability stable
     */
    readonly buildspec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_clone_depth CodebuildProject#git_clone_depth}.
     *
     * @stability stable
     */
    readonly gitCloneDepth?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#insecure_ssl CodebuildProject#insecure_ssl}.
     *
     * @stability stable
     */
    readonly insecureSsl?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#report_build_status CodebuildProject#report_build_status}.
     *
     * @stability stable
     */
    readonly reportBuildStatus?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * auth block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#auth CodebuildProject#auth}
     *
     * @stability stable
     */
    readonly auth?: CodebuildProjectSourceAuth[];
    /**
     * build_status_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_status_config CodebuildProject#build_status_config}
     *
     * @stability stable
     */
    readonly buildStatusConfig?: CodebuildProjectSourceBuildStatusConfig[];
    /**
     * git_submodules_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_submodules_config CodebuildProject#git_submodules_config}
     *
     * @stability stable
     */
    readonly gitSubmodulesConfig?: CodebuildProjectSourceGitSubmodulesConfig[];
}
/**
 * @stability stable
 */
export interface CodebuildProjectVpcConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#security_group_ids CodebuildProject#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#subnets CodebuildProject#subnets}.
     *
     * @stability stable
     */
    readonly subnets: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#vpc_id CodebuildProject#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html aws_codebuild_project}.
 *
 * @stability stable
 */
export declare class CodebuildProject extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html aws_codebuild_project} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodebuildProjectConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _badgeEnabled?;
    /**
     * @stability stable
     */
    get badgeEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set badgeEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBadgeEnabled(): void;
    /**
     * @stability stable
     */
    get badgeEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get badgeUrl(): string;
    private _buildTimeout?;
    /**
     * @stability stable
     */
    get buildTimeout(): number;
    /**
     * @stability stable
     */
    set buildTimeout(value: number);
    /**
     * @stability stable
     */
    resetBuildTimeout(): void;
    /**
     * @stability stable
     */
    get buildTimeoutInput(): number | undefined;
    private _concurrentBuildLimit?;
    /**
     * @stability stable
     */
    get concurrentBuildLimit(): number;
    /**
     * @stability stable
     */
    set concurrentBuildLimit(value: number);
    /**
     * @stability stable
     */
    resetConcurrentBuildLimit(): void;
    /**
     * @stability stable
     */
    get concurrentBuildLimitInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _encryptionKey?;
    /**
     * @stability stable
     */
    get encryptionKey(): string;
    /**
     * @stability stable
     */
    set encryptionKey(value: string);
    /**
     * @stability stable
     */
    resetEncryptionKey(): void;
    /**
     * @stability stable
     */
    get encryptionKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _queuedTimeout?;
    /**
     * @stability stable
     */
    get queuedTimeout(): number;
    /**
     * @stability stable
     */
    set queuedTimeout(value: number);
    /**
     * @stability stable
     */
    resetQueuedTimeout(): void;
    /**
     * @stability stable
     */
    get queuedTimeoutInput(): number | undefined;
    private _serviceRole;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    get serviceRoleInput(): string;
    private _sourceVersion?;
    /**
     * @stability stable
     */
    get sourceVersion(): string;
    /**
     * @stability stable
     */
    set sourceVersion(value: string);
    /**
     * @stability stable
     */
    resetSourceVersion(): void;
    /**
     * @stability stable
     */
    get sourceVersionInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _artifacts;
    /**
     * @stability stable
     */
    get artifacts(): CodebuildProjectArtifacts[];
    /**
     * @stability stable
     */
    set artifacts(value: CodebuildProjectArtifacts[]);
    /**
     * @stability stable
     */
    get artifactsInput(): CodebuildProjectArtifacts[];
    private _buildBatchConfig?;
    /**
     * @stability stable
     */
    get buildBatchConfig(): CodebuildProjectBuildBatchConfig[];
    /**
     * @stability stable
     */
    set buildBatchConfig(value: CodebuildProjectBuildBatchConfig[]);
    /**
     * @stability stable
     */
    resetBuildBatchConfig(): void;
    /**
     * @stability stable
     */
    get buildBatchConfigInput(): CodebuildProjectBuildBatchConfig[] | undefined;
    private _cache?;
    /**
     * @stability stable
     */
    get cache(): CodebuildProjectCache[];
    /**
     * @stability stable
     */
    set cache(value: CodebuildProjectCache[]);
    /**
     * @stability stable
     */
    resetCache(): void;
    /**
     * @stability stable
     */
    get cacheInput(): CodebuildProjectCache[] | undefined;
    private _environment;
    /**
     * @stability stable
     */
    get environment(): CodebuildProjectEnvironment[];
    /**
     * @stability stable
     */
    set environment(value: CodebuildProjectEnvironment[]);
    /**
     * @stability stable
     */
    get environmentInput(): CodebuildProjectEnvironment[];
    private _fileSystemLocations?;
    /**
     * @stability stable
     */
    get fileSystemLocations(): CodebuildProjectFileSystemLocations[];
    /**
     * @stability stable
     */
    set fileSystemLocations(value: CodebuildProjectFileSystemLocations[]);
    /**
     * @stability stable
     */
    resetFileSystemLocations(): void;
    /**
     * @stability stable
     */
    get fileSystemLocationsInput(): CodebuildProjectFileSystemLocations[] | undefined;
    private _logsConfig?;
    /**
     * @stability stable
     */
    get logsConfig(): CodebuildProjectLogsConfig[];
    /**
     * @stability stable
     */
    set logsConfig(value: CodebuildProjectLogsConfig[]);
    /**
     * @stability stable
     */
    resetLogsConfig(): void;
    /**
     * @stability stable
     */
    get logsConfigInput(): CodebuildProjectLogsConfig[] | undefined;
    private _secondaryArtifacts?;
    /**
     * @stability stable
     */
    get secondaryArtifacts(): CodebuildProjectSecondaryArtifacts[];
    /**
     * @stability stable
     */
    set secondaryArtifacts(value: CodebuildProjectSecondaryArtifacts[]);
    /**
     * @stability stable
     */
    resetSecondaryArtifacts(): void;
    /**
     * @stability stable
     */
    get secondaryArtifactsInput(): CodebuildProjectSecondaryArtifacts[] | undefined;
    private _secondarySources?;
    /**
     * @stability stable
     */
    get secondarySources(): CodebuildProjectSecondarySources[];
    /**
     * @stability stable
     */
    set secondarySources(value: CodebuildProjectSecondarySources[]);
    /**
     * @stability stable
     */
    resetSecondarySources(): void;
    /**
     * @stability stable
     */
    get secondarySourcesInput(): CodebuildProjectSecondarySources[] | undefined;
    private _source;
    /**
     * @stability stable
     */
    get source(): CodebuildProjectSource[];
    /**
     * @stability stable
     */
    set source(value: CodebuildProjectSource[]);
    /**
     * @stability stable
     */
    get sourceInput(): CodebuildProjectSource[];
    private _vpcConfig?;
    /**
     * @stability stable
     */
    get vpcConfig(): CodebuildProjectVpcConfig[];
    /**
     * @stability stable
     */
    set vpcConfig(value: CodebuildProjectVpcConfig[]);
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): CodebuildProjectVpcConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
