import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodebuildWebhookConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#branch_filter CodebuildWebhook#branch_filter}.
     *
     * @stability stable
     */
    readonly branchFilter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#build_type CodebuildWebhook#build_type}.
     *
     * @stability stable
     */
    readonly buildType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#project_name CodebuildWebhook#project_name}.
     *
     * @stability stable
     */
    readonly projectName: string;
    /**
     * filter_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#filter_group CodebuildWebhook#filter_group}
     *
     * @stability stable
     */
    readonly filterGroup?: CodebuildWebhookFilterGroup[];
}
/**
 * @stability stable
 */
export interface CodebuildWebhookFilterGroupFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#exclude_matched_pattern CodebuildWebhook#exclude_matched_pattern}.
     *
     * @stability stable
     */
    readonly excludeMatchedPattern?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#pattern CodebuildWebhook#pattern}.
     *
     * @stability stable
     */
    readonly pattern: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#type CodebuildWebhook#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CodebuildWebhookFilterGroup {
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#filter CodebuildWebhook#filter}
     *
     * @stability stable
     */
    readonly filter?: CodebuildWebhookFilterGroupFilter[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html aws_codebuild_webhook}.
 *
 * @stability stable
 */
export declare class CodebuildWebhook extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html aws_codebuild_webhook} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodebuildWebhookConfig);
    private _branchFilter?;
    /**
     * @stability stable
     */
    get branchFilter(): string;
    /**
     * @stability stable
     */
    set branchFilter(value: string);
    /**
     * @stability stable
     */
    resetBranchFilter(): void;
    /**
     * @stability stable
     */
    get branchFilterInput(): string | undefined;
    private _buildType?;
    /**
     * @stability stable
     */
    get buildType(): string;
    /**
     * @stability stable
     */
    set buildType(value: string);
    /**
     * @stability stable
     */
    resetBuildType(): void;
    /**
     * @stability stable
     */
    get buildTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get payloadUrl(): string;
    private _projectName;
    /**
     * @stability stable
     */
    get projectName(): string;
    /**
     * @stability stable
     */
    set projectName(value: string);
    /**
     * @stability stable
     */
    get projectNameInput(): string;
    /**
     * @stability stable
     */
    get secret(): string;
    /**
     * @stability stable
     */
    get url(): string;
    private _filterGroup?;
    /**
     * @stability stable
     */
    get filterGroup(): CodebuildWebhookFilterGroup[];
    /**
     * @stability stable
     */
    set filterGroup(value: CodebuildWebhookFilterGroup[]);
    /**
     * @stability stable
     */
    resetFilterGroup(): void;
    /**
     * @stability stable
     */
    get filterGroupInput(): CodebuildWebhookFilterGroup[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
