import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#app_name CodedeployDeploymentGroup#app_name}.
     *
     * @stability stable
     */
    readonly appName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#autoscaling_groups CodedeployDeploymentGroup#autoscaling_groups}.
     *
     * @stability stable
     */
    readonly autoscalingGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#deployment_config_name CodedeployDeploymentGroup#deployment_config_name}.
     *
     * @stability stable
     */
    readonly deploymentConfigName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#deployment_group_name CodedeployDeploymentGroup#deployment_group_name}.
     *
     * @stability stable
     */
    readonly deploymentGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#service_role_arn CodedeployDeploymentGroup#service_role_arn}.
     *
     * @stability stable
     */
    readonly serviceRoleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#tags CodedeployDeploymentGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#tags_all CodedeployDeploymentGroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * alarm_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#alarm_configuration CodedeployDeploymentGroup#alarm_configuration}
     *
     * @stability stable
     */
    readonly alarmConfiguration?: CodedeployDeploymentGroupAlarmConfiguration[];
    /**
     * auto_rollback_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#auto_rollback_configuration CodedeployDeploymentGroup#auto_rollback_configuration}
     *
     * @stability stable
     */
    readonly autoRollbackConfiguration?: CodedeployDeploymentGroupAutoRollbackConfiguration[];
    /**
     * blue_green_deployment_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#blue_green_deployment_config CodedeployDeploymentGroup#blue_green_deployment_config}
     *
     * @stability stable
     */
    readonly blueGreenDeploymentConfig?: CodedeployDeploymentGroupBlueGreenDeploymentConfig[];
    /**
     * deployment_style block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#deployment_style CodedeployDeploymentGroup#deployment_style}
     *
     * @stability stable
     */
    readonly deploymentStyle?: CodedeployDeploymentGroupDeploymentStyle[];
    /**
     * ec2_tag_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#ec2_tag_filter CodedeployDeploymentGroup#ec2_tag_filter}
     *
     * @stability stable
     */
    readonly ec2TagFilter?: CodedeployDeploymentGroupEc2TagFilter[];
    /**
     * ec2_tag_set block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#ec2_tag_set CodedeployDeploymentGroup#ec2_tag_set}
     *
     * @stability stable
     */
    readonly ec2TagSet?: CodedeployDeploymentGroupEc2TagSet[];
    /**
     * ecs_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#ecs_service CodedeployDeploymentGroup#ecs_service}
     *
     * @stability stable
     */
    readonly ecsService?: CodedeployDeploymentGroupEcsService[];
    /**
     * load_balancer_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#load_balancer_info CodedeployDeploymentGroup#load_balancer_info}
     *
     * @stability stable
     */
    readonly loadBalancerInfo?: CodedeployDeploymentGroupLoadBalancerInfo[];
    /**
     * on_premises_instance_tag_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#on_premises_instance_tag_filter CodedeployDeploymentGroup#on_premises_instance_tag_filter}
     *
     * @stability stable
     */
    readonly onPremisesInstanceTagFilter?: CodedeployDeploymentGroupOnPremisesInstanceTagFilter[];
    /**
     * trigger_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#trigger_configuration CodedeployDeploymentGroup#trigger_configuration}
     *
     * @stability stable
     */
    readonly triggerConfiguration?: CodedeployDeploymentGroupTriggerConfiguration[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupAlarmConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#alarms CodedeployDeploymentGroup#alarms}.
     *
     * @stability stable
     */
    readonly alarms?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#enabled CodedeployDeploymentGroup#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#ignore_poll_alarm_failure CodedeployDeploymentGroup#ignore_poll_alarm_failure}.
     *
     * @stability stable
     */
    readonly ignorePollAlarmFailure?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupAutoRollbackConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#enabled CodedeployDeploymentGroup#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#events CodedeployDeploymentGroup#events}.
     *
     * @stability stable
     */
    readonly events?: string[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfigDeploymentReadyOption {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#action_on_timeout CodedeployDeploymentGroup#action_on_timeout}.
     *
     * @stability stable
     */
    readonly actionOnTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#wait_time_in_minutes CodedeployDeploymentGroup#wait_time_in_minutes}.
     *
     * @stability stable
     */
    readonly waitTimeInMinutes?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfigGreenFleetProvisioningOption {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#action CodedeployDeploymentGroup#action}.
     *
     * @stability stable
     */
    readonly action?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfigTerminateBlueInstancesOnDeploymentSuccess {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#action CodedeployDeploymentGroup#action}.
     *
     * @stability stable
     */
    readonly action?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#termination_wait_time_in_minutes CodedeployDeploymentGroup#termination_wait_time_in_minutes}.
     *
     * @stability stable
     */
    readonly terminationWaitTimeInMinutes?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfig {
    /**
     * deployment_ready_option block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#deployment_ready_option CodedeployDeploymentGroup#deployment_ready_option}
     *
     * @stability stable
     */
    readonly deploymentReadyOption?: CodedeployDeploymentGroupBlueGreenDeploymentConfigDeploymentReadyOption[];
    /**
     * green_fleet_provisioning_option block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#green_fleet_provisioning_option CodedeployDeploymentGroup#green_fleet_provisioning_option}
     *
     * @stability stable
     */
    readonly greenFleetProvisioningOption?: CodedeployDeploymentGroupBlueGreenDeploymentConfigGreenFleetProvisioningOption[];
    /**
     * terminate_blue_instances_on_deployment_success block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#terminate_blue_instances_on_deployment_success CodedeployDeploymentGroup#terminate_blue_instances_on_deployment_success}
     *
     * @stability stable
     */
    readonly terminateBlueInstancesOnDeploymentSuccess?: CodedeployDeploymentGroupBlueGreenDeploymentConfigTerminateBlueInstancesOnDeploymentSuccess[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupDeploymentStyle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#deployment_option CodedeployDeploymentGroup#deployment_option}.
     *
     * @stability stable
     */
    readonly deploymentOption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#deployment_type CodedeployDeploymentGroup#deployment_type}.
     *
     * @stability stable
     */
    readonly deploymentType?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEc2TagFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#key CodedeployDeploymentGroup#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#type CodedeployDeploymentGroup#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#value CodedeployDeploymentGroup#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEc2TagSetEc2TagFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#key CodedeployDeploymentGroup#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#type CodedeployDeploymentGroup#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#value CodedeployDeploymentGroup#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEc2TagSet {
    /**
     * ec2_tag_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#ec2_tag_filter CodedeployDeploymentGroup#ec2_tag_filter}
     *
     * @stability stable
     */
    readonly ec2TagFilter?: CodedeployDeploymentGroupEc2TagSetEc2TagFilter[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEcsService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#cluster_name CodedeployDeploymentGroup#cluster_name}.
     *
     * @stability stable
     */
    readonly clusterName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#service_name CodedeployDeploymentGroup#service_name}.
     *
     * @stability stable
     */
    readonly serviceName: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoElbInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#name CodedeployDeploymentGroup#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#name CodedeployDeploymentGroup#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoProdTrafficRoute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#listener_arns CodedeployDeploymentGroup#listener_arns}.
     *
     * @stability stable
     */
    readonly listenerArns: string[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTargetGroup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#name CodedeployDeploymentGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTestTrafficRoute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#listener_arns CodedeployDeploymentGroup#listener_arns}.
     *
     * @stability stable
     */
    readonly listenerArns: string[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfo {
    /**
     * prod_traffic_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#prod_traffic_route CodedeployDeploymentGroup#prod_traffic_route}
     *
     * @stability stable
     */
    readonly prodTrafficRoute: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoProdTrafficRoute[];
    /**
     * target_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#target_group CodedeployDeploymentGroup#target_group}
     *
     * @stability stable
     */
    readonly targetGroup: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTargetGroup[];
    /**
     * test_traffic_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#test_traffic_route CodedeployDeploymentGroup#test_traffic_route}
     *
     * @stability stable
     */
    readonly testTrafficRoute?: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTestTrafficRoute[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfo {
    /**
     * elb_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#elb_info CodedeployDeploymentGroup#elb_info}
     *
     * @stability stable
     */
    readonly elbInfo?: CodedeployDeploymentGroupLoadBalancerInfoElbInfo[];
    /**
     * target_group_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#target_group_info CodedeployDeploymentGroup#target_group_info}
     *
     * @stability stable
     */
    readonly targetGroupInfo?: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupInfo[];
    /**
     * target_group_pair_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#target_group_pair_info CodedeployDeploymentGroup#target_group_pair_info}
     *
     * @stability stable
     */
    readonly targetGroupPairInfo?: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfo[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupOnPremisesInstanceTagFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#key CodedeployDeploymentGroup#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#type CodedeployDeploymentGroup#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#value CodedeployDeploymentGroup#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupTriggerConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#trigger_events CodedeployDeploymentGroup#trigger_events}.
     *
     * @stability stable
     */
    readonly triggerEvents: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#trigger_name CodedeployDeploymentGroup#trigger_name}.
     *
     * @stability stable
     */
    readonly triggerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html#trigger_target_arn CodedeployDeploymentGroup#trigger_target_arn}.
     *
     * @stability stable
     */
    readonly triggerTargetArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html aws_codedeploy_deployment_group}.
 *
 * @stability stable
 */
export declare class CodedeployDeploymentGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_group.html aws_codedeploy_deployment_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodedeployDeploymentGroupConfig);
    private _appName;
    /**
     * @stability stable
     */
    get appName(): string;
    /**
     * @stability stable
     */
    set appName(value: string);
    /**
     * @stability stable
     */
    get appNameInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingGroups?;
    /**
     * @stability stable
     */
    get autoscalingGroups(): string[];
    /**
     * @stability stable
     */
    set autoscalingGroups(value: string[]);
    /**
     * @stability stable
     */
    resetAutoscalingGroups(): void;
    /**
     * @stability stable
     */
    get autoscalingGroupsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get computePlatform(): string;
    private _deploymentConfigName?;
    /**
     * @stability stable
     */
    get deploymentConfigName(): string;
    /**
     * @stability stable
     */
    set deploymentConfigName(value: string);
    /**
     * @stability stable
     */
    resetDeploymentConfigName(): void;
    /**
     * @stability stable
     */
    get deploymentConfigNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get deploymentGroupId(): string;
    private _deploymentGroupName;
    /**
     * @stability stable
     */
    get deploymentGroupName(): string;
    /**
     * @stability stable
     */
    set deploymentGroupName(value: string);
    /**
     * @stability stable
     */
    get deploymentGroupNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _serviceRoleArn;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _alarmConfiguration?;
    /**
     * @stability stable
     */
    get alarmConfiguration(): CodedeployDeploymentGroupAlarmConfiguration[];
    /**
     * @stability stable
     */
    set alarmConfiguration(value: CodedeployDeploymentGroupAlarmConfiguration[]);
    /**
     * @stability stable
     */
    resetAlarmConfiguration(): void;
    /**
     * @stability stable
     */
    get alarmConfigurationInput(): CodedeployDeploymentGroupAlarmConfiguration[] | undefined;
    private _autoRollbackConfiguration?;
    /**
     * @stability stable
     */
    get autoRollbackConfiguration(): CodedeployDeploymentGroupAutoRollbackConfiguration[];
    /**
     * @stability stable
     */
    set autoRollbackConfiguration(value: CodedeployDeploymentGroupAutoRollbackConfiguration[]);
    /**
     * @stability stable
     */
    resetAutoRollbackConfiguration(): void;
    /**
     * @stability stable
     */
    get autoRollbackConfigurationInput(): CodedeployDeploymentGroupAutoRollbackConfiguration[] | undefined;
    private _blueGreenDeploymentConfig?;
    /**
     * @stability stable
     */
    get blueGreenDeploymentConfig(): CodedeployDeploymentGroupBlueGreenDeploymentConfig[];
    /**
     * @stability stable
     */
    set blueGreenDeploymentConfig(value: CodedeployDeploymentGroupBlueGreenDeploymentConfig[]);
    /**
     * @stability stable
     */
    resetBlueGreenDeploymentConfig(): void;
    /**
     * @stability stable
     */
    get blueGreenDeploymentConfigInput(): CodedeployDeploymentGroupBlueGreenDeploymentConfig[] | undefined;
    private _deploymentStyle?;
    /**
     * @stability stable
     */
    get deploymentStyle(): CodedeployDeploymentGroupDeploymentStyle[];
    /**
     * @stability stable
     */
    set deploymentStyle(value: CodedeployDeploymentGroupDeploymentStyle[]);
    /**
     * @stability stable
     */
    resetDeploymentStyle(): void;
    /**
     * @stability stable
     */
    get deploymentStyleInput(): CodedeployDeploymentGroupDeploymentStyle[] | undefined;
    private _ec2TagFilter?;
    /**
     * @stability stable
     */
    get ec2TagFilter(): CodedeployDeploymentGroupEc2TagFilter[];
    /**
     * @stability stable
     */
    set ec2TagFilter(value: CodedeployDeploymentGroupEc2TagFilter[]);
    /**
     * @stability stable
     */
    resetEc2TagFilter(): void;
    /**
     * @stability stable
     */
    get ec2TagFilterInput(): CodedeployDeploymentGroupEc2TagFilter[] | undefined;
    private _ec2TagSet?;
    /**
     * @stability stable
     */
    get ec2TagSet(): CodedeployDeploymentGroupEc2TagSet[];
    /**
     * @stability stable
     */
    set ec2TagSet(value: CodedeployDeploymentGroupEc2TagSet[]);
    /**
     * @stability stable
     */
    resetEc2TagSet(): void;
    /**
     * @stability stable
     */
    get ec2TagSetInput(): CodedeployDeploymentGroupEc2TagSet[] | undefined;
    private _ecsService?;
    /**
     * @stability stable
     */
    get ecsService(): CodedeployDeploymentGroupEcsService[];
    /**
     * @stability stable
     */
    set ecsService(value: CodedeployDeploymentGroupEcsService[]);
    /**
     * @stability stable
     */
    resetEcsService(): void;
    /**
     * @stability stable
     */
    get ecsServiceInput(): CodedeployDeploymentGroupEcsService[] | undefined;
    private _loadBalancerInfo?;
    /**
     * @stability stable
     */
    get loadBalancerInfo(): CodedeployDeploymentGroupLoadBalancerInfo[];
    /**
     * @stability stable
     */
    set loadBalancerInfo(value: CodedeployDeploymentGroupLoadBalancerInfo[]);
    /**
     * @stability stable
     */
    resetLoadBalancerInfo(): void;
    /**
     * @stability stable
     */
    get loadBalancerInfoInput(): CodedeployDeploymentGroupLoadBalancerInfo[] | undefined;
    private _onPremisesInstanceTagFilter?;
    /**
     * @stability stable
     */
    get onPremisesInstanceTagFilter(): CodedeployDeploymentGroupOnPremisesInstanceTagFilter[];
    /**
     * @stability stable
     */
    set onPremisesInstanceTagFilter(value: CodedeployDeploymentGroupOnPremisesInstanceTagFilter[]);
    /**
     * @stability stable
     */
    resetOnPremisesInstanceTagFilter(): void;
    /**
     * @stability stable
     */
    get onPremisesInstanceTagFilterInput(): CodedeployDeploymentGroupOnPremisesInstanceTagFilter[] | undefined;
    private _triggerConfiguration?;
    /**
     * @stability stable
     */
    get triggerConfiguration(): CodedeployDeploymentGroupTriggerConfiguration[];
    /**
     * @stability stable
     */
    set triggerConfiguration(value: CodedeployDeploymentGroupTriggerConfiguration[]);
    /**
     * @stability stable
     */
    resetTriggerConfiguration(): void;
    /**
     * @stability stable
     */
    get triggerConfigurationInput(): CodedeployDeploymentGroupTriggerConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
