import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodestarconnectionsHostConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#name CodestarconnectionsHost#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#provider_endpoint CodestarconnectionsHost#provider_endpoint}.
     *
     * @stability stable
     */
    readonly providerEndpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#provider_type CodestarconnectionsHost#provider_type}.
     *
     * @stability stable
     */
    readonly providerType: string;
    /**
     * vpc_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#vpc_configuration CodestarconnectionsHost#vpc_configuration}
     *
     * @stability stable
     */
    readonly vpcConfiguration?: CodestarconnectionsHostVpcConfiguration[];
}
/**
 * @stability stable
 */
export interface CodestarconnectionsHostVpcConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#security_group_ids CodestarconnectionsHost#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#subnet_ids CodestarconnectionsHost#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#tls_certificate CodestarconnectionsHost#tls_certificate}.
     *
     * @stability stable
     */
    readonly tlsCertificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html#vpc_id CodestarconnectionsHost#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html aws_codestarconnections_host}.
 *
 * @stability stable
 */
export declare class CodestarconnectionsHost extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host.html aws_codestarconnections_host} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodestarconnectionsHostConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _providerEndpoint;
    /**
     * @stability stable
     */
    get providerEndpoint(): string;
    /**
     * @stability stable
     */
    set providerEndpoint(value: string);
    /**
     * @stability stable
     */
    get providerEndpointInput(): string;
    private _providerType;
    /**
     * @stability stable
     */
    get providerType(): string;
    /**
     * @stability stable
     */
    set providerType(value: string);
    /**
     * @stability stable
     */
    get providerTypeInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _vpcConfiguration?;
    /**
     * @stability stable
     */
    get vpcConfiguration(): CodestarconnectionsHostVpcConfiguration[];
    /**
     * @stability stable
     */
    set vpcConfiguration(value: CodestarconnectionsHostVpcConfiguration[]);
    /**
     * @stability stable
     */
    resetVpcConfiguration(): void;
    /**
     * @stability stable
     */
    get vpcConfigurationInput(): CodestarconnectionsHostVpcConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
