import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoUserPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#alias_attributes CognitoUserPool#alias_attributes}.
     *
     * @stability stable
     */
    readonly aliasAttributes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#auto_verified_attributes CognitoUserPool#auto_verified_attributes}.
     *
     * @stability stable
     */
    readonly autoVerifiedAttributes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_verification_message CognitoUserPool#email_verification_message}.
     *
     * @stability stable
     */
    readonly emailVerificationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_verification_subject CognitoUserPool#email_verification_subject}.
     *
     * @stability stable
     */
    readonly emailVerificationSubject?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#mfa_configuration CognitoUserPool#mfa_configuration}.
     *
     * @stability stable
     */
    readonly mfaConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#name CognitoUserPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#sms_authentication_message CognitoUserPool#sms_authentication_message}.
     *
     * @stability stable
     */
    readonly smsAuthenticationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#sms_verification_message CognitoUserPool#sms_verification_message}.
     *
     * @stability stable
     */
    readonly smsVerificationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#tags CognitoUserPool#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#tags_all CognitoUserPool#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#username_attributes CognitoUserPool#username_attributes}.
     *
     * @stability stable
     */
    readonly usernameAttributes?: string[];
    /**
     * account_recovery_setting block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#account_recovery_setting CognitoUserPool#account_recovery_setting}
     *
     * @stability stable
     */
    readonly accountRecoverySetting?: CognitoUserPoolAccountRecoverySetting[];
    /**
     * admin_create_user_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#admin_create_user_config CognitoUserPool#admin_create_user_config}
     *
     * @stability stable
     */
    readonly adminCreateUserConfig?: CognitoUserPoolAdminCreateUserConfig[];
    /**
     * device_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#device_configuration CognitoUserPool#device_configuration}
     *
     * @stability stable
     */
    readonly deviceConfiguration?: CognitoUserPoolDeviceConfiguration[];
    /**
     * email_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_configuration CognitoUserPool#email_configuration}
     *
     * @stability stable
     */
    readonly emailConfiguration?: CognitoUserPoolEmailConfiguration[];
    /**
     * lambda_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#lambda_config CognitoUserPool#lambda_config}
     *
     * @stability stable
     */
    readonly lambdaConfig?: CognitoUserPoolLambdaConfig[];
    /**
     * password_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#password_policy CognitoUserPool#password_policy}
     *
     * @stability stable
     */
    readonly passwordPolicy?: CognitoUserPoolPasswordPolicy[];
    /**
     * schema block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#schema CognitoUserPool#schema}
     *
     * @stability stable
     */
    readonly schema?: CognitoUserPoolSchema[];
    /**
     * sms_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#sms_configuration CognitoUserPool#sms_configuration}
     *
     * @stability stable
     */
    readonly smsConfiguration?: CognitoUserPoolSmsConfiguration[];
    /**
     * software_token_mfa_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#software_token_mfa_configuration CognitoUserPool#software_token_mfa_configuration}
     *
     * @stability stable
     */
    readonly softwareTokenMfaConfiguration?: CognitoUserPoolSoftwareTokenMfaConfiguration[];
    /**
     * user_pool_add_ons block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#user_pool_add_ons CognitoUserPool#user_pool_add_ons}
     *
     * @stability stable
     */
    readonly userPoolAddOns?: CognitoUserPoolUserPoolAddOns[];
    /**
     * username_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#username_configuration CognitoUserPool#username_configuration}
     *
     * @stability stable
     */
    readonly usernameConfiguration?: CognitoUserPoolUsernameConfiguration[];
    /**
     * verification_message_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#verification_message_template CognitoUserPool#verification_message_template}
     *
     * @stability stable
     */
    readonly verificationMessageTemplate?: CognitoUserPoolVerificationMessageTemplate[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAccountRecoverySettingRecoveryMechanism {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#name CognitoUserPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#priority CognitoUserPool#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAccountRecoverySetting {
    /**
     * recovery_mechanism block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#recovery_mechanism CognitoUserPool#recovery_mechanism}
     *
     * @stability stable
     */
    readonly recoveryMechanism: CognitoUserPoolAccountRecoverySettingRecoveryMechanism[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_message CognitoUserPool#email_message}.
     *
     * @stability stable
     */
    readonly emailMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_subject CognitoUserPool#email_subject}.
     *
     * @stability stable
     */
    readonly emailSubject?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#sms_message CognitoUserPool#sms_message}.
     *
     * @stability stable
     */
    readonly smsMessage?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAdminCreateUserConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#allow_admin_create_user_only CognitoUserPool#allow_admin_create_user_only}.
     *
     * @stability stable
     */
    readonly allowAdminCreateUserOnly?: boolean | cdktf.IResolvable;
    /**
     * invite_message_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#invite_message_template CognitoUserPool#invite_message_template}
     *
     * @stability stable
     */
    readonly inviteMessageTemplate?: CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolDeviceConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#challenge_required_on_new_device CognitoUserPool#challenge_required_on_new_device}.
     *
     * @stability stable
     */
    readonly challengeRequiredOnNewDevice?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#device_only_remembered_on_user_prompt CognitoUserPool#device_only_remembered_on_user_prompt}.
     *
     * @stability stable
     */
    readonly deviceOnlyRememberedOnUserPrompt?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolEmailConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#configuration_set CognitoUserPool#configuration_set}.
     *
     * @stability stable
     */
    readonly configurationSet?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_sending_account CognitoUserPool#email_sending_account}.
     *
     * @stability stable
     */
    readonly emailSendingAccount?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#from_email_address CognitoUserPool#from_email_address}.
     *
     * @stability stable
     */
    readonly fromEmailAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#reply_to_email_address CognitoUserPool#reply_to_email_address}.
     *
     * @stability stable
     */
    readonly replyToEmailAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#source_arn CognitoUserPool#source_arn}.
     *
     * @stability stable
     */
    readonly sourceArn?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolLambdaConfigCustomEmailSender {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#lambda_arn CognitoUserPool#lambda_arn}.
     *
     * @stability stable
     */
    readonly lambdaArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#lambda_version CognitoUserPool#lambda_version}.
     *
     * @stability stable
     */
    readonly lambdaVersion: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolLambdaConfigCustomSmsSender {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#lambda_arn CognitoUserPool#lambda_arn}.
     *
     * @stability stable
     */
    readonly lambdaArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#lambda_version CognitoUserPool#lambda_version}.
     *
     * @stability stable
     */
    readonly lambdaVersion: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolLambdaConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#create_auth_challenge CognitoUserPool#create_auth_challenge}.
     *
     * @stability stable
     */
    readonly createAuthChallenge?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#custom_message CognitoUserPool#custom_message}.
     *
     * @stability stable
     */
    readonly customMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#define_auth_challenge CognitoUserPool#define_auth_challenge}.
     *
     * @stability stable
     */
    readonly defineAuthChallenge?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#kms_key_id CognitoUserPool#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#post_authentication CognitoUserPool#post_authentication}.
     *
     * @stability stable
     */
    readonly postAuthentication?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#post_confirmation CognitoUserPool#post_confirmation}.
     *
     * @stability stable
     */
    readonly postConfirmation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#pre_authentication CognitoUserPool#pre_authentication}.
     *
     * @stability stable
     */
    readonly preAuthentication?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#pre_sign_up CognitoUserPool#pre_sign_up}.
     *
     * @stability stable
     */
    readonly preSignUp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#pre_token_generation CognitoUserPool#pre_token_generation}.
     *
     * @stability stable
     */
    readonly preTokenGeneration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#user_migration CognitoUserPool#user_migration}.
     *
     * @stability stable
     */
    readonly userMigration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#verify_auth_challenge_response CognitoUserPool#verify_auth_challenge_response}.
     *
     * @stability stable
     */
    readonly verifyAuthChallengeResponse?: string;
    /**
     * custom_email_sender block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#custom_email_sender CognitoUserPool#custom_email_sender}
     *
     * @stability stable
     */
    readonly customEmailSender?: CognitoUserPoolLambdaConfigCustomEmailSender[];
    /**
     * custom_sms_sender block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#custom_sms_sender CognitoUserPool#custom_sms_sender}
     *
     * @stability stable
     */
    readonly customSmsSender?: CognitoUserPoolLambdaConfigCustomSmsSender[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolPasswordPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#minimum_length CognitoUserPool#minimum_length}.
     *
     * @stability stable
     */
    readonly minimumLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#require_lowercase CognitoUserPool#require_lowercase}.
     *
     * @stability stable
     */
    readonly requireLowercase?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#require_numbers CognitoUserPool#require_numbers}.
     *
     * @stability stable
     */
    readonly requireNumbers?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#require_symbols CognitoUserPool#require_symbols}.
     *
     * @stability stable
     */
    readonly requireSymbols?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#require_uppercase CognitoUserPool#require_uppercase}.
     *
     * @stability stable
     */
    readonly requireUppercase?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#temporary_password_validity_days CognitoUserPool#temporary_password_validity_days}.
     *
     * @stability stable
     */
    readonly temporaryPasswordValidityDays?: number;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchemaNumberAttributeConstraints {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#max_value CognitoUserPool#max_value}.
     *
     * @stability stable
     */
    readonly maxValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#min_value CognitoUserPool#min_value}.
     *
     * @stability stable
     */
    readonly minValue?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchemaStringAttributeConstraints {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#max_length CognitoUserPool#max_length}.
     *
     * @stability stable
     */
    readonly maxLength?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#min_length CognitoUserPool#min_length}.
     *
     * @stability stable
     */
    readonly minLength?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchema {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#attribute_data_type CognitoUserPool#attribute_data_type}.
     *
     * @stability stable
     */
    readonly attributeDataType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#developer_only_attribute CognitoUserPool#developer_only_attribute}.
     *
     * @stability stable
     */
    readonly developerOnlyAttribute?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#mutable CognitoUserPool#mutable}.
     *
     * @stability stable
     */
    readonly mutable?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#name CognitoUserPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#required CognitoUserPool#required}.
     *
     * @stability stable
     */
    readonly required?: boolean | cdktf.IResolvable;
    /**
     * number_attribute_constraints block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#number_attribute_constraints CognitoUserPool#number_attribute_constraints}
     *
     * @stability stable
     */
    readonly numberAttributeConstraints?: CognitoUserPoolSchemaNumberAttributeConstraints[];
    /**
     * string_attribute_constraints block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#string_attribute_constraints CognitoUserPool#string_attribute_constraints}
     *
     * @stability stable
     */
    readonly stringAttributeConstraints?: CognitoUserPoolSchemaStringAttributeConstraints[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSmsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#external_id CognitoUserPool#external_id}.
     *
     * @stability stable
     */
    readonly externalId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#sns_caller_arn CognitoUserPool#sns_caller_arn}.
     *
     * @stability stable
     */
    readonly snsCallerArn: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSoftwareTokenMfaConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#enabled CognitoUserPool#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolUserPoolAddOns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#advanced_security_mode CognitoUserPool#advanced_security_mode}.
     *
     * @stability stable
     */
    readonly advancedSecurityMode: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolUsernameConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#case_sensitive CognitoUserPool#case_sensitive}.
     *
     * @stability stable
     */
    readonly caseSensitive: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolVerificationMessageTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#default_email_option CognitoUserPool#default_email_option}.
     *
     * @stability stable
     */
    readonly defaultEmailOption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_message CognitoUserPool#email_message}.
     *
     * @stability stable
     */
    readonly emailMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_message_by_link CognitoUserPool#email_message_by_link}.
     *
     * @stability stable
     */
    readonly emailMessageByLink?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_subject CognitoUserPool#email_subject}.
     *
     * @stability stable
     */
    readonly emailSubject?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#email_subject_by_link CognitoUserPool#email_subject_by_link}.
     *
     * @stability stable
     */
    readonly emailSubjectByLink?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html#sms_message CognitoUserPool#sms_message}.
     *
     * @stability stable
     */
    readonly smsMessage?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html aws_cognito_user_pool}.
 *
 * @stability stable
 */
export declare class CognitoUserPool extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool.html aws_cognito_user_pool} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoUserPoolConfig);
    private _aliasAttributes?;
    /**
     * @stability stable
     */
    get aliasAttributes(): string[];
    /**
     * @stability stable
     */
    set aliasAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetAliasAttributes(): void;
    /**
     * @stability stable
     */
    get aliasAttributesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoVerifiedAttributes?;
    /**
     * @stability stable
     */
    get autoVerifiedAttributes(): string[];
    /**
     * @stability stable
     */
    set autoVerifiedAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetAutoVerifiedAttributes(): void;
    /**
     * @stability stable
     */
    get autoVerifiedAttributesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get creationDate(): string;
    /**
     * @stability stable
     */
    get customDomain(): string;
    /**
     * @stability stable
     */
    get domain(): string;
    private _emailVerificationMessage?;
    /**
     * @stability stable
     */
    get emailVerificationMessage(): string;
    /**
     * @stability stable
     */
    set emailVerificationMessage(value: string);
    /**
     * @stability stable
     */
    resetEmailVerificationMessage(): void;
    /**
     * @stability stable
     */
    get emailVerificationMessageInput(): string | undefined;
    private _emailVerificationSubject?;
    /**
     * @stability stable
     */
    get emailVerificationSubject(): string;
    /**
     * @stability stable
     */
    set emailVerificationSubject(value: string);
    /**
     * @stability stable
     */
    resetEmailVerificationSubject(): void;
    /**
     * @stability stable
     */
    get emailVerificationSubjectInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get estimatedNumberOfUsers(): number;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModifiedDate(): string;
    private _mfaConfiguration?;
    /**
     * @stability stable
     */
    get mfaConfiguration(): string;
    /**
     * @stability stable
     */
    set mfaConfiguration(value: string);
    /**
     * @stability stable
     */
    resetMfaConfiguration(): void;
    /**
     * @stability stable
     */
    get mfaConfigurationInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _smsAuthenticationMessage?;
    /**
     * @stability stable
     */
    get smsAuthenticationMessage(): string;
    /**
     * @stability stable
     */
    set smsAuthenticationMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsAuthenticationMessage(): void;
    /**
     * @stability stable
     */
    get smsAuthenticationMessageInput(): string | undefined;
    private _smsVerificationMessage?;
    /**
     * @stability stable
     */
    get smsVerificationMessage(): string;
    /**
     * @stability stable
     */
    set smsVerificationMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsVerificationMessage(): void;
    /**
     * @stability stable
     */
    get smsVerificationMessageInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _usernameAttributes?;
    /**
     * @stability stable
     */
    get usernameAttributes(): string[];
    /**
     * @stability stable
     */
    set usernameAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetUsernameAttributes(): void;
    /**
     * @stability stable
     */
    get usernameAttributesInput(): string[] | undefined;
    private _accountRecoverySetting?;
    /**
     * @stability stable
     */
    get accountRecoverySetting(): CognitoUserPoolAccountRecoverySetting[];
    /**
     * @stability stable
     */
    set accountRecoverySetting(value: CognitoUserPoolAccountRecoverySetting[]);
    /**
     * @stability stable
     */
    resetAccountRecoverySetting(): void;
    /**
     * @stability stable
     */
    get accountRecoverySettingInput(): CognitoUserPoolAccountRecoverySetting[] | undefined;
    private _adminCreateUserConfig?;
    /**
     * @stability stable
     */
    get adminCreateUserConfig(): CognitoUserPoolAdminCreateUserConfig[];
    /**
     * @stability stable
     */
    set adminCreateUserConfig(value: CognitoUserPoolAdminCreateUserConfig[]);
    /**
     * @stability stable
     */
    resetAdminCreateUserConfig(): void;
    /**
     * @stability stable
     */
    get adminCreateUserConfigInput(): CognitoUserPoolAdminCreateUserConfig[] | undefined;
    private _deviceConfiguration?;
    /**
     * @stability stable
     */
    get deviceConfiguration(): CognitoUserPoolDeviceConfiguration[];
    /**
     * @stability stable
     */
    set deviceConfiguration(value: CognitoUserPoolDeviceConfiguration[]);
    /**
     * @stability stable
     */
    resetDeviceConfiguration(): void;
    /**
     * @stability stable
     */
    get deviceConfigurationInput(): CognitoUserPoolDeviceConfiguration[] | undefined;
    private _emailConfiguration?;
    /**
     * @stability stable
     */
    get emailConfiguration(): CognitoUserPoolEmailConfiguration[];
    /**
     * @stability stable
     */
    set emailConfiguration(value: CognitoUserPoolEmailConfiguration[]);
    /**
     * @stability stable
     */
    resetEmailConfiguration(): void;
    /**
     * @stability stable
     */
    get emailConfigurationInput(): CognitoUserPoolEmailConfiguration[] | undefined;
    private _lambdaConfig?;
    /**
     * @stability stable
     */
    get lambdaConfig(): CognitoUserPoolLambdaConfig[];
    /**
     * @stability stable
     */
    set lambdaConfig(value: CognitoUserPoolLambdaConfig[]);
    /**
     * @stability stable
     */
    resetLambdaConfig(): void;
    /**
     * @stability stable
     */
    get lambdaConfigInput(): CognitoUserPoolLambdaConfig[] | undefined;
    private _passwordPolicy?;
    /**
     * @stability stable
     */
    get passwordPolicy(): CognitoUserPoolPasswordPolicy[];
    /**
     * @stability stable
     */
    set passwordPolicy(value: CognitoUserPoolPasswordPolicy[]);
    /**
     * @stability stable
     */
    resetPasswordPolicy(): void;
    /**
     * @stability stable
     */
    get passwordPolicyInput(): CognitoUserPoolPasswordPolicy[] | undefined;
    private _schema?;
    /**
     * @stability stable
     */
    get schema(): CognitoUserPoolSchema[];
    /**
     * @stability stable
     */
    set schema(value: CognitoUserPoolSchema[]);
    /**
     * @stability stable
     */
    resetSchema(): void;
    /**
     * @stability stable
     */
    get schemaInput(): CognitoUserPoolSchema[] | undefined;
    private _smsConfiguration?;
    /**
     * @stability stable
     */
    get smsConfiguration(): CognitoUserPoolSmsConfiguration[];
    /**
     * @stability stable
     */
    set smsConfiguration(value: CognitoUserPoolSmsConfiguration[]);
    /**
     * @stability stable
     */
    resetSmsConfiguration(): void;
    /**
     * @stability stable
     */
    get smsConfigurationInput(): CognitoUserPoolSmsConfiguration[] | undefined;
    private _softwareTokenMfaConfiguration?;
    /**
     * @stability stable
     */
    get softwareTokenMfaConfiguration(): CognitoUserPoolSoftwareTokenMfaConfiguration[];
    /**
     * @stability stable
     */
    set softwareTokenMfaConfiguration(value: CognitoUserPoolSoftwareTokenMfaConfiguration[]);
    /**
     * @stability stable
     */
    resetSoftwareTokenMfaConfiguration(): void;
    /**
     * @stability stable
     */
    get softwareTokenMfaConfigurationInput(): CognitoUserPoolSoftwareTokenMfaConfiguration[] | undefined;
    private _userPoolAddOns?;
    /**
     * @stability stable
     */
    get userPoolAddOns(): CognitoUserPoolUserPoolAddOns[];
    /**
     * @stability stable
     */
    set userPoolAddOns(value: CognitoUserPoolUserPoolAddOns[]);
    /**
     * @stability stable
     */
    resetUserPoolAddOns(): void;
    /**
     * @stability stable
     */
    get userPoolAddOnsInput(): CognitoUserPoolUserPoolAddOns[] | undefined;
    private _usernameConfiguration?;
    /**
     * @stability stable
     */
    get usernameConfiguration(): CognitoUserPoolUsernameConfiguration[];
    /**
     * @stability stable
     */
    set usernameConfiguration(value: CognitoUserPoolUsernameConfiguration[]);
    /**
     * @stability stable
     */
    resetUsernameConfiguration(): void;
    /**
     * @stability stable
     */
    get usernameConfigurationInput(): CognitoUserPoolUsernameConfiguration[] | undefined;
    private _verificationMessageTemplate?;
    /**
     * @stability stable
     */
    get verificationMessageTemplate(): CognitoUserPoolVerificationMessageTemplate[];
    /**
     * @stability stable
     */
    set verificationMessageTemplate(value: CognitoUserPoolVerificationMessageTemplate[]);
    /**
     * @stability stable
     */
    resetVerificationMessageTemplate(): void;
    /**
     * @stability stable
     */
    get verificationMessageTemplateInput(): CognitoUserPoolVerificationMessageTemplate[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
