import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigOrganizationCustomRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#description ConfigOrganizationCustomRule#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#excluded_accounts ConfigOrganizationCustomRule#excluded_accounts}.
     *
     * @stability stable
     */
    readonly excludedAccounts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#input_parameters ConfigOrganizationCustomRule#input_parameters}.
     *
     * @stability stable
     */
    readonly inputParameters?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#lambda_function_arn ConfigOrganizationCustomRule#lambda_function_arn}.
     *
     * @stability stable
     */
    readonly lambdaFunctionArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#maximum_execution_frequency ConfigOrganizationCustomRule#maximum_execution_frequency}.
     *
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#name ConfigOrganizationCustomRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#resource_id_scope ConfigOrganizationCustomRule#resource_id_scope}.
     *
     * @stability stable
     */
    readonly resourceIdScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#resource_types_scope ConfigOrganizationCustomRule#resource_types_scope}.
     *
     * @stability stable
     */
    readonly resourceTypesScope?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#tag_key_scope ConfigOrganizationCustomRule#tag_key_scope}.
     *
     * @stability stable
     */
    readonly tagKeyScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#tag_value_scope ConfigOrganizationCustomRule#tag_value_scope}.
     *
     * @stability stable
     */
    readonly tagValueScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#trigger_types ConfigOrganizationCustomRule#trigger_types}.
     *
     * @stability stable
     */
    readonly triggerTypes: string[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#timeouts ConfigOrganizationCustomRule#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ConfigOrganizationCustomRuleTimeouts;
}
/**
 * @stability stable
 */
export interface ConfigOrganizationCustomRuleTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#create ConfigOrganizationCustomRule#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#delete ConfigOrganizationCustomRule#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#update ConfigOrganizationCustomRule#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html aws_config_organization_custom_rule}.
 *
 * @stability stable
 */
export declare class ConfigOrganizationCustomRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html aws_config_organization_custom_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigOrganizationCustomRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _excludedAccounts?;
    /**
     * @stability stable
     */
    get excludedAccounts(): string[];
    /**
     * @stability stable
     */
    set excludedAccounts(value: string[]);
    /**
     * @stability stable
     */
    resetExcludedAccounts(): void;
    /**
     * @stability stable
     */
    get excludedAccountsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputParameters?;
    /**
     * @stability stable
     */
    get inputParameters(): string;
    /**
     * @stability stable
     */
    set inputParameters(value: string);
    /**
     * @stability stable
     */
    resetInputParameters(): void;
    /**
     * @stability stable
     */
    get inputParametersInput(): string | undefined;
    private _lambdaFunctionArn;
    /**
     * @stability stable
     */
    get lambdaFunctionArn(): string;
    /**
     * @stability stable
     */
    set lambdaFunctionArn(value: string);
    /**
     * @stability stable
     */
    get lambdaFunctionArnInput(): string;
    private _maximumExecutionFrequency?;
    /**
     * @stability stable
     */
    get maximumExecutionFrequency(): string;
    /**
     * @stability stable
     */
    set maximumExecutionFrequency(value: string);
    /**
     * @stability stable
     */
    resetMaximumExecutionFrequency(): void;
    /**
     * @stability stable
     */
    get maximumExecutionFrequencyInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceIdScope?;
    /**
     * @stability stable
     */
    get resourceIdScope(): string;
    /**
     * @stability stable
     */
    set resourceIdScope(value: string);
    /**
     * @stability stable
     */
    resetResourceIdScope(): void;
    /**
     * @stability stable
     */
    get resourceIdScopeInput(): string | undefined;
    private _resourceTypesScope?;
    /**
     * @stability stable
     */
    get resourceTypesScope(): string[];
    /**
     * @stability stable
     */
    set resourceTypesScope(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypesScope(): void;
    /**
     * @stability stable
     */
    get resourceTypesScopeInput(): string[] | undefined;
    private _tagKeyScope?;
    /**
     * @stability stable
     */
    get tagKeyScope(): string;
    /**
     * @stability stable
     */
    set tagKeyScope(value: string);
    /**
     * @stability stable
     */
    resetTagKeyScope(): void;
    /**
     * @stability stable
     */
    get tagKeyScopeInput(): string | undefined;
    private _tagValueScope?;
    /**
     * @stability stable
     */
    get tagValueScope(): string;
    /**
     * @stability stable
     */
    set tagValueScope(value: string);
    /**
     * @stability stable
     */
    resetTagValueScope(): void;
    /**
     * @stability stable
     */
    get tagValueScopeInput(): string | undefined;
    private _triggerTypes;
    /**
     * @stability stable
     */
    get triggerTypes(): string[];
    /**
     * @stability stable
     */
    set triggerTypes(value: string[]);
    /**
     * @stability stable
     */
    get triggerTypesInput(): string[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ConfigOrganizationCustomRuleTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ConfigOrganizationCustomRuleTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ConfigOrganizationCustomRuleTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
