import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsDxLocationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/dx_location.html#location_code DataAwsDxLocation#location_code}.
     *
     * @stability stable
     */
    readonly locationCode: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/dx_location.html aws_dx_location}.
 *
 * @stability stable
 */
export declare class DataAwsDxLocation extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/dx_location.html aws_dx_location} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsDxLocationConfig);
    /**
     * @stability stable
     */
    get availablePortSpeeds(): string[];
    /**
     * @stability stable
     */
    get availableProviders(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _locationCode;
    /**
     * @stability stable
     */
    get locationCode(): string;
    /**
     * @stability stable
     */
    set locationCode(value: string);
    /**
     * @stability stable
     */
    get locationCodeInput(): string;
    /**
     * @stability stable
     */
    get locationName(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
