import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#location_type DataAwsEc2InstanceTypeOffering#location_type}.
     *
     * @stability stable
     */
    readonly locationType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#preferred_instance_types DataAwsEc2InstanceTypeOffering#preferred_instance_types}.
     *
     * @stability stable
     */
    readonly preferredInstanceTypes?: string[];
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#filter DataAwsEc2InstanceTypeOffering#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2InstanceTypeOfferingFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#name DataAwsEc2InstanceTypeOffering#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#values DataAwsEc2InstanceTypeOffering#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html aws_ec2_instance_type_offering}.
 *
 * @stability stable
 */
export declare class DataAwsEc2InstanceTypeOffering extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html aws_ec2_instance_type_offering} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2InstanceTypeOfferingConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceType(): string;
    private _locationType?;
    /**
     * @stability stable
     */
    get locationType(): string;
    /**
     * @stability stable
     */
    set locationType(value: string);
    /**
     * @stability stable
     */
    resetLocationType(): void;
    /**
     * @stability stable
     */
    get locationTypeInput(): string | undefined;
    private _preferredInstanceTypes?;
    /**
     * @stability stable
     */
    get preferredInstanceTypes(): string[];
    /**
     * @stability stable
     */
    set preferredInstanceTypes(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredInstanceTypes(): void;
    /**
     * @stability stable
     */
    get preferredInstanceTypesInput(): string[] | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2InstanceTypeOfferingFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2InstanceTypeOfferingFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2InstanceTypeOfferingFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
