import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#location_type DataAwsEc2InstanceTypeOfferings#location_type}.
     *
     * @stability stable
     */
    readonly locationType?: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#filter DataAwsEc2InstanceTypeOfferings#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2InstanceTypeOfferingsFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingsFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#name DataAwsEc2InstanceTypeOfferings#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#values DataAwsEc2InstanceTypeOfferings#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html aws_ec2_instance_type_offerings}.
 *
 * @stability stable
 */
export declare class DataAwsEc2InstanceTypeOfferings extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html aws_ec2_instance_type_offerings} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2InstanceTypeOfferingsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceTypes(): string[];
    private _locationType?;
    /**
     * @stability stable
     */
    get locationType(): string;
    /**
     * @stability stable
     */
    set locationType(value: string);
    /**
     * @stability stable
     */
    resetLocationType(): void;
    /**
     * @stability stable
     */
    get locationTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get locationTypes(): string[];
    /**
     * @stability stable
     */
    get locations(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2InstanceTypeOfferingsFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2InstanceTypeOfferingsFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2InstanceTypeOfferingsFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
