import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIamGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_group.html#group_name DataAwsIamGroup#group_name}.
     *
     * @stability stable
     */
    readonly groupName: string;
}
/**
 * @stability stable
 */
export declare class DataAwsIamGroupUsers extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get userId(): string;
    /**
     * @stability stable
     */
    get userName(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/iam_group.html aws_iam_group}.
 *
 * @stability stable
 */
export declare class DataAwsIamGroup extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/iam_group.html aws_iam_group} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsIamGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get groupId(): string;
    private _groupName;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    set groupName(value: string);
    /**
     * @stability stable
     */
    get groupNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    users(index: string): DataAwsIamGroupUsers;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
