import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#catalog_id DataAwsLakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#catalog_resource DataAwsLakeformationPermissions#catalog_resource}.
     *
     * @stability stable
     */
    readonly catalogResource?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#principal DataAwsLakeformationPermissions#principal}.
     *
     * @stability stable
     */
    readonly principal: string;
    /**
     * data_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#data_location DataAwsLakeformationPermissions#data_location}
     *
     * @stability stable
     */
    readonly dataLocation?: DataAwsLakeformationPermissionsDataLocation[];
    /**
     * database block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#database DataAwsLakeformationPermissions#database}
     *
     * @stability stable
     */
    readonly database?: DataAwsLakeformationPermissionsDatabase[];
    /**
     * table block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#table DataAwsLakeformationPermissions#table}
     *
     * @stability stable
     */
    readonly table?: DataAwsLakeformationPermissionsTable[];
    /**
     * table_with_columns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#table_with_columns DataAwsLakeformationPermissions#table_with_columns}
     *
     * @stability stable
     */
    readonly tableWithColumns?: DataAwsLakeformationPermissionsTableWithColumns[];
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsDataLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#arn DataAwsLakeformationPermissions#arn}.
     *
     * @stability stable
     */
    readonly arn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#catalog_id DataAwsLakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsDatabase {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#catalog_id DataAwsLakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#name DataAwsLakeformationPermissions#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsTable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#catalog_id DataAwsLakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#database_name DataAwsLakeformationPermissions#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#name DataAwsLakeformationPermissions#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#wildcard DataAwsLakeformationPermissions#wildcard}.
     *
     * @stability stable
     */
    readonly wildcard?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsTableWithColumns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#catalog_id DataAwsLakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#column_names DataAwsLakeformationPermissions#column_names}.
     *
     * @stability stable
     */
    readonly columnNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#database_name DataAwsLakeformationPermissions#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#excluded_column_names DataAwsLakeformationPermissions#excluded_column_names}.
     *
     * @stability stable
     */
    readonly excludedColumnNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#name DataAwsLakeformationPermissions#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html#wildcard DataAwsLakeformationPermissions#wildcard}.
     *
     * @stability stable
     */
    readonly wildcard?: boolean | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html aws_lakeformation_permissions}.
 *
 * @stability stable
 */
export declare class DataAwsLakeformationPermissions extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lakeformation_permissions.html aws_lakeformation_permissions} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLakeformationPermissionsConfig);
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _catalogResource?;
    /**
     * @stability stable
     */
    get catalogResource(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set catalogResource(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCatalogResource(): void;
    /**
     * @stability stable
     */
    get catalogResourceInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get permissions(): string[];
    /**
     * @stability stable
     */
    get permissionsWithGrantOption(): string[];
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _dataLocation?;
    /**
     * @stability stable
     */
    get dataLocation(): DataAwsLakeformationPermissionsDataLocation[];
    /**
     * @stability stable
     */
    set dataLocation(value: DataAwsLakeformationPermissionsDataLocation[]);
    /**
     * @stability stable
     */
    resetDataLocation(): void;
    /**
     * @stability stable
     */
    get dataLocationInput(): DataAwsLakeformationPermissionsDataLocation[] | undefined;
    private _database?;
    /**
     * @stability stable
     */
    get database(): DataAwsLakeformationPermissionsDatabase[];
    /**
     * @stability stable
     */
    set database(value: DataAwsLakeformationPermissionsDatabase[]);
    /**
     * @stability stable
     */
    resetDatabase(): void;
    /**
     * @stability stable
     */
    get databaseInput(): DataAwsLakeformationPermissionsDatabase[] | undefined;
    private _table?;
    /**
     * @stability stable
     */
    get table(): DataAwsLakeformationPermissionsTable[];
    /**
     * @stability stable
     */
    set table(value: DataAwsLakeformationPermissionsTable[]);
    /**
     * @stability stable
     */
    resetTable(): void;
    /**
     * @stability stable
     */
    get tableInput(): DataAwsLakeformationPermissionsTable[] | undefined;
    private _tableWithColumns?;
    /**
     * @stability stable
     */
    get tableWithColumns(): DataAwsLakeformationPermissionsTableWithColumns[];
    /**
     * @stability stable
     */
    set tableWithColumns(value: DataAwsLakeformationPermissionsTableWithColumns[]);
    /**
     * @stability stable
     */
    resetTableWithColumns(): void;
    /**
     * @stability stable
     */
    get tableWithColumnsInput(): DataAwsLakeformationPermissionsTableWithColumns[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
