import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLambdaInvocationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_invocation.html#function_name DataAwsLambdaInvocation#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_invocation.html#input DataAwsLambdaInvocation#input}.
     *
     * @stability stable
     */
    readonly input: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_invocation.html#qualifier DataAwsLambdaInvocation#qualifier}.
     *
     * @stability stable
     */
    readonly qualifier?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lambda_invocation.html aws_lambda_invocation}.
 *
 * @stability stable
 */
export declare class DataAwsLambdaInvocation extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lambda_invocation.html aws_lambda_invocation} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLambdaInvocationConfig);
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _input;
    /**
     * @stability stable
     */
    get input(): string;
    /**
     * @stability stable
     */
    set input(value: string);
    /**
     * @stability stable
     */
    get inputInput(): string;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get result(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
