import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsNetworkInterfaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/network_interface.html#tags DataAwsNetworkInterface#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/network_interface.html#filter DataAwsNetworkInterface#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsNetworkInterfaceFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsNetworkInterfaceAssociation extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get allocationId(): string;
    /**
     * @stability stable
     */
    get associationId(): string;
    /**
     * @stability stable
     */
    get carrierIp(): string;
    /**
     * @stability stable
     */
    get customerOwnedIp(): string;
    /**
     * @stability stable
     */
    get ipOwnerId(): string;
    /**
     * @stability stable
     */
    get publicDnsName(): string;
    /**
     * @stability stable
     */
    get publicIp(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsNetworkInterfaceAttachment extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get attachmentId(): string;
    /**
     * @stability stable
     */
    get deviceIndex(): number;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    get instanceOwnerId(): string;
}
/**
 * @stability stable
 */
export interface DataAwsNetworkInterfaceFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/network_interface.html#name DataAwsNetworkInterface#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/network_interface.html#values DataAwsNetworkInterface#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/network_interface.html aws_network_interface}.
 *
 * @stability stable
 */
export declare class DataAwsNetworkInterface extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/network_interface.html aws_network_interface} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsNetworkInterfaceConfig);
    /**
     * @stability stable
     */
    association(index: string): DataAwsNetworkInterfaceAssociation;
    /**
     * @stability stable
     */
    attachment(index: string): DataAwsNetworkInterfaceAttachment;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get interfaceType(): string;
    /**
     * @stability stable
     */
    get ipv6Addresses(): string[];
    /**
     * @stability stable
     */
    get macAddress(): string;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get privateDnsName(): string;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    get privateIps(): string[];
    /**
     * @stability stable
     */
    get requesterId(): string;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    get subnetId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsNetworkInterfaceFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsNetworkInterfaceFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsNetworkInterfaceFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
