import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsOrganizationsDelegatedAdministratorsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/organizations_delegated_administrators.html#service_principal DataAwsOrganizationsDelegatedAdministrators#service_principal}.
     *
     * @stability stable
     */
    readonly servicePrincipal?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsOrganizationsDelegatedAdministratorsDelegatedAdministrators extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get delegationEnabledDate(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get joinedMethod(): string;
    /**
     * @stability stable
     */
    get joinedTimestamp(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/organizations_delegated_administrators.html aws_organizations_delegated_administrators}.
 *
 * @stability stable
 */
export declare class DataAwsOrganizationsDelegatedAdministrators extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/organizations_delegated_administrators.html aws_organizations_delegated_administrators} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsOrganizationsDelegatedAdministratorsConfig);
    /**
     * @stability stable
     */
    delegatedAdministrators(index: string): DataAwsOrganizationsDelegatedAdministratorsDelegatedAdministrators;
    /**
     * @stability stable
     */
    get id(): string;
    private _servicePrincipal?;
    /**
     * @stability stable
     */
    get servicePrincipal(): string;
    /**
     * @stability stable
     */
    set servicePrincipal(value: string);
    /**
     * @stability stable
     */
    resetServicePrincipal(): void;
    /**
     * @stability stable
     */
    get servicePrincipalInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
