import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRegionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/regions.html#all_regions DataAwsRegions#all_regions}.
     *
     * @stability stable
     */
    readonly allRegions?: boolean | cdktf.IResolvable;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/regions.html#filter DataAwsRegions#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsRegionsFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsRegionsFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/regions.html#name DataAwsRegions#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/regions.html#values DataAwsRegions#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/regions.html aws_regions}.
 *
 * @stability stable
 */
export declare class DataAwsRegions extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/regions.html aws_regions} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsRegionsConfig);
    private _allRegions?;
    /**
     * @stability stable
     */
    get allRegions(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allRegions(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllRegions(): void;
    /**
     * @stability stable
     */
    get allRegionsInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get names(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsRegionsFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsRegionsFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsRegionsFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
