import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#carrier_gateway_id DataAwsRoute#carrier_gateway_id}.
     *
     * @stability stable
     */
    readonly carrierGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#destination_cidr_block DataAwsRoute#destination_cidr_block}.
     *
     * @stability stable
     */
    readonly destinationCidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#destination_ipv6_cidr_block DataAwsRoute#destination_ipv6_cidr_block}.
     *
     * @stability stable
     */
    readonly destinationIpv6CidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#destination_prefix_list_id DataAwsRoute#destination_prefix_list_id}.
     *
     * @stability stable
     */
    readonly destinationPrefixListId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#egress_only_gateway_id DataAwsRoute#egress_only_gateway_id}.
     *
     * @stability stable
     */
    readonly egressOnlyGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#gateway_id DataAwsRoute#gateway_id}.
     *
     * @stability stable
     */
    readonly gatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#instance_id DataAwsRoute#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#local_gateway_id DataAwsRoute#local_gateway_id}.
     *
     * @stability stable
     */
    readonly localGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#nat_gateway_id DataAwsRoute#nat_gateway_id}.
     *
     * @stability stable
     */
    readonly natGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#network_interface_id DataAwsRoute#network_interface_id}.
     *
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#route_table_id DataAwsRoute#route_table_id}.
     *
     * @stability stable
     */
    readonly routeTableId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#transit_gateway_id DataAwsRoute#transit_gateway_id}.
     *
     * @stability stable
     */
    readonly transitGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route.html#vpc_peering_connection_id DataAwsRoute#vpc_peering_connection_id}.
     *
     * @stability stable
     */
    readonly vpcPeeringConnectionId?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/route.html aws_route}.
 *
 * @stability stable
 */
export declare class DataAwsRoute extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/route.html aws_route} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsRouteConfig);
    private _carrierGatewayId?;
    /**
     * @stability stable
     */
    get carrierGatewayId(): string;
    /**
     * @stability stable
     */
    set carrierGatewayId(value: string);
    /**
     * @stability stable
     */
    resetCarrierGatewayId(): void;
    /**
     * @stability stable
     */
    get carrierGatewayIdInput(): string | undefined;
    private _destinationCidrBlock?;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    resetDestinationCidrBlock(): void;
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string | undefined;
    private _destinationIpv6CidrBlock?;
    /**
     * @stability stable
     */
    get destinationIpv6CidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationIpv6CidrBlock(value: string);
    /**
     * @stability stable
     */
    resetDestinationIpv6CidrBlock(): void;
    /**
     * @stability stable
     */
    get destinationIpv6CidrBlockInput(): string | undefined;
    private _destinationPrefixListId?;
    /**
     * @stability stable
     */
    get destinationPrefixListId(): string;
    /**
     * @stability stable
     */
    set destinationPrefixListId(value: string);
    /**
     * @stability stable
     */
    resetDestinationPrefixListId(): void;
    /**
     * @stability stable
     */
    get destinationPrefixListIdInput(): string | undefined;
    private _egressOnlyGatewayId?;
    /**
     * @stability stable
     */
    get egressOnlyGatewayId(): string;
    /**
     * @stability stable
     */
    set egressOnlyGatewayId(value: string);
    /**
     * @stability stable
     */
    resetEgressOnlyGatewayId(): void;
    /**
     * @stability stable
     */
    get egressOnlyGatewayIdInput(): string | undefined;
    private _gatewayId?;
    /**
     * @stability stable
     */
    get gatewayId(): string;
    /**
     * @stability stable
     */
    set gatewayId(value: string);
    /**
     * @stability stable
     */
    resetGatewayId(): void;
    /**
     * @stability stable
     */
    get gatewayIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    resetInstanceId(): void;
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _localGatewayId?;
    /**
     * @stability stable
     */
    get localGatewayId(): string;
    /**
     * @stability stable
     */
    set localGatewayId(value: string);
    /**
     * @stability stable
     */
    resetLocalGatewayId(): void;
    /**
     * @stability stable
     */
    get localGatewayIdInput(): string | undefined;
    private _natGatewayId?;
    /**
     * @stability stable
     */
    get natGatewayId(): string;
    /**
     * @stability stable
     */
    set natGatewayId(value: string);
    /**
     * @stability stable
     */
    resetNatGatewayId(): void;
    /**
     * @stability stable
     */
    get natGatewayIdInput(): string | undefined;
    private _networkInterfaceId?;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    set networkInterfaceId(value: string);
    /**
     * @stability stable
     */
    resetNetworkInterfaceId(): void;
    /**
     * @stability stable
     */
    get networkInterfaceIdInput(): string | undefined;
    private _routeTableId;
    /**
     * @stability stable
     */
    get routeTableId(): string;
    /**
     * @stability stable
     */
    set routeTableId(value: string);
    /**
     * @stability stable
     */
    get routeTableIdInput(): string;
    private _transitGatewayId?;
    /**
     * @stability stable
     */
    get transitGatewayId(): string;
    /**
     * @stability stable
     */
    set transitGatewayId(value: string);
    /**
     * @stability stable
     */
    resetTransitGatewayId(): void;
    /**
     * @stability stable
     */
    get transitGatewayIdInput(): string | undefined;
    private _vpcPeeringConnectionId?;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionId(): string;
    /**
     * @stability stable
     */
    set vpcPeeringConnectionId(value: string);
    /**
     * @stability stable
     */
    resetVpcPeeringConnectionId(): void;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
