import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DmsEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#certificate_arn DmsEndpoint#certificate_arn}.
     *
     * @stability stable
     */
    readonly certificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#database_name DmsEndpoint#database_name}.
     *
     * @stability stable
     */
    readonly databaseName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#endpoint_id DmsEndpoint#endpoint_id}.
     *
     * @stability stable
     */
    readonly endpointId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#endpoint_type DmsEndpoint#endpoint_type}.
     *
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#engine_name DmsEndpoint#engine_name}.
     *
     * @stability stable
     */
    readonly engineName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#extra_connection_attributes DmsEndpoint#extra_connection_attributes}.
     *
     * @stability stable
     */
    readonly extraConnectionAttributes?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#kms_key_arn DmsEndpoint#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#password DmsEndpoint#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#port DmsEndpoint#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#server_name DmsEndpoint#server_name}.
     *
     * @stability stable
     */
    readonly serverName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#service_access_role DmsEndpoint#service_access_role}.
     *
     * @stability stable
     */
    readonly serviceAccessRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#ssl_mode DmsEndpoint#ssl_mode}.
     *
     * @stability stable
     */
    readonly sslMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#tags DmsEndpoint#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#tags_all DmsEndpoint#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#username DmsEndpoint#username}.
     *
     * @stability stable
     */
    readonly username?: string;
    /**
     * elasticsearch_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#elasticsearch_settings DmsEndpoint#elasticsearch_settings}
     *
     * @stability stable
     */
    readonly elasticsearchSettings?: DmsEndpointElasticsearchSettings[];
    /**
     * kafka_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#kafka_settings DmsEndpoint#kafka_settings}
     *
     * @stability stable
     */
    readonly kafkaSettings?: DmsEndpointKafkaSettings[];
    /**
     * kinesis_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#kinesis_settings DmsEndpoint#kinesis_settings}
     *
     * @stability stable
     */
    readonly kinesisSettings?: DmsEndpointKinesisSettings[];
    /**
     * mongodb_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#mongodb_settings DmsEndpoint#mongodb_settings}
     *
     * @stability stable
     */
    readonly mongodbSettings?: DmsEndpointMongodbSettings[];
    /**
     * s3_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#s3_settings DmsEndpoint#s3_settings}
     *
     * @stability stable
     */
    readonly s3Settings?: DmsEndpointS3Settings[];
}
/**
 * @stability stable
 */
export interface DmsEndpointElasticsearchSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#endpoint_uri DmsEndpoint#endpoint_uri}.
     *
     * @stability stable
     */
    readonly endpointUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#error_retry_duration DmsEndpoint#error_retry_duration}.
     *
     * @stability stable
     */
    readonly errorRetryDuration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#full_load_error_percentage DmsEndpoint#full_load_error_percentage}.
     *
     * @stability stable
     */
    readonly fullLoadErrorPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#service_access_role_arn DmsEndpoint#service_access_role_arn}.
     *
     * @stability stable
     */
    readonly serviceAccessRoleArn: string;
}
/**
 * @stability stable
 */
export interface DmsEndpointKafkaSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#broker DmsEndpoint#broker}.
     *
     * @stability stable
     */
    readonly broker: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#include_control_details DmsEndpoint#include_control_details}.
     *
     * @stability stable
     */
    readonly includeControlDetails?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#include_null_and_empty DmsEndpoint#include_null_and_empty}.
     *
     * @stability stable
     */
    readonly includeNullAndEmpty?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#include_partition_value DmsEndpoint#include_partition_value}.
     *
     * @stability stable
     */
    readonly includePartitionValue?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#include_table_alter_operations DmsEndpoint#include_table_alter_operations}.
     *
     * @stability stable
     */
    readonly includeTableAlterOperations?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#include_transaction_details DmsEndpoint#include_transaction_details}.
     *
     * @stability stable
     */
    readonly includeTransactionDetails?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#message_format DmsEndpoint#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#message_max_bytes DmsEndpoint#message_max_bytes}.
     *
     * @stability stable
     */
    readonly messageMaxBytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#no_hex_prefix DmsEndpoint#no_hex_prefix}.
     *
     * @stability stable
     */
    readonly noHexPrefix?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#partition_include_schema_table DmsEndpoint#partition_include_schema_table}.
     *
     * @stability stable
     */
    readonly partitionIncludeSchemaTable?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#sasl_password DmsEndpoint#sasl_password}.
     *
     * @stability stable
     */
    readonly saslPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#sasl_username DmsEndpoint#sasl_username}.
     *
     * @stability stable
     */
    readonly saslUsername?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#security_protocol DmsEndpoint#security_protocol}.
     *
     * @stability stable
     */
    readonly securityProtocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#ssl_ca_certificate_arn DmsEndpoint#ssl_ca_certificate_arn}.
     *
     * @stability stable
     */
    readonly sslCaCertificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#ssl_client_certificate_arn DmsEndpoint#ssl_client_certificate_arn}.
     *
     * @stability stable
     */
    readonly sslClientCertificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#ssl_client_key_arn DmsEndpoint#ssl_client_key_arn}.
     *
     * @stability stable
     */
    readonly sslClientKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#ssl_client_key_password DmsEndpoint#ssl_client_key_password}.
     *
     * @stability stable
     */
    readonly sslClientKeyPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#topic DmsEndpoint#topic}.
     *
     * @stability stable
     */
    readonly topic?: string;
}
/**
 * @stability stable
 */
export interface DmsEndpointKinesisSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#message_format DmsEndpoint#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#service_access_role_arn DmsEndpoint#service_access_role_arn}.
     *
     * @stability stable
     */
    readonly serviceAccessRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#stream_arn DmsEndpoint#stream_arn}.
     *
     * @stability stable
     */
    readonly streamArn?: string;
}
/**
 * @stability stable
 */
export interface DmsEndpointMongodbSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#auth_mechanism DmsEndpoint#auth_mechanism}.
     *
     * @stability stable
     */
    readonly authMechanism?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#auth_source DmsEndpoint#auth_source}.
     *
     * @stability stable
     */
    readonly authSource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#auth_type DmsEndpoint#auth_type}.
     *
     * @stability stable
     */
    readonly authType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#docs_to_investigate DmsEndpoint#docs_to_investigate}.
     *
     * @stability stable
     */
    readonly docsToInvestigate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#extract_doc_id DmsEndpoint#extract_doc_id}.
     *
     * @stability stable
     */
    readonly extractDocId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#nesting_level DmsEndpoint#nesting_level}.
     *
     * @stability stable
     */
    readonly nestingLevel?: string;
}
/**
 * @stability stable
 */
export interface DmsEndpointS3Settings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#bucket_folder DmsEndpoint#bucket_folder}.
     *
     * @stability stable
     */
    readonly bucketFolder?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#bucket_name DmsEndpoint#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#compression_type DmsEndpoint#compression_type}.
     *
     * @stability stable
     */
    readonly compressionType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#csv_delimiter DmsEndpoint#csv_delimiter}.
     *
     * @stability stable
     */
    readonly csvDelimiter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#csv_row_delimiter DmsEndpoint#csv_row_delimiter}.
     *
     * @stability stable
     */
    readonly csvRowDelimiter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#data_format DmsEndpoint#data_format}.
     *
     * @stability stable
     */
    readonly dataFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#date_partition_enabled DmsEndpoint#date_partition_enabled}.
     *
     * @stability stable
     */
    readonly datePartitionEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#encryption_mode DmsEndpoint#encryption_mode}.
     *
     * @stability stable
     */
    readonly encryptionMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#external_table_definition DmsEndpoint#external_table_definition}.
     *
     * @stability stable
     */
    readonly externalTableDefinition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#parquet_timestamp_in_millisecond DmsEndpoint#parquet_timestamp_in_millisecond}.
     *
     * @stability stable
     */
    readonly parquetTimestampInMillisecond?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#parquet_version DmsEndpoint#parquet_version}.
     *
     * @stability stable
     */
    readonly parquetVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#server_side_encryption_kms_key_id DmsEndpoint#server_side_encryption_kms_key_id}.
     *
     * @stability stable
     */
    readonly serverSideEncryptionKmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html#service_access_role_arn DmsEndpoint#service_access_role_arn}.
     *
     * @stability stable
     */
    readonly serviceAccessRoleArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html aws_dms_endpoint}.
 *
 * @stability stable
 */
export declare class DmsEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint.html aws_dms_endpoint} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DmsEndpointConfig);
    private _certificateArn?;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    set certificateArn(value: string);
    /**
     * @stability stable
     */
    resetCertificateArn(): void;
    /**
     * @stability stable
     */
    get certificateArnInput(): string | undefined;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    resetDatabaseName(): void;
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpointArn(): string;
    private _endpointId;
    /**
     * @stability stable
     */
    get endpointId(): string;
    /**
     * @stability stable
     */
    set endpointId(value: string);
    /**
     * @stability stable
     */
    get endpointIdInput(): string;
    private _endpointType;
    /**
     * @stability stable
     */
    get endpointType(): string;
    /**
     * @stability stable
     */
    set endpointType(value: string);
    /**
     * @stability stable
     */
    get endpointTypeInput(): string;
    private _engineName;
    /**
     * @stability stable
     */
    get engineName(): string;
    /**
     * @stability stable
     */
    set engineName(value: string);
    /**
     * @stability stable
     */
    get engineNameInput(): string;
    private _extraConnectionAttributes?;
    /**
     * @stability stable
     */
    get extraConnectionAttributes(): string;
    /**
     * @stability stable
     */
    set extraConnectionAttributes(value: string);
    /**
     * @stability stable
     */
    resetExtraConnectionAttributes(): void;
    /**
     * @stability stable
     */
    get extraConnectionAttributesInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _password?;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    resetPassword(): void;
    /**
     * @stability stable
     */
    get passwordInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _serverName?;
    /**
     * @stability stable
     */
    get serverName(): string;
    /**
     * @stability stable
     */
    set serverName(value: string);
    /**
     * @stability stable
     */
    resetServerName(): void;
    /**
     * @stability stable
     */
    get serverNameInput(): string | undefined;
    private _serviceAccessRole?;
    /**
     * @stability stable
     */
    get serviceAccessRole(): string;
    /**
     * @stability stable
     */
    set serviceAccessRole(value: string);
    /**
     * @stability stable
     */
    resetServiceAccessRole(): void;
    /**
     * @stability stable
     */
    get serviceAccessRoleInput(): string | undefined;
    private _sslMode?;
    /**
     * @stability stable
     */
    get sslMode(): string;
    /**
     * @stability stable
     */
    set sslMode(value: string);
    /**
     * @stability stable
     */
    resetSslMode(): void;
    /**
     * @stability stable
     */
    get sslModeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _username?;
    /**
     * @stability stable
     */
    get username(): string;
    /**
     * @stability stable
     */
    set username(value: string);
    /**
     * @stability stable
     */
    resetUsername(): void;
    /**
     * @stability stable
     */
    get usernameInput(): string | undefined;
    private _elasticsearchSettings?;
    /**
     * @stability stable
     */
    get elasticsearchSettings(): DmsEndpointElasticsearchSettings[];
    /**
     * @stability stable
     */
    set elasticsearchSettings(value: DmsEndpointElasticsearchSettings[]);
    /**
     * @stability stable
     */
    resetElasticsearchSettings(): void;
    /**
     * @stability stable
     */
    get elasticsearchSettingsInput(): DmsEndpointElasticsearchSettings[] | undefined;
    private _kafkaSettings?;
    /**
     * @stability stable
     */
    get kafkaSettings(): DmsEndpointKafkaSettings[];
    /**
     * @stability stable
     */
    set kafkaSettings(value: DmsEndpointKafkaSettings[]);
    /**
     * @stability stable
     */
    resetKafkaSettings(): void;
    /**
     * @stability stable
     */
    get kafkaSettingsInput(): DmsEndpointKafkaSettings[] | undefined;
    private _kinesisSettings?;
    /**
     * @stability stable
     */
    get kinesisSettings(): DmsEndpointKinesisSettings[];
    /**
     * @stability stable
     */
    set kinesisSettings(value: DmsEndpointKinesisSettings[]);
    /**
     * @stability stable
     */
    resetKinesisSettings(): void;
    /**
     * @stability stable
     */
    get kinesisSettingsInput(): DmsEndpointKinesisSettings[] | undefined;
    private _mongodbSettings?;
    /**
     * @stability stable
     */
    get mongodbSettings(): DmsEndpointMongodbSettings[];
    /**
     * @stability stable
     */
    set mongodbSettings(value: DmsEndpointMongodbSettings[]);
    /**
     * @stability stable
     */
    resetMongodbSettings(): void;
    /**
     * @stability stable
     */
    get mongodbSettingsInput(): DmsEndpointMongodbSettings[] | undefined;
    private _s3Settings?;
    /**
     * @stability stable
     */
    get s3Settings(): DmsEndpointS3Settings[];
    /**
     * @stability stable
     */
    set s3Settings(value: DmsEndpointS3Settings[]);
    /**
     * @stability stable
     */
    resetS3Settings(): void;
    /**
     * @stability stable
     */
    get s3SettingsInput(): DmsEndpointS3Settings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
