import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DxGatewayAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#allowed_prefixes DxGatewayAssociation#allowed_prefixes}.
     *
     * @stability stable
     */
    readonly allowedPrefixes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#associated_gateway_id DxGatewayAssociation#associated_gateway_id}.
     *
     * @stability stable
     */
    readonly associatedGatewayId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#associated_gateway_owner_account_id DxGatewayAssociation#associated_gateway_owner_account_id}.
     *
     * @stability stable
     */
    readonly associatedGatewayOwnerAccountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#dx_gateway_id DxGatewayAssociation#dx_gateway_id}.
     *
     * @stability stable
     */
    readonly dxGatewayId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#proposal_id DxGatewayAssociation#proposal_id}.
     *
     * @stability stable
     */
    readonly proposalId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#vpn_gateway_id DxGatewayAssociation#vpn_gateway_id}.
     *
     * @stability stable
     */
    readonly vpnGatewayId?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#timeouts DxGatewayAssociation#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DxGatewayAssociationTimeouts;
}
/**
 * @stability stable
 */
export interface DxGatewayAssociationTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#create DxGatewayAssociation#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#delete DxGatewayAssociation#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html#update DxGatewayAssociation#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html aws_dx_gateway_association}.
 *
 * @stability stable
 */
export declare class DxGatewayAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dx_gateway_association.html aws_dx_gateway_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DxGatewayAssociationConfig);
    private _allowedPrefixes?;
    /**
     * @stability stable
     */
    get allowedPrefixes(): string[];
    /**
     * @stability stable
     */
    set allowedPrefixes(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedPrefixes(): void;
    /**
     * @stability stable
     */
    get allowedPrefixesInput(): string[] | undefined;
    private _associatedGatewayId?;
    /**
     * @stability stable
     */
    get associatedGatewayId(): string;
    /**
     * @stability stable
     */
    set associatedGatewayId(value: string);
    /**
     * @stability stable
     */
    resetAssociatedGatewayId(): void;
    /**
     * @stability stable
     */
    get associatedGatewayIdInput(): string | undefined;
    private _associatedGatewayOwnerAccountId?;
    /**
     * @stability stable
     */
    get associatedGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    set associatedGatewayOwnerAccountId(value: string);
    /**
     * @stability stable
     */
    resetAssociatedGatewayOwnerAccountId(): void;
    /**
     * @stability stable
     */
    get associatedGatewayOwnerAccountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get associatedGatewayType(): string;
    /**
     * @stability stable
     */
    get dxGatewayAssociationId(): string;
    private _dxGatewayId;
    /**
     * @stability stable
     */
    get dxGatewayId(): string;
    /**
     * @stability stable
     */
    set dxGatewayId(value: string);
    /**
     * @stability stable
     */
    get dxGatewayIdInput(): string;
    /**
     * @stability stable
     */
    get dxGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _proposalId?;
    /**
     * @stability stable
     */
    get proposalId(): string;
    /**
     * @stability stable
     */
    set proposalId(value: string);
    /**
     * @stability stable
     */
    resetProposalId(): void;
    /**
     * @stability stable
     */
    get proposalIdInput(): string | undefined;
    private _vpnGatewayId?;
    /**
     * @stability stable
     */
    get vpnGatewayId(): string;
    /**
     * @stability stable
     */
    set vpnGatewayId(value: string);
    /**
     * @stability stable
     */
    resetVpnGatewayId(): void;
    /**
     * @stability stable
     */
    get vpnGatewayIdInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DxGatewayAssociationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DxGatewayAssociationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DxGatewayAssociationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
