import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2ClientVpnAuthorizationRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#access_group_id Ec2ClientVpnAuthorizationRule#access_group_id}.
     *
     * @stability stable
     */
    readonly accessGroupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#authorize_all_groups Ec2ClientVpnAuthorizationRule#authorize_all_groups}.
     *
     * @stability stable
     */
    readonly authorizeAllGroups?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#client_vpn_endpoint_id Ec2ClientVpnAuthorizationRule#client_vpn_endpoint_id}.
     *
     * @stability stable
     */
    readonly clientVpnEndpointId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#description Ec2ClientVpnAuthorizationRule#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#target_network_cidr Ec2ClientVpnAuthorizationRule#target_network_cidr}.
     *
     * @stability stable
     */
    readonly targetNetworkCidr: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html aws_ec2_client_vpn_authorization_rule}.
 *
 * @stability stable
 */
export declare class Ec2ClientVpnAuthorizationRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html aws_ec2_client_vpn_authorization_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2ClientVpnAuthorizationRuleConfig);
    private _accessGroupId?;
    /**
     * @stability stable
     */
    get accessGroupId(): string;
    /**
     * @stability stable
     */
    set accessGroupId(value: string);
    /**
     * @stability stable
     */
    resetAccessGroupId(): void;
    /**
     * @stability stable
     */
    get accessGroupIdInput(): string | undefined;
    private _authorizeAllGroups?;
    /**
     * @stability stable
     */
    get authorizeAllGroups(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set authorizeAllGroups(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAuthorizeAllGroups(): void;
    /**
     * @stability stable
     */
    get authorizeAllGroupsInput(): boolean | cdktf.IResolvable | undefined;
    private _clientVpnEndpointId;
    /**
     * @stability stable
     */
    get clientVpnEndpointId(): string;
    /**
     * @stability stable
     */
    set clientVpnEndpointId(value: string);
    /**
     * @stability stable
     */
    get clientVpnEndpointIdInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _targetNetworkCidr;
    /**
     * @stability stable
     */
    get targetNetworkCidr(): string;
    /**
     * @stability stable
     */
    set targetNetworkCidr(value: string);
    /**
     * @stability stable
     */
    get targetNetworkCidrInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
