import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2ClientVpnRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#client_vpn_endpoint_id Ec2ClientVpnRoute#client_vpn_endpoint_id}.
     *
     * @stability stable
     */
    readonly clientVpnEndpointId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#description Ec2ClientVpnRoute#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#destination_cidr_block Ec2ClientVpnRoute#destination_cidr_block}.
     *
     * @stability stable
     */
    readonly destinationCidrBlock: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#target_vpc_subnet_id Ec2ClientVpnRoute#target_vpc_subnet_id}.
     *
     * @stability stable
     */
    readonly targetVpcSubnetId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html aws_ec2_client_vpn_route}.
 *
 * @stability stable
 */
export declare class Ec2ClientVpnRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html aws_ec2_client_vpn_route} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2ClientVpnRouteConfig);
    private _clientVpnEndpointId;
    /**
     * @stability stable
     */
    get clientVpnEndpointId(): string;
    /**
     * @stability stable
     */
    set clientVpnEndpointId(value: string);
    /**
     * @stability stable
     */
    get clientVpnEndpointIdInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _destinationCidrBlock;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get origin(): string;
    private _targetVpcSubnetId;
    /**
     * @stability stable
     */
    get targetVpcSubnetId(): string;
    /**
     * @stability stable
     */
    set targetVpcSubnetId(value: string);
    /**
     * @stability stable
     */
    get targetVpcSubnetIdInput(): string;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
