import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayRouteTablePropagationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html#transit_gateway_attachment_id Ec2TransitGatewayRouteTablePropagation#transit_gateway_attachment_id}.
     *
     * @stability stable
     */
    readonly transitGatewayAttachmentId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html#transit_gateway_route_table_id Ec2TransitGatewayRouteTablePropagation#transit_gateway_route_table_id}.
     *
     * @stability stable
     */
    readonly transitGatewayRouteTableId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html aws_ec2_transit_gateway_route_table_propagation}.
 *
 * @stability stable
 */
export declare class Ec2TransitGatewayRouteTablePropagation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html aws_ec2_transit_gateway_route_table_propagation} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TransitGatewayRouteTablePropagationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    get resourceType(): string;
    private _transitGatewayAttachmentId;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentId(): string;
    /**
     * @stability stable
     */
    set transitGatewayAttachmentId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayAttachmentIdInput(): string;
    private _transitGatewayRouteTableId;
    /**
     * @stability stable
     */
    get transitGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set transitGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayRouteTableIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
