import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EcrReplicationConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * replication_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecr_replication_configuration.html#replication_configuration EcrReplicationConfiguration#replication_configuration}
     *
     * @stability stable
     */
    readonly replicationConfiguration?: EcrReplicationConfigurationReplicationConfiguration[];
}
/**
 * @stability stable
 */
export interface EcrReplicationConfigurationReplicationConfigurationRuleDestination {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecr_replication_configuration.html#region EcrReplicationConfiguration#region}.
     *
     * @stability stable
     */
    readonly region: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecr_replication_configuration.html#registry_id EcrReplicationConfiguration#registry_id}.
     *
     * @stability stable
     */
    readonly registryId: string;
}
/**
 * @stability stable
 */
export interface EcrReplicationConfigurationReplicationConfigurationRule {
    /**
     * destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecr_replication_configuration.html#destination EcrReplicationConfiguration#destination}
     *
     * @stability stable
     */
    readonly destination: EcrReplicationConfigurationReplicationConfigurationRuleDestination[];
}
/**
 * @stability stable
 */
export interface EcrReplicationConfigurationReplicationConfiguration {
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecr_replication_configuration.html#rule EcrReplicationConfiguration#rule}
     *
     * @stability stable
     */
    readonly rule: EcrReplicationConfigurationReplicationConfigurationRule[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ecr_replication_configuration.html aws_ecr_replication_configuration}.
 *
 * @stability stable
 */
export declare class EcrReplicationConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ecr_replication_configuration.html aws_ecr_replication_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: EcrReplicationConfigurationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get registryId(): string;
    private _replicationConfiguration?;
    /**
     * @stability stable
     */
    get replicationConfiguration(): EcrReplicationConfigurationReplicationConfiguration[];
    /**
     * @stability stable
     */
    set replicationConfiguration(value: EcrReplicationConfigurationReplicationConfiguration[]);
    /**
     * @stability stable
     */
    resetReplicationConfiguration(): void;
    /**
     * @stability stable
     */
    get replicationConfigurationInput(): EcrReplicationConfigurationReplicationConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
