import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EcsServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#cluster EcsService#cluster}.
     *
     * @stability stable
     */
    readonly cluster?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#deployment_maximum_percent EcsService#deployment_maximum_percent}.
     *
     * @stability stable
     */
    readonly deploymentMaximumPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#deployment_minimum_healthy_percent EcsService#deployment_minimum_healthy_percent}.
     *
     * @stability stable
     */
    readonly deploymentMinimumHealthyPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#desired_count EcsService#desired_count}.
     *
     * @stability stable
     */
    readonly desiredCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#enable_ecs_managed_tags EcsService#enable_ecs_managed_tags}.
     *
     * @stability stable
     */
    readonly enableEcsManagedTags?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#enable_execute_command EcsService#enable_execute_command}.
     *
     * @stability stable
     */
    readonly enableExecuteCommand?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#force_new_deployment EcsService#force_new_deployment}.
     *
     * @stability stable
     */
    readonly forceNewDeployment?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#health_check_grace_period_seconds EcsService#health_check_grace_period_seconds}.
     *
     * @stability stable
     */
    readonly healthCheckGracePeriodSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#iam_role EcsService#iam_role}.
     *
     * @stability stable
     */
    readonly iamRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#launch_type EcsService#launch_type}.
     *
     * @stability stable
     */
    readonly launchType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#name EcsService#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#platform_version EcsService#platform_version}.
     *
     * @stability stable
     */
    readonly platformVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#propagate_tags EcsService#propagate_tags}.
     *
     * @stability stable
     */
    readonly propagateTags?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#scheduling_strategy EcsService#scheduling_strategy}.
     *
     * @stability stable
     */
    readonly schedulingStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#tags EcsService#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#tags_all EcsService#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#task_definition EcsService#task_definition}.
     *
     * @stability stable
     */
    readonly taskDefinition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#wait_for_steady_state EcsService#wait_for_steady_state}.
     *
     * @stability stable
     */
    readonly waitForSteadyState?: boolean | cdktf.IResolvable;
    /**
     * capacity_provider_strategy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#capacity_provider_strategy EcsService#capacity_provider_strategy}
     *
     * @stability stable
     */
    readonly capacityProviderStrategy?: EcsServiceCapacityProviderStrategy[];
    /**
     * deployment_circuit_breaker block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#deployment_circuit_breaker EcsService#deployment_circuit_breaker}
     *
     * @stability stable
     */
    readonly deploymentCircuitBreaker?: EcsServiceDeploymentCircuitBreaker[];
    /**
     * deployment_controller block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#deployment_controller EcsService#deployment_controller}
     *
     * @stability stable
     */
    readonly deploymentController?: EcsServiceDeploymentController[];
    /**
     * load_balancer block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#load_balancer EcsService#load_balancer}
     *
     * @stability stable
     */
    readonly loadBalancer?: EcsServiceLoadBalancer[];
    /**
     * network_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#network_configuration EcsService#network_configuration}
     *
     * @stability stable
     */
    readonly networkConfiguration?: EcsServiceNetworkConfiguration[];
    /**
     * ordered_placement_strategy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#ordered_placement_strategy EcsService#ordered_placement_strategy}
     *
     * @stability stable
     */
    readonly orderedPlacementStrategy?: EcsServiceOrderedPlacementStrategy[];
    /**
     * placement_constraints block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#placement_constraints EcsService#placement_constraints}
     *
     * @stability stable
     */
    readonly placementConstraints?: EcsServicePlacementConstraints[];
    /**
     * service_registries block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#service_registries EcsService#service_registries}
     *
     * @stability stable
     */
    readonly serviceRegistries?: EcsServiceServiceRegistries[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#timeouts EcsService#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: EcsServiceTimeouts;
}
/**
 * @stability stable
 */
export interface EcsServiceCapacityProviderStrategy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#base EcsService#base}.
     *
     * @stability stable
     */
    readonly base?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#capacity_provider EcsService#capacity_provider}.
     *
     * @stability stable
     */
    readonly capacityProvider: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#weight EcsService#weight}.
     *
     * @stability stable
     */
    readonly weight?: number;
}
/**
 * @stability stable
 */
export interface EcsServiceDeploymentCircuitBreaker {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#enable EcsService#enable}.
     *
     * @stability stable
     */
    readonly enable: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#rollback EcsService#rollback}.
     *
     * @stability stable
     */
    readonly rollback: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface EcsServiceDeploymentController {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#type EcsService#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface EcsServiceLoadBalancer {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#container_name EcsService#container_name}.
     *
     * @stability stable
     */
    readonly containerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#container_port EcsService#container_port}.
     *
     * @stability stable
     */
    readonly containerPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#elb_name EcsService#elb_name}.
     *
     * @stability stable
     */
    readonly elbName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#target_group_arn EcsService#target_group_arn}.
     *
     * @stability stable
     */
    readonly targetGroupArn?: string;
}
/**
 * @stability stable
 */
export interface EcsServiceNetworkConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#assign_public_ip EcsService#assign_public_ip}.
     *
     * @stability stable
     */
    readonly assignPublicIp?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#security_groups EcsService#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#subnets EcsService#subnets}.
     *
     * @stability stable
     */
    readonly subnets: string[];
}
/**
 * @stability stable
 */
export interface EcsServiceOrderedPlacementStrategy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#field EcsService#field}.
     *
     * @stability stable
     */
    readonly field?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#type EcsService#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface EcsServicePlacementConstraints {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#expression EcsService#expression}.
     *
     * @stability stable
     */
    readonly expression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#type EcsService#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface EcsServiceServiceRegistries {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#container_name EcsService#container_name}.
     *
     * @stability stable
     */
    readonly containerName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#container_port EcsService#container_port}.
     *
     * @stability stable
     */
    readonly containerPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#port EcsService#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#registry_arn EcsService#registry_arn}.
     *
     * @stability stable
     */
    readonly registryArn: string;
}
/**
 * @stability stable
 */
export interface EcsServiceTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html#delete EcsService#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html aws_ecs_service}.
 *
 * @stability stable
 */
export declare class EcsService extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ecs_service.html aws_ecs_service} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EcsServiceConfig);
    private _cluster?;
    /**
     * @stability stable
     */
    get cluster(): string;
    /**
     * @stability stable
     */
    set cluster(value: string);
    /**
     * @stability stable
     */
    resetCluster(): void;
    /**
     * @stability stable
     */
    get clusterInput(): string | undefined;
    private _deploymentMaximumPercent?;
    /**
     * @stability stable
     */
    get deploymentMaximumPercent(): number;
    /**
     * @stability stable
     */
    set deploymentMaximumPercent(value: number);
    /**
     * @stability stable
     */
    resetDeploymentMaximumPercent(): void;
    /**
     * @stability stable
     */
    get deploymentMaximumPercentInput(): number | undefined;
    private _deploymentMinimumHealthyPercent?;
    /**
     * @stability stable
     */
    get deploymentMinimumHealthyPercent(): number;
    /**
     * @stability stable
     */
    set deploymentMinimumHealthyPercent(value: number);
    /**
     * @stability stable
     */
    resetDeploymentMinimumHealthyPercent(): void;
    /**
     * @stability stable
     */
    get deploymentMinimumHealthyPercentInput(): number | undefined;
    private _desiredCount?;
    /**
     * @stability stable
     */
    get desiredCount(): number;
    /**
     * @stability stable
     */
    set desiredCount(value: number);
    /**
     * @stability stable
     */
    resetDesiredCount(): void;
    /**
     * @stability stable
     */
    get desiredCountInput(): number | undefined;
    private _enableEcsManagedTags?;
    /**
     * @stability stable
     */
    get enableEcsManagedTags(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableEcsManagedTags(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableEcsManagedTags(): void;
    /**
     * @stability stable
     */
    get enableEcsManagedTagsInput(): boolean | cdktf.IResolvable | undefined;
    private _enableExecuteCommand?;
    /**
     * @stability stable
     */
    get enableExecuteCommand(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableExecuteCommand(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableExecuteCommand(): void;
    /**
     * @stability stable
     */
    get enableExecuteCommandInput(): boolean | cdktf.IResolvable | undefined;
    private _forceNewDeployment?;
    /**
     * @stability stable
     */
    get forceNewDeployment(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set forceNewDeployment(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetForceNewDeployment(): void;
    /**
     * @stability stable
     */
    get forceNewDeploymentInput(): boolean | cdktf.IResolvable | undefined;
    private _healthCheckGracePeriodSeconds?;
    /**
     * @stability stable
     */
    get healthCheckGracePeriodSeconds(): number;
    /**
     * @stability stable
     */
    set healthCheckGracePeriodSeconds(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckGracePeriodSeconds(): void;
    /**
     * @stability stable
     */
    get healthCheckGracePeriodSecondsInput(): number | undefined;
    private _iamRole?;
    /**
     * @stability stable
     */
    get iamRole(): string;
    /**
     * @stability stable
     */
    set iamRole(value: string);
    /**
     * @stability stable
     */
    resetIamRole(): void;
    /**
     * @stability stable
     */
    get iamRoleInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _launchType?;
    /**
     * @stability stable
     */
    get launchType(): string;
    /**
     * @stability stable
     */
    set launchType(value: string);
    /**
     * @stability stable
     */
    resetLaunchType(): void;
    /**
     * @stability stable
     */
    get launchTypeInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _platformVersion?;
    /**
     * @stability stable
     */
    get platformVersion(): string;
    /**
     * @stability stable
     */
    set platformVersion(value: string);
    /**
     * @stability stable
     */
    resetPlatformVersion(): void;
    /**
     * @stability stable
     */
    get platformVersionInput(): string | undefined;
    private _propagateTags?;
    /**
     * @stability stable
     */
    get propagateTags(): string;
    /**
     * @stability stable
     */
    set propagateTags(value: string);
    /**
     * @stability stable
     */
    resetPropagateTags(): void;
    /**
     * @stability stable
     */
    get propagateTagsInput(): string | undefined;
    private _schedulingStrategy?;
    /**
     * @stability stable
     */
    get schedulingStrategy(): string;
    /**
     * @stability stable
     */
    set schedulingStrategy(value: string);
    /**
     * @stability stable
     */
    resetSchedulingStrategy(): void;
    /**
     * @stability stable
     */
    get schedulingStrategyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _taskDefinition?;
    /**
     * @stability stable
     */
    get taskDefinition(): string;
    /**
     * @stability stable
     */
    set taskDefinition(value: string);
    /**
     * @stability stable
     */
    resetTaskDefinition(): void;
    /**
     * @stability stable
     */
    get taskDefinitionInput(): string | undefined;
    private _waitForSteadyState?;
    /**
     * @stability stable
     */
    get waitForSteadyState(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set waitForSteadyState(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetWaitForSteadyState(): void;
    /**
     * @stability stable
     */
    get waitForSteadyStateInput(): boolean | cdktf.IResolvable | undefined;
    private _capacityProviderStrategy?;
    /**
     * @stability stable
     */
    get capacityProviderStrategy(): EcsServiceCapacityProviderStrategy[];
    /**
     * @stability stable
     */
    set capacityProviderStrategy(value: EcsServiceCapacityProviderStrategy[]);
    /**
     * @stability stable
     */
    resetCapacityProviderStrategy(): void;
    /**
     * @stability stable
     */
    get capacityProviderStrategyInput(): EcsServiceCapacityProviderStrategy[] | undefined;
    private _deploymentCircuitBreaker?;
    /**
     * @stability stable
     */
    get deploymentCircuitBreaker(): EcsServiceDeploymentCircuitBreaker[];
    /**
     * @stability stable
     */
    set deploymentCircuitBreaker(value: EcsServiceDeploymentCircuitBreaker[]);
    /**
     * @stability stable
     */
    resetDeploymentCircuitBreaker(): void;
    /**
     * @stability stable
     */
    get deploymentCircuitBreakerInput(): EcsServiceDeploymentCircuitBreaker[] | undefined;
    private _deploymentController?;
    /**
     * @stability stable
     */
    get deploymentController(): EcsServiceDeploymentController[];
    /**
     * @stability stable
     */
    set deploymentController(value: EcsServiceDeploymentController[]);
    /**
     * @stability stable
     */
    resetDeploymentController(): void;
    /**
     * @stability stable
     */
    get deploymentControllerInput(): EcsServiceDeploymentController[] | undefined;
    private _loadBalancer?;
    /**
     * @stability stable
     */
    get loadBalancer(): EcsServiceLoadBalancer[];
    /**
     * @stability stable
     */
    set loadBalancer(value: EcsServiceLoadBalancer[]);
    /**
     * @stability stable
     */
    resetLoadBalancer(): void;
    /**
     * @stability stable
     */
    get loadBalancerInput(): EcsServiceLoadBalancer[] | undefined;
    private _networkConfiguration?;
    /**
     * @stability stable
     */
    get networkConfiguration(): EcsServiceNetworkConfiguration[];
    /**
     * @stability stable
     */
    set networkConfiguration(value: EcsServiceNetworkConfiguration[]);
    /**
     * @stability stable
     */
    resetNetworkConfiguration(): void;
    /**
     * @stability stable
     */
    get networkConfigurationInput(): EcsServiceNetworkConfiguration[] | undefined;
    private _orderedPlacementStrategy?;
    /**
     * @stability stable
     */
    get orderedPlacementStrategy(): EcsServiceOrderedPlacementStrategy[];
    /**
     * @stability stable
     */
    set orderedPlacementStrategy(value: EcsServiceOrderedPlacementStrategy[]);
    /**
     * @stability stable
     */
    resetOrderedPlacementStrategy(): void;
    /**
     * @stability stable
     */
    get orderedPlacementStrategyInput(): EcsServiceOrderedPlacementStrategy[] | undefined;
    private _placementConstraints?;
    /**
     * @stability stable
     */
    get placementConstraints(): EcsServicePlacementConstraints[];
    /**
     * @stability stable
     */
    set placementConstraints(value: EcsServicePlacementConstraints[]);
    /**
     * @stability stable
     */
    resetPlacementConstraints(): void;
    /**
     * @stability stable
     */
    get placementConstraintsInput(): EcsServicePlacementConstraints[] | undefined;
    private _serviceRegistries?;
    /**
     * @stability stable
     */
    get serviceRegistries(): EcsServiceServiceRegistries[];
    /**
     * @stability stable
     */
    set serviceRegistries(value: EcsServiceServiceRegistries[]);
    /**
     * @stability stable
     */
    resetServiceRegistries(): void;
    /**
     * @stability stable
     */
    get serviceRegistriesInput(): EcsServiceServiceRegistries[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): EcsServiceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: EcsServiceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EcsServiceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
