import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EfsBackupPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy.html#file_system_id EfsBackupPolicy#file_system_id}.
     *
     * @stability stable
     */
    readonly fileSystemId: string;
    /**
     * backup_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy.html#backup_policy EfsBackupPolicy#backup_policy}
     *
     * @stability stable
     */
    readonly backupPolicy: EfsBackupPolicyBackupPolicy[];
}
/**
 * @stability stable
 */
export interface EfsBackupPolicyBackupPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy.html#status EfsBackupPolicy#status}.
     *
     * @stability stable
     */
    readonly status: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy.html aws_efs_backup_policy}.
 *
 * @stability stable
 */
export declare class EfsBackupPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy.html aws_efs_backup_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EfsBackupPolicyConfig);
    private _fileSystemId;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    set fileSystemId(value: string);
    /**
     * @stability stable
     */
    get fileSystemIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _backupPolicy;
    /**
     * @stability stable
     */
    get backupPolicy(): EfsBackupPolicyBackupPolicy[];
    /**
     * @stability stable
     */
    set backupPolicy(value: EfsBackupPolicyBackupPolicy[]);
    /**
     * @stability stable
     */
    get backupPolicyInput(): EfsBackupPolicyBackupPolicy[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
