import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElasticsearchDomainConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#access_policies ElasticsearchDomain#access_policies}.
     *
     * @stability stable
     */
    readonly accessPolicies?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#advanced_options ElasticsearchDomain#advanced_options}.
     *
     * @stability stable
     */
    readonly advancedOptions?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#domain_name ElasticsearchDomain#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#elasticsearch_version ElasticsearchDomain#elasticsearch_version}.
     *
     * @stability stable
     */
    readonly elasticsearchVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#tags ElasticsearchDomain#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#tags_all ElasticsearchDomain#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * advanced_security_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#advanced_security_options ElasticsearchDomain#advanced_security_options}
     *
     * @stability stable
     */
    readonly advancedSecurityOptions?: ElasticsearchDomainAdvancedSecurityOptions[];
    /**
     * cluster_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#cluster_config ElasticsearchDomain#cluster_config}
     *
     * @stability stable
     */
    readonly clusterConfig?: ElasticsearchDomainClusterConfig[];
    /**
     * cognito_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#cognito_options ElasticsearchDomain#cognito_options}
     *
     * @stability stable
     */
    readonly cognitoOptions?: ElasticsearchDomainCognitoOptions[];
    /**
     * domain_endpoint_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#domain_endpoint_options ElasticsearchDomain#domain_endpoint_options}
     *
     * @stability stable
     */
    readonly domainEndpointOptions?: ElasticsearchDomainDomainEndpointOptions[];
    /**
     * ebs_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#ebs_options ElasticsearchDomain#ebs_options}
     *
     * @stability stable
     */
    readonly ebsOptions?: ElasticsearchDomainEbsOptions[];
    /**
     * encrypt_at_rest block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#encrypt_at_rest ElasticsearchDomain#encrypt_at_rest}
     *
     * @stability stable
     */
    readonly encryptAtRest?: ElasticsearchDomainEncryptAtRest[];
    /**
     * log_publishing_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#log_publishing_options ElasticsearchDomain#log_publishing_options}
     *
     * @stability stable
     */
    readonly logPublishingOptions?: ElasticsearchDomainLogPublishingOptions[];
    /**
     * node_to_node_encryption block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#node_to_node_encryption ElasticsearchDomain#node_to_node_encryption}
     *
     * @stability stable
     */
    readonly nodeToNodeEncryption?: ElasticsearchDomainNodeToNodeEncryption[];
    /**
     * snapshot_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#snapshot_options ElasticsearchDomain#snapshot_options}
     *
     * @stability stable
     */
    readonly snapshotOptions?: ElasticsearchDomainSnapshotOptions[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#timeouts ElasticsearchDomain#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ElasticsearchDomainTimeouts;
    /**
     * vpc_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#vpc_options ElasticsearchDomain#vpc_options}
     *
     * @stability stable
     */
    readonly vpcOptions?: ElasticsearchDomainVpcOptions[];
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainAdvancedSecurityOptionsMasterUserOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#master_user_arn ElasticsearchDomain#master_user_arn}.
     *
     * @stability stable
     */
    readonly masterUserArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#master_user_name ElasticsearchDomain#master_user_name}.
     *
     * @stability stable
     */
    readonly masterUserName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#master_user_password ElasticsearchDomain#master_user_password}.
     *
     * @stability stable
     */
    readonly masterUserPassword?: string;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainAdvancedSecurityOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#enabled ElasticsearchDomain#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#internal_user_database_enabled ElasticsearchDomain#internal_user_database_enabled}.
     *
     * @stability stable
     */
    readonly internalUserDatabaseEnabled?: boolean | cdktf.IResolvable;
    /**
     * master_user_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#master_user_options ElasticsearchDomain#master_user_options}
     *
     * @stability stable
     */
    readonly masterUserOptions?: ElasticsearchDomainAdvancedSecurityOptionsMasterUserOptions[];
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainClusterConfigZoneAwarenessConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#availability_zone_count ElasticsearchDomain#availability_zone_count}.
     *
     * @stability stable
     */
    readonly availabilityZoneCount?: number;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainClusterConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#dedicated_master_count ElasticsearchDomain#dedicated_master_count}.
     *
     * @stability stable
     */
    readonly dedicatedMasterCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#dedicated_master_enabled ElasticsearchDomain#dedicated_master_enabled}.
     *
     * @stability stable
     */
    readonly dedicatedMasterEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#dedicated_master_type ElasticsearchDomain#dedicated_master_type}.
     *
     * @stability stable
     */
    readonly dedicatedMasterType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#instance_count ElasticsearchDomain#instance_count}.
     *
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#instance_type ElasticsearchDomain#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#warm_count ElasticsearchDomain#warm_count}.
     *
     * @stability stable
     */
    readonly warmCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#warm_enabled ElasticsearchDomain#warm_enabled}.
     *
     * @stability stable
     */
    readonly warmEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#warm_type ElasticsearchDomain#warm_type}.
     *
     * @stability stable
     */
    readonly warmType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#zone_awareness_enabled ElasticsearchDomain#zone_awareness_enabled}.
     *
     * @stability stable
     */
    readonly zoneAwarenessEnabled?: boolean | cdktf.IResolvable;
    /**
     * zone_awareness_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#zone_awareness_config ElasticsearchDomain#zone_awareness_config}
     *
     * @stability stable
     */
    readonly zoneAwarenessConfig?: ElasticsearchDomainClusterConfigZoneAwarenessConfig[];
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainCognitoOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#enabled ElasticsearchDomain#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#identity_pool_id ElasticsearchDomain#identity_pool_id}.
     *
     * @stability stable
     */
    readonly identityPoolId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#role_arn ElasticsearchDomain#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#user_pool_id ElasticsearchDomain#user_pool_id}.
     *
     * @stability stable
     */
    readonly userPoolId: string;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainDomainEndpointOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#custom_endpoint ElasticsearchDomain#custom_endpoint}.
     *
     * @stability stable
     */
    readonly customEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#custom_endpoint_certificate_arn ElasticsearchDomain#custom_endpoint_certificate_arn}.
     *
     * @stability stable
     */
    readonly customEndpointCertificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#custom_endpoint_enabled ElasticsearchDomain#custom_endpoint_enabled}.
     *
     * @stability stable
     */
    readonly customEndpointEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#enforce_https ElasticsearchDomain#enforce_https}.
     *
     * @stability stable
     */
    readonly enforceHttps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#tls_security_policy ElasticsearchDomain#tls_security_policy}.
     *
     * @stability stable
     */
    readonly tlsSecurityPolicy?: string;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainEbsOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#ebs_enabled ElasticsearchDomain#ebs_enabled}.
     *
     * @stability stable
     */
    readonly ebsEnabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#iops ElasticsearchDomain#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#volume_size ElasticsearchDomain#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#volume_type ElasticsearchDomain#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainEncryptAtRest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#enabled ElasticsearchDomain#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#kms_key_id ElasticsearchDomain#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainLogPublishingOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#cloudwatch_log_group_arn ElasticsearchDomain#cloudwatch_log_group_arn}.
     *
     * @stability stable
     */
    readonly cloudwatchLogGroupArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#enabled ElasticsearchDomain#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#log_type ElasticsearchDomain#log_type}.
     *
     * @stability stable
     */
    readonly logType: string;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainNodeToNodeEncryption {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#enabled ElasticsearchDomain#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainSnapshotOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#automated_snapshot_start_hour ElasticsearchDomain#automated_snapshot_start_hour}.
     *
     * @stability stable
     */
    readonly automatedSnapshotStartHour: number;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#update ElasticsearchDomain#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainVpcOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#security_group_ids ElasticsearchDomain#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html#subnet_ids ElasticsearchDomain#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html aws_elasticsearch_domain}.
 *
 * @stability stable
 */
export declare class ElasticsearchDomain extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain.html aws_elasticsearch_domain} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticsearchDomainConfig);
    private _accessPolicies?;
    /**
     * @stability stable
     */
    get accessPolicies(): string;
    /**
     * @stability stable
     */
    set accessPolicies(value: string);
    /**
     * @stability stable
     */
    resetAccessPolicies(): void;
    /**
     * @stability stable
     */
    get accessPoliciesInput(): string | undefined;
    private _advancedOptions?;
    /**
     * @stability stable
     */
    get advancedOptions(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set advancedOptions(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAdvancedOptions(): void;
    /**
     * @stability stable
     */
    get advancedOptionsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get domainId(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    private _elasticsearchVersion?;
    /**
     * @stability stable
     */
    get elasticsearchVersion(): string;
    /**
     * @stability stable
     */
    set elasticsearchVersion(value: string);
    /**
     * @stability stable
     */
    resetElasticsearchVersion(): void;
    /**
     * @stability stable
     */
    get elasticsearchVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kibanaEndpoint(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _advancedSecurityOptions?;
    /**
     * @stability stable
     */
    get advancedSecurityOptions(): ElasticsearchDomainAdvancedSecurityOptions[];
    /**
     * @stability stable
     */
    set advancedSecurityOptions(value: ElasticsearchDomainAdvancedSecurityOptions[]);
    /**
     * @stability stable
     */
    resetAdvancedSecurityOptions(): void;
    /**
     * @stability stable
     */
    get advancedSecurityOptionsInput(): ElasticsearchDomainAdvancedSecurityOptions[] | undefined;
    private _clusterConfig?;
    /**
     * @stability stable
     */
    get clusterConfig(): ElasticsearchDomainClusterConfig[];
    /**
     * @stability stable
     */
    set clusterConfig(value: ElasticsearchDomainClusterConfig[]);
    /**
     * @stability stable
     */
    resetClusterConfig(): void;
    /**
     * @stability stable
     */
    get clusterConfigInput(): ElasticsearchDomainClusterConfig[] | undefined;
    private _cognitoOptions?;
    /**
     * @stability stable
     */
    get cognitoOptions(): ElasticsearchDomainCognitoOptions[];
    /**
     * @stability stable
     */
    set cognitoOptions(value: ElasticsearchDomainCognitoOptions[]);
    /**
     * @stability stable
     */
    resetCognitoOptions(): void;
    /**
     * @stability stable
     */
    get cognitoOptionsInput(): ElasticsearchDomainCognitoOptions[] | undefined;
    private _domainEndpointOptions?;
    /**
     * @stability stable
     */
    get domainEndpointOptions(): ElasticsearchDomainDomainEndpointOptions[];
    /**
     * @stability stable
     */
    set domainEndpointOptions(value: ElasticsearchDomainDomainEndpointOptions[]);
    /**
     * @stability stable
     */
    resetDomainEndpointOptions(): void;
    /**
     * @stability stable
     */
    get domainEndpointOptionsInput(): ElasticsearchDomainDomainEndpointOptions[] | undefined;
    private _ebsOptions?;
    /**
     * @stability stable
     */
    get ebsOptions(): ElasticsearchDomainEbsOptions[];
    /**
     * @stability stable
     */
    set ebsOptions(value: ElasticsearchDomainEbsOptions[]);
    /**
     * @stability stable
     */
    resetEbsOptions(): void;
    /**
     * @stability stable
     */
    get ebsOptionsInput(): ElasticsearchDomainEbsOptions[] | undefined;
    private _encryptAtRest?;
    /**
     * @stability stable
     */
    get encryptAtRest(): ElasticsearchDomainEncryptAtRest[];
    /**
     * @stability stable
     */
    set encryptAtRest(value: ElasticsearchDomainEncryptAtRest[]);
    /**
     * @stability stable
     */
    resetEncryptAtRest(): void;
    /**
     * @stability stable
     */
    get encryptAtRestInput(): ElasticsearchDomainEncryptAtRest[] | undefined;
    private _logPublishingOptions?;
    /**
     * @stability stable
     */
    get logPublishingOptions(): ElasticsearchDomainLogPublishingOptions[];
    /**
     * @stability stable
     */
    set logPublishingOptions(value: ElasticsearchDomainLogPublishingOptions[]);
    /**
     * @stability stable
     */
    resetLogPublishingOptions(): void;
    /**
     * @stability stable
     */
    get logPublishingOptionsInput(): ElasticsearchDomainLogPublishingOptions[] | undefined;
    private _nodeToNodeEncryption?;
    /**
     * @stability stable
     */
    get nodeToNodeEncryption(): ElasticsearchDomainNodeToNodeEncryption[];
    /**
     * @stability stable
     */
    set nodeToNodeEncryption(value: ElasticsearchDomainNodeToNodeEncryption[]);
    /**
     * @stability stable
     */
    resetNodeToNodeEncryption(): void;
    /**
     * @stability stable
     */
    get nodeToNodeEncryptionInput(): ElasticsearchDomainNodeToNodeEncryption[] | undefined;
    private _snapshotOptions?;
    /**
     * @stability stable
     */
    get snapshotOptions(): ElasticsearchDomainSnapshotOptions[];
    /**
     * @stability stable
     */
    set snapshotOptions(value: ElasticsearchDomainSnapshotOptions[]);
    /**
     * @stability stable
     */
    resetSnapshotOptions(): void;
    /**
     * @stability stable
     */
    get snapshotOptionsInput(): ElasticsearchDomainSnapshotOptions[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ElasticsearchDomainTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ElasticsearchDomainTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ElasticsearchDomainTimeouts | undefined;
    private _vpcOptions?;
    /**
     * @stability stable
     */
    get vpcOptions(): ElasticsearchDomainVpcOptions[];
    /**
     * @stability stable
     */
    set vpcOptions(value: ElasticsearchDomainVpcOptions[]);
    /**
     * @stability stable
     */
    resetVpcOptions(): void;
    /**
     * @stability stable
     */
    get vpcOptionsInput(): ElasticsearchDomainVpcOptions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
