import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#aws_kms_key_arn ElastictranscoderPipeline#aws_kms_key_arn}.
     *
     * @stability stable
     */
    readonly awsKmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#input_bucket ElastictranscoderPipeline#input_bucket}.
     *
     * @stability stable
     */
    readonly inputBucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#name ElastictranscoderPipeline#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#output_bucket ElastictranscoderPipeline#output_bucket}.
     *
     * @stability stable
     */
    readonly outputBucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#role ElastictranscoderPipeline#role}.
     *
     * @stability stable
     */
    readonly role: string;
    /**
     * content_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#content_config ElastictranscoderPipeline#content_config}
     *
     * @stability stable
     */
    readonly contentConfig?: ElastictranscoderPipelineContentConfig[];
    /**
     * content_config_permissions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#content_config_permissions ElastictranscoderPipeline#content_config_permissions}
     *
     * @stability stable
     */
    readonly contentConfigPermissions?: ElastictranscoderPipelineContentConfigPermissions[];
    /**
     * notifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#notifications ElastictranscoderPipeline#notifications}
     *
     * @stability stable
     */
    readonly notifications?: ElastictranscoderPipelineNotifications[];
    /**
     * thumbnail_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#thumbnail_config ElastictranscoderPipeline#thumbnail_config}
     *
     * @stability stable
     */
    readonly thumbnailConfig?: ElastictranscoderPipelineThumbnailConfig[];
    /**
     * thumbnail_config_permissions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#thumbnail_config_permissions ElastictranscoderPipeline#thumbnail_config_permissions}
     *
     * @stability stable
     */
    readonly thumbnailConfigPermissions?: ElastictranscoderPipelineThumbnailConfigPermissions[];
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineContentConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#bucket ElastictranscoderPipeline#bucket}.
     *
     * @stability stable
     */
    readonly bucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#storage_class ElastictranscoderPipeline#storage_class}.
     *
     * @stability stable
     */
    readonly storageClass?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineContentConfigPermissions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#access ElastictranscoderPipeline#access}.
     *
     * @stability stable
     */
    readonly access?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#grantee ElastictranscoderPipeline#grantee}.
     *
     * @stability stable
     */
    readonly grantee?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#grantee_type ElastictranscoderPipeline#grantee_type}.
     *
     * @stability stable
     */
    readonly granteeType?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineNotifications {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#completed ElastictranscoderPipeline#completed}.
     *
     * @stability stable
     */
    readonly completed?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#error ElastictranscoderPipeline#error}.
     *
     * @stability stable
     */
    readonly error?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#progressing ElastictranscoderPipeline#progressing}.
     *
     * @stability stable
     */
    readonly progressing?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#warning ElastictranscoderPipeline#warning}.
     *
     * @stability stable
     */
    readonly warning?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineThumbnailConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#bucket ElastictranscoderPipeline#bucket}.
     *
     * @stability stable
     */
    readonly bucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#storage_class ElastictranscoderPipeline#storage_class}.
     *
     * @stability stable
     */
    readonly storageClass?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineThumbnailConfigPermissions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#access ElastictranscoderPipeline#access}.
     *
     * @stability stable
     */
    readonly access?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#grantee ElastictranscoderPipeline#grantee}.
     *
     * @stability stable
     */
    readonly grantee?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html#grantee_type ElastictranscoderPipeline#grantee_type}.
     *
     * @stability stable
     */
    readonly granteeType?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html aws_elastictranscoder_pipeline}.
 *
 * @stability stable
 */
export declare class ElastictranscoderPipeline extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_pipeline.html aws_elastictranscoder_pipeline} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElastictranscoderPipelineConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsKmsKeyArn?;
    /**
     * @stability stable
     */
    get awsKmsKeyArn(): string;
    /**
     * @stability stable
     */
    set awsKmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetAwsKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get awsKmsKeyArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputBucket;
    /**
     * @stability stable
     */
    get inputBucket(): string;
    /**
     * @stability stable
     */
    set inputBucket(value: string);
    /**
     * @stability stable
     */
    get inputBucketInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _outputBucket?;
    /**
     * @stability stable
     */
    get outputBucket(): string;
    /**
     * @stability stable
     */
    set outputBucket(value: string);
    /**
     * @stability stable
     */
    resetOutputBucket(): void;
    /**
     * @stability stable
     */
    get outputBucketInput(): string | undefined;
    private _role;
    /**
     * @stability stable
     */
    get role(): string;
    /**
     * @stability stable
     */
    set role(value: string);
    /**
     * @stability stable
     */
    get roleInput(): string;
    private _contentConfig?;
    /**
     * @stability stable
     */
    get contentConfig(): ElastictranscoderPipelineContentConfig[];
    /**
     * @stability stable
     */
    set contentConfig(value: ElastictranscoderPipelineContentConfig[]);
    /**
     * @stability stable
     */
    resetContentConfig(): void;
    /**
     * @stability stable
     */
    get contentConfigInput(): ElastictranscoderPipelineContentConfig[] | undefined;
    private _contentConfigPermissions?;
    /**
     * @stability stable
     */
    get contentConfigPermissions(): ElastictranscoderPipelineContentConfigPermissions[];
    /**
     * @stability stable
     */
    set contentConfigPermissions(value: ElastictranscoderPipelineContentConfigPermissions[]);
    /**
     * @stability stable
     */
    resetContentConfigPermissions(): void;
    /**
     * @stability stable
     */
    get contentConfigPermissionsInput(): ElastictranscoderPipelineContentConfigPermissions[] | undefined;
    private _notifications?;
    /**
     * @stability stable
     */
    get notifications(): ElastictranscoderPipelineNotifications[];
    /**
     * @stability stable
     */
    set notifications(value: ElastictranscoderPipelineNotifications[]);
    /**
     * @stability stable
     */
    resetNotifications(): void;
    /**
     * @stability stable
     */
    get notificationsInput(): ElastictranscoderPipelineNotifications[] | undefined;
    private _thumbnailConfig?;
    /**
     * @stability stable
     */
    get thumbnailConfig(): ElastictranscoderPipelineThumbnailConfig[];
    /**
     * @stability stable
     */
    set thumbnailConfig(value: ElastictranscoderPipelineThumbnailConfig[]);
    /**
     * @stability stable
     */
    resetThumbnailConfig(): void;
    /**
     * @stability stable
     */
    get thumbnailConfigInput(): ElastictranscoderPipelineThumbnailConfig[] | undefined;
    private _thumbnailConfigPermissions?;
    /**
     * @stability stable
     */
    get thumbnailConfigPermissions(): ElastictranscoderPipelineThumbnailConfigPermissions[];
    /**
     * @stability stable
     */
    set thumbnailConfigPermissions(value: ElastictranscoderPipelineThumbnailConfigPermissions[]);
    /**
     * @stability stable
     */
    resetThumbnailConfigPermissions(): void;
    /**
     * @stability stable
     */
    get thumbnailConfigPermissionsInput(): ElastictranscoderPipelineThumbnailConfigPermissions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
