import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EmrClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#additional_info EmrCluster#additional_info}.
     *
     * @stability stable
     */
    readonly additionalInfo?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#applications EmrCluster#applications}.
     *
     * @stability stable
     */
    readonly applications?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#autoscaling_role EmrCluster#autoscaling_role}.
     *
     * @stability stable
     */
    readonly autoscalingRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations EmrCluster#configurations}.
     *
     * @stability stable
     */
    readonly configurations?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations_json EmrCluster#configurations_json}.
     *
     * @stability stable
     */
    readonly configurationsJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#custom_ami_id EmrCluster#custom_ami_id}.
     *
     * @stability stable
     */
    readonly customAmiId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_root_volume_size EmrCluster#ebs_root_volume_size}.
     *
     * @stability stable
     */
    readonly ebsRootVolumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#keep_job_flow_alive_when_no_steps EmrCluster#keep_job_flow_alive_when_no_steps}.
     *
     * @stability stable
     */
    readonly keepJobFlowAliveWhenNoSteps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#log_encryption_kms_key_id EmrCluster#log_encryption_kms_key_id}.
     *
     * @stability stable
     */
    readonly logEncryptionKmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#log_uri EmrCluster#log_uri}.
     *
     * @stability stable
     */
    readonly logUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#release_label EmrCluster#release_label}.
     *
     * @stability stable
     */
    readonly releaseLabel: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#scale_down_behavior EmrCluster#scale_down_behavior}.
     *
     * @stability stable
     */
    readonly scaleDownBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#security_configuration EmrCluster#security_configuration}.
     *
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#service_role EmrCluster#service_role}.
     *
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#step EmrCluster#step}.
     *
     * @stability stable
     */
    readonly step?: EmrClusterStep[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#step_concurrency_level EmrCluster#step_concurrency_level}.
     *
     * @stability stable
     */
    readonly stepConcurrencyLevel?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#tags EmrCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#tags_all EmrCluster#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#termination_protection EmrCluster#termination_protection}.
     *
     * @stability stable
     */
    readonly terminationProtection?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#visible_to_all_users EmrCluster#visible_to_all_users}.
     *
     * @stability stable
     */
    readonly visibleToAllUsers?: boolean | cdktf.IResolvable;
    /**
     * bootstrap_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bootstrap_action EmrCluster#bootstrap_action}
     *
     * @stability stable
     */
    readonly bootstrapAction?: EmrClusterBootstrapAction[];
    /**
     * core_instance_fleet block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#core_instance_fleet EmrCluster#core_instance_fleet}
     *
     * @stability stable
     */
    readonly coreInstanceFleet?: EmrClusterCoreInstanceFleet[];
    /**
     * core_instance_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#core_instance_group EmrCluster#core_instance_group}
     *
     * @stability stable
     */
    readonly coreInstanceGroup?: EmrClusterCoreInstanceGroup[];
    /**
     * ec2_attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ec2_attributes EmrCluster#ec2_attributes}
     *
     * @stability stable
     */
    readonly ec2Attributes?: EmrClusterEc2Attributes[];
    /**
     * kerberos_attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#kerberos_attributes EmrCluster#kerberos_attributes}
     *
     * @stability stable
     */
    readonly kerberosAttributes?: EmrClusterKerberosAttributes[];
    /**
     * master_instance_fleet block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#master_instance_fleet EmrCluster#master_instance_fleet}
     *
     * @stability stable
     */
    readonly masterInstanceFleet?: EmrClusterMasterInstanceFleet[];
    /**
     * master_instance_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#master_instance_group EmrCluster#master_instance_group}
     *
     * @stability stable
     */
    readonly masterInstanceGroup?: EmrClusterMasterInstanceGroup[];
}
/**
 * @stability stable
 */
export interface EmrClusterStepHadoopJarStep {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#args EmrCluster#args}.
     *
     * @stability stable
     */
    readonly args?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#jar EmrCluster#jar}.
     *
     * @stability stable
     */
    readonly jar?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#main_class EmrCluster#main_class}.
     *
     * @stability stable
     */
    readonly mainClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#properties EmrCluster#properties}.
     *
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface EmrClusterStep {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#action_on_failure EmrCluster#action_on_failure}.
     *
     * @stability stable
     */
    readonly actionOnFailure?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#hadoop_jar_step EmrCluster#hadoop_jar_step}.
     *
     * @stability stable
     */
    readonly hadoopJarStep?: EmrClusterStepHadoopJarStep[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface EmrClusterBootstrapAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#args EmrCluster#args}.
     *
     * @stability stable
     */
    readonly args?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#path EmrCluster#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#classification EmrCluster#classification}.
     *
     * @stability stable
     */
    readonly classification?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#properties EmrCluster#properties}.
     *
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price_as_percentage_of_on_demand_price EmrCluster#bid_price_as_percentage_of_on_demand_price}.
     *
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#weighted_capacity EmrCluster#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations EmrCluster#configurations}
     *
     * @stability stable
     */
    readonly configurations?: EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations[];
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#block_duration_minutes EmrCluster#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_action EmrCluster#timeout_action}.
     *
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_duration_minutes EmrCluster#timeout_duration_minutes}.
     *
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#on_demand_specification EmrCluster#on_demand_specification}
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[];
    /**
     * spot_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#spot_specification EmrCluster#spot_specification}
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[];
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleet {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_on_demand_capacity EmrCluster#target_on_demand_capacity}.
     *
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_spot_capacity EmrCluster#target_spot_capacity}.
     *
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type_configs EmrCluster#instance_type_configs}
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrClusterCoreInstanceFleetInstanceTypeConfigs[];
    /**
     * launch_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#launch_specifications EmrCluster#launch_specifications}
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrClusterCoreInstanceFleetLaunchSpecifications[];
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceGroupEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceGroup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#autoscaling_policy EmrCluster#autoscaling_policy}.
     *
     * @stability stable
     */
    readonly autoscalingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_count EmrCluster#instance_count}.
     *
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterCoreInstanceGroupEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrClusterEc2Attributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#additional_master_security_groups EmrCluster#additional_master_security_groups}.
     *
     * @stability stable
     */
    readonly additionalMasterSecurityGroups?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#additional_slave_security_groups EmrCluster#additional_slave_security_groups}.
     *
     * @stability stable
     */
    readonly additionalSlaveSecurityGroups?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#emr_managed_master_security_group EmrCluster#emr_managed_master_security_group}.
     *
     * @stability stable
     */
    readonly emrManagedMasterSecurityGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#emr_managed_slave_security_group EmrCluster#emr_managed_slave_security_group}.
     *
     * @stability stable
     */
    readonly emrManagedSlaveSecurityGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_profile EmrCluster#instance_profile}.
     *
     * @stability stable
     */
    readonly instanceProfile: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#key_name EmrCluster#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#service_access_security_group EmrCluster#service_access_security_group}.
     *
     * @stability stable
     */
    readonly serviceAccessSecurityGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#subnet_id EmrCluster#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#subnet_ids EmrCluster#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds?: string[];
}
/**
 * @stability stable
 */
export interface EmrClusterKerberosAttributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ad_domain_join_password EmrCluster#ad_domain_join_password}.
     *
     * @stability stable
     */
    readonly adDomainJoinPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ad_domain_join_user EmrCluster#ad_domain_join_user}.
     *
     * @stability stable
     */
    readonly adDomainJoinUser?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#cross_realm_trust_principal_password EmrCluster#cross_realm_trust_principal_password}.
     *
     * @stability stable
     */
    readonly crossRealmTrustPrincipalPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#kdc_admin_password EmrCluster#kdc_admin_password}.
     *
     * @stability stable
     */
    readonly kdcAdminPassword: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#realm EmrCluster#realm}.
     *
     * @stability stable
     */
    readonly realm: string;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#classification EmrCluster#classification}.
     *
     * @stability stable
     */
    readonly classification?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#properties EmrCluster#properties}.
     *
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price_as_percentage_of_on_demand_price EmrCluster#bid_price_as_percentage_of_on_demand_price}.
     *
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#weighted_capacity EmrCluster#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations EmrCluster#configurations}
     *
     * @stability stable
     */
    readonly configurations?: EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations[];
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#block_duration_minutes EmrCluster#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_action EmrCluster#timeout_action}.
     *
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_duration_minutes EmrCluster#timeout_duration_minutes}.
     *
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#on_demand_specification EmrCluster#on_demand_specification}
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[];
    /**
     * spot_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#spot_specification EmrCluster#spot_specification}
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[];
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleet {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_on_demand_capacity EmrCluster#target_on_demand_capacity}.
     *
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_spot_capacity EmrCluster#target_spot_capacity}.
     *
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type_configs EmrCluster#instance_type_configs}
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrClusterMasterInstanceFleetInstanceTypeConfigs[];
    /**
     * launch_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#launch_specifications EmrCluster#launch_specifications}
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrClusterMasterInstanceFleetLaunchSpecifications[];
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceGroupEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceGroup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_count EmrCluster#instance_count}.
     *
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterMasterInstanceGroupEbsConfig[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html aws_emr_cluster}.
 *
 * @stability stable
 */
export declare class EmrCluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html aws_emr_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrClusterConfig);
    private _additionalInfo?;
    /**
     * @stability stable
     */
    get additionalInfo(): string;
    /**
     * @stability stable
     */
    set additionalInfo(value: string);
    /**
     * @stability stable
     */
    resetAdditionalInfo(): void;
    /**
     * @stability stable
     */
    get additionalInfoInput(): string | undefined;
    private _applications?;
    /**
     * @stability stable
     */
    get applications(): string[];
    /**
     * @stability stable
     */
    set applications(value: string[]);
    /**
     * @stability stable
     */
    resetApplications(): void;
    /**
     * @stability stable
     */
    get applicationsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingRole?;
    /**
     * @stability stable
     */
    get autoscalingRole(): string;
    /**
     * @stability stable
     */
    set autoscalingRole(value: string);
    /**
     * @stability stable
     */
    resetAutoscalingRole(): void;
    /**
     * @stability stable
     */
    get autoscalingRoleInput(): string | undefined;
    /**
     * @stability stable
     */
    get clusterState(): string;
    private _configurations?;
    /**
     * @stability stable
     */
    get configurations(): string;
    /**
     * @stability stable
     */
    set configurations(value: string);
    /**
     * @stability stable
     */
    resetConfigurations(): void;
    /**
     * @stability stable
     */
    get configurationsInput(): string | undefined;
    private _configurationsJson?;
    /**
     * @stability stable
     */
    get configurationsJson(): string;
    /**
     * @stability stable
     */
    set configurationsJson(value: string);
    /**
     * @stability stable
     */
    resetConfigurationsJson(): void;
    /**
     * @stability stable
     */
    get configurationsJsonInput(): string | undefined;
    private _customAmiId?;
    /**
     * @stability stable
     */
    get customAmiId(): string;
    /**
     * @stability stable
     */
    set customAmiId(value: string);
    /**
     * @stability stable
     */
    resetCustomAmiId(): void;
    /**
     * @stability stable
     */
    get customAmiIdInput(): string | undefined;
    private _ebsRootVolumeSize?;
    /**
     * @stability stable
     */
    get ebsRootVolumeSize(): number;
    /**
     * @stability stable
     */
    set ebsRootVolumeSize(value: number);
    /**
     * @stability stable
     */
    resetEbsRootVolumeSize(): void;
    /**
     * @stability stable
     */
    get ebsRootVolumeSizeInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _keepJobFlowAliveWhenNoSteps?;
    /**
     * @stability stable
     */
    get keepJobFlowAliveWhenNoSteps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set keepJobFlowAliveWhenNoSteps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetKeepJobFlowAliveWhenNoSteps(): void;
    /**
     * @stability stable
     */
    get keepJobFlowAliveWhenNoStepsInput(): boolean | cdktf.IResolvable | undefined;
    private _logEncryptionKmsKeyId?;
    /**
     * @stability stable
     */
    get logEncryptionKmsKeyId(): string;
    /**
     * @stability stable
     */
    set logEncryptionKmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetLogEncryptionKmsKeyId(): void;
    /**
     * @stability stable
     */
    get logEncryptionKmsKeyIdInput(): string | undefined;
    private _logUri?;
    /**
     * @stability stable
     */
    get logUri(): string;
    /**
     * @stability stable
     */
    set logUri(value: string);
    /**
     * @stability stable
     */
    resetLogUri(): void;
    /**
     * @stability stable
     */
    get logUriInput(): string | undefined;
    /**
     * @stability stable
     */
    get masterPublicDns(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _releaseLabel;
    /**
     * @stability stable
     */
    get releaseLabel(): string;
    /**
     * @stability stable
     */
    set releaseLabel(value: string);
    /**
     * @stability stable
     */
    get releaseLabelInput(): string;
    private _scaleDownBehavior?;
    /**
     * @stability stable
     */
    get scaleDownBehavior(): string;
    /**
     * @stability stable
     */
    set scaleDownBehavior(value: string);
    /**
     * @stability stable
     */
    resetScaleDownBehavior(): void;
    /**
     * @stability stable
     */
    get scaleDownBehaviorInput(): string | undefined;
    private _securityConfiguration?;
    /**
     * @stability stable
     */
    get securityConfiguration(): string;
    /**
     * @stability stable
     */
    set securityConfiguration(value: string);
    /**
     * @stability stable
     */
    resetSecurityConfiguration(): void;
    /**
     * @stability stable
     */
    get securityConfigurationInput(): string | undefined;
    private _serviceRole;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    get serviceRoleInput(): string;
    private _step?;
    /**
     * @stability stable
     */
    get step(): EmrClusterStep[];
    /**
     * @stability stable
     */
    set step(value: EmrClusterStep[]);
    /**
     * @stability stable
     */
    resetStep(): void;
    /**
     * @stability stable
     */
    get stepInput(): EmrClusterStep[] | undefined;
    private _stepConcurrencyLevel?;
    /**
     * @stability stable
     */
    get stepConcurrencyLevel(): number;
    /**
     * @stability stable
     */
    set stepConcurrencyLevel(value: number);
    /**
     * @stability stable
     */
    resetStepConcurrencyLevel(): void;
    /**
     * @stability stable
     */
    get stepConcurrencyLevelInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _terminationProtection?;
    /**
     * @stability stable
     */
    get terminationProtection(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set terminationProtection(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTerminationProtection(): void;
    /**
     * @stability stable
     */
    get terminationProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _visibleToAllUsers?;
    /**
     * @stability stable
     */
    get visibleToAllUsers(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set visibleToAllUsers(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetVisibleToAllUsers(): void;
    /**
     * @stability stable
     */
    get visibleToAllUsersInput(): boolean | cdktf.IResolvable | undefined;
    private _bootstrapAction?;
    /**
     * @stability stable
     */
    get bootstrapAction(): EmrClusterBootstrapAction[];
    /**
     * @stability stable
     */
    set bootstrapAction(value: EmrClusterBootstrapAction[]);
    /**
     * @stability stable
     */
    resetBootstrapAction(): void;
    /**
     * @stability stable
     */
    get bootstrapActionInput(): EmrClusterBootstrapAction[] | undefined;
    private _coreInstanceFleet?;
    /**
     * @stability stable
     */
    get coreInstanceFleet(): EmrClusterCoreInstanceFleet[];
    /**
     * @stability stable
     */
    set coreInstanceFleet(value: EmrClusterCoreInstanceFleet[]);
    /**
     * @stability stable
     */
    resetCoreInstanceFleet(): void;
    /**
     * @stability stable
     */
    get coreInstanceFleetInput(): EmrClusterCoreInstanceFleet[] | undefined;
    private _coreInstanceGroup?;
    /**
     * @stability stable
     */
    get coreInstanceGroup(): EmrClusterCoreInstanceGroup[];
    /**
     * @stability stable
     */
    set coreInstanceGroup(value: EmrClusterCoreInstanceGroup[]);
    /**
     * @stability stable
     */
    resetCoreInstanceGroup(): void;
    /**
     * @stability stable
     */
    get coreInstanceGroupInput(): EmrClusterCoreInstanceGroup[] | undefined;
    private _ec2Attributes?;
    /**
     * @stability stable
     */
    get ec2Attributes(): EmrClusterEc2Attributes[];
    /**
     * @stability stable
     */
    set ec2Attributes(value: EmrClusterEc2Attributes[]);
    /**
     * @stability stable
     */
    resetEc2Attributes(): void;
    /**
     * @stability stable
     */
    get ec2AttributesInput(): EmrClusterEc2Attributes[] | undefined;
    private _kerberosAttributes?;
    /**
     * @stability stable
     */
    get kerberosAttributes(): EmrClusterKerberosAttributes[];
    /**
     * @stability stable
     */
    set kerberosAttributes(value: EmrClusterKerberosAttributes[]);
    /**
     * @stability stable
     */
    resetKerberosAttributes(): void;
    /**
     * @stability stable
     */
    get kerberosAttributesInput(): EmrClusterKerberosAttributes[] | undefined;
    private _masterInstanceFleet?;
    /**
     * @stability stable
     */
    get masterInstanceFleet(): EmrClusterMasterInstanceFleet[];
    /**
     * @stability stable
     */
    set masterInstanceFleet(value: EmrClusterMasterInstanceFleet[]);
    /**
     * @stability stable
     */
    resetMasterInstanceFleet(): void;
    /**
     * @stability stable
     */
    get masterInstanceFleetInput(): EmrClusterMasterInstanceFleet[] | undefined;
    private _masterInstanceGroup?;
    /**
     * @stability stable
     */
    get masterInstanceGroup(): EmrClusterMasterInstanceGroup[];
    /**
     * @stability stable
     */
    set masterInstanceGroup(value: EmrClusterMasterInstanceGroup[]);
    /**
     * @stability stable
     */
    resetMasterInstanceGroup(): void;
    /**
     * @stability stable
     */
    get masterInstanceGroupInput(): EmrClusterMasterInstanceGroup[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
