import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FmsPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#delete_all_policy_resources FmsPolicy#delete_all_policy_resources}.
     *
     * @stability stable
     */
    readonly deleteAllPolicyResources?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#exclude_resource_tags FmsPolicy#exclude_resource_tags}.
     *
     * @stability stable
     */
    readonly excludeResourceTags: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#name FmsPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#remediation_enabled FmsPolicy#remediation_enabled}.
     *
     * @stability stable
     */
    readonly remediationEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#resource_tags FmsPolicy#resource_tags}.
     *
     * @stability stable
     */
    readonly resourceTags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#resource_type FmsPolicy#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#resource_type_list FmsPolicy#resource_type_list}.
     *
     * @stability stable
     */
    readonly resourceTypeList?: string[];
    /**
     * exclude_map block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#exclude_map FmsPolicy#exclude_map}
     *
     * @stability stable
     */
    readonly excludeMap?: FmsPolicyExcludeMap[];
    /**
     * include_map block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#include_map FmsPolicy#include_map}
     *
     * @stability stable
     */
    readonly includeMap?: FmsPolicyIncludeMap[];
    /**
     * security_service_policy_data block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#security_service_policy_data FmsPolicy#security_service_policy_data}
     *
     * @stability stable
     */
    readonly securityServicePolicyData: FmsPolicySecurityServicePolicyData[];
}
/**
 * @stability stable
 */
export interface FmsPolicyExcludeMap {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#account FmsPolicy#account}.
     *
     * @stability stable
     */
    readonly account?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#orgunit FmsPolicy#orgunit}.
     *
     * @stability stable
     */
    readonly orgunit?: string[];
}
/**
 * @stability stable
 */
export interface FmsPolicyIncludeMap {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#account FmsPolicy#account}.
     *
     * @stability stable
     */
    readonly account?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#orgunit FmsPolicy#orgunit}.
     *
     * @stability stable
     */
    readonly orgunit?: string[];
}
/**
 * @stability stable
 */
export interface FmsPolicySecurityServicePolicyData {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#managed_service_data FmsPolicy#managed_service_data}.
     *
     * @stability stable
     */
    readonly managedServiceData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html#type FmsPolicy#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html aws_fms_policy}.
 *
 * @stability stable
 */
export declare class FmsPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fms_policy.html aws_fms_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FmsPolicyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deleteAllPolicyResources?;
    /**
     * @stability stable
     */
    get deleteAllPolicyResources(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deleteAllPolicyResources(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeleteAllPolicyResources(): void;
    /**
     * @stability stable
     */
    get deleteAllPolicyResourcesInput(): boolean | cdktf.IResolvable | undefined;
    private _excludeResourceTags;
    /**
     * @stability stable
     */
    get excludeResourceTags(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set excludeResourceTags(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get excludeResourceTagsInput(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get policyUpdateToken(): string;
    private _remediationEnabled?;
    /**
     * @stability stable
     */
    get remediationEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set remediationEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRemediationEnabled(): void;
    /**
     * @stability stable
     */
    get remediationEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _resourceTags?;
    /**
     * @stability stable
     */
    get resourceTags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set resourceTags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetResourceTags(): void;
    /**
     * @stability stable
     */
    get resourceTagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _resourceType?;
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    set resourceType(value: string);
    /**
     * @stability stable
     */
    resetResourceType(): void;
    /**
     * @stability stable
     */
    get resourceTypeInput(): string | undefined;
    private _resourceTypeList?;
    /**
     * @stability stable
     */
    get resourceTypeList(): string[];
    /**
     * @stability stable
     */
    set resourceTypeList(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypeList(): void;
    /**
     * @stability stable
     */
    get resourceTypeListInput(): string[] | undefined;
    private _excludeMap?;
    /**
     * @stability stable
     */
    get excludeMap(): FmsPolicyExcludeMap[];
    /**
     * @stability stable
     */
    set excludeMap(value: FmsPolicyExcludeMap[]);
    /**
     * @stability stable
     */
    resetExcludeMap(): void;
    /**
     * @stability stable
     */
    get excludeMapInput(): FmsPolicyExcludeMap[] | undefined;
    private _includeMap?;
    /**
     * @stability stable
     */
    get includeMap(): FmsPolicyIncludeMap[];
    /**
     * @stability stable
     */
    set includeMap(value: FmsPolicyIncludeMap[]);
    /**
     * @stability stable
     */
    resetIncludeMap(): void;
    /**
     * @stability stable
     */
    get includeMapInput(): FmsPolicyIncludeMap[] | undefined;
    private _securityServicePolicyData;
    /**
     * @stability stable
     */
    get securityServicePolicyData(): FmsPolicySecurityServicePolicyData[];
    /**
     * @stability stable
     */
    set securityServicePolicyData(value: FmsPolicySecurityServicePolicyData[]);
    /**
     * @stability stable
     */
    get securityServicePolicyDataInput(): FmsPolicySecurityServicePolicyData[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
