import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FsxOntapFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#automatic_backup_retention_days FsxOntapFileSystem#automatic_backup_retention_days}.
     *
     * @stability stable
     */
    readonly automaticBackupRetentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#daily_automatic_backup_start_time FsxOntapFileSystem#daily_automatic_backup_start_time}.
     *
     * @stability stable
     */
    readonly dailyAutomaticBackupStartTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#deployment_type FsxOntapFileSystem#deployment_type}.
     *
     * @stability stable
     */
    readonly deploymentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#endpoint_ip_address_range FsxOntapFileSystem#endpoint_ip_address_range}.
     *
     * @stability stable
     */
    readonly endpointIpAddressRange?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#fsx_admin_password FsxOntapFileSystem#fsx_admin_password}.
     *
     * @stability stable
     */
    readonly fsxAdminPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#kms_key_id FsxOntapFileSystem#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#preferred_subnet_id FsxOntapFileSystem#preferred_subnet_id}.
     *
     * @stability stable
     */
    readonly preferredSubnetId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#route_table_ids FsxOntapFileSystem#route_table_ids}.
     *
     * @stability stable
     */
    readonly routeTableIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#security_group_ids FsxOntapFileSystem#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#storage_capacity FsxOntapFileSystem#storage_capacity}.
     *
     * @stability stable
     */
    readonly storageCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#storage_type FsxOntapFileSystem#storage_type}.
     *
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#subnet_ids FsxOntapFileSystem#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#tags FsxOntapFileSystem#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#tags_all FsxOntapFileSystem#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#throughput_capacity FsxOntapFileSystem#throughput_capacity}.
     *
     * @stability stable
     */
    readonly throughputCapacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#weekly_maintenance_start_time FsxOntapFileSystem#weekly_maintenance_start_time}.
     *
     * @stability stable
     */
    readonly weeklyMaintenanceStartTime?: string;
    /**
     * disk_iops_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#disk_iops_configuration FsxOntapFileSystem#disk_iops_configuration}
     *
     * @stability stable
     */
    readonly diskIopsConfiguration?: FsxOntapFileSystemDiskIopsConfiguration[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#timeouts FsxOntapFileSystem#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FsxOntapFileSystemTimeouts;
}
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemEndpointsIntercluster extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get ipAddresses(): string[];
}
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemEndpointsManagement extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get ipAddresses(): string[];
}
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemEndpoints extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get intercluster(): any;
    /**
     * @stability stable
     */
    get management(): any;
}
/**
 * @stability stable
 */
export interface FsxOntapFileSystemDiskIopsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#iops FsxOntapFileSystem#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#mode FsxOntapFileSystem#mode}.
     *
     * @stability stable
     */
    readonly mode?: string;
}
/**
 * @stability stable
 */
export interface FsxOntapFileSystemTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#create FsxOntapFileSystem#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#delete FsxOntapFileSystem#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html#update FsxOntapFileSystem#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html aws_fsx_ontap_file_system}.
 *
 * @stability stable
 */
export declare class FsxOntapFileSystem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system.html aws_fsx_ontap_file_system} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxOntapFileSystemConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _automaticBackupRetentionDays?;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDays(): number;
    /**
     * @stability stable
     */
    set automaticBackupRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetAutomaticBackupRetentionDays(): void;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDaysInput(): number | undefined;
    private _dailyAutomaticBackupStartTime?;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTime(): string;
    /**
     * @stability stable
     */
    set dailyAutomaticBackupStartTime(value: string);
    /**
     * @stability stable
     */
    resetDailyAutomaticBackupStartTime(): void;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTimeInput(): string | undefined;
    private _deploymentType;
    /**
     * @stability stable
     */
    get deploymentType(): string;
    /**
     * @stability stable
     */
    set deploymentType(value: string);
    /**
     * @stability stable
     */
    get deploymentTypeInput(): string;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _endpointIpAddressRange?;
    /**
     * @stability stable
     */
    get endpointIpAddressRange(): string;
    /**
     * @stability stable
     */
    set endpointIpAddressRange(value: string);
    /**
     * @stability stable
     */
    resetEndpointIpAddressRange(): void;
    /**
     * @stability stable
     */
    get endpointIpAddressRangeInput(): string | undefined;
    /**
     * @stability stable
     */
    endpoints(index: string): FsxOntapFileSystemEndpoints;
    private _fsxAdminPassword?;
    /**
     * @stability stable
     */
    get fsxAdminPassword(): string;
    /**
     * @stability stable
     */
    set fsxAdminPassword(value: string);
    /**
     * @stability stable
     */
    resetFsxAdminPassword(): void;
    /**
     * @stability stable
     */
    get fsxAdminPasswordInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _preferredSubnetId;
    /**
     * @stability stable
     */
    get preferredSubnetId(): string;
    /**
     * @stability stable
     */
    set preferredSubnetId(value: string);
    /**
     * @stability stable
     */
    get preferredSubnetIdInput(): string;
    private _routeTableIds?;
    /**
     * @stability stable
     */
    get routeTableIds(): string[];
    /**
     * @stability stable
     */
    set routeTableIds(value: string[]);
    /**
     * @stability stable
     */
    resetRouteTableIds(): void;
    /**
     * @stability stable
     */
    get routeTableIdsInput(): string[] | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _storageCapacity?;
    /**
     * @stability stable
     */
    get storageCapacity(): number;
    /**
     * @stability stable
     */
    set storageCapacity(value: number);
    /**
     * @stability stable
     */
    resetStorageCapacity(): void;
    /**
     * @stability stable
     */
    get storageCapacityInput(): number | undefined;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _throughputCapacity;
    /**
     * @stability stable
     */
    get throughputCapacity(): number;
    /**
     * @stability stable
     */
    set throughputCapacity(value: number);
    /**
     * @stability stable
     */
    get throughputCapacityInput(): number;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _weeklyMaintenanceStartTime?;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTime(): string;
    /**
     * @stability stable
     */
    set weeklyMaintenanceStartTime(value: string);
    /**
     * @stability stable
     */
    resetWeeklyMaintenanceStartTime(): void;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTimeInput(): string | undefined;
    private _diskIopsConfiguration?;
    /**
     * @stability stable
     */
    get diskIopsConfiguration(): FsxOntapFileSystemDiskIopsConfiguration[];
    /**
     * @stability stable
     */
    set diskIopsConfiguration(value: FsxOntapFileSystemDiskIopsConfiguration[]);
    /**
     * @stability stable
     */
    resetDiskIopsConfiguration(): void;
    /**
     * @stability stable
     */
    get diskIopsConfigurationInput(): FsxOntapFileSystemDiskIopsConfiguration[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): FsxOntapFileSystemTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: FsxOntapFileSystemTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxOntapFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
