import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#active_directory_id FsxWindowsFileSystem#active_directory_id}.
     *
     * @stability stable
     */
    readonly activeDirectoryId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#aliases FsxWindowsFileSystem#aliases}.
     *
     * @stability stable
     */
    readonly aliases?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#automatic_backup_retention_days FsxWindowsFileSystem#automatic_backup_retention_days}.
     *
     * @stability stable
     */
    readonly automaticBackupRetentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#backup_id FsxWindowsFileSystem#backup_id}.
     *
     * @stability stable
     */
    readonly backupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#copy_tags_to_backups FsxWindowsFileSystem#copy_tags_to_backups}.
     *
     * @stability stable
     */
    readonly copyTagsToBackups?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#daily_automatic_backup_start_time FsxWindowsFileSystem#daily_automatic_backup_start_time}.
     *
     * @stability stable
     */
    readonly dailyAutomaticBackupStartTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#deployment_type FsxWindowsFileSystem#deployment_type}.
     *
     * @stability stable
     */
    readonly deploymentType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#kms_key_id FsxWindowsFileSystem#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#preferred_subnet_id FsxWindowsFileSystem#preferred_subnet_id}.
     *
     * @stability stable
     */
    readonly preferredSubnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#security_group_ids FsxWindowsFileSystem#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#skip_final_backup FsxWindowsFileSystem#skip_final_backup}.
     *
     * @stability stable
     */
    readonly skipFinalBackup?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#storage_capacity FsxWindowsFileSystem#storage_capacity}.
     *
     * @stability stable
     */
    readonly storageCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#storage_type FsxWindowsFileSystem#storage_type}.
     *
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#subnet_ids FsxWindowsFileSystem#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#tags FsxWindowsFileSystem#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#tags_all FsxWindowsFileSystem#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#throughput_capacity FsxWindowsFileSystem#throughput_capacity}.
     *
     * @stability stable
     */
    readonly throughputCapacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#weekly_maintenance_start_time FsxWindowsFileSystem#weekly_maintenance_start_time}.
     *
     * @stability stable
     */
    readonly weeklyMaintenanceStartTime?: string;
    /**
     * audit_log_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#audit_log_configuration FsxWindowsFileSystem#audit_log_configuration}
     *
     * @stability stable
     */
    readonly auditLogConfiguration?: FsxWindowsFileSystemAuditLogConfiguration[];
    /**
     * self_managed_active_directory block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#self_managed_active_directory FsxWindowsFileSystem#self_managed_active_directory}
     *
     * @stability stable
     */
    readonly selfManagedActiveDirectory?: FsxWindowsFileSystemSelfManagedActiveDirectory[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#timeouts FsxWindowsFileSystem#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FsxWindowsFileSystemTimeouts;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemAuditLogConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#audit_log_destination FsxWindowsFileSystem#audit_log_destination}.
     *
     * @stability stable
     */
    readonly auditLogDestination?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#file_access_audit_log_level FsxWindowsFileSystem#file_access_audit_log_level}.
     *
     * @stability stable
     */
    readonly fileAccessAuditLogLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#file_share_access_audit_log_level FsxWindowsFileSystem#file_share_access_audit_log_level}.
     *
     * @stability stable
     */
    readonly fileShareAccessAuditLogLevel?: string;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemSelfManagedActiveDirectory {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#dns_ips FsxWindowsFileSystem#dns_ips}.
     *
     * @stability stable
     */
    readonly dnsIps: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#domain_name FsxWindowsFileSystem#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#file_system_administrators_group FsxWindowsFileSystem#file_system_administrators_group}.
     *
     * @stability stable
     */
    readonly fileSystemAdministratorsGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#organizational_unit_distinguished_name FsxWindowsFileSystem#organizational_unit_distinguished_name}.
     *
     * @stability stable
     */
    readonly organizationalUnitDistinguishedName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#password FsxWindowsFileSystem#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#username FsxWindowsFileSystem#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#create FsxWindowsFileSystem#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#delete FsxWindowsFileSystem#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html#update FsxWindowsFileSystem#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html aws_fsx_windows_file_system}.
 *
 * @stability stable
 */
export declare class FsxWindowsFileSystem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system.html aws_fsx_windows_file_system} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxWindowsFileSystemConfig);
    private _activeDirectoryId?;
    /**
     * @stability stable
     */
    get activeDirectoryId(): string;
    /**
     * @stability stable
     */
    set activeDirectoryId(value: string);
    /**
     * @stability stable
     */
    resetActiveDirectoryId(): void;
    /**
     * @stability stable
     */
    get activeDirectoryIdInput(): string | undefined;
    private _aliases?;
    /**
     * @stability stable
     */
    get aliases(): string[];
    /**
     * @stability stable
     */
    set aliases(value: string[]);
    /**
     * @stability stable
     */
    resetAliases(): void;
    /**
     * @stability stable
     */
    get aliasesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _automaticBackupRetentionDays?;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDays(): number;
    /**
     * @stability stable
     */
    set automaticBackupRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetAutomaticBackupRetentionDays(): void;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDaysInput(): number | undefined;
    private _backupId?;
    /**
     * @stability stable
     */
    get backupId(): string;
    /**
     * @stability stable
     */
    set backupId(value: string);
    /**
     * @stability stable
     */
    resetBackupId(): void;
    /**
     * @stability stable
     */
    get backupIdInput(): string | undefined;
    private _copyTagsToBackups?;
    /**
     * @stability stable
     */
    get copyTagsToBackups(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set copyTagsToBackups(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCopyTagsToBackups(): void;
    /**
     * @stability stable
     */
    get copyTagsToBackupsInput(): boolean | cdktf.IResolvable | undefined;
    private _dailyAutomaticBackupStartTime?;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTime(): string;
    /**
     * @stability stable
     */
    set dailyAutomaticBackupStartTime(value: string);
    /**
     * @stability stable
     */
    resetDailyAutomaticBackupStartTime(): void;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTimeInput(): string | undefined;
    private _deploymentType?;
    /**
     * @stability stable
     */
    get deploymentType(): string;
    /**
     * @stability stable
     */
    set deploymentType(value: string);
    /**
     * @stability stable
     */
    resetDeploymentType(): void;
    /**
     * @stability stable
     */
    get deploymentTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get preferredFileServerIp(): string;
    private _preferredSubnetId?;
    /**
     * @stability stable
     */
    get preferredSubnetId(): string;
    /**
     * @stability stable
     */
    set preferredSubnetId(value: string);
    /**
     * @stability stable
     */
    resetPreferredSubnetId(): void;
    /**
     * @stability stable
     */
    get preferredSubnetIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get remoteAdministrationEndpoint(): string;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _skipFinalBackup?;
    /**
     * @stability stable
     */
    get skipFinalBackup(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set skipFinalBackup(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSkipFinalBackup(): void;
    /**
     * @stability stable
     */
    get skipFinalBackupInput(): boolean | cdktf.IResolvable | undefined;
    private _storageCapacity?;
    /**
     * @stability stable
     */
    get storageCapacity(): number;
    /**
     * @stability stable
     */
    set storageCapacity(value: number);
    /**
     * @stability stable
     */
    resetStorageCapacity(): void;
    /**
     * @stability stable
     */
    get storageCapacityInput(): number | undefined;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _throughputCapacity;
    /**
     * @stability stable
     */
    get throughputCapacity(): number;
    /**
     * @stability stable
     */
    set throughputCapacity(value: number);
    /**
     * @stability stable
     */
    get throughputCapacityInput(): number;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _weeklyMaintenanceStartTime?;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTime(): string;
    /**
     * @stability stable
     */
    set weeklyMaintenanceStartTime(value: string);
    /**
     * @stability stable
     */
    resetWeeklyMaintenanceStartTime(): void;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTimeInput(): string | undefined;
    private _auditLogConfiguration?;
    /**
     * @stability stable
     */
    get auditLogConfiguration(): FsxWindowsFileSystemAuditLogConfiguration[];
    /**
     * @stability stable
     */
    set auditLogConfiguration(value: FsxWindowsFileSystemAuditLogConfiguration[]);
    /**
     * @stability stable
     */
    resetAuditLogConfiguration(): void;
    /**
     * @stability stable
     */
    get auditLogConfigurationInput(): FsxWindowsFileSystemAuditLogConfiguration[] | undefined;
    private _selfManagedActiveDirectory?;
    /**
     * @stability stable
     */
    get selfManagedActiveDirectory(): FsxWindowsFileSystemSelfManagedActiveDirectory[];
    /**
     * @stability stable
     */
    set selfManagedActiveDirectory(value: FsxWindowsFileSystemSelfManagedActiveDirectory[]);
    /**
     * @stability stable
     */
    resetSelfManagedActiveDirectory(): void;
    /**
     * @stability stable
     */
    get selfManagedActiveDirectoryInput(): FsxWindowsFileSystemSelfManagedActiveDirectory[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): FsxWindowsFileSystemTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: FsxWindowsFileSystemTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxWindowsFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
