import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_group_region GlobalacceleratorEndpointGroup#endpoint_group_region}.
     *
     * @stability stable
     */
    readonly endpointGroupRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_interval_seconds GlobalacceleratorEndpointGroup#health_check_interval_seconds}.
     *
     * @stability stable
     */
    readonly healthCheckIntervalSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_path GlobalacceleratorEndpointGroup#health_check_path}.
     *
     * @stability stable
     */
    readonly healthCheckPath?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_port GlobalacceleratorEndpointGroup#health_check_port}.
     *
     * @stability stable
     */
    readonly healthCheckPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_protocol GlobalacceleratorEndpointGroup#health_check_protocol}.
     *
     * @stability stable
     */
    readonly healthCheckProtocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#listener_arn GlobalacceleratorEndpointGroup#listener_arn}.
     *
     * @stability stable
     */
    readonly listenerArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#threshold_count GlobalacceleratorEndpointGroup#threshold_count}.
     *
     * @stability stable
     */
    readonly thresholdCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#traffic_dial_percentage GlobalacceleratorEndpointGroup#traffic_dial_percentage}.
     *
     * @stability stable
     */
    readonly trafficDialPercentage?: number;
    /**
     * endpoint_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_configuration GlobalacceleratorEndpointGroup#endpoint_configuration}
     *
     * @stability stable
     */
    readonly endpointConfiguration?: GlobalacceleratorEndpointGroupEndpointConfiguration[];
    /**
     * port_override block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#port_override GlobalacceleratorEndpointGroup#port_override}
     *
     * @stability stable
     */
    readonly portOverride?: GlobalacceleratorEndpointGroupPortOverride[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#timeouts GlobalacceleratorEndpointGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorEndpointGroupTimeouts;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupEndpointConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#client_ip_preservation_enabled GlobalacceleratorEndpointGroup#client_ip_preservation_enabled}.
     *
     * @stability stable
     */
    readonly clientIpPreservationEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_id GlobalacceleratorEndpointGroup#endpoint_id}.
     *
     * @stability stable
     */
    readonly endpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#weight GlobalacceleratorEndpointGroup#weight}.
     *
     * @stability stable
     */
    readonly weight?: number;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupPortOverride {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_port GlobalacceleratorEndpointGroup#endpoint_port}.
     *
     * @stability stable
     */
    readonly endpointPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#listener_port GlobalacceleratorEndpointGroup#listener_port}.
     *
     * @stability stable
     */
    readonly listenerPort: number;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#create GlobalacceleratorEndpointGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#delete GlobalacceleratorEndpointGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#update GlobalacceleratorEndpointGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html aws_globalaccelerator_endpoint_group}.
 *
 * @stability stable
 */
export declare class GlobalacceleratorEndpointGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html aws_globalaccelerator_endpoint_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorEndpointGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _endpointGroupRegion?;
    /**
     * @stability stable
     */
    get endpointGroupRegion(): string;
    /**
     * @stability stable
     */
    set endpointGroupRegion(value: string);
    /**
     * @stability stable
     */
    resetEndpointGroupRegion(): void;
    /**
     * @stability stable
     */
    get endpointGroupRegionInput(): string | undefined;
    private _healthCheckIntervalSeconds?;
    /**
     * @stability stable
     */
    get healthCheckIntervalSeconds(): number;
    /**
     * @stability stable
     */
    set healthCheckIntervalSeconds(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckIntervalSeconds(): void;
    /**
     * @stability stable
     */
    get healthCheckIntervalSecondsInput(): number | undefined;
    private _healthCheckPath?;
    /**
     * @stability stable
     */
    get healthCheckPath(): string;
    /**
     * @stability stable
     */
    set healthCheckPath(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckPath(): void;
    /**
     * @stability stable
     */
    get healthCheckPathInput(): string | undefined;
    private _healthCheckPort?;
    /**
     * @stability stable
     */
    get healthCheckPort(): number;
    /**
     * @stability stable
     */
    set healthCheckPort(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckPort(): void;
    /**
     * @stability stable
     */
    get healthCheckPortInput(): number | undefined;
    private _healthCheckProtocol?;
    /**
     * @stability stable
     */
    get healthCheckProtocol(): string;
    /**
     * @stability stable
     */
    set healthCheckProtocol(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckProtocol(): void;
    /**
     * @stability stable
     */
    get healthCheckProtocolInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _listenerArn;
    /**
     * @stability stable
     */
    get listenerArn(): string;
    /**
     * @stability stable
     */
    set listenerArn(value: string);
    /**
     * @stability stable
     */
    get listenerArnInput(): string;
    private _thresholdCount?;
    /**
     * @stability stable
     */
    get thresholdCount(): number;
    /**
     * @stability stable
     */
    set thresholdCount(value: number);
    /**
     * @stability stable
     */
    resetThresholdCount(): void;
    /**
     * @stability stable
     */
    get thresholdCountInput(): number | undefined;
    private _trafficDialPercentage?;
    /**
     * @stability stable
     */
    get trafficDialPercentage(): number;
    /**
     * @stability stable
     */
    set trafficDialPercentage(value: number);
    /**
     * @stability stable
     */
    resetTrafficDialPercentage(): void;
    /**
     * @stability stable
     */
    get trafficDialPercentageInput(): number | undefined;
    private _endpointConfiguration?;
    /**
     * @stability stable
     */
    get endpointConfiguration(): GlobalacceleratorEndpointGroupEndpointConfiguration[];
    /**
     * @stability stable
     */
    set endpointConfiguration(value: GlobalacceleratorEndpointGroupEndpointConfiguration[]);
    /**
     * @stability stable
     */
    resetEndpointConfiguration(): void;
    /**
     * @stability stable
     */
    get endpointConfigurationInput(): GlobalacceleratorEndpointGroupEndpointConfiguration[] | undefined;
    private _portOverride?;
    /**
     * @stability stable
     */
    get portOverride(): GlobalacceleratorEndpointGroupPortOverride[];
    /**
     * @stability stable
     */
    set portOverride(value: GlobalacceleratorEndpointGroupPortOverride[]);
    /**
     * @stability stable
     */
    resetPortOverride(): void;
    /**
     * @stability stable
     */
    get portOverrideInput(): GlobalacceleratorEndpointGroupPortOverride[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorEndpointGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GlobalacceleratorEndpointGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorEndpointGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
