import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#accelerator_arn GlobalacceleratorListener#accelerator_arn}.
     *
     * @stability stable
     */
    readonly acceleratorArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#client_affinity GlobalacceleratorListener#client_affinity}.
     *
     * @stability stable
     */
    readonly clientAffinity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#protocol GlobalacceleratorListener#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * port_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#port_range GlobalacceleratorListener#port_range}
     *
     * @stability stable
     */
    readonly portRange: GlobalacceleratorListenerPortRange[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#timeouts GlobalacceleratorListener#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorListenerTimeouts;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerPortRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#from_port GlobalacceleratorListener#from_port}.
     *
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#to_port GlobalacceleratorListener#to_port}.
     *
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#create GlobalacceleratorListener#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#delete GlobalacceleratorListener#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#update GlobalacceleratorListener#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html aws_globalaccelerator_listener}.
 *
 * @stability stable
 */
export declare class GlobalacceleratorListener extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html aws_globalaccelerator_listener} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorListenerConfig);
    private _acceleratorArn;
    /**
     * @stability stable
     */
    get acceleratorArn(): string;
    /**
     * @stability stable
     */
    set acceleratorArn(value: string);
    /**
     * @stability stable
     */
    get acceleratorArnInput(): string;
    private _clientAffinity?;
    /**
     * @stability stable
     */
    get clientAffinity(): string;
    /**
     * @stability stable
     */
    set clientAffinity(value: string);
    /**
     * @stability stable
     */
    resetClientAffinity(): void;
    /**
     * @stability stable
     */
    get clientAffinityInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _protocol;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string;
    private _portRange;
    /**
     * @stability stable
     */
    get portRange(): GlobalacceleratorListenerPortRange[];
    /**
     * @stability stable
     */
    set portRange(value: GlobalacceleratorListenerPortRange[]);
    /**
     * @stability stable
     */
    get portRangeInput(): GlobalacceleratorListenerPortRange[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorListenerTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GlobalacceleratorListenerTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorListenerTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
