import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyMemberConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#account_id GuarddutyMember#account_id}.
     *
     * @stability stable
     */
    readonly accountId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#detector_id GuarddutyMember#detector_id}.
     *
     * @stability stable
     */
    readonly detectorId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#disable_email_notification GuarddutyMember#disable_email_notification}.
     *
     * @stability stable
     */
    readonly disableEmailNotification?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#email GuarddutyMember#email}.
     *
     * @stability stable
     */
    readonly email: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#invitation_message GuarddutyMember#invitation_message}.
     *
     * @stability stable
     */
    readonly invitationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#invite GuarddutyMember#invite}.
     *
     * @stability stable
     */
    readonly invite?: boolean | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#timeouts GuarddutyMember#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GuarddutyMemberTimeouts;
}
/**
 * @stability stable
 */
export interface GuarddutyMemberTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#create GuarddutyMember#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html#update GuarddutyMember#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html aws_guardduty_member}.
 *
 * @stability stable
 */
export declare class GuarddutyMember extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/guardduty_member.html aws_guardduty_member} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GuarddutyMemberConfig);
    private _accountId;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    get accountIdInput(): string;
    private _detectorId;
    /**
     * @stability stable
     */
    get detectorId(): string;
    /**
     * @stability stable
     */
    set detectorId(value: string);
    /**
     * @stability stable
     */
    get detectorIdInput(): string;
    private _disableEmailNotification?;
    /**
     * @stability stable
     */
    get disableEmailNotification(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set disableEmailNotification(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDisableEmailNotification(): void;
    /**
     * @stability stable
     */
    get disableEmailNotificationInput(): boolean | cdktf.IResolvable | undefined;
    private _email;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    set email(value: string);
    /**
     * @stability stable
     */
    get emailInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _invitationMessage?;
    /**
     * @stability stable
     */
    get invitationMessage(): string;
    /**
     * @stability stable
     */
    set invitationMessage(value: string);
    /**
     * @stability stable
     */
    resetInvitationMessage(): void;
    /**
     * @stability stable
     */
    get invitationMessageInput(): string | undefined;
    private _invite?;
    /**
     * @stability stable
     */
    get invite(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set invite(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInvite(): void;
    /**
     * @stability stable
     */
    get inviteInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get relationshipStatus(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GuarddutyMemberTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GuarddutyMemberTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GuarddutyMemberTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
