import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyOrganizationConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_organization_configuration.html#auto_enable GuarddutyOrganizationConfiguration#auto_enable}.
     *
     * @stability stable
     */
    readonly autoEnable: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_organization_configuration.html#detector_id GuarddutyOrganizationConfiguration#detector_id}.
     *
     * @stability stable
     */
    readonly detectorId: string;
    /**
     * datasources block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_organization_configuration.html#datasources GuarddutyOrganizationConfiguration#datasources}
     *
     * @stability stable
     */
    readonly datasources?: GuarddutyOrganizationConfigurationDatasources[];
}
/**
 * @stability stable
 */
export interface GuarddutyOrganizationConfigurationDatasourcesS3Logs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_organization_configuration.html#auto_enable GuarddutyOrganizationConfiguration#auto_enable}.
     *
     * @stability stable
     */
    readonly autoEnable: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface GuarddutyOrganizationConfigurationDatasources {
    /**
     * s3_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/guardduty_organization_configuration.html#s3_logs GuarddutyOrganizationConfiguration#s3_logs}
     *
     * @stability stable
     */
    readonly s3Logs?: GuarddutyOrganizationConfigurationDatasourcesS3Logs[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/guardduty_organization_configuration.html aws_guardduty_organization_configuration}.
 *
 * @stability stable
 */
export declare class GuarddutyOrganizationConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/guardduty_organization_configuration.html aws_guardduty_organization_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GuarddutyOrganizationConfigurationConfig);
    private _autoEnable;
    /**
     * @stability stable
     */
    get autoEnable(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoEnable(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get autoEnableInput(): boolean | cdktf.IResolvable;
    private _detectorId;
    /**
     * @stability stable
     */
    get detectorId(): string;
    /**
     * @stability stable
     */
    set detectorId(value: string);
    /**
     * @stability stable
     */
    get detectorIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _datasources?;
    /**
     * @stability stable
     */
    get datasources(): GuarddutyOrganizationConfigurationDatasources[];
    /**
     * @stability stable
     */
    set datasources(value: GuarddutyOrganizationConfigurationDatasources[]);
    /**
     * @stability stable
     */
    resetDatasources(): void;
    /**
     * @stability stable
     */
    get datasourcesInput(): GuarddutyOrganizationConfigurationDatasources[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
