import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamServiceLinkedRoleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_service_linked_role.html#aws_service_name IamServiceLinkedRole#aws_service_name}.
     *
     * @stability stable
     */
    readonly awsServiceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_service_linked_role.html#custom_suffix IamServiceLinkedRole#custom_suffix}.
     *
     * @stability stable
     */
    readonly customSuffix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_service_linked_role.html#description IamServiceLinkedRole#description}.
     *
     * @stability stable
     */
    readonly description?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iam_service_linked_role.html aws_iam_service_linked_role}.
 *
 * @stability stable
 */
export declare class IamServiceLinkedRole extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iam_service_linked_role.html aws_iam_service_linked_role} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamServiceLinkedRoleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsServiceName;
    /**
     * @stability stable
     */
    get awsServiceName(): string;
    /**
     * @stability stable
     */
    set awsServiceName(value: string);
    /**
     * @stability stable
     */
    get awsServiceNameInput(): string;
    /**
     * @stability stable
     */
    get createDate(): string;
    private _customSuffix?;
    /**
     * @stability stable
     */
    get customSuffix(): string;
    /**
     * @stability stable
     */
    set customSuffix(value: string);
    /**
     * @stability stable
     */
    resetCustomSuffix(): void;
    /**
     * @stability stable
     */
    get customSuffixInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get uniqueId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
