import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamUserLoginProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_user_login_profile.html#password_length IamUserLoginProfile#password_length}.
     *
     * @stability stable
     */
    readonly passwordLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_user_login_profile.html#password_reset_required IamUserLoginProfile#password_reset_required}.
     *
     * @stability stable
     */
    readonly passwordResetRequired?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_user_login_profile.html#pgp_key IamUserLoginProfile#pgp_key}.
     *
     * @stability stable
     */
    readonly pgpKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_user_login_profile.html#user IamUserLoginProfile#user}.
     *
     * @stability stable
     */
    readonly user: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iam_user_login_profile.html aws_iam_user_login_profile}.
 *
 * @stability stable
 */
export declare class IamUserLoginProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iam_user_login_profile.html aws_iam_user_login_profile} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamUserLoginProfileConfig);
    /**
     * @stability stable
     */
    get encryptedPassword(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get keyFingerprint(): string;
    private _passwordLength?;
    /**
     * @stability stable
     */
    get passwordLength(): number;
    /**
     * @stability stable
     */
    set passwordLength(value: number);
    /**
     * @stability stable
     */
    resetPasswordLength(): void;
    /**
     * @stability stable
     */
    get passwordLengthInput(): number | undefined;
    private _passwordResetRequired?;
    /**
     * @stability stable
     */
    get passwordResetRequired(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set passwordResetRequired(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPasswordResetRequired(): void;
    /**
     * @stability stable
     */
    get passwordResetRequiredInput(): boolean | cdktf.IResolvable | undefined;
    private _pgpKey;
    /**
     * @stability stable
     */
    get pgpKey(): string;
    /**
     * @stability stable
     */
    set pgpKey(value: string);
    /**
     * @stability stable
     */
    get pgpKeyInput(): string;
    private _user;
    /**
     * @stability stable
     */
    get user(): string;
    /**
     * @stability stable
     */
    set user(value: string);
    /**
     * @stability stable
     */
    get userInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
