import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface InstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ami Instance#ami}.
     *
     * @stability stable
     */
    readonly ami?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#associate_public_ip_address Instance#associate_public_ip_address}.
     *
     * @stability stable
     */
    readonly associatePublicIpAddress?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#availability_zone Instance#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#cpu_core_count Instance#cpu_core_count}.
     *
     * @stability stable
     */
    readonly cpuCoreCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#cpu_threads_per_core Instance#cpu_threads_per_core}.
     *
     * @stability stable
     */
    readonly cpuThreadsPerCore?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#disable_api_termination Instance#disable_api_termination}.
     *
     * @stability stable
     */
    readonly disableApiTermination?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ebs_optimized Instance#ebs_optimized}.
     *
     * @stability stable
     */
    readonly ebsOptimized?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#get_password_data Instance#get_password_data}.
     *
     * @stability stable
     */
    readonly fetchPasswordData?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#hibernation Instance#hibernation}.
     *
     * @stability stable
     */
    readonly hibernation?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#host_id Instance#host_id}.
     *
     * @stability stable
     */
    readonly hostId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#iam_instance_profile Instance#iam_instance_profile}.
     *
     * @stability stable
     */
    readonly iamInstanceProfile?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#instance_initiated_shutdown_behavior Instance#instance_initiated_shutdown_behavior}.
     *
     * @stability stable
     */
    readonly instanceInitiatedShutdownBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#instance_type Instance#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ipv6_address_count Instance#ipv6_address_count}.
     *
     * @stability stable
     */
    readonly ipv6AddressCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ipv6_addresses Instance#ipv6_addresses}.
     *
     * @stability stable
     */
    readonly ipv6Addresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#key_name Instance#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#monitoring Instance#monitoring}.
     *
     * @stability stable
     */
    readonly monitoring?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#placement_group Instance#placement_group}.
     *
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#placement_partition_number Instance#placement_partition_number}.
     *
     * @stability stable
     */
    readonly placementPartitionNumber?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#private_ip Instance#private_ip}.
     *
     * @stability stable
     */
    readonly privateIp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#secondary_private_ips Instance#secondary_private_ips}.
     *
     * @stability stable
     */
    readonly secondaryPrivateIps?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#security_groups Instance#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#source_dest_check Instance#source_dest_check}.
     *
     * @stability stable
     */
    readonly sourceDestCheck?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#subnet_id Instance#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags Instance#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags_all Instance#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tenancy Instance#tenancy}.
     *
     * @stability stable
     */
    readonly tenancy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#user_data Instance#user_data}.
     *
     * @stability stable
     */
    readonly userData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#user_data_base64 Instance#user_data_base64}.
     *
     * @stability stable
     */
    readonly userDataBase64?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_tags Instance#volume_tags}.
     *
     * @stability stable
     */
    readonly volumeTags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#vpc_security_group_ids Instance#vpc_security_group_ids}.
     *
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * capacity_reservation_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_specification Instance#capacity_reservation_specification}
     *
     * @stability stable
     */
    readonly capacityReservationSpecification?: InstanceCapacityReservationSpecification[];
    /**
     * credit_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#credit_specification Instance#credit_specification}
     *
     * @stability stable
     */
    readonly creditSpecification?: InstanceCreditSpecification[];
    /**
     * ebs_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ebs_block_device Instance#ebs_block_device}
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: InstanceEbsBlockDevice[];
    /**
     * enclave_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#enclave_options Instance#enclave_options}
     *
     * @stability stable
     */
    readonly enclaveOptions?: InstanceEnclaveOptions[];
    /**
     * ephemeral_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ephemeral_block_device Instance#ephemeral_block_device}
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: InstanceEphemeralBlockDevice[];
    /**
     * launch_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#launch_template Instance#launch_template}
     *
     * @stability stable
     */
    readonly launchTemplate?: InstanceLaunchTemplate[];
    /**
     * metadata_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#metadata_options Instance#metadata_options}
     *
     * @stability stable
     */
    readonly metadataOptions?: InstanceMetadataOptions[];
    /**
     * network_interface block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#network_interface Instance#network_interface}
     *
     * @stability stable
     */
    readonly networkInterface?: InstanceNetworkInterface[];
    /**
     * root_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#root_block_device Instance#root_block_device}
     *
     * @stability stable
     */
    readonly rootBlockDevice?: InstanceRootBlockDevice[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#timeouts Instance#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: InstanceTimeouts;
}
/**
 * @stability stable
 */
export interface InstanceCapacityReservationSpecificationCapacityReservationTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_id Instance#capacity_reservation_id}.
     *
     * @stability stable
     */
    readonly capacityReservationId?: string;
}
/**
 * @stability stable
 */
export interface InstanceCapacityReservationSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_preference Instance#capacity_reservation_preference}.
     *
     * @stability stable
     */
    readonly capacityReservationPreference?: string;
    /**
     * capacity_reservation_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_target Instance#capacity_reservation_target}
     *
     * @stability stable
     */
    readonly capacityReservationTarget?: InstanceCapacityReservationSpecificationCapacityReservationTarget[];
}
/**
 * @stability stable
 */
export interface InstanceCreditSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#cpu_credits Instance#cpu_credits}.
     *
     * @stability stable
     */
    readonly cpuCredits?: string;
}
/**
 * @stability stable
 */
export interface InstanceEbsBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete_on_termination Instance#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#device_name Instance#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#encrypted Instance#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#iops Instance#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#kms_key_id Instance#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#snapshot_id Instance#snapshot_id}.
     *
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags Instance#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#throughput Instance#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_size Instance#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_type Instance#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface InstanceEnclaveOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#enabled Instance#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface InstanceEphemeralBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#device_name Instance#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#no_device Instance#no_device}.
     *
     * @stability stable
     */
    readonly noDevice?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#virtual_name Instance#virtual_name}.
     *
     * @stability stable
     */
    readonly virtualName?: string;
}
/**
 * @stability stable
 */
export interface InstanceLaunchTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#id Instance#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#name Instance#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#version Instance#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface InstanceMetadataOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#http_endpoint Instance#http_endpoint}.
     *
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#http_put_response_hop_limit Instance#http_put_response_hop_limit}.
     *
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#http_tokens Instance#http_tokens}.
     *
     * @stability stable
     */
    readonly httpTokens?: string;
}
/**
 * @stability stable
 */
export interface InstanceNetworkInterface {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete_on_termination Instance#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#device_index Instance#device_index}.
     *
     * @stability stable
     */
    readonly deviceIndex: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#network_interface_id Instance#network_interface_id}.
     *
     * @stability stable
     */
    readonly networkInterfaceId: string;
}
/**
 * @stability stable
 */
export interface InstanceRootBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete_on_termination Instance#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#encrypted Instance#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#iops Instance#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#kms_key_id Instance#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags Instance#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#throughput Instance#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_size Instance#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_type Instance#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface InstanceTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#create Instance#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete Instance#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#update Instance#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/instance.html aws_instance}.
 *
 * @stability stable
 */
export declare class Instance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/instance.html aws_instance} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: InstanceConfig);
    private _ami?;
    /**
     * @stability stable
     */
    get ami(): string;
    /**
     * @stability stable
     */
    set ami(value: string);
    /**
     * @stability stable
     */
    resetAmi(): void;
    /**
     * @stability stable
     */
    get amiInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _associatePublicIpAddress?;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set associatePublicIpAddress(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAssociatePublicIpAddress(): void;
    /**
     * @stability stable
     */
    get associatePublicIpAddressInput(): boolean | cdktf.IResolvable | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _cpuCoreCount?;
    /**
     * @stability stable
     */
    get cpuCoreCount(): number;
    /**
     * @stability stable
     */
    set cpuCoreCount(value: number);
    /**
     * @stability stable
     */
    resetCpuCoreCount(): void;
    /**
     * @stability stable
     */
    get cpuCoreCountInput(): number | undefined;
    private _cpuThreadsPerCore?;
    /**
     * @stability stable
     */
    get cpuThreadsPerCore(): number;
    /**
     * @stability stable
     */
    set cpuThreadsPerCore(value: number);
    /**
     * @stability stable
     */
    resetCpuThreadsPerCore(): void;
    /**
     * @stability stable
     */
    get cpuThreadsPerCoreInput(): number | undefined;
    private _disableApiTermination?;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set disableApiTermination(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDisableApiTermination(): void;
    /**
     * @stability stable
     */
    get disableApiTerminationInput(): boolean | cdktf.IResolvable | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | cdktf.IResolvable | undefined;
    private _getPasswordData?;
    /**
     * @stability stable
     */
    get fetchPasswordData(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set fetchPasswordData(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFetchPasswordData(): void;
    /**
     * @stability stable
     */
    get fetchPasswordDataInput(): boolean | cdktf.IResolvable | undefined;
    private _hibernation?;
    /**
     * @stability stable
     */
    get hibernation(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set hibernation(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetHibernation(): void;
    /**
     * @stability stable
     */
    get hibernationInput(): boolean | cdktf.IResolvable | undefined;
    private _hostId?;
    /**
     * @stability stable
     */
    get hostId(): string;
    /**
     * @stability stable
     */
    set hostId(value: string);
    /**
     * @stability stable
     */
    resetHostId(): void;
    /**
     * @stability stable
     */
    get hostIdInput(): string | undefined;
    private _iamInstanceProfile?;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): string;
    /**
     * @stability stable
     */
    set iamInstanceProfile(value: string);
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceInitiatedShutdownBehavior?;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInitiatedShutdownBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInitiatedShutdownBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehaviorInput(): string | undefined;
    /**
     * @stability stable
     */
    get instanceState(): string;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _ipv6AddressCount?;
    /**
     * @stability stable
     */
    get ipv6AddressCount(): number;
    /**
     * @stability stable
     */
    set ipv6AddressCount(value: number);
    /**
     * @stability stable
     */
    resetIpv6AddressCount(): void;
    /**
     * @stability stable
     */
    get ipv6AddressCountInput(): number | undefined;
    private _ipv6Addresses?;
    /**
     * @stability stable
     */
    get ipv6Addresses(): string[];
    /**
     * @stability stable
     */
    set ipv6Addresses(value: string[]);
    /**
     * @stability stable
     */
    resetIpv6Addresses(): void;
    /**
     * @stability stable
     */
    get ipv6AddressesInput(): string[] | undefined;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    private _monitoring?;
    /**
     * @stability stable
     */
    get monitoring(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set monitoring(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMonitoring(): void;
    /**
     * @stability stable
     */
    get monitoringInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get passwordData(): string;
    private _placementGroup?;
    /**
     * @stability stable
     */
    get placementGroup(): string;
    /**
     * @stability stable
     */
    set placementGroup(value: string);
    /**
     * @stability stable
     */
    resetPlacementGroup(): void;
    /**
     * @stability stable
     */
    get placementGroupInput(): string | undefined;
    private _placementPartitionNumber?;
    /**
     * @stability stable
     */
    get placementPartitionNumber(): number;
    /**
     * @stability stable
     */
    set placementPartitionNumber(value: number);
    /**
     * @stability stable
     */
    resetPlacementPartitionNumber(): void;
    /**
     * @stability stable
     */
    get placementPartitionNumberInput(): number | undefined;
    /**
     * @stability stable
     */
    get primaryNetworkInterfaceId(): string;
    /**
     * @stability stable
     */
    get privateDns(): string;
    private _privateIp?;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    set privateIp(value: string);
    /**
     * @stability stable
     */
    resetPrivateIp(): void;
    /**
     * @stability stable
     */
    get privateIpInput(): string | undefined;
    /**
     * @stability stable
     */
    get publicDns(): string;
    /**
     * @stability stable
     */
    get publicIp(): string;
    private _secondaryPrivateIps?;
    /**
     * @stability stable
     */
    get secondaryPrivateIps(): string[];
    /**
     * @stability stable
     */
    set secondaryPrivateIps(value: string[]);
    /**
     * @stability stable
     */
    resetSecondaryPrivateIps(): void;
    /**
     * @stability stable
     */
    get secondaryPrivateIpsInput(): string[] | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _sourceDestCheck?;
    /**
     * @stability stable
     */
    get sourceDestCheck(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set sourceDestCheck(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSourceDestCheck(): void;
    /**
     * @stability stable
     */
    get sourceDestCheckInput(): boolean | cdktf.IResolvable | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tenancy?;
    /**
     * @stability stable
     */
    get tenancy(): string;
    /**
     * @stability stable
     */
    set tenancy(value: string);
    /**
     * @stability stable
     */
    resetTenancy(): void;
    /**
     * @stability stable
     */
    get tenancyInput(): string | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _userDataBase64?;
    /**
     * @stability stable
     */
    get userDataBase64(): string;
    /**
     * @stability stable
     */
    set userDataBase64(value: string);
    /**
     * @stability stable
     */
    resetUserDataBase64(): void;
    /**
     * @stability stable
     */
    get userDataBase64Input(): string | undefined;
    private _volumeTags?;
    /**
     * @stability stable
     */
    get volumeTags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set volumeTags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetVolumeTags(): void;
    /**
     * @stability stable
     */
    get volumeTagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _capacityReservationSpecification?;
    /**
     * @stability stable
     */
    get capacityReservationSpecification(): InstanceCapacityReservationSpecification[];
    /**
     * @stability stable
     */
    set capacityReservationSpecification(value: InstanceCapacityReservationSpecification[]);
    /**
     * @stability stable
     */
    resetCapacityReservationSpecification(): void;
    /**
     * @stability stable
     */
    get capacityReservationSpecificationInput(): InstanceCapacityReservationSpecification[] | undefined;
    private _creditSpecification?;
    /**
     * @stability stable
     */
    get creditSpecification(): InstanceCreditSpecification[];
    /**
     * @stability stable
     */
    set creditSpecification(value: InstanceCreditSpecification[]);
    /**
     * @stability stable
     */
    resetCreditSpecification(): void;
    /**
     * @stability stable
     */
    get creditSpecificationInput(): InstanceCreditSpecification[] | undefined;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): InstanceEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: InstanceEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): InstanceEbsBlockDevice[] | undefined;
    private _enclaveOptions?;
    /**
     * @stability stable
     */
    get enclaveOptions(): InstanceEnclaveOptions[];
    /**
     * @stability stable
     */
    set enclaveOptions(value: InstanceEnclaveOptions[]);
    /**
     * @stability stable
     */
    resetEnclaveOptions(): void;
    /**
     * @stability stable
     */
    get enclaveOptionsInput(): InstanceEnclaveOptions[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): InstanceEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: InstanceEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): InstanceEphemeralBlockDevice[] | undefined;
    private _launchTemplate?;
    /**
     * @stability stable
     */
    get launchTemplate(): InstanceLaunchTemplate[];
    /**
     * @stability stable
     */
    set launchTemplate(value: InstanceLaunchTemplate[]);
    /**
     * @stability stable
     */
    resetLaunchTemplate(): void;
    /**
     * @stability stable
     */
    get launchTemplateInput(): InstanceLaunchTemplate[] | undefined;
    private _metadataOptions?;
    /**
     * @stability stable
     */
    get metadataOptions(): InstanceMetadataOptions[];
    /**
     * @stability stable
     */
    set metadataOptions(value: InstanceMetadataOptions[]);
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): InstanceMetadataOptions[] | undefined;
    private _networkInterface?;
    /**
     * @stability stable
     */
    get networkInterface(): InstanceNetworkInterface[];
    /**
     * @stability stable
     */
    set networkInterface(value: InstanceNetworkInterface[]);
    /**
     * @stability stable
     */
    resetNetworkInterface(): void;
    /**
     * @stability stable
     */
    get networkInterfaceInput(): InstanceNetworkInterface[] | undefined;
    private _rootBlockDevice?;
    /**
     * @stability stable
     */
    get rootBlockDevice(): InstanceRootBlockDevice[];
    /**
     * @stability stable
     */
    set rootBlockDevice(value: InstanceRootBlockDevice[]);
    /**
     * @stability stable
     */
    resetRootBlockDevice(): void;
    /**
     * @stability stable
     */
    get rootBlockDeviceInput(): InstanceRootBlockDevice[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): InstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: InstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): InstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
