import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotTopicRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#description IotTopicRule#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#enabled IotTopicRule#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#name IotTopicRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#sql IotTopicRule#sql}.
     *
     * @stability stable
     */
    readonly sql: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#sql_version IotTopicRule#sql_version}.
     *
     * @stability stable
     */
    readonly sqlVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#tags IotTopicRule#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#tags_all IotTopicRule#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * cloudwatch_alarm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#cloudwatch_alarm IotTopicRule#cloudwatch_alarm}
     *
     * @stability stable
     */
    readonly cloudwatchAlarm?: IotTopicRuleCloudwatchAlarm[];
    /**
     * cloudwatch_metric block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#cloudwatch_metric IotTopicRule#cloudwatch_metric}
     *
     * @stability stable
     */
    readonly cloudwatchMetric?: IotTopicRuleCloudwatchMetric[];
    /**
     * dynamodb block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#dynamodb IotTopicRule#dynamodb}
     *
     * @stability stable
     */
    readonly dynamodb?: IotTopicRuleDynamodb[];
    /**
     * dynamodbv2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#dynamodbv2 IotTopicRule#dynamodbv2}
     *
     * @stability stable
     */
    readonly dynamodbv2?: IotTopicRuleDynamodbv2[];
    /**
     * elasticsearch block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#elasticsearch IotTopicRule#elasticsearch}
     *
     * @stability stable
     */
    readonly elasticsearch?: IotTopicRuleElasticsearch[];
    /**
     * error_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#error_action IotTopicRule#error_action}
     *
     * @stability stable
     */
    readonly errorAction?: IotTopicRuleErrorAction[];
    /**
     * firehose block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#firehose IotTopicRule#firehose}
     *
     * @stability stable
     */
    readonly firehose?: IotTopicRuleFirehose[];
    /**
     * iot_analytics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#iot_analytics IotTopicRule#iot_analytics}
     *
     * @stability stable
     */
    readonly iotAnalytics?: IotTopicRuleIotAnalytics[];
    /**
     * iot_events block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#iot_events IotTopicRule#iot_events}
     *
     * @stability stable
     */
    readonly iotEvents?: IotTopicRuleIotEvents[];
    /**
     * kinesis block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#kinesis IotTopicRule#kinesis}
     *
     * @stability stable
     */
    readonly kinesis?: IotTopicRuleKinesis[];
    /**
     * lambda block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#lambda IotTopicRule#lambda}
     *
     * @stability stable
     */
    readonly lambda?: IotTopicRuleLambda[];
    /**
     * republish block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#republish IotTopicRule#republish}
     *
     * @stability stable
     */
    readonly republish?: IotTopicRuleRepublish[];
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#s3 IotTopicRule#s3}
     *
     * @stability stable
     */
    readonly s3?: IotTopicRuleS3[];
    /**
     * sns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#sns IotTopicRule#sns}
     *
     * @stability stable
     */
    readonly sns?: IotTopicRuleSns[];
    /**
     * sqs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#sqs IotTopicRule#sqs}
     *
     * @stability stable
     */
    readonly sqs?: IotTopicRuleSqs[];
    /**
     * step_functions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#step_functions IotTopicRule#step_functions}
     *
     * @stability stable
     */
    readonly stepFunctions?: IotTopicRuleStepFunctions[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleCloudwatchAlarm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#alarm_name IotTopicRule#alarm_name}.
     *
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#state_reason IotTopicRule#state_reason}.
     *
     * @stability stable
     */
    readonly stateReason: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#state_value IotTopicRule#state_value}.
     *
     * @stability stable
     */
    readonly stateValue: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleCloudwatchMetric {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_name IotTopicRule#metric_name}.
     *
     * @stability stable
     */
    readonly metricName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_namespace IotTopicRule#metric_namespace}.
     *
     * @stability stable
     */
    readonly metricNamespace: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_timestamp IotTopicRule#metric_timestamp}.
     *
     * @stability stable
     */
    readonly metricTimestamp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_unit IotTopicRule#metric_unit}.
     *
     * @stability stable
     */
    readonly metricUnit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_value IotTopicRule#metric_value}.
     *
     * @stability stable
     */
    readonly metricValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodb {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#hash_key_field IotTopicRule#hash_key_field}.
     *
     * @stability stable
     */
    readonly hashKeyField: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#hash_key_type IotTopicRule#hash_key_type}.
     *
     * @stability stable
     */
    readonly hashKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#hash_key_value IotTopicRule#hash_key_value}.
     *
     * @stability stable
     */
    readonly hashKeyValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#operation IotTopicRule#operation}.
     *
     * @stability stable
     */
    readonly operation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#payload_field IotTopicRule#payload_field}.
     *
     * @stability stable
     */
    readonly payloadField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#range_key_field IotTopicRule#range_key_field}.
     *
     * @stability stable
     */
    readonly rangeKeyField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#range_key_type IotTopicRule#range_key_type}.
     *
     * @stability stable
     */
    readonly rangeKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#range_key_value IotTopicRule#range_key_value}.
     *
     * @stability stable
     */
    readonly rangeKeyValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodbv2PutItem {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodbv2 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * put_item block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#put_item IotTopicRule#put_item}
     *
     * @stability stable
     */
    readonly putItem?: IotTopicRuleDynamodbv2PutItem[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleElasticsearch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#endpoint IotTopicRule#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#id IotTopicRule#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#index IotTopicRule#index}.
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#type IotTopicRule#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionCloudwatchAlarm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#alarm_name IotTopicRule#alarm_name}.
     *
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#state_reason IotTopicRule#state_reason}.
     *
     * @stability stable
     */
    readonly stateReason: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#state_value IotTopicRule#state_value}.
     *
     * @stability stable
     */
    readonly stateValue: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionCloudwatchMetric {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_name IotTopicRule#metric_name}.
     *
     * @stability stable
     */
    readonly metricName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_namespace IotTopicRule#metric_namespace}.
     *
     * @stability stable
     */
    readonly metricNamespace: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_timestamp IotTopicRule#metric_timestamp}.
     *
     * @stability stable
     */
    readonly metricTimestamp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_unit IotTopicRule#metric_unit}.
     *
     * @stability stable
     */
    readonly metricUnit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#metric_value IotTopicRule#metric_value}.
     *
     * @stability stable
     */
    readonly metricValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodb {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#hash_key_field IotTopicRule#hash_key_field}.
     *
     * @stability stable
     */
    readonly hashKeyField: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#hash_key_type IotTopicRule#hash_key_type}.
     *
     * @stability stable
     */
    readonly hashKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#hash_key_value IotTopicRule#hash_key_value}.
     *
     * @stability stable
     */
    readonly hashKeyValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#operation IotTopicRule#operation}.
     *
     * @stability stable
     */
    readonly operation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#payload_field IotTopicRule#payload_field}.
     *
     * @stability stable
     */
    readonly payloadField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#range_key_field IotTopicRule#range_key_field}.
     *
     * @stability stable
     */
    readonly rangeKeyField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#range_key_type IotTopicRule#range_key_type}.
     *
     * @stability stable
     */
    readonly rangeKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#range_key_value IotTopicRule#range_key_value}.
     *
     * @stability stable
     */
    readonly rangeKeyValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodbv2PutItem {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodbv2 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * put_item block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#put_item IotTopicRule#put_item}
     *
     * @stability stable
     */
    readonly putItem?: IotTopicRuleErrorActionDynamodbv2PutItem[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionElasticsearch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#endpoint IotTopicRule#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#id IotTopicRule#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#index IotTopicRule#index}.
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#type IotTopicRule#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionFirehose {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#delivery_stream_name IotTopicRule#delivery_stream_name}.
     *
     * @stability stable
     */
    readonly deliveryStreamName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#separator IotTopicRule#separator}.
     *
     * @stability stable
     */
    readonly separator?: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionIotAnalytics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#channel_name IotTopicRule#channel_name}.
     *
     * @stability stable
     */
    readonly channelName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionIotEvents {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#input_name IotTopicRule#input_name}.
     *
     * @stability stable
     */
    readonly inputName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#message_id IotTopicRule#message_id}.
     *
     * @stability stable
     */
    readonly messageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionKinesis {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#partition_key IotTopicRule#partition_key}.
     *
     * @stability stable
     */
    readonly partitionKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#stream_name IotTopicRule#stream_name}.
     *
     * @stability stable
     */
    readonly streamName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionLambda {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#function_arn IotTopicRule#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionRepublish {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#qos IotTopicRule#qos}.
     *
     * @stability stable
     */
    readonly qos?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#topic IotTopicRule#topic}.
     *
     * @stability stable
     */
    readonly topic: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionS3 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#bucket_name IotTopicRule#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#key IotTopicRule#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionSns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#message_format IotTopicRule#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#target_arn IotTopicRule#target_arn}.
     *
     * @stability stable
     */
    readonly targetArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionSqs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#queue_url IotTopicRule#queue_url}.
     *
     * @stability stable
     */
    readonly queueUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#use_base64 IotTopicRule#use_base64}.
     *
     * @stability stable
     */
    readonly useBase64: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionStepFunctions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#execution_name_prefix IotTopicRule#execution_name_prefix}.
     *
     * @stability stable
     */
    readonly executionNamePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#state_machine_name IotTopicRule#state_machine_name}.
     *
     * @stability stable
     */
    readonly stateMachineName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorAction {
    /**
     * cloudwatch_alarm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#cloudwatch_alarm IotTopicRule#cloudwatch_alarm}
     *
     * @stability stable
     */
    readonly cloudwatchAlarm?: IotTopicRuleErrorActionCloudwatchAlarm[];
    /**
     * cloudwatch_metric block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#cloudwatch_metric IotTopicRule#cloudwatch_metric}
     *
     * @stability stable
     */
    readonly cloudwatchMetric?: IotTopicRuleErrorActionCloudwatchMetric[];
    /**
     * dynamodb block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#dynamodb IotTopicRule#dynamodb}
     *
     * @stability stable
     */
    readonly dynamodb?: IotTopicRuleErrorActionDynamodb[];
    /**
     * dynamodbv2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#dynamodbv2 IotTopicRule#dynamodbv2}
     *
     * @stability stable
     */
    readonly dynamodbv2?: IotTopicRuleErrorActionDynamodbv2[];
    /**
     * elasticsearch block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#elasticsearch IotTopicRule#elasticsearch}
     *
     * @stability stable
     */
    readonly elasticsearch?: IotTopicRuleErrorActionElasticsearch[];
    /**
     * firehose block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#firehose IotTopicRule#firehose}
     *
     * @stability stable
     */
    readonly firehose?: IotTopicRuleErrorActionFirehose[];
    /**
     * iot_analytics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#iot_analytics IotTopicRule#iot_analytics}
     *
     * @stability stable
     */
    readonly iotAnalytics?: IotTopicRuleErrorActionIotAnalytics[];
    /**
     * iot_events block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#iot_events IotTopicRule#iot_events}
     *
     * @stability stable
     */
    readonly iotEvents?: IotTopicRuleErrorActionIotEvents[];
    /**
     * kinesis block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#kinesis IotTopicRule#kinesis}
     *
     * @stability stable
     */
    readonly kinesis?: IotTopicRuleErrorActionKinesis[];
    /**
     * lambda block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#lambda IotTopicRule#lambda}
     *
     * @stability stable
     */
    readonly lambda?: IotTopicRuleErrorActionLambda[];
    /**
     * republish block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#republish IotTopicRule#republish}
     *
     * @stability stable
     */
    readonly republish?: IotTopicRuleErrorActionRepublish[];
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#s3 IotTopicRule#s3}
     *
     * @stability stable
     */
    readonly s3?: IotTopicRuleErrorActionS3[];
    /**
     * sns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#sns IotTopicRule#sns}
     *
     * @stability stable
     */
    readonly sns?: IotTopicRuleErrorActionSns[];
    /**
     * sqs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#sqs IotTopicRule#sqs}
     *
     * @stability stable
     */
    readonly sqs?: IotTopicRuleErrorActionSqs[];
    /**
     * step_functions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#step_functions IotTopicRule#step_functions}
     *
     * @stability stable
     */
    readonly stepFunctions?: IotTopicRuleErrorActionStepFunctions[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleFirehose {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#delivery_stream_name IotTopicRule#delivery_stream_name}.
     *
     * @stability stable
     */
    readonly deliveryStreamName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#separator IotTopicRule#separator}.
     *
     * @stability stable
     */
    readonly separator?: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleIotAnalytics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#channel_name IotTopicRule#channel_name}.
     *
     * @stability stable
     */
    readonly channelName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleIotEvents {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#input_name IotTopicRule#input_name}.
     *
     * @stability stable
     */
    readonly inputName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#message_id IotTopicRule#message_id}.
     *
     * @stability stable
     */
    readonly messageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleKinesis {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#partition_key IotTopicRule#partition_key}.
     *
     * @stability stable
     */
    readonly partitionKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#stream_name IotTopicRule#stream_name}.
     *
     * @stability stable
     */
    readonly streamName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleLambda {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#function_arn IotTopicRule#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleRepublish {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#qos IotTopicRule#qos}.
     *
     * @stability stable
     */
    readonly qos?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#topic IotTopicRule#topic}.
     *
     * @stability stable
     */
    readonly topic: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleS3 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#bucket_name IotTopicRule#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#key IotTopicRule#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleSns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#message_format IotTopicRule#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#target_arn IotTopicRule#target_arn}.
     *
     * @stability stable
     */
    readonly targetArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleSqs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#queue_url IotTopicRule#queue_url}.
     *
     * @stability stable
     */
    readonly queueUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#use_base64 IotTopicRule#use_base64}.
     *
     * @stability stable
     */
    readonly useBase64: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface IotTopicRuleStepFunctions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#execution_name_prefix IotTopicRule#execution_name_prefix}.
     *
     * @stability stable
     */
    readonly executionNamePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html#state_machine_name IotTopicRule#state_machine_name}.
     *
     * @stability stable
     */
    readonly stateMachineName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html aws_iot_topic_rule}.
 *
 * @stability stable
 */
export declare class IotTopicRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule.html aws_iot_topic_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotTopicRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enabled;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _sql;
    /**
     * @stability stable
     */
    get sql(): string;
    /**
     * @stability stable
     */
    set sql(value: string);
    /**
     * @stability stable
     */
    get sqlInput(): string;
    private _sqlVersion;
    /**
     * @stability stable
     */
    get sqlVersion(): string;
    /**
     * @stability stable
     */
    set sqlVersion(value: string);
    /**
     * @stability stable
     */
    get sqlVersionInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _cloudwatchAlarm?;
    /**
     * @stability stable
     */
    get cloudwatchAlarm(): IotTopicRuleCloudwatchAlarm[];
    /**
     * @stability stable
     */
    set cloudwatchAlarm(value: IotTopicRuleCloudwatchAlarm[]);
    /**
     * @stability stable
     */
    resetCloudwatchAlarm(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmInput(): IotTopicRuleCloudwatchAlarm[] | undefined;
    private _cloudwatchMetric?;
    /**
     * @stability stable
     */
    get cloudwatchMetric(): IotTopicRuleCloudwatchMetric[];
    /**
     * @stability stable
     */
    set cloudwatchMetric(value: IotTopicRuleCloudwatchMetric[]);
    /**
     * @stability stable
     */
    resetCloudwatchMetric(): void;
    /**
     * @stability stable
     */
    get cloudwatchMetricInput(): IotTopicRuleCloudwatchMetric[] | undefined;
    private _dynamodb?;
    /**
     * @stability stable
     */
    get dynamodb(): IotTopicRuleDynamodb[];
    /**
     * @stability stable
     */
    set dynamodb(value: IotTopicRuleDynamodb[]);
    /**
     * @stability stable
     */
    resetDynamodb(): void;
    /**
     * @stability stable
     */
    get dynamodbInput(): IotTopicRuleDynamodb[] | undefined;
    private _dynamodbv2?;
    /**
     * @stability stable
     */
    get dynamodbv2(): IotTopicRuleDynamodbv2[];
    /**
     * @stability stable
     */
    set dynamodbv2(value: IotTopicRuleDynamodbv2[]);
    /**
     * @stability stable
     */
    resetDynamodbv2(): void;
    /**
     * @stability stable
     */
    get dynamodbv2Input(): IotTopicRuleDynamodbv2[] | undefined;
    private _elasticsearch?;
    /**
     * @stability stable
     */
    get elasticsearch(): IotTopicRuleElasticsearch[];
    /**
     * @stability stable
     */
    set elasticsearch(value: IotTopicRuleElasticsearch[]);
    /**
     * @stability stable
     */
    resetElasticsearch(): void;
    /**
     * @stability stable
     */
    get elasticsearchInput(): IotTopicRuleElasticsearch[] | undefined;
    private _errorAction?;
    /**
     * @stability stable
     */
    get errorAction(): IotTopicRuleErrorAction[];
    /**
     * @stability stable
     */
    set errorAction(value: IotTopicRuleErrorAction[]);
    /**
     * @stability stable
     */
    resetErrorAction(): void;
    /**
     * @stability stable
     */
    get errorActionInput(): IotTopicRuleErrorAction[] | undefined;
    private _firehose?;
    /**
     * @stability stable
     */
    get firehose(): IotTopicRuleFirehose[];
    /**
     * @stability stable
     */
    set firehose(value: IotTopicRuleFirehose[]);
    /**
     * @stability stable
     */
    resetFirehose(): void;
    /**
     * @stability stable
     */
    get firehoseInput(): IotTopicRuleFirehose[] | undefined;
    private _iotAnalytics?;
    /**
     * @stability stable
     */
    get iotAnalytics(): IotTopicRuleIotAnalytics[];
    /**
     * @stability stable
     */
    set iotAnalytics(value: IotTopicRuleIotAnalytics[]);
    /**
     * @stability stable
     */
    resetIotAnalytics(): void;
    /**
     * @stability stable
     */
    get iotAnalyticsInput(): IotTopicRuleIotAnalytics[] | undefined;
    private _iotEvents?;
    /**
     * @stability stable
     */
    get iotEvents(): IotTopicRuleIotEvents[];
    /**
     * @stability stable
     */
    set iotEvents(value: IotTopicRuleIotEvents[]);
    /**
     * @stability stable
     */
    resetIotEvents(): void;
    /**
     * @stability stable
     */
    get iotEventsInput(): IotTopicRuleIotEvents[] | undefined;
    private _kinesis?;
    /**
     * @stability stable
     */
    get kinesis(): IotTopicRuleKinesis[];
    /**
     * @stability stable
     */
    set kinesis(value: IotTopicRuleKinesis[]);
    /**
     * @stability stable
     */
    resetKinesis(): void;
    /**
     * @stability stable
     */
    get kinesisInput(): IotTopicRuleKinesis[] | undefined;
    private _lambda?;
    /**
     * @stability stable
     */
    get lambda(): IotTopicRuleLambda[];
    /**
     * @stability stable
     */
    set lambda(value: IotTopicRuleLambda[]);
    /**
     * @stability stable
     */
    resetLambda(): void;
    /**
     * @stability stable
     */
    get lambdaInput(): IotTopicRuleLambda[] | undefined;
    private _republish?;
    /**
     * @stability stable
     */
    get republish(): IotTopicRuleRepublish[];
    /**
     * @stability stable
     */
    set republish(value: IotTopicRuleRepublish[]);
    /**
     * @stability stable
     */
    resetRepublish(): void;
    /**
     * @stability stable
     */
    get republishInput(): IotTopicRuleRepublish[] | undefined;
    private _s3?;
    /**
     * @stability stable
     */
    get s3(): IotTopicRuleS3[];
    /**
     * @stability stable
     */
    set s3(value: IotTopicRuleS3[]);
    /**
     * @stability stable
     */
    resetS3(): void;
    /**
     * @stability stable
     */
    get s3Input(): IotTopicRuleS3[] | undefined;
    private _sns?;
    /**
     * @stability stable
     */
    get sns(): IotTopicRuleSns[];
    /**
     * @stability stable
     */
    set sns(value: IotTopicRuleSns[]);
    /**
     * @stability stable
     */
    resetSns(): void;
    /**
     * @stability stable
     */
    get snsInput(): IotTopicRuleSns[] | undefined;
    private _sqs?;
    /**
     * @stability stable
     */
    get sqs(): IotTopicRuleSqs[];
    /**
     * @stability stable
     */
    set sqs(value: IotTopicRuleSqs[]);
    /**
     * @stability stable
     */
    resetSqs(): void;
    /**
     * @stability stable
     */
    get sqsInput(): IotTopicRuleSqs[] | undefined;
    private _stepFunctions?;
    /**
     * @stability stable
     */
    get stepFunctions(): IotTopicRuleStepFunctions[];
    /**
     * @stability stable
     */
    set stepFunctions(value: IotTopicRuleStepFunctions[]);
    /**
     * @stability stable
     */
    resetStepFunctions(): void;
    /**
     * @stability stable
     */
    get stepFunctionsInput(): IotTopicRuleStepFunctions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
