import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#batch_size LambdaEventSourceMapping#batch_size}.
     *
     * @stability stable
     */
    readonly batchSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#bisect_batch_on_function_error LambdaEventSourceMapping#bisect_batch_on_function_error}.
     *
     * @stability stable
     */
    readonly bisectBatchOnFunctionError?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#enabled LambdaEventSourceMapping#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#event_source_arn LambdaEventSourceMapping#event_source_arn}.
     *
     * @stability stable
     */
    readonly eventSourceArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#function_name LambdaEventSourceMapping#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#function_response_types LambdaEventSourceMapping#function_response_types}.
     *
     * @stability stable
     */
    readonly functionResponseTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#maximum_batching_window_in_seconds LambdaEventSourceMapping#maximum_batching_window_in_seconds}.
     *
     * @stability stable
     */
    readonly maximumBatchingWindowInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#maximum_record_age_in_seconds LambdaEventSourceMapping#maximum_record_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maximumRecordAgeInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#maximum_retry_attempts LambdaEventSourceMapping#maximum_retry_attempts}.
     *
     * @stability stable
     */
    readonly maximumRetryAttempts?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#parallelization_factor LambdaEventSourceMapping#parallelization_factor}.
     *
     * @stability stable
     */
    readonly parallelizationFactor?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#queues LambdaEventSourceMapping#queues}.
     *
     * @stability stable
     */
    readonly queues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#starting_position LambdaEventSourceMapping#starting_position}.
     *
     * @stability stable
     */
    readonly startingPosition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#starting_position_timestamp LambdaEventSourceMapping#starting_position_timestamp}.
     *
     * @stability stable
     */
    readonly startingPositionTimestamp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#topics LambdaEventSourceMapping#topics}.
     *
     * @stability stable
     */
    readonly topics?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#tumbling_window_in_seconds LambdaEventSourceMapping#tumbling_window_in_seconds}.
     *
     * @stability stable
     */
    readonly tumblingWindowInSeconds?: number;
    /**
     * destination_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#destination_config LambdaEventSourceMapping#destination_config}
     *
     * @stability stable
     */
    readonly destinationConfig?: LambdaEventSourceMappingDestinationConfig[];
    /**
     * self_managed_event_source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#self_managed_event_source LambdaEventSourceMapping#self_managed_event_source}
     *
     * @stability stable
     */
    readonly selfManagedEventSource?: LambdaEventSourceMappingSelfManagedEventSource[];
    /**
     * source_access_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#source_access_configuration LambdaEventSourceMapping#source_access_configuration}
     *
     * @stability stable
     */
    readonly sourceAccessConfiguration?: LambdaEventSourceMappingSourceAccessConfiguration[];
}
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingDestinationConfigOnFailure {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#destination_arn LambdaEventSourceMapping#destination_arn}.
     *
     * @stability stable
     */
    readonly destinationArn: string;
}
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingDestinationConfig {
    /**
     * on_failure block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#on_failure LambdaEventSourceMapping#on_failure}
     *
     * @stability stable
     */
    readonly onFailure?: LambdaEventSourceMappingDestinationConfigOnFailure[];
}
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingSelfManagedEventSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#endpoints LambdaEventSourceMapping#endpoints}.
     *
     * @stability stable
     */
    readonly endpoints: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingSourceAccessConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#type LambdaEventSourceMapping#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html#uri LambdaEventSourceMapping#uri}.
     *
     * @stability stable
     */
    readonly uri: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html aws_lambda_event_source_mapping}.
 *
 * @stability stable
 */
export declare class LambdaEventSourceMapping extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lambda_event_source_mapping.html aws_lambda_event_source_mapping} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaEventSourceMappingConfig);
    private _batchSize?;
    /**
     * @stability stable
     */
    get batchSize(): number;
    /**
     * @stability stable
     */
    set batchSize(value: number);
    /**
     * @stability stable
     */
    resetBatchSize(): void;
    /**
     * @stability stable
     */
    get batchSizeInput(): number | undefined;
    private _bisectBatchOnFunctionError?;
    /**
     * @stability stable
     */
    get bisectBatchOnFunctionError(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set bisectBatchOnFunctionError(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBisectBatchOnFunctionError(): void;
    /**
     * @stability stable
     */
    get bisectBatchOnFunctionErrorInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _eventSourceArn?;
    /**
     * @stability stable
     */
    get eventSourceArn(): string;
    /**
     * @stability stable
     */
    set eventSourceArn(value: string);
    /**
     * @stability stable
     */
    resetEventSourceArn(): void;
    /**
     * @stability stable
     */
    get eventSourceArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get functionArn(): string;
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    private _functionResponseTypes?;
    /**
     * @stability stable
     */
    get functionResponseTypes(): string[];
    /**
     * @stability stable
     */
    set functionResponseTypes(value: string[]);
    /**
     * @stability stable
     */
    resetFunctionResponseTypes(): void;
    /**
     * @stability stable
     */
    get functionResponseTypesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModified(): string;
    /**
     * @stability stable
     */
    get lastProcessingResult(): string;
    private _maximumBatchingWindowInSeconds?;
    /**
     * @stability stable
     */
    get maximumBatchingWindowInSeconds(): number;
    /**
     * @stability stable
     */
    set maximumBatchingWindowInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaximumBatchingWindowInSeconds(): void;
    /**
     * @stability stable
     */
    get maximumBatchingWindowInSecondsInput(): number | undefined;
    private _maximumRecordAgeInSeconds?;
    /**
     * @stability stable
     */
    get maximumRecordAgeInSeconds(): number;
    /**
     * @stability stable
     */
    set maximumRecordAgeInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaximumRecordAgeInSeconds(): void;
    /**
     * @stability stable
     */
    get maximumRecordAgeInSecondsInput(): number | undefined;
    private _maximumRetryAttempts?;
    /**
     * @stability stable
     */
    get maximumRetryAttempts(): number;
    /**
     * @stability stable
     */
    set maximumRetryAttempts(value: number);
    /**
     * @stability stable
     */
    resetMaximumRetryAttempts(): void;
    /**
     * @stability stable
     */
    get maximumRetryAttemptsInput(): number | undefined;
    private _parallelizationFactor?;
    /**
     * @stability stable
     */
    get parallelizationFactor(): number;
    /**
     * @stability stable
     */
    set parallelizationFactor(value: number);
    /**
     * @stability stable
     */
    resetParallelizationFactor(): void;
    /**
     * @stability stable
     */
    get parallelizationFactorInput(): number | undefined;
    private _queues?;
    /**
     * @stability stable
     */
    get queues(): string[];
    /**
     * @stability stable
     */
    set queues(value: string[]);
    /**
     * @stability stable
     */
    resetQueues(): void;
    /**
     * @stability stable
     */
    get queuesInput(): string[] | undefined;
    private _startingPosition?;
    /**
     * @stability stable
     */
    get startingPosition(): string;
    /**
     * @stability stable
     */
    set startingPosition(value: string);
    /**
     * @stability stable
     */
    resetStartingPosition(): void;
    /**
     * @stability stable
     */
    get startingPositionInput(): string | undefined;
    private _startingPositionTimestamp?;
    /**
     * @stability stable
     */
    get startingPositionTimestamp(): string;
    /**
     * @stability stable
     */
    set startingPositionTimestamp(value: string);
    /**
     * @stability stable
     */
    resetStartingPositionTimestamp(): void;
    /**
     * @stability stable
     */
    get startingPositionTimestampInput(): string | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    get stateTransitionReason(): string;
    private _topics?;
    /**
     * @stability stable
     */
    get topics(): string[];
    /**
     * @stability stable
     */
    set topics(value: string[]);
    /**
     * @stability stable
     */
    resetTopics(): void;
    /**
     * @stability stable
     */
    get topicsInput(): string[] | undefined;
    private _tumblingWindowInSeconds?;
    /**
     * @stability stable
     */
    get tumblingWindowInSeconds(): number;
    /**
     * @stability stable
     */
    set tumblingWindowInSeconds(value: number);
    /**
     * @stability stable
     */
    resetTumblingWindowInSeconds(): void;
    /**
     * @stability stable
     */
    get tumblingWindowInSecondsInput(): number | undefined;
    /**
     * @stability stable
     */
    get uuid(): string;
    private _destinationConfig?;
    /**
     * @stability stable
     */
    get destinationConfig(): LambdaEventSourceMappingDestinationConfig[];
    /**
     * @stability stable
     */
    set destinationConfig(value: LambdaEventSourceMappingDestinationConfig[]);
    /**
     * @stability stable
     */
    resetDestinationConfig(): void;
    /**
     * @stability stable
     */
    get destinationConfigInput(): LambdaEventSourceMappingDestinationConfig[] | undefined;
    private _selfManagedEventSource?;
    /**
     * @stability stable
     */
    get selfManagedEventSource(): LambdaEventSourceMappingSelfManagedEventSource[];
    /**
     * @stability stable
     */
    set selfManagedEventSource(value: LambdaEventSourceMappingSelfManagedEventSource[]);
    /**
     * @stability stable
     */
    resetSelfManagedEventSource(): void;
    /**
     * @stability stable
     */
    get selfManagedEventSourceInput(): LambdaEventSourceMappingSelfManagedEventSource[] | undefined;
    private _sourceAccessConfiguration?;
    /**
     * @stability stable
     */
    get sourceAccessConfiguration(): LambdaEventSourceMappingSourceAccessConfiguration[];
    /**
     * @stability stable
     */
    set sourceAccessConfiguration(value: LambdaEventSourceMappingSourceAccessConfiguration[]);
    /**
     * @stability stable
     */
    resetSourceAccessConfiguration(): void;
    /**
     * @stability stable
     */
    get sourceAccessConfigurationInput(): LambdaEventSourceMappingSourceAccessConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
