import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#function_name LambdaFunctionEventInvokeConfig#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#maximum_event_age_in_seconds LambdaFunctionEventInvokeConfig#maximum_event_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maximumEventAgeInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#maximum_retry_attempts LambdaFunctionEventInvokeConfig#maximum_retry_attempts}.
     *
     * @stability stable
     */
    readonly maximumRetryAttempts?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#qualifier LambdaFunctionEventInvokeConfig#qualifier}.
     *
     * @stability stable
     */
    readonly qualifier?: string;
    /**
     * destination_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#destination_config LambdaFunctionEventInvokeConfig#destination_config}
     *
     * @stability stable
     */
    readonly destinationConfig?: LambdaFunctionEventInvokeConfigDestinationConfig[];
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfigOnFailure {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#destination LambdaFunctionEventInvokeConfig#destination}.
     *
     * @stability stable
     */
    readonly destination: string;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#destination LambdaFunctionEventInvokeConfig#destination}.
     *
     * @stability stable
     */
    readonly destination: string;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfig {
    /**
     * on_failure block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#on_failure LambdaFunctionEventInvokeConfig#on_failure}
     *
     * @stability stable
     */
    readonly onFailure?: LambdaFunctionEventInvokeConfigDestinationConfigOnFailure[];
    /**
     * on_success block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html#on_success LambdaFunctionEventInvokeConfig#on_success}
     *
     * @stability stable
     */
    readonly onSuccess?: LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html aws_lambda_function_event_invoke_config}.
 *
 * @stability stable
 */
export declare class LambdaFunctionEventInvokeConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config.html aws_lambda_function_event_invoke_config} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaFunctionEventInvokeConfigConfig);
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _maximumEventAgeInSeconds?;
    /**
     * @stability stable
     */
    get maximumEventAgeInSeconds(): number;
    /**
     * @stability stable
     */
    set maximumEventAgeInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaximumEventAgeInSeconds(): void;
    /**
     * @stability stable
     */
    get maximumEventAgeInSecondsInput(): number | undefined;
    private _maximumRetryAttempts?;
    /**
     * @stability stable
     */
    get maximumRetryAttempts(): number;
    /**
     * @stability stable
     */
    set maximumRetryAttempts(value: number);
    /**
     * @stability stable
     */
    resetMaximumRetryAttempts(): void;
    /**
     * @stability stable
     */
    get maximumRetryAttemptsInput(): number | undefined;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    private _destinationConfig?;
    /**
     * @stability stable
     */
    get destinationConfig(): LambdaFunctionEventInvokeConfigDestinationConfig[];
    /**
     * @stability stable
     */
    set destinationConfig(value: LambdaFunctionEventInvokeConfigDestinationConfig[]);
    /**
     * @stability stable
     */
    resetDestinationConfig(): void;
    /**
     * @stability stable
     */
    get destinationConfigInput(): LambdaFunctionEventInvokeConfigDestinationConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
