import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LbCookieStickinessPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_cookie_stickiness_policy.html#cookie_expiration_period LbCookieStickinessPolicy#cookie_expiration_period}.
     *
     * @stability stable
     */
    readonly cookieExpirationPeriod?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_cookie_stickiness_policy.html#lb_port LbCookieStickinessPolicy#lb_port}.
     *
     * @stability stable
     */
    readonly lbPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_cookie_stickiness_policy.html#load_balancer LbCookieStickinessPolicy#load_balancer}.
     *
     * @stability stable
     */
    readonly loadBalancer: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_cookie_stickiness_policy.html#name LbCookieStickinessPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lb_cookie_stickiness_policy.html aws_lb_cookie_stickiness_policy}.
 *
 * @stability stable
 */
export declare class LbCookieStickinessPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lb_cookie_stickiness_policy.html aws_lb_cookie_stickiness_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LbCookieStickinessPolicyConfig);
    private _cookieExpirationPeriod?;
    /**
     * @stability stable
     */
    get cookieExpirationPeriod(): number;
    /**
     * @stability stable
     */
    set cookieExpirationPeriod(value: number);
    /**
     * @stability stable
     */
    resetCookieExpirationPeriod(): void;
    /**
     * @stability stable
     */
    get cookieExpirationPeriodInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _lbPort;
    /**
     * @stability stable
     */
    get lbPort(): number;
    /**
     * @stability stable
     */
    set lbPort(value: number);
    /**
     * @stability stable
     */
    get lbPortInput(): number;
    private _loadBalancer;
    /**
     * @stability stable
     */
    get loadBalancer(): string;
    /**
     * @stability stable
     */
    set loadBalancer(value: string);
    /**
     * @stability stable
     */
    get loadBalancerInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
