import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LexSlotTypeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#create_version LexSlotType#create_version}.
     *
     * @stability stable
     */
    readonly createVersion?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#description LexSlotType#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#name LexSlotType#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#value_selection_strategy LexSlotType#value_selection_strategy}.
     *
     * @stability stable
     */
    readonly valueSelectionStrategy?: string;
    /**
     * enumeration_value block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#enumeration_value LexSlotType#enumeration_value}
     *
     * @stability stable
     */
    readonly enumerationValue: LexSlotTypeEnumerationValue[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#timeouts LexSlotType#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: LexSlotTypeTimeouts;
}
/**
 * @stability stable
 */
export interface LexSlotTypeEnumerationValue {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#synonyms LexSlotType#synonyms}.
     *
     * @stability stable
     */
    readonly synonyms?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#value LexSlotType#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface LexSlotTypeTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#create LexSlotType#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#delete LexSlotType#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#update LexSlotType#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html aws_lex_slot_type}.
 *
 * @stability stable
 */
export declare class LexSlotType extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html aws_lex_slot_type} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexSlotTypeConfig);
    /**
     * @stability stable
     */
    get checksum(): string;
    private _createVersion?;
    /**
     * @stability stable
     */
    get createVersion(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set createVersion(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCreateVersion(): void;
    /**
     * @stability stable
     */
    get createVersionInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _valueSelectionStrategy?;
    /**
     * @stability stable
     */
    get valueSelectionStrategy(): string;
    /**
     * @stability stable
     */
    set valueSelectionStrategy(value: string);
    /**
     * @stability stable
     */
    resetValueSelectionStrategy(): void;
    /**
     * @stability stable
     */
    get valueSelectionStrategyInput(): string | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _enumerationValue;
    /**
     * @stability stable
     */
    get enumerationValue(): LexSlotTypeEnumerationValue[];
    /**
     * @stability stable
     */
    set enumerationValue(value: LexSlotTypeEnumerationValue[]);
    /**
     * @stability stable
     */
    get enumerationValueInput(): LexSlotTypeEnumerationValue[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): LexSlotTypeTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: LexSlotTypeTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexSlotTypeTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
