import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LoadBalancerBackendServerPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_backend_server_policy.html#instance_port LoadBalancerBackendServerPolicy#instance_port}.
     *
     * @stability stable
     */
    readonly instancePort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_backend_server_policy.html#load_balancer_name LoadBalancerBackendServerPolicy#load_balancer_name}.
     *
     * @stability stable
     */
    readonly loadBalancerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_backend_server_policy.html#policy_names LoadBalancerBackendServerPolicy#policy_names}.
     *
     * @stability stable
     */
    readonly policyNames?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_backend_server_policy.html aws_load_balancer_backend_server_policy}.
 *
 * @stability stable
 */
export declare class LoadBalancerBackendServerPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_backend_server_policy.html aws_load_balancer_backend_server_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LoadBalancerBackendServerPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instancePort;
    /**
     * @stability stable
     */
    get instancePort(): number;
    /**
     * @stability stable
     */
    set instancePort(value: number);
    /**
     * @stability stable
     */
    get instancePortInput(): number;
    private _loadBalancerName;
    /**
     * @stability stable
     */
    get loadBalancerName(): string;
    /**
     * @stability stable
     */
    set loadBalancerName(value: string);
    /**
     * @stability stable
     */
    get loadBalancerNameInput(): string;
    private _policyNames?;
    /**
     * @stability stable
     */
    get policyNames(): string[];
    /**
     * @stability stable
     */
    set policyNames(value: string[]);
    /**
     * @stability stable
     */
    resetPolicyNames(): void;
    /**
     * @stability stable
     */
    get policyNamesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
