import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LoadBalancerListenerPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_listener_policy.html#load_balancer_name LoadBalancerListenerPolicy#load_balancer_name}.
     *
     * @stability stable
     */
    readonly loadBalancerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_listener_policy.html#load_balancer_port LoadBalancerListenerPolicy#load_balancer_port}.
     *
     * @stability stable
     */
    readonly loadBalancerPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_listener_policy.html#policy_names LoadBalancerListenerPolicy#policy_names}.
     *
     * @stability stable
     */
    readonly policyNames?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_listener_policy.html aws_load_balancer_listener_policy}.
 *
 * @stability stable
 */
export declare class LoadBalancerListenerPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_listener_policy.html aws_load_balancer_listener_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LoadBalancerListenerPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _loadBalancerName;
    /**
     * @stability stable
     */
    get loadBalancerName(): string;
    /**
     * @stability stable
     */
    set loadBalancerName(value: string);
    /**
     * @stability stable
     */
    get loadBalancerNameInput(): string;
    private _loadBalancerPort;
    /**
     * @stability stable
     */
    get loadBalancerPort(): number;
    /**
     * @stability stable
     */
    set loadBalancerPort(value: number);
    /**
     * @stability stable
     */
    get loadBalancerPortInput(): number;
    private _policyNames?;
    /**
     * @stability stable
     */
    get policyNames(): string[];
    /**
     * @stability stable
     */
    set policyNames(value: string[]);
    /**
     * @stability stable
     */
    resetPolicyNames(): void;
    /**
     * @stability stable
     */
    get policyNamesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
