import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Macie2MemberConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#account_id Macie2Member#account_id}.
     *
     * @stability stable
     */
    readonly accountId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#email Macie2Member#email}.
     *
     * @stability stable
     */
    readonly email: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#invitation_disable_email_notification Macie2Member#invitation_disable_email_notification}.
     *
     * @stability stable
     */
    readonly invitationDisableEmailNotification?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#invitation_message Macie2Member#invitation_message}.
     *
     * @stability stable
     */
    readonly invitationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#invite Macie2Member#invite}.
     *
     * @stability stable
     */
    readonly invite?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#status Macie2Member#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#tags Macie2Member#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#tags_all Macie2Member#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#timeouts Macie2Member#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: Macie2MemberTimeouts;
}
/**
 * @stability stable
 */
export interface Macie2MemberTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#create Macie2Member#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html#update Macie2Member#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html aws_macie2_member}.
 *
 * @stability stable
 */
export declare class Macie2Member extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie2_member.html aws_macie2_member} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Macie2MemberConfig);
    private _accountId;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    get accountIdInput(): string;
    /**
     * @stability stable
     */
    get administratorAccountId(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _email;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    set email(value: string);
    /**
     * @stability stable
     */
    get emailInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _invitationDisableEmailNotification?;
    /**
     * @stability stable
     */
    get invitationDisableEmailNotification(): string;
    /**
     * @stability stable
     */
    set invitationDisableEmailNotification(value: string);
    /**
     * @stability stable
     */
    resetInvitationDisableEmailNotification(): void;
    /**
     * @stability stable
     */
    get invitationDisableEmailNotificationInput(): string | undefined;
    private _invitationMessage?;
    /**
     * @stability stable
     */
    get invitationMessage(): string;
    /**
     * @stability stable
     */
    set invitationMessage(value: string);
    /**
     * @stability stable
     */
    resetInvitationMessage(): void;
    /**
     * @stability stable
     */
    get invitationMessageInput(): string | undefined;
    private _invite?;
    /**
     * @stability stable
     */
    get invite(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set invite(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInvite(): void;
    /**
     * @stability stable
     */
    get inviteInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get invitedAt(): string;
    /**
     * @stability stable
     */
    get masterAccountId(): string;
    /**
     * @stability stable
     */
    get relationshipStatus(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get updatedAt(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Macie2MemberTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Macie2MemberTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Macie2MemberTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
