import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MqBrokerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#apply_immediately MqBroker#apply_immediately}.
     *
     * @stability stable
     */
    readonly applyImmediately?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#authentication_strategy MqBroker#authentication_strategy}.
     *
     * @stability stable
     */
    readonly authenticationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#auto_minor_version_upgrade MqBroker#auto_minor_version_upgrade}.
     *
     * @stability stable
     */
    readonly autoMinorVersionUpgrade?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#broker_name MqBroker#broker_name}.
     *
     * @stability stable
     */
    readonly brokerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#deployment_mode MqBroker#deployment_mode}.
     *
     * @stability stable
     */
    readonly deploymentMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#engine_type MqBroker#engine_type}.
     *
     * @stability stable
     */
    readonly engineType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#engine_version MqBroker#engine_version}.
     *
     * @stability stable
     */
    readonly engineVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#host_instance_type MqBroker#host_instance_type}.
     *
     * @stability stable
     */
    readonly hostInstanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#publicly_accessible MqBroker#publicly_accessible}.
     *
     * @stability stable
     */
    readonly publiclyAccessible?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#security_groups MqBroker#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#storage_type MqBroker#storage_type}.
     *
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#subnet_ids MqBroker#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#tags MqBroker#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#tags_all MqBroker#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#configuration MqBroker#configuration}
     *
     * @stability stable
     */
    readonly configuration?: MqBrokerConfiguration[];
    /**
     * encryption_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#encryption_options MqBroker#encryption_options}
     *
     * @stability stable
     */
    readonly encryptionOptions?: MqBrokerEncryptionOptions[];
    /**
     * ldap_server_metadata block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#ldap_server_metadata MqBroker#ldap_server_metadata}
     *
     * @stability stable
     */
    readonly ldapServerMetadata?: MqBrokerLdapServerMetadata[];
    /**
     * logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#logs MqBroker#logs}
     *
     * @stability stable
     */
    readonly logs?: MqBrokerLogs[];
    /**
     * maintenance_window_start_time block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#maintenance_window_start_time MqBroker#maintenance_window_start_time}
     *
     * @stability stable
     */
    readonly maintenanceWindowStartTime?: MqBrokerMaintenanceWindowStartTime[];
    /**
     * user block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user MqBroker#user}
     *
     * @stability stable
     */
    readonly user: MqBrokerUser[];
}
/**
 * @stability stable
 */
export declare class MqBrokerInstances extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get consoleUrl(): string;
    /**
     * @stability stable
     */
    get endpoints(): string[];
    /**
     * @stability stable
     */
    get ipAddress(): string;
}
/**
 * @stability stable
 */
export interface MqBrokerConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#id MqBroker#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#revision MqBroker#revision}.
     *
     * @stability stable
     */
    readonly revision?: number;
}
/**
 * @stability stable
 */
export interface MqBrokerEncryptionOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#kms_key_id MqBroker#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#use_aws_owned_key MqBroker#use_aws_owned_key}.
     *
     * @stability stable
     */
    readonly useAwsOwnedKey?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface MqBrokerLdapServerMetadata {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#hosts MqBroker#hosts}.
     *
     * @stability stable
     */
    readonly hosts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_base MqBroker#role_base}.
     *
     * @stability stable
     */
    readonly roleBase?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_name MqBroker#role_name}.
     *
     * @stability stable
     */
    readonly roleName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_search_matching MqBroker#role_search_matching}.
     *
     * @stability stable
     */
    readonly roleSearchMatching?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_search_subtree MqBroker#role_search_subtree}.
     *
     * @stability stable
     */
    readonly roleSearchSubtree?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#service_account_password MqBroker#service_account_password}.
     *
     * @stability stable
     */
    readonly serviceAccountPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#service_account_username MqBroker#service_account_username}.
     *
     * @stability stable
     */
    readonly serviceAccountUsername?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_base MqBroker#user_base}.
     *
     * @stability stable
     */
    readonly userBase?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_role_name MqBroker#user_role_name}.
     *
     * @stability stable
     */
    readonly userRoleName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_search_matching MqBroker#user_search_matching}.
     *
     * @stability stable
     */
    readonly userSearchMatching?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_search_subtree MqBroker#user_search_subtree}.
     *
     * @stability stable
     */
    readonly userSearchSubtree?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface MqBrokerLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#audit MqBroker#audit}.
     *
     * @stability stable
     */
    readonly audit?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#general MqBroker#general}.
     *
     * @stability stable
     */
    readonly general?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface MqBrokerMaintenanceWindowStartTime {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#day_of_week MqBroker#day_of_week}.
     *
     * @stability stable
     */
    readonly dayOfWeek: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#time_of_day MqBroker#time_of_day}.
     *
     * @stability stable
     */
    readonly timeOfDay: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#time_zone MqBroker#time_zone}.
     *
     * @stability stable
     */
    readonly timeZone: string;
}
/**
 * @stability stable
 */
export interface MqBrokerUser {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#console_access MqBroker#console_access}.
     *
     * @stability stable
     */
    readonly consoleAccess?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#groups MqBroker#groups}.
     *
     * @stability stable
     */
    readonly groups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#password MqBroker#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#username MqBroker#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html aws_mq_broker}.
 *
 * @stability stable
 */
export declare class MqBroker extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html aws_mq_broker} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MqBrokerConfig);
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _authenticationStrategy?;
    /**
     * @stability stable
     */
    get authenticationStrategy(): string;
    /**
     * @stability stable
     */
    set authenticationStrategy(value: string);
    /**
     * @stability stable
     */
    resetAuthenticationStrategy(): void;
    /**
     * @stability stable
     */
    get authenticationStrategyInput(): string | undefined;
    private _autoMinorVersionUpgrade?;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoMinorVersionUpgrade(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoMinorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _brokerName;
    /**
     * @stability stable
     */
    get brokerName(): string;
    /**
     * @stability stable
     */
    set brokerName(value: string);
    /**
     * @stability stable
     */
    get brokerNameInput(): string;
    private _deploymentMode?;
    /**
     * @stability stable
     */
    get deploymentMode(): string;
    /**
     * @stability stable
     */
    set deploymentMode(value: string);
    /**
     * @stability stable
     */
    resetDeploymentMode(): void;
    /**
     * @stability stable
     */
    get deploymentModeInput(): string | undefined;
    private _engineType;
    /**
     * @stability stable
     */
    get engineType(): string;
    /**
     * @stability stable
     */
    set engineType(value: string);
    /**
     * @stability stable
     */
    get engineTypeInput(): string;
    private _engineVersion;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    get engineVersionInput(): string;
    private _hostInstanceType;
    /**
     * @stability stable
     */
    get hostInstanceType(): string;
    /**
     * @stability stable
     */
    set hostInstanceType(value: string);
    /**
     * @stability stable
     */
    get hostInstanceTypeInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    instances(index: string): MqBrokerInstances;
    private _publiclyAccessible?;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set publiclyAccessible(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPubliclyAccessible(): void;
    /**
     * @stability stable
     */
    get publiclyAccessibleInput(): boolean | cdktf.IResolvable | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _configuration?;
    /**
     * @stability stable
     */
    get configuration(): MqBrokerConfiguration[];
    /**
     * @stability stable
     */
    set configuration(value: MqBrokerConfiguration[]);
    /**
     * @stability stable
     */
    resetConfiguration(): void;
    /**
     * @stability stable
     */
    get configurationInput(): MqBrokerConfiguration[] | undefined;
    private _encryptionOptions?;
    /**
     * @stability stable
     */
    get encryptionOptions(): MqBrokerEncryptionOptions[];
    /**
     * @stability stable
     */
    set encryptionOptions(value: MqBrokerEncryptionOptions[]);
    /**
     * @stability stable
     */
    resetEncryptionOptions(): void;
    /**
     * @stability stable
     */
    get encryptionOptionsInput(): MqBrokerEncryptionOptions[] | undefined;
    private _ldapServerMetadata?;
    /**
     * @stability stable
     */
    get ldapServerMetadata(): MqBrokerLdapServerMetadata[];
    /**
     * @stability stable
     */
    set ldapServerMetadata(value: MqBrokerLdapServerMetadata[]);
    /**
     * @stability stable
     */
    resetLdapServerMetadata(): void;
    /**
     * @stability stable
     */
    get ldapServerMetadataInput(): MqBrokerLdapServerMetadata[] | undefined;
    private _logs?;
    /**
     * @stability stable
     */
    get logs(): MqBrokerLogs[];
    /**
     * @stability stable
     */
    set logs(value: MqBrokerLogs[]);
    /**
     * @stability stable
     */
    resetLogs(): void;
    /**
     * @stability stable
     */
    get logsInput(): MqBrokerLogs[] | undefined;
    private _maintenanceWindowStartTime?;
    /**
     * @stability stable
     */
    get maintenanceWindowStartTime(): MqBrokerMaintenanceWindowStartTime[];
    /**
     * @stability stable
     */
    set maintenanceWindowStartTime(value: MqBrokerMaintenanceWindowStartTime[]);
    /**
     * @stability stable
     */
    resetMaintenanceWindowStartTime(): void;
    /**
     * @stability stable
     */
    get maintenanceWindowStartTimeInput(): MqBrokerMaintenanceWindowStartTime[] | undefined;
    private _user;
    /**
     * @stability stable
     */
    get user(): MqBrokerUser[];
    /**
     * @stability stable
     */
    set user(value: MqBrokerUser[]);
    /**
     * @stability stable
     */
    get userInput(): MqBrokerUser[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
