import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MwaaEnvironmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#airflow_configuration_options MwaaEnvironment#airflow_configuration_options}.
     *
     * @stability stable
     */
    readonly airflowConfigurationOptions?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#airflow_version MwaaEnvironment#airflow_version}.
     *
     * @stability stable
     */
    readonly airflowVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#dag_s3_path MwaaEnvironment#dag_s3_path}.
     *
     * @stability stable
     */
    readonly dagS3Path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#environment_class MwaaEnvironment#environment_class}.
     *
     * @stability stable
     */
    readonly environmentClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#execution_role_arn MwaaEnvironment#execution_role_arn}.
     *
     * @stability stable
     */
    readonly executionRoleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#kms_key MwaaEnvironment#kms_key}.
     *
     * @stability stable
     */
    readonly kmsKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#max_workers MwaaEnvironment#max_workers}.
     *
     * @stability stable
     */
    readonly maxWorkers?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#min_workers MwaaEnvironment#min_workers}.
     *
     * @stability stable
     */
    readonly minWorkers?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#name MwaaEnvironment#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#plugins_s3_object_version MwaaEnvironment#plugins_s3_object_version}.
     *
     * @stability stable
     */
    readonly pluginsS3ObjectVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#plugins_s3_path MwaaEnvironment#plugins_s3_path}.
     *
     * @stability stable
     */
    readonly pluginsS3Path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#requirements_s3_object_version MwaaEnvironment#requirements_s3_object_version}.
     *
     * @stability stable
     */
    readonly requirementsS3ObjectVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#requirements_s3_path MwaaEnvironment#requirements_s3_path}.
     *
     * @stability stable
     */
    readonly requirementsS3Path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#source_bucket_arn MwaaEnvironment#source_bucket_arn}.
     *
     * @stability stable
     */
    readonly sourceBucketArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#tags MwaaEnvironment#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#tags_all MwaaEnvironment#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#webserver_access_mode MwaaEnvironment#webserver_access_mode}.
     *
     * @stability stable
     */
    readonly webserverAccessMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#weekly_maintenance_window_start MwaaEnvironment#weekly_maintenance_window_start}.
     *
     * @stability stable
     */
    readonly weeklyMaintenanceWindowStart?: string;
    /**
     * logging_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#logging_configuration MwaaEnvironment#logging_configuration}
     *
     * @stability stable
     */
    readonly loggingConfiguration?: MwaaEnvironmentLoggingConfiguration[];
    /**
     * network_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#network_configuration MwaaEnvironment#network_configuration}
     *
     * @stability stable
     */
    readonly networkConfiguration: MwaaEnvironmentNetworkConfiguration[];
}
/**
 * @stability stable
 */
export declare class MwaaEnvironmentLastUpdatedError extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get errorCode(): string;
    /**
     * @stability stable
     */
    get errorMessage(): string;
}
/**
 * @stability stable
 */
export declare class MwaaEnvironmentLastUpdated extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get createdAt(): string;
    /**
     * @stability stable
     */
    get error(): any;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * @stability stable
 */
export interface MwaaEnvironmentLoggingConfigurationDagProcessingLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#enabled MwaaEnvironment#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#log_level MwaaEnvironment#log_level}.
     *
     * @stability stable
     */
    readonly logLevel?: string;
}
/**
 * @stability stable
 */
export interface MwaaEnvironmentLoggingConfigurationSchedulerLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#enabled MwaaEnvironment#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#log_level MwaaEnvironment#log_level}.
     *
     * @stability stable
     */
    readonly logLevel?: string;
}
/**
 * @stability stable
 */
export interface MwaaEnvironmentLoggingConfigurationTaskLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#enabled MwaaEnvironment#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#log_level MwaaEnvironment#log_level}.
     *
     * @stability stable
     */
    readonly logLevel?: string;
}
/**
 * @stability stable
 */
export interface MwaaEnvironmentLoggingConfigurationWebserverLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#enabled MwaaEnvironment#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#log_level MwaaEnvironment#log_level}.
     *
     * @stability stable
     */
    readonly logLevel?: string;
}
/**
 * @stability stable
 */
export interface MwaaEnvironmentLoggingConfigurationWorkerLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#enabled MwaaEnvironment#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#log_level MwaaEnvironment#log_level}.
     *
     * @stability stable
     */
    readonly logLevel?: string;
}
/**
 * @stability stable
 */
export interface MwaaEnvironmentLoggingConfiguration {
    /**
     * dag_processing_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#dag_processing_logs MwaaEnvironment#dag_processing_logs}
     *
     * @stability stable
     */
    readonly dagProcessingLogs?: MwaaEnvironmentLoggingConfigurationDagProcessingLogs[];
    /**
     * scheduler_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#scheduler_logs MwaaEnvironment#scheduler_logs}
     *
     * @stability stable
     */
    readonly schedulerLogs?: MwaaEnvironmentLoggingConfigurationSchedulerLogs[];
    /**
     * task_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#task_logs MwaaEnvironment#task_logs}
     *
     * @stability stable
     */
    readonly taskLogs?: MwaaEnvironmentLoggingConfigurationTaskLogs[];
    /**
     * webserver_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#webserver_logs MwaaEnvironment#webserver_logs}
     *
     * @stability stable
     */
    readonly webserverLogs?: MwaaEnvironmentLoggingConfigurationWebserverLogs[];
    /**
     * worker_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#worker_logs MwaaEnvironment#worker_logs}
     *
     * @stability stable
     */
    readonly workerLogs?: MwaaEnvironmentLoggingConfigurationWorkerLogs[];
}
/**
 * @stability stable
 */
export interface MwaaEnvironmentNetworkConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#security_group_ids MwaaEnvironment#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html#subnet_ids MwaaEnvironment#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html aws_mwaa_environment}.
 *
 * @stability stable
 */
export declare class MwaaEnvironment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/mwaa_environment.html aws_mwaa_environment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MwaaEnvironmentConfig);
    private _airflowConfigurationOptions?;
    /**
     * @stability stable
     */
    get airflowConfigurationOptions(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set airflowConfigurationOptions(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAirflowConfigurationOptions(): void;
    /**
     * @stability stable
     */
    get airflowConfigurationOptionsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _airflowVersion?;
    /**
     * @stability stable
     */
    get airflowVersion(): string;
    /**
     * @stability stable
     */
    set airflowVersion(value: string);
    /**
     * @stability stable
     */
    resetAirflowVersion(): void;
    /**
     * @stability stable
     */
    get airflowVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdAt(): string;
    private _dagS3Path;
    /**
     * @stability stable
     */
    get dagS3Path(): string;
    /**
     * @stability stable
     */
    set dagS3Path(value: string);
    /**
     * @stability stable
     */
    get dagS3PathInput(): string;
    private _environmentClass?;
    /**
     * @stability stable
     */
    get environmentClass(): string;
    /**
     * @stability stable
     */
    set environmentClass(value: string);
    /**
     * @stability stable
     */
    resetEnvironmentClass(): void;
    /**
     * @stability stable
     */
    get environmentClassInput(): string | undefined;
    private _executionRoleArn;
    /**
     * @stability stable
     */
    get executionRoleArn(): string;
    /**
     * @stability stable
     */
    set executionRoleArn(value: string);
    /**
     * @stability stable
     */
    get executionRoleArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKey?;
    /**
     * @stability stable
     */
    get kmsKey(): string;
    /**
     * @stability stable
     */
    set kmsKey(value: string);
    /**
     * @stability stable
     */
    resetKmsKey(): void;
    /**
     * @stability stable
     */
    get kmsKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    lastUpdated(index: string): MwaaEnvironmentLastUpdated;
    private _maxWorkers?;
    /**
     * @stability stable
     */
    get maxWorkers(): number;
    /**
     * @stability stable
     */
    set maxWorkers(value: number);
    /**
     * @stability stable
     */
    resetMaxWorkers(): void;
    /**
     * @stability stable
     */
    get maxWorkersInput(): number | undefined;
    private _minWorkers?;
    /**
     * @stability stable
     */
    get minWorkers(): number;
    /**
     * @stability stable
     */
    set minWorkers(value: number);
    /**
     * @stability stable
     */
    resetMinWorkers(): void;
    /**
     * @stability stable
     */
    get minWorkersInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _pluginsS3ObjectVersion?;
    /**
     * @stability stable
     */
    get pluginsS3ObjectVersion(): string;
    /**
     * @stability stable
     */
    set pluginsS3ObjectVersion(value: string);
    /**
     * @stability stable
     */
    resetPluginsS3ObjectVersion(): void;
    /**
     * @stability stable
     */
    get pluginsS3ObjectVersionInput(): string | undefined;
    private _pluginsS3Path?;
    /**
     * @stability stable
     */
    get pluginsS3Path(): string;
    /**
     * @stability stable
     */
    set pluginsS3Path(value: string);
    /**
     * @stability stable
     */
    resetPluginsS3Path(): void;
    /**
     * @stability stable
     */
    get pluginsS3PathInput(): string | undefined;
    private _requirementsS3ObjectVersion?;
    /**
     * @stability stable
     */
    get requirementsS3ObjectVersion(): string;
    /**
     * @stability stable
     */
    set requirementsS3ObjectVersion(value: string);
    /**
     * @stability stable
     */
    resetRequirementsS3ObjectVersion(): void;
    /**
     * @stability stable
     */
    get requirementsS3ObjectVersionInput(): string | undefined;
    private _requirementsS3Path?;
    /**
     * @stability stable
     */
    get requirementsS3Path(): string;
    /**
     * @stability stable
     */
    set requirementsS3Path(value: string);
    /**
     * @stability stable
     */
    resetRequirementsS3Path(): void;
    /**
     * @stability stable
     */
    get requirementsS3PathInput(): string | undefined;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    private _sourceBucketArn;
    /**
     * @stability stable
     */
    get sourceBucketArn(): string;
    /**
     * @stability stable
     */
    set sourceBucketArn(value: string);
    /**
     * @stability stable
     */
    get sourceBucketArnInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _webserverAccessMode?;
    /**
     * @stability stable
     */
    get webserverAccessMode(): string;
    /**
     * @stability stable
     */
    set webserverAccessMode(value: string);
    /**
     * @stability stable
     */
    resetWebserverAccessMode(): void;
    /**
     * @stability stable
     */
    get webserverAccessModeInput(): string | undefined;
    /**
     * @stability stable
     */
    get webserverUrl(): string;
    private _weeklyMaintenanceWindowStart?;
    /**
     * @stability stable
     */
    get weeklyMaintenanceWindowStart(): string;
    /**
     * @stability stable
     */
    set weeklyMaintenanceWindowStart(value: string);
    /**
     * @stability stable
     */
    resetWeeklyMaintenanceWindowStart(): void;
    /**
     * @stability stable
     */
    get weeklyMaintenanceWindowStartInput(): string | undefined;
    private _loggingConfiguration?;
    /**
     * @stability stable
     */
    get loggingConfiguration(): MwaaEnvironmentLoggingConfiguration[];
    /**
     * @stability stable
     */
    set loggingConfiguration(value: MwaaEnvironmentLoggingConfiguration[]);
    /**
     * @stability stable
     */
    resetLoggingConfiguration(): void;
    /**
     * @stability stable
     */
    get loggingConfigurationInput(): MwaaEnvironmentLoggingConfiguration[] | undefined;
    private _networkConfiguration;
    /**
     * @stability stable
     */
    get networkConfiguration(): MwaaEnvironmentNetworkConfiguration[];
    /**
     * @stability stable
     */
    set networkConfiguration(value: MwaaEnvironmentNetworkConfiguration[]);
    /**
     * @stability stable
     */
    get networkConfigurationInput(): MwaaEnvironmentNetworkConfiguration[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
