import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksNodejsAppLayerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#auto_assign_elastic_ips OpsworksNodejsAppLayer#auto_assign_elastic_ips}.
     *
     * @stability stable
     */
    readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#auto_assign_public_ips OpsworksNodejsAppLayer#auto_assign_public_ips}.
     *
     * @stability stable
     */
    readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#auto_healing OpsworksNodejsAppLayer#auto_healing}.
     *
     * @stability stable
     */
    readonly autoHealing?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_configure_recipes OpsworksNodejsAppLayer#custom_configure_recipes}.
     *
     * @stability stable
     */
    readonly customConfigureRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_deploy_recipes OpsworksNodejsAppLayer#custom_deploy_recipes}.
     *
     * @stability stable
     */
    readonly customDeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_instance_profile_arn OpsworksNodejsAppLayer#custom_instance_profile_arn}.
     *
     * @stability stable
     */
    readonly customInstanceProfileArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_json OpsworksNodejsAppLayer#custom_json}.
     *
     * @stability stable
     */
    readonly customJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_security_group_ids OpsworksNodejsAppLayer#custom_security_group_ids}.
     *
     * @stability stable
     */
    readonly customSecurityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_setup_recipes OpsworksNodejsAppLayer#custom_setup_recipes}.
     *
     * @stability stable
     */
    readonly customSetupRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_shutdown_recipes OpsworksNodejsAppLayer#custom_shutdown_recipes}.
     *
     * @stability stable
     */
    readonly customShutdownRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_undeploy_recipes OpsworksNodejsAppLayer#custom_undeploy_recipes}.
     *
     * @stability stable
     */
    readonly customUndeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#drain_elb_on_shutdown OpsworksNodejsAppLayer#drain_elb_on_shutdown}.
     *
     * @stability stable
     */
    readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#elastic_load_balancer OpsworksNodejsAppLayer#elastic_load_balancer}.
     *
     * @stability stable
     */
    readonly elasticLoadBalancer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#install_updates_on_boot OpsworksNodejsAppLayer#install_updates_on_boot}.
     *
     * @stability stable
     */
    readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#instance_shutdown_timeout OpsworksNodejsAppLayer#instance_shutdown_timeout}.
     *
     * @stability stable
     */
    readonly instanceShutdownTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#name OpsworksNodejsAppLayer#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#nodejs_version OpsworksNodejsAppLayer#nodejs_version}.
     *
     * @stability stable
     */
    readonly nodejsVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#stack_id OpsworksNodejsAppLayer#stack_id}.
     *
     * @stability stable
     */
    readonly stackId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#system_packages OpsworksNodejsAppLayer#system_packages}.
     *
     * @stability stable
     */
    readonly systemPackages?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#tags OpsworksNodejsAppLayer#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#tags_all OpsworksNodejsAppLayer#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#use_ebs_optimized_instances OpsworksNodejsAppLayer#use_ebs_optimized_instances}.
     *
     * @stability stable
     */
    readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
    /**
     * ebs_volume block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#ebs_volume OpsworksNodejsAppLayer#ebs_volume}
     *
     * @stability stable
     */
    readonly ebsVolume?: OpsworksNodejsAppLayerEbsVolume[];
}
/**
 * @stability stable
 */
export interface OpsworksNodejsAppLayerEbsVolume {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#encrypted OpsworksNodejsAppLayer#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#iops OpsworksNodejsAppLayer#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#mount_point OpsworksNodejsAppLayer#mount_point}.
     *
     * @stability stable
     */
    readonly mountPoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#number_of_disks OpsworksNodejsAppLayer#number_of_disks}.
     *
     * @stability stable
     */
    readonly numberOfDisks: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#raid_level OpsworksNodejsAppLayer#raid_level}.
     *
     * @stability stable
     */
    readonly raidLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#size OpsworksNodejsAppLayer#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#type OpsworksNodejsAppLayer#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html aws_opsworks_nodejs_app_layer}.
 *
 * @stability stable
 */
export declare class OpsworksNodejsAppLayer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html aws_opsworks_nodejs_app_layer} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksNodejsAppLayerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoAssignElasticIps?;
    /**
     * @stability stable
     */
    get autoAssignElasticIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignElasticIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignElasticIps(): void;
    /**
     * @stability stable
     */
    get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoAssignPublicIps?;
    /**
     * @stability stable
     */
    get autoAssignPublicIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignPublicIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignPublicIps(): void;
    /**
     * @stability stable
     */
    get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoHealing?;
    /**
     * @stability stable
     */
    get autoHealing(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoHealing(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoHealing(): void;
    /**
     * @stability stable
     */
    get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
    private _customConfigureRecipes?;
    /**
     * @stability stable
     */
    get customConfigureRecipes(): string[];
    /**
     * @stability stable
     */
    set customConfigureRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomConfigureRecipes(): void;
    /**
     * @stability stable
     */
    get customConfigureRecipesInput(): string[] | undefined;
    private _customDeployRecipes?;
    /**
     * @stability stable
     */
    get customDeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customDeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomDeployRecipes(): void;
    /**
     * @stability stable
     */
    get customDeployRecipesInput(): string[] | undefined;
    private _customInstanceProfileArn?;
    /**
     * @stability stable
     */
    get customInstanceProfileArn(): string;
    /**
     * @stability stable
     */
    set customInstanceProfileArn(value: string);
    /**
     * @stability stable
     */
    resetCustomInstanceProfileArn(): void;
    /**
     * @stability stable
     */
    get customInstanceProfileArnInput(): string | undefined;
    private _customJson?;
    /**
     * @stability stable
     */
    get customJson(): string;
    /**
     * @stability stable
     */
    set customJson(value: string);
    /**
     * @stability stable
     */
    resetCustomJson(): void;
    /**
     * @stability stable
     */
    get customJsonInput(): string | undefined;
    private _customSecurityGroupIds?;
    /**
     * @stability stable
     */
    get customSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set customSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get customSecurityGroupIdsInput(): string[] | undefined;
    private _customSetupRecipes?;
    /**
     * @stability stable
     */
    get customSetupRecipes(): string[];
    /**
     * @stability stable
     */
    set customSetupRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSetupRecipes(): void;
    /**
     * @stability stable
     */
    get customSetupRecipesInput(): string[] | undefined;
    private _customShutdownRecipes?;
    /**
     * @stability stable
     */
    get customShutdownRecipes(): string[];
    /**
     * @stability stable
     */
    set customShutdownRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomShutdownRecipes(): void;
    /**
     * @stability stable
     */
    get customShutdownRecipesInput(): string[] | undefined;
    private _customUndeployRecipes?;
    /**
     * @stability stable
     */
    get customUndeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customUndeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomUndeployRecipes(): void;
    /**
     * @stability stable
     */
    get customUndeployRecipesInput(): string[] | undefined;
    private _drainElbOnShutdown?;
    /**
     * @stability stable
     */
    get drainElbOnShutdown(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set drainElbOnShutdown(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDrainElbOnShutdown(): void;
    /**
     * @stability stable
     */
    get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
    private _elasticLoadBalancer?;
    /**
     * @stability stable
     */
    get elasticLoadBalancer(): string;
    /**
     * @stability stable
     */
    set elasticLoadBalancer(value: string);
    /**
     * @stability stable
     */
    resetElasticLoadBalancer(): void;
    /**
     * @stability stable
     */
    get elasticLoadBalancerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _installUpdatesOnBoot?;
    /**
     * @stability stable
     */
    get installUpdatesOnBoot(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set installUpdatesOnBoot(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstallUpdatesOnBoot(): void;
    /**
     * @stability stable
     */
    get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
    private _instanceShutdownTimeout?;
    /**
     * @stability stable
     */
    get instanceShutdownTimeout(): number;
    /**
     * @stability stable
     */
    set instanceShutdownTimeout(value: number);
    /**
     * @stability stable
     */
    resetInstanceShutdownTimeout(): void;
    /**
     * @stability stable
     */
    get instanceShutdownTimeoutInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _nodejsVersion?;
    /**
     * @stability stable
     */
    get nodejsVersion(): string;
    /**
     * @stability stable
     */
    set nodejsVersion(value: string);
    /**
     * @stability stable
     */
    resetNodejsVersion(): void;
    /**
     * @stability stable
     */
    get nodejsVersionInput(): string | undefined;
    private _stackId;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string;
    private _systemPackages?;
    /**
     * @stability stable
     */
    get systemPackages(): string[];
    /**
     * @stability stable
     */
    set systemPackages(value: string[]);
    /**
     * @stability stable
     */
    resetSystemPackages(): void;
    /**
     * @stability stable
     */
    get systemPackagesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _useEbsOptimizedInstances?;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstances(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseEbsOptimizedInstances(): void;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _ebsVolume?;
    /**
     * @stability stable
     */
    get ebsVolume(): OpsworksNodejsAppLayerEbsVolume[];
    /**
     * @stability stable
     */
    set ebsVolume(value: OpsworksNodejsAppLayerEbsVolume[]);
    /**
     * @stability stable
     */
    resetEbsVolume(): void;
    /**
     * @stability stable
     */
    get ebsVolumeInput(): OpsworksNodejsAppLayerEbsVolume[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
