import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksPermissionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#allow_ssh OpsworksPermission#allow_ssh}.
     *
     * @stability stable
     */
    readonly allowSsh?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#allow_sudo OpsworksPermission#allow_sudo}.
     *
     * @stability stable
     */
    readonly allowSudo?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#level OpsworksPermission#level}.
     *
     * @stability stable
     */
    readonly level?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#stack_id OpsworksPermission#stack_id}.
     *
     * @stability stable
     */
    readonly stackId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#user_arn OpsworksPermission#user_arn}.
     *
     * @stability stable
     */
    readonly userArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html aws_opsworks_permission}.
 *
 * @stability stable
 */
export declare class OpsworksPermission extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html aws_opsworks_permission} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksPermissionConfig);
    private _allowSsh?;
    /**
     * @stability stable
     */
    get allowSsh(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowSsh(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowSsh(): void;
    /**
     * @stability stable
     */
    get allowSshInput(): boolean | cdktf.IResolvable | undefined;
    private _allowSudo?;
    /**
     * @stability stable
     */
    get allowSudo(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowSudo(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowSudo(): void;
    /**
     * @stability stable
     */
    get allowSudoInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _level?;
    /**
     * @stability stable
     */
    get level(): string;
    /**
     * @stability stable
     */
    set level(value: string);
    /**
     * @stability stable
     */
    resetLevel(): void;
    /**
     * @stability stable
     */
    get levelInput(): string | undefined;
    private _stackId?;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    resetStackId(): void;
    /**
     * @stability stable
     */
    get stackIdInput(): string | undefined;
    private _userArn;
    /**
     * @stability stable
     */
    get userArn(): string;
    /**
     * @stability stable
     */
    set userArn(value: string);
    /**
     * @stability stable
     */
    get userArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
