import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface QuicksightDataSourceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aws_account_id QuicksightDataSource#aws_account_id}.
     *
     * @stability stable
     */
    readonly awsAccountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#data_source_id QuicksightDataSource#data_source_id}.
     *
     * @stability stable
     */
    readonly dataSourceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#name QuicksightDataSource#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#tags QuicksightDataSource#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#tags_all QuicksightDataSource#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#type QuicksightDataSource#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * credentials block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#credentials QuicksightDataSource#credentials}
     *
     * @stability stable
     */
    readonly credentials?: QuicksightDataSourceCredentials[];
    /**
     * parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#parameters QuicksightDataSource#parameters}
     *
     * @stability stable
     */
    readonly parameters: QuicksightDataSourceParameters[];
    /**
     * permission block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#permission QuicksightDataSource#permission}
     *
     * @stability stable
     */
    readonly permission?: QuicksightDataSourcePermission[];
    /**
     * ssl_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#ssl_properties QuicksightDataSource#ssl_properties}
     *
     * @stability stable
     */
    readonly sslProperties?: QuicksightDataSourceSslProperties[];
    /**
     * vpc_connection_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#vpc_connection_properties QuicksightDataSource#vpc_connection_properties}
     *
     * @stability stable
     */
    readonly vpcConnectionProperties?: QuicksightDataSourceVpcConnectionProperties[];
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceCredentialsCredentialPair {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#password QuicksightDataSource#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#username QuicksightDataSource#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceCredentials {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#copy_source_arn QuicksightDataSource#copy_source_arn}.
     *
     * @stability stable
     */
    readonly copySourceArn?: string;
    /**
     * credential_pair block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#credential_pair QuicksightDataSource#credential_pair}
     *
     * @stability stable
     */
    readonly credentialPair?: QuicksightDataSourceCredentialsCredentialPair[];
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersAmazonElasticsearch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#domain QuicksightDataSource#domain}.
     *
     * @stability stable
     */
    readonly domain: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersAthena {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#work_group QuicksightDataSource#work_group}.
     *
     * @stability stable
     */
    readonly workGroup?: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersAurora {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersAuroraPostgresql {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersAwsIotAnalytics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#data_set_name QuicksightDataSource#data_set_name}.
     *
     * @stability stable
     */
    readonly dataSetName: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersJira {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#site_base_url QuicksightDataSource#site_base_url}.
     *
     * @stability stable
     */
    readonly siteBaseUrl: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersMariaDb {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersMysql {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersOracle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersPostgresql {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersPresto {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#catalog QuicksightDataSource#catalog}.
     *
     * @stability stable
     */
    readonly catalog: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersRds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#instance_id QuicksightDataSource#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersRedshift {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#cluster_id QuicksightDataSource#cluster_id}.
     *
     * @stability stable
     */
    readonly clusterId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port?: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersS3ManifestFileLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#bucket QuicksightDataSource#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#key QuicksightDataSource#key}.
     *
     * @stability stable
     */
    readonly key: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersS3 {
    /**
     * manifest_file_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#manifest_file_location QuicksightDataSource#manifest_file_location}
     *
     * @stability stable
     */
    readonly manifestFileLocation: QuicksightDataSourceParametersS3ManifestFileLocation[];
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersServiceNow {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#site_base_url QuicksightDataSource#site_base_url}.
     *
     * @stability stable
     */
    readonly siteBaseUrl: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersSnowflake {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#warehouse QuicksightDataSource#warehouse}.
     *
     * @stability stable
     */
    readonly warehouse: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersSpark {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersSqlServer {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersTeradata {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
     *
     * @stability stable
     */
    readonly database: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
     *
     * @stability stable
     */
    readonly host: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
     *
     * @stability stable
     */
    readonly port: number;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParametersTwitter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#max_rows QuicksightDataSource#max_rows}.
     *
     * @stability stable
     */
    readonly maxRows: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#query QuicksightDataSource#query}.
     *
     * @stability stable
     */
    readonly query: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceParameters {
    /**
     * amazon_elasticsearch block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#amazon_elasticsearch QuicksightDataSource#amazon_elasticsearch}
     *
     * @stability stable
     */
    readonly amazonElasticsearch?: QuicksightDataSourceParametersAmazonElasticsearch[];
    /**
     * athena block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#athena QuicksightDataSource#athena}
     *
     * @stability stable
     */
    readonly athena?: QuicksightDataSourceParametersAthena[];
    /**
     * aurora block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aurora QuicksightDataSource#aurora}
     *
     * @stability stable
     */
    readonly aurora?: QuicksightDataSourceParametersAurora[];
    /**
     * aurora_postgresql block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aurora_postgresql QuicksightDataSource#aurora_postgresql}
     *
     * @stability stable
     */
    readonly auroraPostgresql?: QuicksightDataSourceParametersAuroraPostgresql[];
    /**
     * aws_iot_analytics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aws_iot_analytics QuicksightDataSource#aws_iot_analytics}
     *
     * @stability stable
     */
    readonly awsIotAnalytics?: QuicksightDataSourceParametersAwsIotAnalytics[];
    /**
     * jira block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#jira QuicksightDataSource#jira}
     *
     * @stability stable
     */
    readonly jira?: QuicksightDataSourceParametersJira[];
    /**
     * maria_db block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#maria_db QuicksightDataSource#maria_db}
     *
     * @stability stable
     */
    readonly mariaDb?: QuicksightDataSourceParametersMariaDb[];
    /**
     * mysql block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#mysql QuicksightDataSource#mysql}
     *
     * @stability stable
     */
    readonly mysql?: QuicksightDataSourceParametersMysql[];
    /**
     * oracle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#oracle QuicksightDataSource#oracle}
     *
     * @stability stable
     */
    readonly oracle?: QuicksightDataSourceParametersOracle[];
    /**
     * postgresql block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#postgresql QuicksightDataSource#postgresql}
     *
     * @stability stable
     */
    readonly postgresql?: QuicksightDataSourceParametersPostgresql[];
    /**
     * presto block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#presto QuicksightDataSource#presto}
     *
     * @stability stable
     */
    readonly presto?: QuicksightDataSourceParametersPresto[];
    /**
     * rds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#rds QuicksightDataSource#rds}
     *
     * @stability stable
     */
    readonly rds?: QuicksightDataSourceParametersRds[];
    /**
     * redshift block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#redshift QuicksightDataSource#redshift}
     *
     * @stability stable
     */
    readonly redshift?: QuicksightDataSourceParametersRedshift[];
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#s3 QuicksightDataSource#s3}
     *
     * @stability stable
     */
    readonly s3?: QuicksightDataSourceParametersS3[];
    /**
     * service_now block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#service_now QuicksightDataSource#service_now}
     *
     * @stability stable
     */
    readonly serviceNow?: QuicksightDataSourceParametersServiceNow[];
    /**
     * snowflake block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#snowflake QuicksightDataSource#snowflake}
     *
     * @stability stable
     */
    readonly snowflake?: QuicksightDataSourceParametersSnowflake[];
    /**
     * spark block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#spark QuicksightDataSource#spark}
     *
     * @stability stable
     */
    readonly spark?: QuicksightDataSourceParametersSpark[];
    /**
     * sql_server block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#sql_server QuicksightDataSource#sql_server}
     *
     * @stability stable
     */
    readonly sqlServer?: QuicksightDataSourceParametersSqlServer[];
    /**
     * teradata block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#teradata QuicksightDataSource#teradata}
     *
     * @stability stable
     */
    readonly teradata?: QuicksightDataSourceParametersTeradata[];
    /**
     * twitter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#twitter QuicksightDataSource#twitter}
     *
     * @stability stable
     */
    readonly twitter?: QuicksightDataSourceParametersTwitter[];
}
/**
 * @stability stable
 */
export interface QuicksightDataSourcePermission {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#actions QuicksightDataSource#actions}.
     *
     * @stability stable
     */
    readonly actions: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#principal QuicksightDataSource#principal}.
     *
     * @stability stable
     */
    readonly principal: string;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceSslProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#disable_ssl QuicksightDataSource#disable_ssl}.
     *
     * @stability stable
     */
    readonly disableSsl: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface QuicksightDataSourceVpcConnectionProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#vpc_connection_arn QuicksightDataSource#vpc_connection_arn}.
     *
     * @stability stable
     */
    readonly vpcConnectionArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html aws_quicksight_data_source}.
 *
 * @stability stable
 */
export declare class QuicksightDataSource extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html aws_quicksight_data_source} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: QuicksightDataSourceConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsAccountId?;
    /**
     * @stability stable
     */
    get awsAccountId(): string;
    /**
     * @stability stable
     */
    set awsAccountId(value: string);
    /**
     * @stability stable
     */
    resetAwsAccountId(): void;
    /**
     * @stability stable
     */
    get awsAccountIdInput(): string | undefined;
    private _dataSourceId;
    /**
     * @stability stable
     */
    get dataSourceId(): string;
    /**
     * @stability stable
     */
    set dataSourceId(value: string);
    /**
     * @stability stable
     */
    get dataSourceIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _credentials?;
    /**
     * @stability stable
     */
    get credentials(): QuicksightDataSourceCredentials[];
    /**
     * @stability stable
     */
    set credentials(value: QuicksightDataSourceCredentials[]);
    /**
     * @stability stable
     */
    resetCredentials(): void;
    /**
     * @stability stable
     */
    get credentialsInput(): QuicksightDataSourceCredentials[] | undefined;
    private _parameters;
    /**
     * @stability stable
     */
    get parameters(): QuicksightDataSourceParameters[];
    /**
     * @stability stable
     */
    set parameters(value: QuicksightDataSourceParameters[]);
    /**
     * @stability stable
     */
    get parametersInput(): QuicksightDataSourceParameters[];
    private _permission?;
    /**
     * @stability stable
     */
    get permission(): QuicksightDataSourcePermission[];
    /**
     * @stability stable
     */
    set permission(value: QuicksightDataSourcePermission[]);
    /**
     * @stability stable
     */
    resetPermission(): void;
    /**
     * @stability stable
     */
    get permissionInput(): QuicksightDataSourcePermission[] | undefined;
    private _sslProperties?;
    /**
     * @stability stable
     */
    get sslProperties(): QuicksightDataSourceSslProperties[];
    /**
     * @stability stable
     */
    set sslProperties(value: QuicksightDataSourceSslProperties[]);
    /**
     * @stability stable
     */
    resetSslProperties(): void;
    /**
     * @stability stable
     */
    get sslPropertiesInput(): QuicksightDataSourceSslProperties[] | undefined;
    private _vpcConnectionProperties?;
    /**
     * @stability stable
     */
    get vpcConnectionProperties(): QuicksightDataSourceVpcConnectionProperties[];
    /**
     * @stability stable
     */
    set vpcConnectionProperties(value: QuicksightDataSourceVpcConnectionProperties[]);
    /**
     * @stability stable
     */
    resetVpcConnectionProperties(): void;
    /**
     * @stability stable
     */
    get vpcConnectionPropertiesInput(): QuicksightDataSourceVpcConnectionProperties[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
