import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RamResourceShareAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter.html#share_arn RamResourceShareAccepter#share_arn}.
     *
     * @stability stable
     */
    readonly shareArn: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter.html#timeouts RamResourceShareAccepter#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: RamResourceShareAccepterTimeouts;
}
/**
 * @stability stable
 */
export interface RamResourceShareAccepterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter.html#create RamResourceShareAccepter#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter.html#delete RamResourceShareAccepter#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter.html aws_ram_resource_share_accepter}.
 *
 * @stability stable
 */
export declare class RamResourceShareAccepter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter.html aws_ram_resource_share_accepter} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RamResourceShareAccepterConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invitationArn(): string;
    /**
     * @stability stable
     */
    get receiverAccountId(): string;
    /**
     * @stability stable
     */
    get resources(): string[];
    /**
     * @stability stable
     */
    get senderAccountId(): string;
    private _shareArn;
    /**
     * @stability stable
     */
    get shareArn(): string;
    /**
     * @stability stable
     */
    set shareArn(value: string);
    /**
     * @stability stable
     */
    get shareArnInput(): string;
    /**
     * @stability stable
     */
    get shareId(): string;
    /**
     * @stability stable
     */
    get shareName(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): RamResourceShareAccepterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: RamResourceShareAccepterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): RamResourceShareAccepterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
