import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53QueryLogConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html#cloudwatch_log_group_arn Route53QueryLog#cloudwatch_log_group_arn}.
     *
     * @stability stable
     */
    readonly cloudwatchLogGroupArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html#zone_id Route53QueryLog#zone_id}.
     *
     * @stability stable
     */
    readonly zoneId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html aws_route53_query_log}.
 *
 * @stability stable
 */
export declare class Route53QueryLog extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html aws_route53_query_log} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53QueryLogConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _cloudwatchLogGroupArn;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchLogGroupArn(value: string);
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _zoneId;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    set zoneId(value: string);
    /**
     * @stability stable
     */
    get zoneIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
