import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53ResolverFirewallRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#action Route53ResolverFirewallRule#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_override_dns_type Route53ResolverFirewallRule#block_override_dns_type}.
     *
     * @stability stable
     */
    readonly blockOverrideDnsType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_override_domain Route53ResolverFirewallRule#block_override_domain}.
     *
     * @stability stable
     */
    readonly blockOverrideDomain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_override_ttl Route53ResolverFirewallRule#block_override_ttl}.
     *
     * @stability stable
     */
    readonly blockOverrideTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_response Route53ResolverFirewallRule#block_response}.
     *
     * @stability stable
     */
    readonly blockResponse?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#firewall_domain_list_id Route53ResolverFirewallRule#firewall_domain_list_id}.
     *
     * @stability stable
     */
    readonly firewallDomainListId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#firewall_rule_group_id Route53ResolverFirewallRule#firewall_rule_group_id}.
     *
     * @stability stable
     */
    readonly firewallRuleGroupId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#name Route53ResolverFirewallRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#priority Route53ResolverFirewallRule#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html aws_route53_resolver_firewall_rule}.
 *
 * @stability stable
 */
export declare class Route53ResolverFirewallRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html aws_route53_resolver_firewall_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53ResolverFirewallRuleConfig);
    private _action;
    /**
     * @stability stable
     */
    get action(): string;
    /**
     * @stability stable
     */
    set action(value: string);
    /**
     * @stability stable
     */
    get actionInput(): string;
    private _blockOverrideDnsType?;
    /**
     * @stability stable
     */
    get blockOverrideDnsType(): string;
    /**
     * @stability stable
     */
    set blockOverrideDnsType(value: string);
    /**
     * @stability stable
     */
    resetBlockOverrideDnsType(): void;
    /**
     * @stability stable
     */
    get blockOverrideDnsTypeInput(): string | undefined;
    private _blockOverrideDomain?;
    /**
     * @stability stable
     */
    get blockOverrideDomain(): string;
    /**
     * @stability stable
     */
    set blockOverrideDomain(value: string);
    /**
     * @stability stable
     */
    resetBlockOverrideDomain(): void;
    /**
     * @stability stable
     */
    get blockOverrideDomainInput(): string | undefined;
    private _blockOverrideTtl?;
    /**
     * @stability stable
     */
    get blockOverrideTtl(): number;
    /**
     * @stability stable
     */
    set blockOverrideTtl(value: number);
    /**
     * @stability stable
     */
    resetBlockOverrideTtl(): void;
    /**
     * @stability stable
     */
    get blockOverrideTtlInput(): number | undefined;
    private _blockResponse?;
    /**
     * @stability stable
     */
    get blockResponse(): string;
    /**
     * @stability stable
     */
    set blockResponse(value: string);
    /**
     * @stability stable
     */
    resetBlockResponse(): void;
    /**
     * @stability stable
     */
    get blockResponseInput(): string | undefined;
    private _firewallDomainListId;
    /**
     * @stability stable
     */
    get firewallDomainListId(): string;
    /**
     * @stability stable
     */
    set firewallDomainListId(value: string);
    /**
     * @stability stable
     */
    get firewallDomainListIdInput(): string;
    private _firewallRuleGroupId;
    /**
     * @stability stable
     */
    get firewallRuleGroupId(): string;
    /**
     * @stability stable
     */
    set firewallRuleGroupId(value: string);
    /**
     * @stability stable
     */
    get firewallRuleGroupIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _priority;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    get priorityInput(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
