import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53RecoverycontrolconfigSafetyRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#asserted_controls Route53RecoverycontrolconfigSafetyRule#asserted_controls}.
     *
     * @stability stable
     */
    readonly assertedControls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#control_panel_arn Route53RecoverycontrolconfigSafetyRule#control_panel_arn}.
     *
     * @stability stable
     */
    readonly controlPanelArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#gating_controls Route53RecoverycontrolconfigSafetyRule#gating_controls}.
     *
     * @stability stable
     */
    readonly gatingControls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#name Route53RecoverycontrolconfigSafetyRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#target_controls Route53RecoverycontrolconfigSafetyRule#target_controls}.
     *
     * @stability stable
     */
    readonly targetControls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#wait_period_ms Route53RecoverycontrolconfigSafetyRule#wait_period_ms}.
     *
     * @stability stable
     */
    readonly waitPeriodMs: number;
    /**
     * rule_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#rule_config Route53RecoverycontrolconfigSafetyRule#rule_config}
     *
     * @stability stable
     */
    readonly ruleConfig: Route53RecoverycontrolconfigSafetyRuleRuleConfig[];
}
/**
 * @stability stable
 */
export interface Route53RecoverycontrolconfigSafetyRuleRuleConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#inverted Route53RecoverycontrolconfigSafetyRule#inverted}.
     *
     * @stability stable
     */
    readonly inverted: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#threshold Route53RecoverycontrolconfigSafetyRule#threshold}.
     *
     * @stability stable
     */
    readonly threshold: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#type Route53RecoverycontrolconfigSafetyRule#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html aws_route53recoverycontrolconfig_safety_rule}.
 *
 * @stability stable
 */
export declare class Route53RecoverycontrolconfigSafetyRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html aws_route53recoverycontrolconfig_safety_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53RecoverycontrolconfigSafetyRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _assertedControls?;
    /**
     * @stability stable
     */
    get assertedControls(): string[];
    /**
     * @stability stable
     */
    set assertedControls(value: string[]);
    /**
     * @stability stable
     */
    resetAssertedControls(): void;
    /**
     * @stability stable
     */
    get assertedControlsInput(): string[] | undefined;
    private _controlPanelArn;
    /**
     * @stability stable
     */
    get controlPanelArn(): string;
    /**
     * @stability stable
     */
    set controlPanelArn(value: string);
    /**
     * @stability stable
     */
    get controlPanelArnInput(): string;
    private _gatingControls?;
    /**
     * @stability stable
     */
    get gatingControls(): string[];
    /**
     * @stability stable
     */
    set gatingControls(value: string[]);
    /**
     * @stability stable
     */
    resetGatingControls(): void;
    /**
     * @stability stable
     */
    get gatingControlsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _targetControls?;
    /**
     * @stability stable
     */
    get targetControls(): string[];
    /**
     * @stability stable
     */
    set targetControls(value: string[]);
    /**
     * @stability stable
     */
    resetTargetControls(): void;
    /**
     * @stability stable
     */
    get targetControlsInput(): string[] | undefined;
    private _waitPeriodMs;
    /**
     * @stability stable
     */
    get waitPeriodMs(): number;
    /**
     * @stability stable
     */
    set waitPeriodMs(value: number);
    /**
     * @stability stable
     */
    get waitPeriodMsInput(): number;
    private _ruleConfig;
    /**
     * @stability stable
     */
    get ruleConfig(): Route53RecoverycontrolconfigSafetyRuleRuleConfig[];
    /**
     * @stability stable
     */
    set ruleConfig(value: Route53RecoverycontrolconfigSafetyRuleRuleConfig[]);
    /**
     * @stability stable
     */
    get ruleConfigInput(): Route53RecoverycontrolconfigSafetyRuleRuleConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
