import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3BucketConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#acceleration_status S3Bucket#acceleration_status}.
     *
     * @stability stable
     */
    readonly accelerationStatus?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#acl S3Bucket#acl}.
     *
     * @stability stable
     */
    readonly acl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#bucket S3Bucket#bucket}.
     *
     * @stability stable
     */
    readonly bucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#bucket_prefix S3Bucket#bucket_prefix}.
     *
     * @stability stable
     */
    readonly bucketPrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#force_destroy S3Bucket#force_destroy}.
     *
     * @stability stable
     */
    readonly forceDestroy?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#hosted_zone_id S3Bucket#hosted_zone_id}.
     *
     * @stability stable
     */
    readonly hostedZoneId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#policy S3Bucket#policy}.
     *
     * @stability stable
     */
    readonly policy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#request_payer S3Bucket#request_payer}.
     *
     * @stability stable
     */
    readonly requestPayer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#tags S3Bucket#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#tags_all S3Bucket#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#website_domain S3Bucket#website_domain}.
     *
     * @stability stable
     */
    readonly websiteDomain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#website_endpoint S3Bucket#website_endpoint}.
     *
     * @stability stable
     */
    readonly websiteEndpoint?: string;
    /**
     * cors_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#cors_rule S3Bucket#cors_rule}
     *
     * @stability stable
     */
    readonly corsRule?: S3BucketCorsRule[];
    /**
     * grant block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#grant S3Bucket#grant}
     *
     * @stability stable
     */
    readonly grant?: S3BucketGrant[];
    /**
     * lifecycle_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#lifecycle_rule S3Bucket#lifecycle_rule}
     *
     * @stability stable
     */
    readonly lifecycleRule?: S3BucketLifecycleRule[];
    /**
     * logging block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#logging S3Bucket#logging}
     *
     * @stability stable
     */
    readonly logging?: S3BucketLogging[];
    /**
     * object_lock_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#object_lock_configuration S3Bucket#object_lock_configuration}
     *
     * @stability stable
     */
    readonly objectLockConfiguration?: S3BucketObjectLockConfiguration[];
    /**
     * replication_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#replication_configuration S3Bucket#replication_configuration}
     *
     * @stability stable
     */
    readonly replicationConfiguration?: S3BucketReplicationConfiguration[];
    /**
     * server_side_encryption_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#server_side_encryption_configuration S3Bucket#server_side_encryption_configuration}
     *
     * @stability stable
     */
    readonly serverSideEncryptionConfiguration?: S3BucketServerSideEncryptionConfiguration[];
    /**
     * versioning block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#versioning S3Bucket#versioning}
     *
     * @stability stable
     */
    readonly versioning?: S3BucketVersioning[];
    /**
     * website block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#website S3Bucket#website}
     *
     * @stability stable
     */
    readonly website?: S3BucketWebsite[];
}
/**
 * @stability stable
 */
export interface S3BucketCorsRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#allowed_headers S3Bucket#allowed_headers}.
     *
     * @stability stable
     */
    readonly allowedHeaders?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#allowed_methods S3Bucket#allowed_methods}.
     *
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#allowed_origins S3Bucket#allowed_origins}.
     *
     * @stability stable
     */
    readonly allowedOrigins: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#expose_headers S3Bucket#expose_headers}.
     *
     * @stability stable
     */
    readonly exposeHeaders?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#max_age_seconds S3Bucket#max_age_seconds}.
     *
     * @stability stable
     */
    readonly maxAgeSeconds?: number;
}
/**
 * @stability stable
 */
export interface S3BucketGrant {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#id S3Bucket#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#permissions S3Bucket#permissions}.
     *
     * @stability stable
     */
    readonly permissions: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#type S3Bucket#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#uri S3Bucket#uri}.
     *
     * @stability stable
     */
    readonly uri?: string;
}
/**
 * @stability stable
 */
export interface S3BucketLifecycleRuleExpiration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#date S3Bucket#date}.
     *
     * @stability stable
     */
    readonly date?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#days S3Bucket#days}.
     *
     * @stability stable
     */
    readonly days?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#expired_object_delete_marker S3Bucket#expired_object_delete_marker}.
     *
     * @stability stable
     */
    readonly expiredObjectDeleteMarker?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface S3BucketLifecycleRuleNoncurrentVersionExpiration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#days S3Bucket#days}.
     *
     * @stability stable
     */
    readonly days?: number;
}
/**
 * @stability stable
 */
export interface S3BucketLifecycleRuleNoncurrentVersionTransition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#days S3Bucket#days}.
     *
     * @stability stable
     */
    readonly days?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#storage_class S3Bucket#storage_class}.
     *
     * @stability stable
     */
    readonly storageClass: string;
}
/**
 * @stability stable
 */
export interface S3BucketLifecycleRuleTransition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#date S3Bucket#date}.
     *
     * @stability stable
     */
    readonly date?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#days S3Bucket#days}.
     *
     * @stability stable
     */
    readonly days?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#storage_class S3Bucket#storage_class}.
     *
     * @stability stable
     */
    readonly storageClass: string;
}
/**
 * @stability stable
 */
export interface S3BucketLifecycleRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#abort_incomplete_multipart_upload_days S3Bucket#abort_incomplete_multipart_upload_days}.
     *
     * @stability stable
     */
    readonly abortIncompleteMultipartUploadDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#enabled S3Bucket#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#id S3Bucket#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#prefix S3Bucket#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#tags S3Bucket#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * expiration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#expiration S3Bucket#expiration}
     *
     * @stability stable
     */
    readonly expiration?: S3BucketLifecycleRuleExpiration[];
    /**
     * noncurrent_version_expiration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#noncurrent_version_expiration S3Bucket#noncurrent_version_expiration}
     *
     * @stability stable
     */
    readonly noncurrentVersionExpiration?: S3BucketLifecycleRuleNoncurrentVersionExpiration[];
    /**
     * noncurrent_version_transition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#noncurrent_version_transition S3Bucket#noncurrent_version_transition}
     *
     * @stability stable
     */
    readonly noncurrentVersionTransition?: S3BucketLifecycleRuleNoncurrentVersionTransition[];
    /**
     * transition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#transition S3Bucket#transition}
     *
     * @stability stable
     */
    readonly transition?: S3BucketLifecycleRuleTransition[];
}
/**
 * @stability stable
 */
export interface S3BucketLogging {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#target_bucket S3Bucket#target_bucket}.
     *
     * @stability stable
     */
    readonly targetBucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#target_prefix S3Bucket#target_prefix}.
     *
     * @stability stable
     */
    readonly targetPrefix?: string;
}
/**
 * @stability stable
 */
export interface S3BucketObjectLockConfigurationRuleDefaultRetention {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#days S3Bucket#days}.
     *
     * @stability stable
     */
    readonly days?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#mode S3Bucket#mode}.
     *
     * @stability stable
     */
    readonly mode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#years S3Bucket#years}.
     *
     * @stability stable
     */
    readonly years?: number;
}
/**
 * @stability stable
 */
export interface S3BucketObjectLockConfigurationRule {
    /**
     * default_retention block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#default_retention S3Bucket#default_retention}
     *
     * @stability stable
     */
    readonly defaultRetention: S3BucketObjectLockConfigurationRuleDefaultRetention[];
}
/**
 * @stability stable
 */
export interface S3BucketObjectLockConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#object_lock_enabled S3Bucket#object_lock_enabled}.
     *
     * @stability stable
     */
    readonly objectLockEnabled: string;
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#rule S3Bucket#rule}
     *
     * @stability stable
     */
    readonly rule?: S3BucketObjectLockConfigurationRule[];
}
/**
 * @stability stable
 */
export interface S3BucketReplicationConfigurationRulesDestinationAccessControlTranslation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#owner S3Bucket#owner}.
     *
     * @stability stable
     */
    readonly owner: string;
}
/**
 * @stability stable
 */
export interface S3BucketReplicationConfigurationRulesDestination {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#account_id S3Bucket#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#bucket S3Bucket#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#replica_kms_key_id S3Bucket#replica_kms_key_id}.
     *
     * @stability stable
     */
    readonly replicaKmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#storage_class S3Bucket#storage_class}.
     *
     * @stability stable
     */
    readonly storageClass?: string;
    /**
     * access_control_translation block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#access_control_translation S3Bucket#access_control_translation}
     *
     * @stability stable
     */
    readonly accessControlTranslation?: S3BucketReplicationConfigurationRulesDestinationAccessControlTranslation[];
}
/**
 * @stability stable
 */
export interface S3BucketReplicationConfigurationRulesFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#prefix S3Bucket#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#tags S3Bucket#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface S3BucketReplicationConfigurationRulesSourceSelectionCriteriaSseKmsEncryptedObjects {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#enabled S3Bucket#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface S3BucketReplicationConfigurationRulesSourceSelectionCriteria {
    /**
     * sse_kms_encrypted_objects block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#sse_kms_encrypted_objects S3Bucket#sse_kms_encrypted_objects}
     *
     * @stability stable
     */
    readonly sseKmsEncryptedObjects?: S3BucketReplicationConfigurationRulesSourceSelectionCriteriaSseKmsEncryptedObjects[];
}
/**
 * @stability stable
 */
export interface S3BucketReplicationConfigurationRules {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#delete_marker_replication_status S3Bucket#delete_marker_replication_status}.
     *
     * @stability stable
     */
    readonly deleteMarkerReplicationStatus?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#id S3Bucket#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#prefix S3Bucket#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#priority S3Bucket#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#status S3Bucket#status}.
     *
     * @stability stable
     */
    readonly status: string;
    /**
     * destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#destination S3Bucket#destination}
     *
     * @stability stable
     */
    readonly destination: S3BucketReplicationConfigurationRulesDestination[];
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#filter S3Bucket#filter}
     *
     * @stability stable
     */
    readonly filter?: S3BucketReplicationConfigurationRulesFilter[];
    /**
     * source_selection_criteria block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#source_selection_criteria S3Bucket#source_selection_criteria}
     *
     * @stability stable
     */
    readonly sourceSelectionCriteria?: S3BucketReplicationConfigurationRulesSourceSelectionCriteria[];
}
/**
 * @stability stable
 */
export interface S3BucketReplicationConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#role S3Bucket#role}.
     *
     * @stability stable
     */
    readonly role: string;
    /**
     * rules block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#rules S3Bucket#rules}
     *
     * @stability stable
     */
    readonly rules: S3BucketReplicationConfigurationRules[];
}
/**
 * @stability stable
 */
export interface S3BucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#kms_master_key_id S3Bucket#kms_master_key_id}.
     *
     * @stability stable
     */
    readonly kmsMasterKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#sse_algorithm S3Bucket#sse_algorithm}.
     *
     * @stability stable
     */
    readonly sseAlgorithm: string;
}
/**
 * @stability stable
 */
export interface S3BucketServerSideEncryptionConfigurationRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#bucket_key_enabled S3Bucket#bucket_key_enabled}.
     *
     * @stability stable
     */
    readonly bucketKeyEnabled?: boolean | cdktf.IResolvable;
    /**
     * apply_server_side_encryption_by_default block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#apply_server_side_encryption_by_default S3Bucket#apply_server_side_encryption_by_default}
     *
     * @stability stable
     */
    readonly applyServerSideEncryptionByDefault: S3BucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault[];
}
/**
 * @stability stable
 */
export interface S3BucketServerSideEncryptionConfiguration {
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#rule S3Bucket#rule}
     *
     * @stability stable
     */
    readonly rule: S3BucketServerSideEncryptionConfigurationRule[];
}
/**
 * @stability stable
 */
export interface S3BucketVersioning {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#enabled S3Bucket#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#mfa_delete S3Bucket#mfa_delete}.
     *
     * @stability stable
     */
    readonly mfaDelete?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface S3BucketWebsite {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#error_document S3Bucket#error_document}.
     *
     * @stability stable
     */
    readonly errorDocument?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#index_document S3Bucket#index_document}.
     *
     * @stability stable
     */
    readonly indexDocument?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#redirect_all_requests_to S3Bucket#redirect_all_requests_to}.
     *
     * @stability stable
     */
    readonly redirectAllRequestsTo?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html#routing_rules S3Bucket#routing_rules}.
     *
     * @stability stable
     */
    readonly routingRules?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html aws_s3_bucket}.
 *
 * @stability stable
 */
export declare class S3Bucket extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket.html aws_s3_bucket} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: S3BucketConfig);
    private _accelerationStatus?;
    /**
     * @stability stable
     */
    get accelerationStatus(): string;
    /**
     * @stability stable
     */
    set accelerationStatus(value: string);
    /**
     * @stability stable
     */
    resetAccelerationStatus(): void;
    /**
     * @stability stable
     */
    get accelerationStatusInput(): string | undefined;
    private _acl?;
    /**
     * @stability stable
     */
    get acl(): string;
    /**
     * @stability stable
     */
    set acl(value: string);
    /**
     * @stability stable
     */
    resetAcl(): void;
    /**
     * @stability stable
     */
    get aclInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _bucket?;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    resetBucket(): void;
    /**
     * @stability stable
     */
    get bucketInput(): string | undefined;
    /**
     * @stability stable
     */
    get bucketDomainName(): string;
    private _bucketPrefix?;
    /**
     * @stability stable
     */
    get bucketPrefix(): string;
    /**
     * @stability stable
     */
    set bucketPrefix(value: string);
    /**
     * @stability stable
     */
    resetBucketPrefix(): void;
    /**
     * @stability stable
     */
    get bucketPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get bucketRegionalDomainName(): string;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | cdktf.IResolvable | undefined;
    private _hostedZoneId?;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    /**
     * @stability stable
     */
    set hostedZoneId(value: string);
    /**
     * @stability stable
     */
    resetHostedZoneId(): void;
    /**
     * @stability stable
     */
    get hostedZoneIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    /**
     * @stability stable
     */
    get region(): string;
    private _requestPayer?;
    /**
     * @stability stable
     */
    get requestPayer(): string;
    /**
     * @stability stable
     */
    set requestPayer(value: string);
    /**
     * @stability stable
     */
    resetRequestPayer(): void;
    /**
     * @stability stable
     */
    get requestPayerInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _websiteDomain?;
    /**
     * @stability stable
     */
    get websiteDomain(): string;
    /**
     * @stability stable
     */
    set websiteDomain(value: string);
    /**
     * @stability stable
     */
    resetWebsiteDomain(): void;
    /**
     * @stability stable
     */
    get websiteDomainInput(): string | undefined;
    private _websiteEndpoint?;
    /**
     * @stability stable
     */
    get websiteEndpoint(): string;
    /**
     * @stability stable
     */
    set websiteEndpoint(value: string);
    /**
     * @stability stable
     */
    resetWebsiteEndpoint(): void;
    /**
     * @stability stable
     */
    get websiteEndpointInput(): string | undefined;
    private _corsRule?;
    /**
     * @stability stable
     */
    get corsRule(): S3BucketCorsRule[];
    /**
     * @stability stable
     */
    set corsRule(value: S3BucketCorsRule[]);
    /**
     * @stability stable
     */
    resetCorsRule(): void;
    /**
     * @stability stable
     */
    get corsRuleInput(): S3BucketCorsRule[] | undefined;
    private _grant?;
    /**
     * @stability stable
     */
    get grant(): S3BucketGrant[];
    /**
     * @stability stable
     */
    set grant(value: S3BucketGrant[]);
    /**
     * @stability stable
     */
    resetGrant(): void;
    /**
     * @stability stable
     */
    get grantInput(): S3BucketGrant[] | undefined;
    private _lifecycleRule?;
    /**
     * @stability stable
     */
    get lifecycleRule(): S3BucketLifecycleRule[];
    /**
     * @stability stable
     */
    set lifecycleRule(value: S3BucketLifecycleRule[]);
    /**
     * @stability stable
     */
    resetLifecycleRule(): void;
    /**
     * @stability stable
     */
    get lifecycleRuleInput(): S3BucketLifecycleRule[] | undefined;
    private _logging?;
    /**
     * @stability stable
     */
    get logging(): S3BucketLogging[];
    /**
     * @stability stable
     */
    set logging(value: S3BucketLogging[]);
    /**
     * @stability stable
     */
    resetLogging(): void;
    /**
     * @stability stable
     */
    get loggingInput(): S3BucketLogging[] | undefined;
    private _objectLockConfiguration?;
    /**
     * @stability stable
     */
    get objectLockConfiguration(): S3BucketObjectLockConfiguration[];
    /**
     * @stability stable
     */
    set objectLockConfiguration(value: S3BucketObjectLockConfiguration[]);
    /**
     * @stability stable
     */
    resetObjectLockConfiguration(): void;
    /**
     * @stability stable
     */
    get objectLockConfigurationInput(): S3BucketObjectLockConfiguration[] | undefined;
    private _replicationConfiguration?;
    /**
     * @stability stable
     */
    get replicationConfiguration(): S3BucketReplicationConfiguration[];
    /**
     * @stability stable
     */
    set replicationConfiguration(value: S3BucketReplicationConfiguration[]);
    /**
     * @stability stable
     */
    resetReplicationConfiguration(): void;
    /**
     * @stability stable
     */
    get replicationConfigurationInput(): S3BucketReplicationConfiguration[] | undefined;
    private _serverSideEncryptionConfiguration?;
    /**
     * @stability stable
     */
    get serverSideEncryptionConfiguration(): S3BucketServerSideEncryptionConfiguration[];
    /**
     * @stability stable
     */
    set serverSideEncryptionConfiguration(value: S3BucketServerSideEncryptionConfiguration[]);
    /**
     * @stability stable
     */
    resetServerSideEncryptionConfiguration(): void;
    /**
     * @stability stable
     */
    get serverSideEncryptionConfigurationInput(): S3BucketServerSideEncryptionConfiguration[] | undefined;
    private _versioning?;
    /**
     * @stability stable
     */
    get versioning(): S3BucketVersioning[];
    /**
     * @stability stable
     */
    set versioning(value: S3BucketVersioning[]);
    /**
     * @stability stable
     */
    resetVersioning(): void;
    /**
     * @stability stable
     */
    get versioningInput(): S3BucketVersioning[] | undefined;
    private _website?;
    /**
     * @stability stable
     */
    get website(): S3BucketWebsite[];
    /**
     * @stability stable
     */
    set website(value: S3BucketWebsite[]);
    /**
     * @stability stable
     */
    resetWebsite(): void;
    /**
     * @stability stable
     */
    get websiteInput(): S3BucketWebsite[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
