import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#description SagemakerFeatureGroup#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#event_time_feature_name SagemakerFeatureGroup#event_time_feature_name}.
     *
     * @stability stable
     */
    readonly eventTimeFeatureName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#feature_group_name SagemakerFeatureGroup#feature_group_name}.
     *
     * @stability stable
     */
    readonly featureGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#record_identifier_feature_name SagemakerFeatureGroup#record_identifier_feature_name}.
     *
     * @stability stable
     */
    readonly recordIdentifierFeatureName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#role_arn SagemakerFeatureGroup#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#tags SagemakerFeatureGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#tags_all SagemakerFeatureGroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * feature_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#feature_definition SagemakerFeatureGroup#feature_definition}
     *
     * @stability stable
     */
    readonly featureDefinition: SagemakerFeatureGroupFeatureDefinition[];
    /**
     * offline_store_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#offline_store_config SagemakerFeatureGroup#offline_store_config}
     *
     * @stability stable
     */
    readonly offlineStoreConfig?: SagemakerFeatureGroupOfflineStoreConfig[];
    /**
     * online_store_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#online_store_config SagemakerFeatureGroup#online_store_config}
     *
     * @stability stable
     */
    readonly onlineStoreConfig?: SagemakerFeatureGroupOnlineStoreConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupFeatureDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#feature_name SagemakerFeatureGroup#feature_name}.
     *
     * @stability stable
     */
    readonly featureName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#feature_type SagemakerFeatureGroup#feature_type}.
     *
     * @stability stable
     */
    readonly featureType?: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOfflineStoreConfigDataCatalogConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#catalog SagemakerFeatureGroup#catalog}.
     *
     * @stability stable
     */
    readonly catalog?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#database SagemakerFeatureGroup#database}.
     *
     * @stability stable
     */
    readonly database?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#table_name SagemakerFeatureGroup#table_name}.
     *
     * @stability stable
     */
    readonly tableName?: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOfflineStoreConfigS3StorageConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#kms_key_id SagemakerFeatureGroup#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#s3_uri SagemakerFeatureGroup#s3_uri}.
     *
     * @stability stable
     */
    readonly s3Uri: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOfflineStoreConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#disable_glue_table_creation SagemakerFeatureGroup#disable_glue_table_creation}.
     *
     * @stability stable
     */
    readonly disableGlueTableCreation?: boolean | cdktf.IResolvable;
    /**
     * data_catalog_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#data_catalog_config SagemakerFeatureGroup#data_catalog_config}
     *
     * @stability stable
     */
    readonly dataCatalogConfig?: SagemakerFeatureGroupOfflineStoreConfigDataCatalogConfig[];
    /**
     * s3_storage_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#s3_storage_config SagemakerFeatureGroup#s3_storage_config}
     *
     * @stability stable
     */
    readonly s3StorageConfig: SagemakerFeatureGroupOfflineStoreConfigS3StorageConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOnlineStoreConfigSecurityConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#kms_key_id SagemakerFeatureGroup#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOnlineStoreConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#enable_online_store SagemakerFeatureGroup#enable_online_store}.
     *
     * @stability stable
     */
    readonly enableOnlineStore?: boolean | cdktf.IResolvable;
    /**
     * security_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html#security_config SagemakerFeatureGroup#security_config}
     *
     * @stability stable
     */
    readonly securityConfig?: SagemakerFeatureGroupOnlineStoreConfigSecurityConfig[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html aws_sagemaker_feature_group}.
 *
 * @stability stable
 */
export declare class SagemakerFeatureGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_feature_group.html aws_sagemaker_feature_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerFeatureGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _eventTimeFeatureName;
    /**
     * @stability stable
     */
    get eventTimeFeatureName(): string;
    /**
     * @stability stable
     */
    set eventTimeFeatureName(value: string);
    /**
     * @stability stable
     */
    get eventTimeFeatureNameInput(): string;
    private _featureGroupName;
    /**
     * @stability stable
     */
    get featureGroupName(): string;
    /**
     * @stability stable
     */
    set featureGroupName(value: string);
    /**
     * @stability stable
     */
    get featureGroupNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _recordIdentifierFeatureName;
    /**
     * @stability stable
     */
    get recordIdentifierFeatureName(): string;
    /**
     * @stability stable
     */
    set recordIdentifierFeatureName(value: string);
    /**
     * @stability stable
     */
    get recordIdentifierFeatureNameInput(): string;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _featureDefinition;
    /**
     * @stability stable
     */
    get featureDefinition(): SagemakerFeatureGroupFeatureDefinition[];
    /**
     * @stability stable
     */
    set featureDefinition(value: SagemakerFeatureGroupFeatureDefinition[]);
    /**
     * @stability stable
     */
    get featureDefinitionInput(): SagemakerFeatureGroupFeatureDefinition[];
    private _offlineStoreConfig?;
    /**
     * @stability stable
     */
    get offlineStoreConfig(): SagemakerFeatureGroupOfflineStoreConfig[];
    /**
     * @stability stable
     */
    set offlineStoreConfig(value: SagemakerFeatureGroupOfflineStoreConfig[]);
    /**
     * @stability stable
     */
    resetOfflineStoreConfig(): void;
    /**
     * @stability stable
     */
    get offlineStoreConfigInput(): SagemakerFeatureGroupOfflineStoreConfig[] | undefined;
    private _onlineStoreConfig?;
    /**
     * @stability stable
     */
    get onlineStoreConfig(): SagemakerFeatureGroupOnlineStoreConfig[];
    /**
     * @stability stable
     */
    set onlineStoreConfig(value: SagemakerFeatureGroupOnlineStoreConfig[]);
    /**
     * @stability stable
     */
    resetOnlineStoreConfig(): void;
    /**
     * @stability stable
     */
    get onlineStoreConfigInput(): SagemakerFeatureGroupOnlineStoreConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
