import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#flow_definition_name SagemakerFlowDefinition#flow_definition_name}.
     *
     * @stability stable
     */
    readonly flowDefinitionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#role_arn SagemakerFlowDefinition#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#tags SagemakerFlowDefinition#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#tags_all SagemakerFlowDefinition#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * human_loop_activation_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#human_loop_activation_config SagemakerFlowDefinition#human_loop_activation_config}
     *
     * @stability stable
     */
    readonly humanLoopActivationConfig?: SagemakerFlowDefinitionHumanLoopActivationConfig[];
    /**
     * human_loop_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#human_loop_config SagemakerFlowDefinition#human_loop_config}
     *
     * @stability stable
     */
    readonly humanLoopConfig: SagemakerFlowDefinitionHumanLoopConfig[];
    /**
     * human_loop_request_source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#human_loop_request_source SagemakerFlowDefinition#human_loop_request_source}
     *
     * @stability stable
     */
    readonly humanLoopRequestSource?: SagemakerFlowDefinitionHumanLoopRequestSource[];
    /**
     * output_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#output_config SagemakerFlowDefinition#output_config}
     *
     * @stability stable
     */
    readonly outputConfig: SagemakerFlowDefinitionOutputConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#human_loop_activation_conditions SagemakerFlowDefinition#human_loop_activation_conditions}.
     *
     * @stability stable
     */
    readonly humanLoopActivationConditions: string;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopActivationConfig {
    /**
     * human_loop_activation_conditions_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#human_loop_activation_conditions_config SagemakerFlowDefinition#human_loop_activation_conditions_config}
     *
     * @stability stable
     */
    readonly humanLoopActivationConditionsConfig?: SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#cents SagemakerFlowDefinition#cents}.
     *
     * @stability stable
     */
    readonly cents?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#dollars SagemakerFlowDefinition#dollars}.
     *
     * @stability stable
     */
    readonly dollars?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#tenth_fractions_of_a_cent SagemakerFlowDefinition#tenth_fractions_of_a_cent}.
     *
     * @stability stable
     */
    readonly tenthFractionsOfACent?: number;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice {
    /**
     * amount_in_usd block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#amount_in_usd SagemakerFlowDefinition#amount_in_usd}
     *
     * @stability stable
     */
    readonly amountInUsd?: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd[];
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#human_task_ui_arn SagemakerFlowDefinition#human_task_ui_arn}.
     *
     * @stability stable
     */
    readonly humanTaskUiArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#task_availability_lifetime_in_seconds SagemakerFlowDefinition#task_availability_lifetime_in_seconds}.
     *
     * @stability stable
     */
    readonly taskAvailabilityLifetimeInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#task_count SagemakerFlowDefinition#task_count}.
     *
     * @stability stable
     */
    readonly taskCount: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#task_description SagemakerFlowDefinition#task_description}.
     *
     * @stability stable
     */
    readonly taskDescription: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#task_keywords SagemakerFlowDefinition#task_keywords}.
     *
     * @stability stable
     */
    readonly taskKeywords?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#task_time_limit_in_seconds SagemakerFlowDefinition#task_time_limit_in_seconds}.
     *
     * @stability stable
     */
    readonly taskTimeLimitInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#task_title SagemakerFlowDefinition#task_title}.
     *
     * @stability stable
     */
    readonly taskTitle: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#workteam_arn SagemakerFlowDefinition#workteam_arn}.
     *
     * @stability stable
     */
    readonly workteamArn: string;
    /**
     * public_workforce_task_price block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#public_workforce_task_price SagemakerFlowDefinition#public_workforce_task_price}
     *
     * @stability stable
     */
    readonly publicWorkforceTaskPrice?: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice[];
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopRequestSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#aws_managed_human_loop_request_source SagemakerFlowDefinition#aws_managed_human_loop_request_source}.
     *
     * @stability stable
     */
    readonly awsManagedHumanLoopRequestSource: string;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionOutputConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#kms_key_id SagemakerFlowDefinition#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html#s3_output_path SagemakerFlowDefinition#s3_output_path}.
     *
     * @stability stable
     */
    readonly s3OutputPath: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html aws_sagemaker_flow_definition}.
 *
 * @stability stable
 */
export declare class SagemakerFlowDefinition extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition.html aws_sagemaker_flow_definition} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerFlowDefinitionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _flowDefinitionName;
    /**
     * @stability stable
     */
    get flowDefinitionName(): string;
    /**
     * @stability stable
     */
    set flowDefinitionName(value: string);
    /**
     * @stability stable
     */
    get flowDefinitionNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _humanLoopActivationConfig?;
    /**
     * @stability stable
     */
    get humanLoopActivationConfig(): SagemakerFlowDefinitionHumanLoopActivationConfig[];
    /**
     * @stability stable
     */
    set humanLoopActivationConfig(value: SagemakerFlowDefinitionHumanLoopActivationConfig[]);
    /**
     * @stability stable
     */
    resetHumanLoopActivationConfig(): void;
    /**
     * @stability stable
     */
    get humanLoopActivationConfigInput(): SagemakerFlowDefinitionHumanLoopActivationConfig[] | undefined;
    private _humanLoopConfig;
    /**
     * @stability stable
     */
    get humanLoopConfig(): SagemakerFlowDefinitionHumanLoopConfig[];
    /**
     * @stability stable
     */
    set humanLoopConfig(value: SagemakerFlowDefinitionHumanLoopConfig[]);
    /**
     * @stability stable
     */
    get humanLoopConfigInput(): SagemakerFlowDefinitionHumanLoopConfig[];
    private _humanLoopRequestSource?;
    /**
     * @stability stable
     */
    get humanLoopRequestSource(): SagemakerFlowDefinitionHumanLoopRequestSource[];
    /**
     * @stability stable
     */
    set humanLoopRequestSource(value: SagemakerFlowDefinitionHumanLoopRequestSource[]);
    /**
     * @stability stable
     */
    resetHumanLoopRequestSource(): void;
    /**
     * @stability stable
     */
    get humanLoopRequestSourceInput(): SagemakerFlowDefinitionHumanLoopRequestSource[] | undefined;
    private _outputConfig;
    /**
     * @stability stable
     */
    get outputConfig(): SagemakerFlowDefinitionOutputConfig[];
    /**
     * @stability stable
     */
    set outputConfig(value: SagemakerFlowDefinitionOutputConfig[]);
    /**
     * @stability stable
     */
    get outputConfigInput(): SagemakerFlowDefinitionOutputConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
