import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerWorkteamConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#description SagemakerWorkteam#description}.
     *
     * @stability stable
     */
    readonly description: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#tags SagemakerWorkteam#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#tags_all SagemakerWorkteam#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#workforce_name SagemakerWorkteam#workforce_name}.
     *
     * @stability stable
     */
    readonly workforceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#workteam_name SagemakerWorkteam#workteam_name}.
     *
     * @stability stable
     */
    readonly workteamName: string;
    /**
     * member_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#member_definition SagemakerWorkteam#member_definition}
     *
     * @stability stable
     */
    readonly memberDefinition: SagemakerWorkteamMemberDefinition[];
    /**
     * notification_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#notification_configuration SagemakerWorkteam#notification_configuration}
     *
     * @stability stable
     */
    readonly notificationConfiguration?: SagemakerWorkteamNotificationConfiguration[];
}
/**
 * @stability stable
 */
export interface SagemakerWorkteamMemberDefinitionCognitoMemberDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#client_id SagemakerWorkteam#client_id}.
     *
     * @stability stable
     */
    readonly clientId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#user_group SagemakerWorkteam#user_group}.
     *
     * @stability stable
     */
    readonly userGroup: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#user_pool SagemakerWorkteam#user_pool}.
     *
     * @stability stable
     */
    readonly userPool: string;
}
/**
 * @stability stable
 */
export interface SagemakerWorkteamMemberDefinitionOidcMemberDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#groups SagemakerWorkteam#groups}.
     *
     * @stability stable
     */
    readonly groups: string[];
}
/**
 * @stability stable
 */
export interface SagemakerWorkteamMemberDefinition {
    /**
     * cognito_member_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#cognito_member_definition SagemakerWorkteam#cognito_member_definition}
     *
     * @stability stable
     */
    readonly cognitoMemberDefinition?: SagemakerWorkteamMemberDefinitionCognitoMemberDefinition[];
    /**
     * oidc_member_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#oidc_member_definition SagemakerWorkteam#oidc_member_definition}
     *
     * @stability stable
     */
    readonly oidcMemberDefinition?: SagemakerWorkteamMemberDefinitionOidcMemberDefinition[];
}
/**
 * @stability stable
 */
export interface SagemakerWorkteamNotificationConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html#notification_topic_arn SagemakerWorkteam#notification_topic_arn}.
     *
     * @stability stable
     */
    readonly notificationTopicArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html aws_sagemaker_workteam}.
 *
 * @stability stable
 */
export declare class SagemakerWorkteam extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam.html aws_sagemaker_workteam} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerWorkteamConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    get descriptionInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get subdomain(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _workforceName;
    /**
     * @stability stable
     */
    get workforceName(): string;
    /**
     * @stability stable
     */
    set workforceName(value: string);
    /**
     * @stability stable
     */
    get workforceNameInput(): string;
    private _workteamName;
    /**
     * @stability stable
     */
    get workteamName(): string;
    /**
     * @stability stable
     */
    set workteamName(value: string);
    /**
     * @stability stable
     */
    get workteamNameInput(): string;
    private _memberDefinition;
    /**
     * @stability stable
     */
    get memberDefinition(): SagemakerWorkteamMemberDefinition[];
    /**
     * @stability stable
     */
    set memberDefinition(value: SagemakerWorkteamMemberDefinition[]);
    /**
     * @stability stable
     */
    get memberDefinitionInput(): SagemakerWorkteamMemberDefinition[];
    private _notificationConfiguration?;
    /**
     * @stability stable
     */
    get notificationConfiguration(): SagemakerWorkteamNotificationConfiguration[];
    /**
     * @stability stable
     */
    set notificationConfiguration(value: SagemakerWorkteamNotificationConfiguration[]);
    /**
     * @stability stable
     */
    resetNotificationConfiguration(): void;
    /**
     * @stability stable
     */
    get notificationConfigurationInput(): SagemakerWorkteamNotificationConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
