import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecretsmanagerSecretVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/secretsmanager_secret_version.html#secret_binary SecretsmanagerSecretVersion#secret_binary}.
     *
     * @stability stable
     */
    readonly secretBinary?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/secretsmanager_secret_version.html#secret_id SecretsmanagerSecretVersion#secret_id}.
     *
     * @stability stable
     */
    readonly secretId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/secretsmanager_secret_version.html#secret_string SecretsmanagerSecretVersion#secret_string}.
     *
     * @stability stable
     */
    readonly secretString?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/secretsmanager_secret_version.html#version_stages SecretsmanagerSecretVersion#version_stages}.
     *
     * @stability stable
     */
    readonly versionStages?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/secretsmanager_secret_version.html aws_secretsmanager_secret_version}.
 *
 * @stability stable
 */
export declare class SecretsmanagerSecretVersion extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/secretsmanager_secret_version.html aws_secretsmanager_secret_version} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecretsmanagerSecretVersionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _secretBinary?;
    /**
     * @stability stable
     */
    get secretBinary(): string;
    /**
     * @stability stable
     */
    set secretBinary(value: string);
    /**
     * @stability stable
     */
    resetSecretBinary(): void;
    /**
     * @stability stable
     */
    get secretBinaryInput(): string | undefined;
    private _secretId;
    /**
     * @stability stable
     */
    get secretId(): string;
    /**
     * @stability stable
     */
    set secretId(value: string);
    /**
     * @stability stable
     */
    get secretIdInput(): string;
    private _secretString?;
    /**
     * @stability stable
     */
    get secretString(): string;
    /**
     * @stability stable
     */
    set secretString(value: string);
    /**
     * @stability stable
     */
    resetSecretString(): void;
    /**
     * @stability stable
     */
    get secretStringInput(): string | undefined;
    /**
     * @stability stable
     */
    get versionId(): string;
    private _versionStages?;
    /**
     * @stability stable
     */
    get versionStages(): string[];
    /**
     * @stability stable
     */
    set versionStages(value: string[]);
    /**
     * @stability stable
     */
    resetVersionStages(): void;
    /**
     * @stability stable
     */
    get versionStagesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
