import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecurityhubStandardsControlConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_standards_control.html#control_status SecurityhubStandardsControl#control_status}.
     *
     * @stability stable
     */
    readonly controlStatus: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_standards_control.html#disabled_reason SecurityhubStandardsControl#disabled_reason}.
     *
     * @stability stable
     */
    readonly disabledReason?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_standards_control.html#standards_control_arn SecurityhubStandardsControl#standards_control_arn}.
     *
     * @stability stable
     */
    readonly standardsControlArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/securityhub_standards_control.html aws_securityhub_standards_control}.
 *
 * @stability stable
 */
export declare class SecurityhubStandardsControl extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/securityhub_standards_control.html aws_securityhub_standards_control} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityhubStandardsControlConfig);
    /**
     * @stability stable
     */
    get controlId(): string;
    private _controlStatus;
    /**
     * @stability stable
     */
    get controlStatus(): string;
    /**
     * @stability stable
     */
    set controlStatus(value: string);
    /**
     * @stability stable
     */
    get controlStatusInput(): string;
    /**
     * @stability stable
     */
    get controlStatusUpdatedAt(): string;
    /**
     * @stability stable
     */
    get description(): string;
    private _disabledReason?;
    /**
     * @stability stable
     */
    get disabledReason(): string;
    /**
     * @stability stable
     */
    set disabledReason(value: string);
    /**
     * @stability stable
     */
    resetDisabledReason(): void;
    /**
     * @stability stable
     */
    get disabledReasonInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get relatedRequirements(): string[];
    /**
     * @stability stable
     */
    get remediationUrl(): string;
    /**
     * @stability stable
     */
    get severityRating(): string;
    private _standardsControlArn;
    /**
     * @stability stable
     */
    get standardsControlArn(): string;
    /**
     * @stability stable
     */
    set standardsControlArn(value: string);
    /**
     * @stability stable
     */
    get standardsControlArnInput(): string;
    /**
     * @stability stable
     */
    get title(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
