import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServicecatalogProvisionedProductConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#accept_language ServicecatalogProvisionedProduct#accept_language}.
     *
     * @stability stable
     */
    readonly acceptLanguage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#ignore_errors ServicecatalogProvisionedProduct#ignore_errors}.
     *
     * @stability stable
     */
    readonly ignoreErrors?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#name ServicecatalogProvisionedProduct#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#notification_arns ServicecatalogProvisionedProduct#notification_arns}.
     *
     * @stability stable
     */
    readonly notificationArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#path_id ServicecatalogProvisionedProduct#path_id}.
     *
     * @stability stable
     */
    readonly pathId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#path_name ServicecatalogProvisionedProduct#path_name}.
     *
     * @stability stable
     */
    readonly pathName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#product_id ServicecatalogProvisionedProduct#product_id}.
     *
     * @stability stable
     */
    readonly productId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#product_name ServicecatalogProvisionedProduct#product_name}.
     *
     * @stability stable
     */
    readonly productName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#provisioning_artifact_id ServicecatalogProvisionedProduct#provisioning_artifact_id}.
     *
     * @stability stable
     */
    readonly provisioningArtifactId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#provisioning_artifact_name ServicecatalogProvisionedProduct#provisioning_artifact_name}.
     *
     * @stability stable
     */
    readonly provisioningArtifactName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#retain_physical_resources ServicecatalogProvisionedProduct#retain_physical_resources}.
     *
     * @stability stable
     */
    readonly retainPhysicalResources?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#tags ServicecatalogProvisionedProduct#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#tags_all ServicecatalogProvisionedProduct#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * provisioning_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#provisioning_parameters ServicecatalogProvisionedProduct#provisioning_parameters}
     *
     * @stability stable
     */
    readonly provisioningParameters?: ServicecatalogProvisionedProductProvisioningParameters[];
    /**
     * stack_set_provisioning_preferences block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#stack_set_provisioning_preferences ServicecatalogProvisionedProduct#stack_set_provisioning_preferences}
     *
     * @stability stable
     */
    readonly stackSetProvisioningPreferences?: ServicecatalogProvisionedProductStackSetProvisioningPreferences[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#timeouts ServicecatalogProvisionedProduct#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ServicecatalogProvisionedProductTimeouts;
}
/**
 * @stability stable
 */
export interface ServicecatalogProvisionedProductProvisioningParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#key ServicecatalogProvisionedProduct#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#use_previous_value ServicecatalogProvisionedProduct#use_previous_value}.
     *
     * @stability stable
     */
    readonly usePreviousValue?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#value ServicecatalogProvisionedProduct#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServicecatalogProvisionedProductStackSetProvisioningPreferences {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#accounts ServicecatalogProvisionedProduct#accounts}.
     *
     * @stability stable
     */
    readonly accounts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#failure_tolerance_count ServicecatalogProvisionedProduct#failure_tolerance_count}.
     *
     * @stability stable
     */
    readonly failureToleranceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#failure_tolerance_percentage ServicecatalogProvisionedProduct#failure_tolerance_percentage}.
     *
     * @stability stable
     */
    readonly failureTolerancePercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#max_concurrency_count ServicecatalogProvisionedProduct#max_concurrency_count}.
     *
     * @stability stable
     */
    readonly maxConcurrencyCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#max_concurrency_percentage ServicecatalogProvisionedProduct#max_concurrency_percentage}.
     *
     * @stability stable
     */
    readonly maxConcurrencyPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#regions ServicecatalogProvisionedProduct#regions}.
     *
     * @stability stable
     */
    readonly regions?: string[];
}
/**
 * @stability stable
 */
export interface ServicecatalogProvisionedProductTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#create ServicecatalogProvisionedProduct#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#delete ServicecatalogProvisionedProduct#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#update ServicecatalogProvisionedProduct#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html aws_servicecatalog_provisioned_product}.
 *
 * @stability stable
 */
export declare class ServicecatalogProvisionedProduct extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html aws_servicecatalog_provisioned_product} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServicecatalogProvisionedProductConfig);
    private _acceptLanguage?;
    /**
     * @stability stable
     */
    get acceptLanguage(): string;
    /**
     * @stability stable
     */
    set acceptLanguage(value: string);
    /**
     * @stability stable
     */
    resetAcceptLanguage(): void;
    /**
     * @stability stable
     */
    get acceptLanguageInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get cloudwatchDashboardNames(): string[];
    /**
     * @stability stable
     */
    get createdTime(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ignoreErrors?;
    /**
     * @stability stable
     */
    get ignoreErrors(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ignoreErrors(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIgnoreErrors(): void;
    /**
     * @stability stable
     */
    get ignoreErrorsInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get lastProvisioningRecordId(): string;
    /**
     * @stability stable
     */
    get lastRecordId(): string;
    /**
     * @stability stable
     */
    get lastSuccessfulProvisioningRecordId(): string;
    /**
     * @stability stable
     */
    get launchRoleArn(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _notificationArns?;
    /**
     * @stability stable
     */
    get notificationArns(): string[];
    /**
     * @stability stable
     */
    set notificationArns(value: string[]);
    /**
     * @stability stable
     */
    resetNotificationArns(): void;
    /**
     * @stability stable
     */
    get notificationArnsInput(): string[] | undefined;
    private _pathId?;
    /**
     * @stability stable
     */
    get pathId(): string;
    /**
     * @stability stable
     */
    set pathId(value: string);
    /**
     * @stability stable
     */
    resetPathId(): void;
    /**
     * @stability stable
     */
    get pathIdInput(): string | undefined;
    private _pathName?;
    /**
     * @stability stable
     */
    get pathName(): string;
    /**
     * @stability stable
     */
    set pathName(value: string);
    /**
     * @stability stable
     */
    resetPathName(): void;
    /**
     * @stability stable
     */
    get pathNameInput(): string | undefined;
    private _productId?;
    /**
     * @stability stable
     */
    get productId(): string;
    /**
     * @stability stable
     */
    set productId(value: string);
    /**
     * @stability stable
     */
    resetProductId(): void;
    /**
     * @stability stable
     */
    get productIdInput(): string | undefined;
    private _productName?;
    /**
     * @stability stable
     */
    get productName(): string;
    /**
     * @stability stable
     */
    set productName(value: string);
    /**
     * @stability stable
     */
    resetProductName(): void;
    /**
     * @stability stable
     */
    get productNameInput(): string | undefined;
    private _provisioningArtifactId?;
    /**
     * @stability stable
     */
    get provisioningArtifactId(): string;
    /**
     * @stability stable
     */
    set provisioningArtifactId(value: string);
    /**
     * @stability stable
     */
    resetProvisioningArtifactId(): void;
    /**
     * @stability stable
     */
    get provisioningArtifactIdInput(): string | undefined;
    private _provisioningArtifactName?;
    /**
     * @stability stable
     */
    get provisioningArtifactName(): string;
    /**
     * @stability stable
     */
    set provisioningArtifactName(value: string);
    /**
     * @stability stable
     */
    resetProvisioningArtifactName(): void;
    /**
     * @stability stable
     */
    get provisioningArtifactNameInput(): string | undefined;
    private _retainPhysicalResources?;
    /**
     * @stability stable
     */
    get retainPhysicalResources(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set retainPhysicalResources(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRetainPhysicalResources(): void;
    /**
     * @stability stable
     */
    get retainPhysicalResourcesInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get statusMessage(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get type(): string;
    private _provisioningParameters?;
    /**
     * @stability stable
     */
    get provisioningParameters(): ServicecatalogProvisionedProductProvisioningParameters[];
    /**
     * @stability stable
     */
    set provisioningParameters(value: ServicecatalogProvisionedProductProvisioningParameters[]);
    /**
     * @stability stable
     */
    resetProvisioningParameters(): void;
    /**
     * @stability stable
     */
    get provisioningParametersInput(): ServicecatalogProvisionedProductProvisioningParameters[] | undefined;
    private _stackSetProvisioningPreferences?;
    /**
     * @stability stable
     */
    get stackSetProvisioningPreferences(): ServicecatalogProvisionedProductStackSetProvisioningPreferences[];
    /**
     * @stability stable
     */
    set stackSetProvisioningPreferences(value: ServicecatalogProvisionedProductStackSetProvisioningPreferences[]);
    /**
     * @stability stable
     */
    resetStackSetProvisioningPreferences(): void;
    /**
     * @stability stable
     */
    get stackSetProvisioningPreferencesInput(): ServicecatalogProvisionedProductStackSetProvisioningPreferences[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ServicecatalogProvisionedProductTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ServicecatalogProvisionedProductTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ServicecatalogProvisionedProductTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
