import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesConfigurationSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_configuration_set.html#name SesConfigurationSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_configuration_set.html#reputation_metrics_enabled SesConfigurationSet#reputation_metrics_enabled}.
     *
     * @stability stable
     */
    readonly reputationMetricsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_configuration_set.html#sending_enabled SesConfigurationSet#sending_enabled}.
     *
     * @stability stable
     */
    readonly sendingEnabled?: boolean | cdktf.IResolvable;
    /**
     * delivery_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_configuration_set.html#delivery_options SesConfigurationSet#delivery_options}
     *
     * @stability stable
     */
    readonly deliveryOptions?: SesConfigurationSetDeliveryOptions[];
}
/**
 * @stability stable
 */
export interface SesConfigurationSetDeliveryOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_configuration_set.html#tls_policy SesConfigurationSet#tls_policy}.
     *
     * @stability stable
     */
    readonly tlsPolicy?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ses_configuration_set.html aws_ses_configuration_set}.
 *
 * @stability stable
 */
export declare class SesConfigurationSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ses_configuration_set.html aws_ses_configuration_set} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesConfigurationSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastFreshStart(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _reputationMetricsEnabled?;
    /**
     * @stability stable
     */
    get reputationMetricsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set reputationMetricsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetReputationMetricsEnabled(): void;
    /**
     * @stability stable
     */
    get reputationMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _sendingEnabled?;
    /**
     * @stability stable
     */
    get sendingEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set sendingEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSendingEnabled(): void;
    /**
     * @stability stable
     */
    get sendingEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _deliveryOptions?;
    /**
     * @stability stable
     */
    get deliveryOptions(): SesConfigurationSetDeliveryOptions[];
    /**
     * @stability stable
     */
    set deliveryOptions(value: SesConfigurationSetDeliveryOptions[]);
    /**
     * @stability stable
     */
    resetDeliveryOptions(): void;
    /**
     * @stability stable
     */
    get deliveryOptionsInput(): SesConfigurationSetDeliveryOptions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
