import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesDomainMailFromConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_domain_mail_from.html#behavior_on_mx_failure SesDomainMailFrom#behavior_on_mx_failure}.
     *
     * @stability stable
     */
    readonly behaviorOnMxFailure?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_domain_mail_from.html#domain SesDomainMailFrom#domain}.
     *
     * @stability stable
     */
    readonly domain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_domain_mail_from.html#mail_from_domain SesDomainMailFrom#mail_from_domain}.
     *
     * @stability stable
     */
    readonly mailFromDomain: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ses_domain_mail_from.html aws_ses_domain_mail_from}.
 *
 * @stability stable
 */
export declare class SesDomainMailFrom extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ses_domain_mail_from.html aws_ses_domain_mail_from} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesDomainMailFromConfig);
    private _behaviorOnMxFailure?;
    /**
     * @stability stable
     */
    get behaviorOnMxFailure(): string;
    /**
     * @stability stable
     */
    set behaviorOnMxFailure(value: string);
    /**
     * @stability stable
     */
    resetBehaviorOnMxFailure(): void;
    /**
     * @stability stable
     */
    get behaviorOnMxFailureInput(): string | undefined;
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _mailFromDomain;
    /**
     * @stability stable
     */
    get mailFromDomain(): string;
    /**
     * @stability stable
     */
    set mailFromDomain(value: string);
    /**
     * @stability stable
     */
    get mailFromDomainInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
