import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SignerSigningProfilePermissionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#action SignerSigningProfilePermission#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#principal SignerSigningProfilePermission#principal}.
     *
     * @stability stable
     */
    readonly principal: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#profile_name SignerSigningProfilePermission#profile_name}.
     *
     * @stability stable
     */
    readonly profileName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#profile_version SignerSigningProfilePermission#profile_version}.
     *
     * @stability stable
     */
    readonly profileVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#statement_id SignerSigningProfilePermission#statement_id}.
     *
     * @stability stable
     */
    readonly statementId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#statement_id_prefix SignerSigningProfilePermission#statement_id_prefix}.
     *
     * @stability stable
     */
    readonly statementIdPrefix?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html aws_signer_signing_profile_permission}.
 *
 * @stability stable
 */
export declare class SignerSigningProfilePermission extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html aws_signer_signing_profile_permission} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SignerSigningProfilePermissionConfig);
    private _action;
    /**
     * @stability stable
     */
    get action(): string;
    /**
     * @stability stable
     */
    set action(value: string);
    /**
     * @stability stable
     */
    get actionInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _profileName;
    /**
     * @stability stable
     */
    get profileName(): string;
    /**
     * @stability stable
     */
    set profileName(value: string);
    /**
     * @stability stable
     */
    get profileNameInput(): string;
    private _profileVersion?;
    /**
     * @stability stable
     */
    get profileVersion(): string;
    /**
     * @stability stable
     */
    set profileVersion(value: string);
    /**
     * @stability stable
     */
    resetProfileVersion(): void;
    /**
     * @stability stable
     */
    get profileVersionInput(): string | undefined;
    private _statementId?;
    /**
     * @stability stable
     */
    get statementId(): string;
    /**
     * @stability stable
     */
    set statementId(value: string);
    /**
     * @stability stable
     */
    resetStatementId(): void;
    /**
     * @stability stable
     */
    get statementIdInput(): string | undefined;
    private _statementIdPrefix?;
    /**
     * @stability stable
     */
    get statementIdPrefix(): string;
    /**
     * @stability stable
     */
    set statementIdPrefix(value: string);
    /**
     * @stability stable
     */
    resetStatementIdPrefix(): void;
    /**
     * @stability stable
     */
    get statementIdPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
