import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SnsTopicSubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#confirmation_timeout_in_minutes SnsTopicSubscription#confirmation_timeout_in_minutes}.
     *
     * @stability stable
     */
    readonly confirmationTimeoutInMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#delivery_policy SnsTopicSubscription#delivery_policy}.
     *
     * @stability stable
     */
    readonly deliveryPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#endpoint SnsTopicSubscription#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#endpoint_auto_confirms SnsTopicSubscription#endpoint_auto_confirms}.
     *
     * @stability stable
     */
    readonly endpointAutoConfirms?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#filter_policy SnsTopicSubscription#filter_policy}.
     *
     * @stability stable
     */
    readonly filterPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#protocol SnsTopicSubscription#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#raw_message_delivery SnsTopicSubscription#raw_message_delivery}.
     *
     * @stability stable
     */
    readonly rawMessageDelivery?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#redrive_policy SnsTopicSubscription#redrive_policy}.
     *
     * @stability stable
     */
    readonly redrivePolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#subscription_role_arn SnsTopicSubscription#subscription_role_arn}.
     *
     * @stability stable
     */
    readonly subscriptionRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#topic_arn SnsTopicSubscription#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html aws_sns_topic_subscription}.
 *
 * @stability stable
 */
export declare class SnsTopicSubscription extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html aws_sns_topic_subscription} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SnsTopicSubscriptionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _confirmationTimeoutInMinutes?;
    /**
     * @stability stable
     */
    get confirmationTimeoutInMinutes(): number;
    /**
     * @stability stable
     */
    set confirmationTimeoutInMinutes(value: number);
    /**
     * @stability stable
     */
    resetConfirmationTimeoutInMinutes(): void;
    /**
     * @stability stable
     */
    get confirmationTimeoutInMinutesInput(): number | undefined;
    /**
     * @stability stable
     */
    get confirmationWasAuthenticated(): cdktf.IResolvable;
    private _deliveryPolicy?;
    /**
     * @stability stable
     */
    get deliveryPolicy(): string;
    /**
     * @stability stable
     */
    set deliveryPolicy(value: string);
    /**
     * @stability stable
     */
    resetDeliveryPolicy(): void;
    /**
     * @stability stable
     */
    get deliveryPolicyInput(): string | undefined;
    private _endpoint;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    get endpointInput(): string;
    private _endpointAutoConfirms?;
    /**
     * @stability stable
     */
    get endpointAutoConfirms(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set endpointAutoConfirms(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEndpointAutoConfirms(): void;
    /**
     * @stability stable
     */
    get endpointAutoConfirmsInput(): boolean | cdktf.IResolvable | undefined;
    private _filterPolicy?;
    /**
     * @stability stable
     */
    get filterPolicy(): string;
    /**
     * @stability stable
     */
    set filterPolicy(value: string);
    /**
     * @stability stable
     */
    resetFilterPolicy(): void;
    /**
     * @stability stable
     */
    get filterPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get pendingConfirmation(): cdktf.IResolvable;
    private _protocol;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string;
    private _rawMessageDelivery?;
    /**
     * @stability stable
     */
    get rawMessageDelivery(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set rawMessageDelivery(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRawMessageDelivery(): void;
    /**
     * @stability stable
     */
    get rawMessageDeliveryInput(): boolean | cdktf.IResolvable | undefined;
    private _redrivePolicy?;
    /**
     * @stability stable
     */
    get redrivePolicy(): string;
    /**
     * @stability stable
     */
    set redrivePolicy(value: string);
    /**
     * @stability stable
     */
    resetRedrivePolicy(): void;
    /**
     * @stability stable
     */
    get redrivePolicyInput(): string | undefined;
    private _subscriptionRoleArn?;
    /**
     * @stability stable
     */
    get subscriptionRoleArn(): string;
    /**
     * @stability stable
     */
    set subscriptionRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSubscriptionRoleArn(): void;
    /**
     * @stability stable
     */
    get subscriptionRoleArnInput(): string | undefined;
    private _topicArn;
    /**
     * @stability stable
     */
    get topicArn(): string;
    /**
     * @stability stable
     */
    set topicArn(value: string);
    /**
     * @stability stable
     */
    get topicArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
