import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsmPatchGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssm_patch_group.html#baseline_id SsmPatchGroup#baseline_id}.
     *
     * @stability stable
     */
    readonly baselineId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssm_patch_group.html#patch_group SsmPatchGroup#patch_group}.
     *
     * @stability stable
     */
    readonly patchGroup: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ssm_patch_group.html aws_ssm_patch_group}.
 *
 * @stability stable
 */
export declare class SsmPatchGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ssm_patch_group.html aws_ssm_patch_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsmPatchGroupConfig);
    private _baselineId;
    /**
     * @stability stable
     */
    get baselineId(): string;
    /**
     * @stability stable
     */
    set baselineId(value: string);
    /**
     * @stability stable
     */
    get baselineIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _patchGroup;
    /**
     * @stability stable
     */
    get patchGroup(): string;
    /**
     * @stability stable
     */
    set patchGroup(value: string);
    /**
     * @stability stable
     */
    get patchGroupInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
