import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewayGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#activation_key StoragegatewayGateway#activation_key}.
     *
     * @stability stable
     */
    readonly activationKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#average_download_rate_limit_in_bits_per_sec StoragegatewayGateway#average_download_rate_limit_in_bits_per_sec}.
     *
     * @stability stable
     */
    readonly averageDownloadRateLimitInBitsPerSec?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#average_upload_rate_limit_in_bits_per_sec StoragegatewayGateway#average_upload_rate_limit_in_bits_per_sec}.
     *
     * @stability stable
     */
    readonly averageUploadRateLimitInBitsPerSec?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#cloudwatch_log_group_arn StoragegatewayGateway#cloudwatch_log_group_arn}.
     *
     * @stability stable
     */
    readonly cloudwatchLogGroupArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#gateway_ip_address StoragegatewayGateway#gateway_ip_address}.
     *
     * @stability stable
     */
    readonly gatewayIpAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#gateway_name StoragegatewayGateway#gateway_name}.
     *
     * @stability stable
     */
    readonly gatewayName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#gateway_timezone StoragegatewayGateway#gateway_timezone}.
     *
     * @stability stable
     */
    readonly gatewayTimezone: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#gateway_type StoragegatewayGateway#gateway_type}.
     *
     * @stability stable
     */
    readonly gatewayType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#gateway_vpc_endpoint StoragegatewayGateway#gateway_vpc_endpoint}.
     *
     * @stability stable
     */
    readonly gatewayVpcEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#medium_changer_type StoragegatewayGateway#medium_changer_type}.
     *
     * @stability stable
     */
    readonly mediumChangerType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#smb_file_share_visibility StoragegatewayGateway#smb_file_share_visibility}.
     *
     * @stability stable
     */
    readonly smbFileShareVisibility?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#smb_guest_password StoragegatewayGateway#smb_guest_password}.
     *
     * @stability stable
     */
    readonly smbGuestPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#smb_security_strategy StoragegatewayGateway#smb_security_strategy}.
     *
     * @stability stable
     */
    readonly smbSecurityStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#tags StoragegatewayGateway#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#tags_all StoragegatewayGateway#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#tape_drive_type StoragegatewayGateway#tape_drive_type}.
     *
     * @stability stable
     */
    readonly tapeDriveType?: string;
    /**
     * smb_active_directory_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#smb_active_directory_settings StoragegatewayGateway#smb_active_directory_settings}
     *
     * @stability stable
     */
    readonly smbActiveDirectorySettings?: StoragegatewayGatewaySmbActiveDirectorySettings[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#timeouts StoragegatewayGateway#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StoragegatewayGatewayTimeouts;
}
/**
 * @stability stable
 */
export declare class StoragegatewayGatewayGatewayNetworkInterface extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ipv4Address(): string;
}
/**
 * @stability stable
 */
export interface StoragegatewayGatewaySmbActiveDirectorySettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#domain_controllers StoragegatewayGateway#domain_controllers}.
     *
     * @stability stable
     */
    readonly domainControllers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#domain_name StoragegatewayGateway#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#organizational_unit StoragegatewayGateway#organizational_unit}.
     *
     * @stability stable
     */
    readonly organizationalUnit?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#password StoragegatewayGateway#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#timeout_in_seconds StoragegatewayGateway#timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly timeoutInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#username StoragegatewayGateway#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface StoragegatewayGatewayTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html#create StoragegatewayGateway#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html aws_storagegateway_gateway}.
 *
 * @stability stable
 */
export declare class StoragegatewayGateway extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_gateway.html aws_storagegateway_gateway} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewayGatewayConfig);
    private _activationKey?;
    /**
     * @stability stable
     */
    get activationKey(): string;
    /**
     * @stability stable
     */
    set activationKey(value: string);
    /**
     * @stability stable
     */
    resetActivationKey(): void;
    /**
     * @stability stable
     */
    get activationKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _averageDownloadRateLimitInBitsPerSec?;
    /**
     * @stability stable
     */
    get averageDownloadRateLimitInBitsPerSec(): number;
    /**
     * @stability stable
     */
    set averageDownloadRateLimitInBitsPerSec(value: number);
    /**
     * @stability stable
     */
    resetAverageDownloadRateLimitInBitsPerSec(): void;
    /**
     * @stability stable
     */
    get averageDownloadRateLimitInBitsPerSecInput(): number | undefined;
    private _averageUploadRateLimitInBitsPerSec?;
    /**
     * @stability stable
     */
    get averageUploadRateLimitInBitsPerSec(): number;
    /**
     * @stability stable
     */
    set averageUploadRateLimitInBitsPerSec(value: number);
    /**
     * @stability stable
     */
    resetAverageUploadRateLimitInBitsPerSec(): void;
    /**
     * @stability stable
     */
    get averageUploadRateLimitInBitsPerSecInput(): number | undefined;
    private _cloudwatchLogGroupArn?;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchLogGroupArn(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchLogGroupArn(): void;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get ec2InstanceId(): string;
    /**
     * @stability stable
     */
    get endpointType(): string;
    /**
     * @stability stable
     */
    get gatewayId(): string;
    private _gatewayIpAddress?;
    /**
     * @stability stable
     */
    get gatewayIpAddress(): string;
    /**
     * @stability stable
     */
    set gatewayIpAddress(value: string);
    /**
     * @stability stable
     */
    resetGatewayIpAddress(): void;
    /**
     * @stability stable
     */
    get gatewayIpAddressInput(): string | undefined;
    private _gatewayName;
    /**
     * @stability stable
     */
    get gatewayName(): string;
    /**
     * @stability stable
     */
    set gatewayName(value: string);
    /**
     * @stability stable
     */
    get gatewayNameInput(): string;
    /**
     * @stability stable
     */
    gatewayNetworkInterface(index: string): StoragegatewayGatewayGatewayNetworkInterface;
    private _gatewayTimezone;
    /**
     * @stability stable
     */
    get gatewayTimezone(): string;
    /**
     * @stability stable
     */
    set gatewayTimezone(value: string);
    /**
     * @stability stable
     */
    get gatewayTimezoneInput(): string;
    private _gatewayType?;
    /**
     * @stability stable
     */
    get gatewayType(): string;
    /**
     * @stability stable
     */
    set gatewayType(value: string);
    /**
     * @stability stable
     */
    resetGatewayType(): void;
    /**
     * @stability stable
     */
    get gatewayTypeInput(): string | undefined;
    private _gatewayVpcEndpoint?;
    /**
     * @stability stable
     */
    get gatewayVpcEndpoint(): string;
    /**
     * @stability stable
     */
    set gatewayVpcEndpoint(value: string);
    /**
     * @stability stable
     */
    resetGatewayVpcEndpoint(): void;
    /**
     * @stability stable
     */
    get gatewayVpcEndpointInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostEnvironment(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _mediumChangerType?;
    /**
     * @stability stable
     */
    get mediumChangerType(): string;
    /**
     * @stability stable
     */
    set mediumChangerType(value: string);
    /**
     * @stability stable
     */
    resetMediumChangerType(): void;
    /**
     * @stability stable
     */
    get mediumChangerTypeInput(): string | undefined;
    private _smbFileShareVisibility?;
    /**
     * @stability stable
     */
    get smbFileShareVisibility(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set smbFileShareVisibility(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSmbFileShareVisibility(): void;
    /**
     * @stability stable
     */
    get smbFileShareVisibilityInput(): boolean | cdktf.IResolvable | undefined;
    private _smbGuestPassword?;
    /**
     * @stability stable
     */
    get smbGuestPassword(): string;
    /**
     * @stability stable
     */
    set smbGuestPassword(value: string);
    /**
     * @stability stable
     */
    resetSmbGuestPassword(): void;
    /**
     * @stability stable
     */
    get smbGuestPasswordInput(): string | undefined;
    private _smbSecurityStrategy?;
    /**
     * @stability stable
     */
    get smbSecurityStrategy(): string;
    /**
     * @stability stable
     */
    set smbSecurityStrategy(value: string);
    /**
     * @stability stable
     */
    resetSmbSecurityStrategy(): void;
    /**
     * @stability stable
     */
    get smbSecurityStrategyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tapeDriveType?;
    /**
     * @stability stable
     */
    get tapeDriveType(): string;
    /**
     * @stability stable
     */
    set tapeDriveType(value: string);
    /**
     * @stability stable
     */
    resetTapeDriveType(): void;
    /**
     * @stability stable
     */
    get tapeDriveTypeInput(): string | undefined;
    private _smbActiveDirectorySettings?;
    /**
     * @stability stable
     */
    get smbActiveDirectorySettings(): StoragegatewayGatewaySmbActiveDirectorySettings[];
    /**
     * @stability stable
     */
    set smbActiveDirectorySettings(value: StoragegatewayGatewaySmbActiveDirectorySettings[]);
    /**
     * @stability stable
     */
    resetSmbActiveDirectorySettings(): void;
    /**
     * @stability stable
     */
    get smbActiveDirectorySettingsInput(): StoragegatewayGatewaySmbActiveDirectorySettings[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): StoragegatewayGatewayTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: StoragegatewayGatewayTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StoragegatewayGatewayTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
