import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcPeeringConnectionOptionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#vpc_peering_connection_id VpcPeeringConnectionOptions#vpc_peering_connection_id}.
     *
     * @stability stable
     */
    readonly vpcPeeringConnectionId: string;
    /**
     * accepter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#accepter VpcPeeringConnectionOptions#accepter}
     *
     * @stability stable
     */
    readonly accepter?: VpcPeeringConnectionOptionsAccepter[];
    /**
     * requester block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#requester VpcPeeringConnectionOptions#requester}
     *
     * @stability stable
     */
    readonly requester?: VpcPeeringConnectionOptionsRequester[];
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionOptionsAccepter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#allow_classic_link_to_remote_vpc VpcPeeringConnectionOptions#allow_classic_link_to_remote_vpc}.
     *
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#allow_remote_vpc_dns_resolution VpcPeeringConnectionOptions#allow_remote_vpc_dns_resolution}.
     *
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#allow_vpc_to_remote_classic_link VpcPeeringConnectionOptions#allow_vpc_to_remote_classic_link}.
     *
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionOptionsRequester {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#allow_classic_link_to_remote_vpc VpcPeeringConnectionOptions#allow_classic_link_to_remote_vpc}.
     *
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#allow_remote_vpc_dns_resolution VpcPeeringConnectionOptions#allow_remote_vpc_dns_resolution}.
     *
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html#allow_vpc_to_remote_classic_link VpcPeeringConnectionOptions#allow_vpc_to_remote_classic_link}.
     *
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html aws_vpc_peering_connection_options}.
 *
 * @stability stable
 */
export declare class VpcPeeringConnectionOptions extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection_options.html aws_vpc_peering_connection_options} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcPeeringConnectionOptionsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _vpcPeeringConnectionId;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionId(): string;
    /**
     * @stability stable
     */
    set vpcPeeringConnectionId(value: string);
    /**
     * @stability stable
     */
    get vpcPeeringConnectionIdInput(): string;
    private _accepter?;
    /**
     * @stability stable
     */
    get accepter(): VpcPeeringConnectionOptionsAccepter[];
    /**
     * @stability stable
     */
    set accepter(value: VpcPeeringConnectionOptionsAccepter[]);
    /**
     * @stability stable
     */
    resetAccepter(): void;
    /**
     * @stability stable
     */
    get accepterInput(): VpcPeeringConnectionOptionsAccepter[] | undefined;
    private _requester?;
    /**
     * @stability stable
     */
    get requester(): VpcPeeringConnectionOptionsRequester[];
    /**
     * @stability stable
     */
    set requester(value: VpcPeeringConnectionOptionsRequester[]);
    /**
     * @stability stable
     */
    resetRequester(): void;
    /**
     * @stability stable
     */
    get requesterInput(): VpcPeeringConnectionOptionsRequester[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
